Package: decompTumor2Sig
Type: Package
Title: Decomposition of individual tumors into mutational signatures by
        signature refitting
Depends: R(>= 4.0), ggplot2
Imports: methods, Matrix, quadprog(>= 1.5-5), GenomicRanges, stats,
        GenomicFeatures, Biostrings, BiocGenerics, S4Vectors, plyr,
        utils, graphics, BSgenome.Hsapiens.UCSC.hg19,
        TxDb.Hsapiens.UCSC.hg19.knownGene, VariantAnnotation,
        SummarizedExperiment, ggseqlogo, gridExtra, data.table,
        Seqinfo, readxl
Suggests: knitr, rmarkdown, BiocStyle
Version: 2.28.0
Date: 2025-07-22
Encoding: UTF-8
Authors@R: c(
    person("Rosario M.", "Piro", email = "rmpiro@gmail.com",
            role = c("aut", "cre")),
    person("Sandra", "Krueger", role = c("ctb"))
    )
Description: Uses quadratic programming for signature refitting, i.e., to
    decompose the mutation catalog from an individual tumor sample into a set of
    given mutational signatures (either Alexandrov-model signatures or
    Shiraishi-model signatures), computing weights that reflect the
    contributions of the signatures to the mutation load of the tumor.
License: GPL-2
URL: http://rmpiro.net/decompTumor2Sig/,
        https://github.com/rmpiro/decompTumor2Sig
BugReports: https://github.com/rmpiro/decompTumor2Sig/issues
biocViews: Software, SNP, Sequencing, DNASeq, GenomicVariation,
        SomaticMutation, BiomedicalInformatics, Genetics,
        BiologicalQuestion, StatisticalMethod
VignetteBuilder: knitr
RoxygenNote: 7.1.2
git_url: https://git.bioconductor.org/packages/decompTumor2Sig
git_branch: RELEASE_3_23
git_last_commit: 83dd5b2
git_last_commit_date: 2026-04-28
Repository: Bioconductor 3.23
Date/Publication: 2026-04-28
NeedsCompilation: no
Packaged: 2026-04-28 21:40:33 UTC; biocbuild
Author: Rosario M. Piro [aut, cre],
  Sandra Krueger [ctb]
Maintainer: Rosario M. Piro <rmpiro@gmail.com>

# decompTumor2Sig
decompTumor2Sig - Decomposition of individual tumors into mutational
signatures by signature refitting

Please visit the package's Bioconductor website for more information:

https://www.bioconductor.org/packages/release/bioc/html/decompTumor2Sig.html

####################
# public functions #
####################


#' Decompose tumor genomes into mutational signatures
#'
#' `decomposeTumorGenomes()` is the core function of this package. It
#' decomposes tumor genomes into a given set of mutational signatures by
#' computing their contributions (exposures) to the mutational load via
#' quadratic programming. The function takes a set of mutational signatures
#' and the mutation features of one or more tumor genomes and computes
#' weights, i.e., contributions for each of the signatures in each
#' individual genome. Alternatively, the function can determine for each
#' genome only a subset of signatures whose contributions are sufficient
#' to exceed a user-given minimum threshold for the explained variance
#' of the genome's mutation patterns.
#'
#' @usage decomposeTumorGenomes(genomes, signatures, minExplainedVariance=NULL,
#' minNumSignatures=2, maxNumSignatures=NULL, greedySearch=FALSE,
#' constrainToMaxContribution=FALSE, tolerance=0.1, verbose=FALSE)
#' @param genomes (Mandatory) Can be either a vector, a data frame or a
#' matrix (for an individual tumor genome), or a list of one of these
#' object types (for multiple tumors). Each tumor genome must be of the
#' same form as the \code{signatures}.
#' @param signatures (Mandatory) A list of vectors, data frames or matrices.
#' Each of the objects represents one mutational signature. Vectors are
#' used for Alexandrov signatures, data frames or matrices for Shiraishi
#' signatures. 
#' @param minExplainedVariance (Optional) If \code{NULL} (default), exactly
#' \code{maxNumSignatures} (see below; default: all) will be taken for
#' decomposing each genome. If a numeric value between 0 and 1 is specified
#' for \code{minExplainedVariance}, for each genome the function will select
#' the smallest number of signatures which is sufficient to explain at least
#' the specified fraction of the variance of the genome's mutation patterns.
#' E.g., if \code{minExplainedVariance}=0.99 the smallest subset of
#' signatures that explains at least 99\% of the variance is taken.
#' Please note: depending on the number of signatures, this may take quite
#' a while because by default for each number K of signatures, all possible
#' subsets composed of K signatures will be tested to identify the subset that
#' explains the highest part of the variance. If not enough variance is
#' explained, K will be incremented by one. Notes: 1) to speed up the search,
#' the parameters \code{minNumSignatures}, \code{maxNumSignatures} and
#' \code{greedySearch} can be used; 2) for genomes for which
#' none of the possible subsets of signatures explains enough variance, the
#' returned exposure vector will be set to \code{NULL}. 
#' @param minNumSignatures (Optional) Used if \code{minExplainedVariance} is
#' specified (see above). To find the smallest subset of signatures which
#' explain the variance, at least this number of signatures will be taken. This
#' can be used to reduce the search space in a time-consuming search over a
#' large number of signatures.
#' @param maxNumSignatures (Optional) If \code{minExplainedVariance} is
#' specified to find the smallest subset of signatures which
#' explain the variance, at most \code{maxNumSignatures} will be taken. This 
#' can be used to reduce the search space in a time-consuming search over a
#' large number of signatures. If \code{minExplainedVariance} is \code{NULL},
#' then exactly \code{maxNumSignatures} signatures will be used. The default
#' for \code{maxNumSignatures} is \code{NULL} (all signatures).
#' @param greedySearch (Optional) Used only in case \code{minExplainedVariance}
#' has been specified. If \code{greedySearch} is \code{TRUE} then not all
#' possible combinations of \code{minNumSignatures} to \code{maxNumSignatures}
#' signatures will be checked. Instead, first all possible combinations for
#' exactly \code{minNumSignatures} will be checked to select the best starting
#' set, then iteratively the next best signature will be added (maximum
#' increase in explained variability) until \code{minExplainedVariance} of the
#' variance can be explained (or \code{maxNumSignatures} is exceeded).
#' NOTE: this approximate search is highly recommended for large sets of
#' signatures (>15)! 
#' @param constrainToMaxContribution (Optional) [Note: this is EXPERIMENTAL
#' and is usually not needed!] If \code{TRUE}, the maximum contribution that
#' can be attributed to a signature will be constraint by the variant feature
#' counts (e.g., specific flanking bases) observed in the individual tumor
#' genome. If, for example, 30\% of all observed variants have a specific
#' feature and 60\% of the variants produced by a mutational process/signature
#' will manifest the feature, then the signature can have contributed up to
#' 0.3/0.6 (=0.5 or 50\%) of the observed variants. The lowest possible
#' contribution over all signature features will be taken as the allowed
#' maximum contribution of the signature. This allowed maximum will
#' additionally be increased by the value specified as \code{tolerance}
#' (see below). For the illustrated example and \code{tolerance}=0.1 a
#' contribution of up to 0.5+0.1 = 0.6 (or 60\%) of the signature would be
#' allowed. 
#' @param tolerance (Optional) If \code{constrainToMaxContribution} is
#' \code{TRUE}, the maximum contribution computed for a signature is increased
#' by this value (see above). If the parameter \code{constrainToMaxContribution}
#' is \code{FALSE}, the tolerance value is ignored. Default: 0.1. 
#' @param verbose (Optional) If \code{TRUE} some information about the
#' processed genome and used number of signatures will be printed.
#' @return A list of signature weight vectors (also called 'exposures'), one
#' for each tumor genome. E.g., the first vector element of the first list
#' object is the weight/contribution of the first signature to the first
#' tumor genome. IMPORTANT: If \code{minExplainedVariance} is specified, then
#' the exposures of a genome will NOT be returned if the minimum explained
#' variance is not reached within the requested minimum and maximum numbers
#' of signatures (\code{minNumSignatures} and \code{maxNumSignatures})! The
#' corresponding exposure vector will be set to \code{NULL}. 
#' @author Rosario M. Piro, Politecnico di Milano\cr
#' Sandra Krueger, Freie Universitaet Berlin\cr Maintainer: Rosario
#' M. Piro\cr E-Mail: <rmpiro@@gmail.com> or <rosariomichael.piro@@polimi.it>
#' @references \url{http://rmpiro.net/decompTumor2Sig/}\cr
#' Krueger, Piro (2019) decompTumor2Sig: Identification of mutational
#' signatures active in individual tumors. BMC Bioinformatics 
#' 20(Suppl 4):152.\cr
#' @seealso \code{\link{decompTumor2Sig}}
#' @examples
#' 
#' ### get Alexandrov signatures from COSMIC
#' signatures <- readAlexandrovSignatures()
#' 
#' ### load reference genome
#' refGenome <- BSgenome.Hsapiens.UCSC.hg19::BSgenome.Hsapiens.UCSC.hg19
#' 
#' ### read breast cancer genomes from Nik-Zainal et al (PMID: 22608084) 
#' gfile <- system.file("extdata",
#'          "Nik-Zainal_PMID_22608084-VCF-convertedfromMPF.vcf.gz", 
#'          package="decompTumor2Sig")
#' genomes <- readGenomesFromVCF(gfile, numBases=3, type="Alexandrov",
#'          trDir=FALSE, refGenome=refGenome, verbose=FALSE)
#' 
#' ### compute exposures
#' exposures <- decomposeTumorGenomes(genomes, signatures, verbose=FALSE)
#' 
#' ### (for further examples on searching subsets, please see the vignette)
#' 
#' @importFrom BSgenome.Hsapiens.UCSC.hg19 BSgenome.Hsapiens.UCSC.hg19
#' @export decomposeTumorGenomes
decomposeTumorGenomes <- function(genomes, signatures,
                                  minExplainedVariance=NULL,
                                  minNumSignatures=2, maxNumSignatures=NULL,
                                  greedySearch=FALSE, 
                                  constrainToMaxContribution=FALSE,
                                  tolerance=0.1, verbose=FALSE) {
    
    # input: gnomes = either a list of genome mutation counts as matrices or
    #                  vectors, or a single genome (matrix or vector)
    #        signatures = a list of signatures (matrices or vectors)
    #        [need to have the same format]

    # constrainToMaxContribution and tolerance:
    # We want to constrain the maximum contribution each signature can have
    # (given some tolerance): For each row in sigMa (each signature), we
    # divide the counts from the genome by the corresponding fractions in
    # the signature and take the minimum over the signature, the signature
    # can't have a higher contribution than this ratio, but we add a tolerance
    # value (given that the data is noisy!)
    # Example: if in the genome 30% of variants have a specific feature
    # (e.g., a specific flanking base), i.e., the counts score is 0.3, and
    # 60% (0.6) of the variants produced by a process/signature have this 
    # feature, then the signature can have contributed up to 0.3/0.6 = 0.5 (50%)
    # of the genome's variants. 
    # With the default tolerance of 0.1, we would allow the quadratic
    # programming approach to assign up to 0.5+0.1 (60%) of the variants to
    # this signature

    # minExplainedVariance and minNumSignatures and maxNumSignatures:
    # If minExplainedVariance is specified, the minimum number of signatures
    # required will be determined such that the minimum threshold for
    # explained variance is satisfied. The tested numbers of signatures range
    # from minNumSignatures (default: 2) to maxNumSignatures (default: all)

    # if greedySearch=TRUE then _not_ all possible combinations of
    # minNumSignatures to maxNumSignatures signatures will be checked. Instead,
    # first all possible combinations for exactly minNumSignatures will be
    # checked, then the next best signature will be added (maximum increase
    # in explained variability) until minExplainedVariance is reached
    # (or maxNumSignatures is exceeded).
    
    # If minExplainedVariance is NULL, then exactly maxNumSignatures
    # signatures will be taken (default: all)

    # Returns: exposure(s), but only if they satisfy minExplainedVariance or
    # if not minimum explained variance is requested.

    
    if (!isSignatureSet(signatures)) {
        stop("Parameter 'signatures' must be a set (list) of signatures.")
    }

    # if maximum number of signatures is not defined, set it to the total
    # number of signatures
    if(is.null(maxNumSignatures)) {
        maxNumSignatures <- length(signatures)
    }

    # if we don't require to find the minimum number of signatures for which
    # we exceed the minimum explained variance, we simply take the maximum
    # number of signatures (usually the default: all)
    # This way we make sure that we use exactly k = maxNumSignatures
    if (is.null(minExplainedVariance)) {
        minNumSignatures <- maxNumSignatures
        
    } else if(!is.numeric(minExplainedVariance)
              || minExplainedVariance<0 || minExplainedVariance>1) {

        stop("minExplainedVariance must be NULL or between 0 and 1!")
    }

    
    # is the signatures are unnamed, name them by enumerating them
    if(is.null(names(signatures))) {
        names(signatures) <- paste0("sign_",seq_along(signatures))
    }

    
    if (!is.logical(greedySearch)) {
         stop("greedySearch must be logical (TRUE or FALSE)!")
    }

    if (!is.logical(constrainToMaxContribution)) {
         stop("constrainToMaxContribution must be logical (TRUE or FALSE)!")
    }

    if (constrainToMaxContribution && (tolerance < 0 ||  tolerance > 1)) {
        stop(paste("tolerance must be between 0 and 1 when constraining the",
                   "maximum contribution of signatures (default: 0.1)!"))
    }



    if (is.probability.object(genomes)) {
        # this is only one genome, use a list nonetheless for later iteration
        genomes <- list(genomes)
    }

    if (!isSignatureSet(genomes)) { # same type of object as signatures
        stop("Parameter 'genomes' must be a set (list) of genomes.")
    }
    
    if (is.null(names(genomes))) { # numbering of genomes if they are not named!
                                   # (we need the names for the results)
        names(genomes) <- paste0("genome_", as.character(seq_along(genomes)))
    }


    if (!sameSignatureFormat(signatures, genomes)) {
        stop("Signatures and genomes must be of the same format.")
    }

    
    # initialize an empty list with all elements set to NULL
    decompositions  <- vector("list", length(genomes))  
    
    for (g in seq_along(genomes)) {
        # evaluate each genome individually

        if(verbose) {
            cat(paste0("Decomposing genome ",g," (",names(genomes)[g],")"))
        }
        
        counts <- genomes[[g]]
       
        # iterating for all possible numbers of signatures from
        # minNumSignatures to maxNumSignatures
        decompTmpList <- list()

        if(!greedySearch) {
            # default: full search; all possible combinations!
            for (k in seq(minNumSignatures, maxNumSignatures)) {

                if(verbose) {
                    cat(paste(" with", k, "signatures ...\n"))
                }
            
                decompTmpList[[length(decompTmpList)+1]] <-
                    getBestDecomp4Ksignatures(counts, signatures, k,
                                              constrainToMaxContribution,
                                              tolerance)

                if (!is.null(minExplainedVariance)) {
                    # test the decomposition to check if we found one that
                    # explains at least minExplainedVariance of the variance
                    # of the observed mutation data of the genome

                    if (decompTmpList[[length(decompTmpList)]]$explVar
                        >= minExplainedVariance) {
                        
                        break
                    }
                }
            }
        } else {
            # greedy search! start with best combination of minNumSignatures;
            # then add one at a time
            k <- minNumSignatures

            if(verbose) {
                cat(paste(" with", k, "signatures ...\n"))
            }

            decompTmpList[[length(decompTmpList)+1]] <-
                getBestDecomp4Ksignatures(counts, signatures, k,
                                          constrainToMaxContribution,
                                          tolerance)

            while(decompTmpList[[length(decompTmpList)]]$explVar
                       < minExplainedVariance
                  && k < maxNumSignatures) {

                if(verbose) {
                    cat(paste(" adding signature", k+1, "...\n"))
                }

                haveSubset <- decompTmpList[[length(decompTmpList)]]$sigList
                decompTmpList[[length(decompTmpList)+1]] <-
                    addBestSignatureToSubset(counts, signatures, haveSubset,
                                             constrainToMaxContribution,
                                             tolerance)
                k <- k + 1
            }
        }

        haveExplVar <- decompTmpList[[length(decompTmpList)]]$explVar
        
        if(verbose) {
            cat(paste(" explained variance:", haveExplVar))
        }
        
        # The last decomposition we obtained should be the correct one, either
        # because the k signatures exceed the threshold minExplainedVariance,
        # or because no such threshold was required
        # However, if no combination of signatures reached the specified
        # threshold, we do not report the result!

        if (is.null(minExplainedVariance)
            || haveExplVar >= minExplainedVariance) {
            # threshold not specified or satisfied

            # return _all_ signatures but set unused signatures to NA

            # empty vector of NAs
            decompositions[[g]] <- rep(NA, length(signatures))
            names(decompositions[[g]]) <- names(signatures)

            # set used signatures to their exposure/contribution
            listlen <- length(decompTmpList)
            decompositions[[g]][decompTmpList[[listlen]]$sigList] <-
                decompTmpList[[listlen]]$decomposition

            if(verbose) {
                cat("\n")
            }
        } else {
            # threshold specified but not satisfied; do not report the results
            # (set to NULL instead)

            if(verbose) {
                cat(paste(" <", minExplainedVariance,"(rejected)\n"))
            }
        }

        names(decompositions)[g] <- names(genomes)[g]

    }
    
    return(decompositions)
}

###########################################
# internal helper functions for sequences #
###########################################

#' Compute nucleotide frequencies (internal function)
#'
#' Compute nucleotide frequencies for a reference genome and a region set.
#'
#' @usage compNucFreq(refGenome, regions=NULL, numBases=1, mergeByRevComp=TRUE)
#' @param refGenome Reference genome (\code{BSgenome})
#' @param regions (Optional) Regions (\code{GRanges}); default:
#' \code{NULL} (whole genome).
#' @param numBases (Optional) Sequence pattern length for which to compute
#' frequencies (e.g., '3' for trinucleotides). Default: 1 (single nucleotides).
#' @param mergeByRevComp (Optional) Reduce redundancy by merging counts
#' for reverse complement sequence patterns. This function allows this only
#' for sequence patterns with odd length (e.g., single nucleotides,
#' trinucleotides). Default: \code{TRUE}.
#' @return Vector of computed nucleotide frequencies
#' @author Rosario M. Piro\cr Politecnico di Milano\cr Maintainer: Rosario
#' M. Piro\cr E-Mail: <rmpiro@@gmail.com> or <rosariomichael.piro@@polimi.it>
#' @references \url{http://rmpiro.net/decompTumor2Sig/}\cr
#' Krueger, Piro (2019) decompTumor2Sig: Identification of mutational
#' signatures active in individual tumors. BMC Bioinformatics
#' 20(Suppl 4):152.\cr
#' @importFrom Biostrings oligonucleotideFrequency DNAStringSet
#' reverseComplement
#' @keywords internal
compNucFreq <- function(refGenome, regions=NULL, numBases=1,
                        mergeByRevComp=TRUE) { 

    if (is.null(regions)) {
        sequences <- Biostrings::getSeq(refGenome)
    } else {
        sequences <- Biostrings::getSeq(refGenome, regions)
    }

    # compute nucleotide pattern counts for individual sequences
    counts <- oligonucleotideFrequency(sequences, numBases)
    # sum counts over all sequences
    if(is.matrix(counts)) {
        counts <- apply(counts, 2, sum)
    }

    # merge counts from reverse complement patterns?
    if (mergeByRevComp) {
        if ((numBases %% 2) == 0) {
            stop(paste0("Nucleotide patterns must be of odd length for ",
                        "merging reverse complements!"))
        }
    
        # nucloetide patterns are equivalent to their reverseComplement!
        revNuc <- as.character(reverseComplement(DNAStringSet(names(counts))))
        counts <- counts + counts[revNuc]

        # take only those with C and T at center (convention of signatures)
        pattern <- paste0(strrep(".", (numBases-1)/2),
                          "[CT]", strrep(".", (numBases-1)/2))
    
        counts <- counts[grep(pattern, names(counts))]
    }

    # convert to frequencies
    freqs <- counts / sum(counts)

    return(freqs)
}


#' Convert sequence pattern frequencies to base frequencies (internal function)
#'
#' Convert sequence pattern frequencies (Alexandrov-like) to frequencies for
#' individual bases (Shiraishi-like).
#'
#' @usage convertSeqFreqToBaseFreq(frequencies, sigType)
#' @param frequencies Vector for frequencies of individual sequence patterns
#' @param sigType Signature type information as returned by
#' \code{\link{determineTypeNumBasesAndTrDir}}
#' @return Shiraishi signature-like matrix of per-base nucleotide frequencies
#' @author Rosario M. Piro\cr Politecnico di Milano\cr Maintainer: Rosario
#' M. Piro\cr E-Mail: <rmpiro@@gmail.com> or <rosariomichael.piro@@polimi.it>
#' @references \url{http://rmpiro.net/decompTumor2Sig/}\cr
#' Krueger, Piro (2019) decompTumor2Sig: Identification of mutational
#' signatures active in individual tumors. BMC Bioinformatics
#' 20(Suppl 4):152.\cr
#' @keywords internal
convertSeqFreqToBaseFreq <- function(frequencies, sigType) { 

    numBases <- sigType$numBases    # number of bases in sequence pattern
    center <- (numBases+1)/2        # position of central base
    
    # initialize a Shiraishi signature-like matrix for frequencies
    # add a row for transcription direction info, if necessary;
    # initialize everything to 1 because we later divide one matrix by another;
    # hence the initial base factor for normalization is 1 for each element
    # in the matrix
    freqMatrix <- matrix(1, ncol=6, nrow=(numBases+sigType$trDir))

    # compute nucleotide frequencies for individual bases of the pattern
    for (pos in seq(numBases)) {
        # for this position, get the corresponding base for each element in
        # the frequency vector
        posBases <- substr(names(frequencies), start=pos, stop=pos)

        # split the frequency vector according to the bases
        freqSplit <- split(frequencies, posBases)

        # convert split list to overall base frequencies (by summing)
        baseFreq <- vapply(freqSplit, sum, FUN.VALUE=numeric(1))

        # decide where to put this in the matrix
        if (pos == center) {
            # central (mutated) base; row 1 of the matrix
            # each frequency 3 times (row is: C>A, C>G, C>T, T>A, T>C, T>G)
            freqMatrix[1,] <- rep(baseFreq, each=3)
        } else {
            # flanking bases
            # if (pos<center): upstream base; starting from row 2 in the matrix
            #                  row=pos+1 (because 1st row is the center!)
            # if (pos>center): downstream base; row=pos
            # just copy to first 4 row elements (row is: A, C, G, T, 0, 0)
            freqMatrix[pos+(pos<center),] <- c(baseFreq, rep(1,2))
            # Note: we use dummy score 1 for two remaining row elements
            # because we later divide one matrix by another, so that the
            # respective factors becomes 1
        }
    }

    return(freqMatrix)
}


#' Adjust an Alexandrov signature (internal function)
#'
#' Adjust an Alexandrov signature by a set of pattern-specific factors.
#'
#' @usage adjustAlexandrovSignature(signature, factors)
#' @param signature Single Alexandrov signature to be adjusted
#' @param factors Factors for trinucleotides 
#' @return Adjusted Alexandrov signature
#' @author Rosario M. Piro\cr Politecnico di Milano\cr Maintainer: Rosario
#' M. Piro\cr E-Mail: <rmpiro@@gmail.com> or <rosariomichael.piro@@polimi.it>
#' @references \url{http://rmpiro.net/decompTumor2Sig/}\cr
#' Krueger, Piro (2019) decompTumor2Sig: Identification of mutational
#' signature active in individual tumors. BMC Bioinformatics
#' 20(Suppl 4):152.\cr
#' @keywords internal
adjustAlexandrovSignature <- function(signature, factors) { 

    # keep names of the mutation types
    muttypes <- names(signature)

    # get trinucleotides in the same order
    tri <- gsub("\\[([CT])>.\\]", "\\1", muttypes)

    # adjust mutation probabilities according to trinucleotide factors
    sign <- signature * factors[tri]

    # finally, re-normalize signature to sum up to 1
    sign <- sign / sum(sign)

    return(sign)
}



#' Adjust an Shiraishi signature (internal function)
#'
#' Adjust an Shiraishi signature by a set of base-specific factors.
#'
#' @usage adjustShiraishiSignature(signature, factorsMatrix)
#' @param signature Single Shiraishi signature to be adjusted
#' @param factorsMatrix Factors for single nucleotides (Shiraishi-like matrix) 
#' @return Adjusted Shiraishi signature
#' @author Rosario M. Piro\cr Politecnico di Milano\cr Maintainer: Rosario
#' M. Piro\cr E-Mail: <rmpiro@@gmail.com> or <rosariomichael.piro@@polimi.it>
#' @references \url{http://rmpiro.net/decompTumor2Sig/}\cr
#' Krueger, Piro (2019) decompTumor2Sig: Identification of mutational
#' signature active in individual tumors. BMC Bioinformatics
#' 20(Suppl 4):152.\cr
#' @keywords internal
adjustShiraishiSignature <- function(signature, factorsMatrix) { 

    if ( !(is.matrix(signature) && is.matrix(factorsMatrix)) ||
         !(all(dim(signature) == dim(factorsMatrix))) ) {
        stop("signature and factorsMatrix need to be matrices of same format!")
    }

    # multiply signature elementwise by adjustment factors
    sign <- signature * factorsMatrix

    # renormalize each row (=base of the pattern) to sum up to 1
    sign <- t(apply(sign, 1, function(x){ x/sum(x)}))
    
    return(sign)
}

# produces the files:
# Nik-Zainal_PMID_22608084-pmsignature-G.Rdata
# Nik-Zainal_PMID_22608084-pmsignature-Param.Rdata
# Nik-Zainal_PMID_22608084-pmsignature-sig1.tsv
# Nik-Zainal_PMID_22608084-pmsignature-sig2.tsv
# Nik-Zainal_PMID_22608084-pmsignature-sig3.tsv
# Nik-Zainal_PMID_22608084-pmsignature-sig4.tsv
# Nik-Zainal_PMID_22608084-pmsignature-sigall.Rdata

### ATTENTION: every run will be slightly different, due to stochastic 
### processes in pmsignature; see below!

library(pmsignature)
library(decompTumor2Sig)


NUMSIG <- 4

numBases <- 5
trDir <- TRUE
sigType <- "independent"  # Shiraishi


# get reference genome and transcript annotation
refGenome <- BSgenome.Hsapiens.UCSC.hg19::BSgenome.Hsapiens.UCSC.hg19
transcriptAnno <-
    TxDb.Hsapiens.UCSC.hg19.knownGene::TxDb.Hsapiens.UCSC.hg19.knownGene

# read mutation data by pmsignature
G <- readMPFile(infile="inst/extdata/Nik-Zainal_PMID_22608084-MPF.txt.gz", trDir=trDir, numBases=numBases, type=sigType, bs_genome=refGenome, txdb_transcript=transcriptAnno)

# save the G object as Rdata file
save(G, file="Nik-Zainal_PMID_22608084-pmsignature-G.Rdata")

# get signatures (and exposures) by de novo signature inference (pmsignature)
### IMPORTANT: this is a stochastic process, so signatures can slightly change
### every time this is executed; above all: there is no guarantee that they
### will have the same order as before!
Param <- getPMSignature(G, K=NUMSIG)

# save the G and Param file as Rdata file
save(G, Param, file="Nik-Zainal_PMID_22608084-pmsignature-Param.Rdata")


# convert the signatures to the decompTumor2Sig format
signatures <- getSignaturesFromEstParam(Param)


# save the signatures in individual TSV flat files
for (ii in seq_along(signatures)) {
    write.table(signatures[[ii]], file=paste0("Nik-Zainal_PMID_22608084-pmsignature-sig",ii,".tsv"), sep="\t", row.names = FALSE, col.names = FALSE, quote=FALSE)
}


# now read them by decompTumor2Sig 
# (signatures will then be named by the file name)
sigfiles <- dir(pattern="Nik-Zainal_PMID_22608084-pmsignature-sig")

signatures <- readShiraishiSignatures(files=sigfiles)

# save them again as Rdata object
save(signatures, file="Nik-Zainal_PMID_22608084-pmsignature-sigall.Rdata")

## ----style, echo = FALSE, results = 'asis'------------------------------------
library(BiocStyle)

## ----echo = FALSE-------------------------------------------------------------
library(knitr)

## ----results='hide', message=FALSE--------------------------------------------
library(decompTumor2Sig)

## ----message=FALSE, warning=FALSE---------------------------------------------
signatures <- readAlexandrovSignatures()
length(signatures)
signatures[1]

## ----eval=FALSE---------------------------------------------------------------
# signatures <- readAlexandrovSignatures(file="<signature_file>")

## -----------------------------------------------------------------------------
# take the example signature flat files provided with decompTumor2Sig
sigfiles <- system.file("extdata",
                 paste0("Nik-Zainal_PMID_22608084-pmsignature-sig",1:4,".tsv"),
                 package="decompTumor2Sig")

# read the signature flat files
signatures <- readShiraishiSignatures(files=sigfiles)
signatures[1]

## -----------------------------------------------------------------------------
# load example signatures for breast cancer genomes from Nik-Zainal et al
# (PMID: 22608084) in the format produced by pmsignature (PMID: 26630308)
pmsigdata <- system.file("extdata",
          "Nik-Zainal_PMID_22608084-pmsignature-Param.Rdata", 
          package="decompTumor2Sig")
load(pmsigdata)
 
# extract the signatures from the pmsignature 'Param' object
signatures <- getSignaturesFromEstParam(Param)
signatures[1]

## ----message=FALSE, warning=FALSE---------------------------------------------
sign_a <- readAlexandrovSignatures()
sign_s <- convertAlexandrov2Shiraishi(sign_a)
sign_s[1]

## ----message=FALSE, warning=FALSE---------------------------------------------
# get Alexandrov signatures from COSMIC
signatures <- readAlexandrovSignatures()

signatures$Signature.1[1:5]


# get gene annotation for the default reference genome (hg19)
txdb <- TxDb.Hsapiens.UCSC.hg19.knownGene::TxDb.Hsapiens.UCSC.hg19.knownGene

# get a GRanges object for gene promoters (-2000 to +200 bases from TSS)
library(GenomicRanges)
regionsTarget <- promoters(txdb, upstream=2000, downstream=200)

# adjust signatures according to nucleotide frequencies in this subset of
# the genome
sign_adj <-
   adjustSignaturesForRegionSet(signatures,
            regionsTarget, regionsOriginal=NULL,
            refGenome=BSgenome.Hsapiens.UCSC.hg19::BSgenome.Hsapiens.UCSC.hg19)

sign_adj$Signature.1[1:5]

## -----------------------------------------------------------------------------
isAlexandrovSet(sign_a)
isSignatureSet(sign_a)
isShiraishiSet(sign_s)
isSignatureSet(sign_s)
sameSignatureFormat(sign_a, sign_s)

## -----------------------------------------------------------------------------
# load the reference genome and the transcript annotation database
refGenome <- BSgenome.Hsapiens.UCSC.hg19::BSgenome.Hsapiens.UCSC.hg19
transcriptAnno <-
           TxDb.Hsapiens.UCSC.hg19.knownGene::TxDb.Hsapiens.UCSC.hg19.knownGene

# take the six breast cancer genomes from Nik-Zainal et al (PMID: 22608084) 
gfile <- system.file("extdata",
                     "Nik-Zainal_PMID_22608084-VCF-convertedfromMPF.vcf.gz",
                     package="decompTumor2Sig")

# read the cancer genomes in VCF format
genomes <- readGenomesFromVCF(gfile, numBases=5, type="Shiraishi",
                              trDir=TRUE, refGenome=refGenome,
                              transcriptAnno=transcriptAnno, verbose=FALSE)
length(genomes)
genomes[1:2]

## -----------------------------------------------------------------------------
# load the reference genome and the transcript annotation database
refGenome <- BSgenome.Hsapiens.UCSC.hg19::BSgenome.Hsapiens.UCSC.hg19
transcriptAnno <-
           TxDb.Hsapiens.UCSC.hg19.knownGene::TxDb.Hsapiens.UCSC.hg19.knownGene

# take the six breast cancer genomes from Nik-Zainal et al (PMID: 22608084) 
gfile <- system.file("extdata", "Nik-Zainal_PMID_22608084-MPF.txt.gz", 
                     package="decompTumor2Sig")

# read the cancer genomes in MPF format
genomes <- readGenomesFromMPF(gfile, numBases=5, type="Shiraishi",
                              trDir=TRUE, refGenome=refGenome,
                              transcriptAnno=transcriptAnno, verbose=FALSE)

## -----------------------------------------------------------------------------
# get breast cancer genomes from Nik-Zainal et al (PMID: 22608084) 
# in the format produced by pmsignature (PMID: 26630308)
pmsigdata <- system.file("extdata", 
                         "Nik-Zainal_PMID_22608084-pmsignature-G.Rdata", 
                         package="decompTumor2Sig")
load(pmsigdata)

# extract the genomes from the pmsignature 'G' object
genomes <- getGenomesFromMutFeatData(G, normalize=TRUE)
genomes[1]

## ----message=FALSE------------------------------------------------------------
# load the reference genome and the transcript annotation database
refGenome <- BSgenome.Hsapiens.UCSC.hg19::BSgenome.Hsapiens.UCSC.hg19
transcriptAnno <-
           TxDb.Hsapiens.UCSC.hg19.knownGene::TxDb.Hsapiens.UCSC.hg19.knownGene

# take six breast cancer genomes from Nik-Zainal et al (PMID: 22608084) 
gfile <- system.file("extdata",
                     "Nik-Zainal_PMID_22608084-VCF-convertedfromMPF.vcf.gz", 
                     package="decompTumor2Sig")

# get the corresponding VRanges object (using the VariantAnnotation package)
library(VariantAnnotation)
vr <- readVcfAsVRanges(gfile, genome="hg19")

# convert the VRanges object to the decompTumor2Sig format
genomes <- convertGenomesFromVRanges(vr, numBases=5, type="Shiraishi",
                                     trDir=TRUE, refGenome=refGenome,
                                     transcriptAnno=transcriptAnno,
                                     verbose=FALSE)

## -----------------------------------------------------------------------------
signatures <- readAlexandrovSignatures()
plotMutationDistribution(signatures[[1]])

## -----------------------------------------------------------------------------
sigfiles <- system.file("extdata",
                 paste0("Nik-Zainal_PMID_22608084-pmsignature-sig",1:4,".tsv"), 
                 package="decompTumor2Sig")
signatures <- readShiraishiSignatures(files=sigfiles)

plotMutationDistribution(signatures[[1]])

## ----echo=FALSE---------------------------------------------------------------
include_graphics("example-sign-Shiraishi.png")

## -----------------------------------------------------------------------------
refGenome <- BSgenome.Hsapiens.UCSC.hg19::BSgenome.Hsapiens.UCSC.hg19
gfile <- system.file("extdata",
                     "Nik-Zainal_PMID_22608084-VCF-convertedfromMPF.vcf.gz", 
                     package="decompTumor2Sig")
genomes <- readGenomesFromVCF(gfile, numBases=3, type="Alexandrov",
         trDir=FALSE, refGenome=refGenome, verbose=FALSE)

plotMutationDistribution(genomes[[1]])

## -----------------------------------------------------------------------------
# load the 15 Shiraishi signatures obtained from 
# 435 tumor genomes from Alexandrov et al.
sfile <- system.file("extdata",
              "Alexandrov_PMID_23945592_435_tumors-pmsignature-15sig.Rdata", 
              package="decompTumor2Sig")
load(sfile)
length(signatures)
signatures[1]

## -----------------------------------------------------------------------------
# load the reference genome and the transcript annotation database
refGenome <- BSgenome.Hsapiens.UCSC.hg19::BSgenome.Hsapiens.UCSC.hg19
transcriptAnno <-
           TxDb.Hsapiens.UCSC.hg19.knownGene::TxDb.Hsapiens.UCSC.hg19.knownGene

# take six breast cancer genomes from Nik-Zainal et al (PMID: 22608084) 
gfile <- system.file("extdata",
                     "Nik-Zainal_PMID_22608084-VCF-convertedfromMPF.vcf.gz", 
                     package="decompTumor2Sig")

# read the cancer genomes in VCF format
genomes <- readGenomesFromVCF(gfile, numBases=5, type="Shiraishi",
                              trDir=TRUE, refGenome=refGenome,
                              transcriptAnno=transcriptAnno, verbose=FALSE)

## ----fig.asp=1----------------------------------------------------------------
plotExplainedVariance(genomes[[1]], signatures, minExplainedVariance=0.9,
                                    minNumSignatures=2, maxNumSignatures=NULL,
                                    greedySearch=TRUE)

## -----------------------------------------------------------------------------
exposure <- decomposeTumorGenomes(genomes[1], signatures)

## -----------------------------------------------------------------------------
exposure

## ----message=FALSE, warning=FALSE, fig.asp=1----------------------------------
plotDecomposedContribution(exposure)

## -----------------------------------------------------------------------------
exposures <- decomposeTumorGenomes(genomes, signatures)
length(exposures)
exposures[1:2]

## -----------------------------------------------------------------------------
isExposureSet(exposures)

## -----------------------------------------------------------------------------
exposures <- decomposeTumorGenomes(genomes[1], signatures,
                                   minExplainedVariance=0.9,
                                   minNumSignatures=2, maxNumSignatures=NULL,
                                   greedySearch=FALSE, verbose=TRUE)

## -----------------------------------------------------------------------------
exposures

## ----fig.asp=1----------------------------------------------------------------
plotDecomposedContribution(exposures[[1]])

## ----fig.asp=1----------------------------------------------------------------
exposures <- decomposeTumorGenomes(genomes[1], signatures,
                                   minExplainedVariance=0.95,
                                   minNumSignatures=2, maxNumSignatures=NULL,
                                   greedySearch=TRUE, verbose=TRUE)

exposures

plotDecomposedContribution(exposures[[1]])

## ----echo=FALSE---------------------------------------------------------------
# load the reference genome and the transcript annotation database
refGenome <- BSgenome.Hsapiens.UCSC.hg19::BSgenome.Hsapiens.UCSC.hg19
transcriptAnno <-
           TxDb.Hsapiens.UCSC.hg19.knownGene::TxDb.Hsapiens.UCSC.hg19.knownGene

# take the 15 Shiraishi signatures obtained from
# 435 tumor genomes from Alexandrov et al.
sfile <- system.file("extdata",
              "Alexandrov_PMID_23945592_435_tumors-pmsignature-15sig.Rdata", 
              package="decompTumor2Sig")
load(sfile)

gfile <- system.file("extdata",
              "Nik-Zainal_PMID_22608084-VCF-convertedfromMPF.vcf.gz", 
              package="decompTumor2Sig")

# read the cancer genomes in VCF format
genomes <- readGenomesFromVCF(gfile, numBases=5, type="Shiraishi",
                              trDir=TRUE, refGenome=refGenome,
                              transcriptAnno=transcriptAnno, verbose=FALSE)

## -----------------------------------------------------------------------------
exposures <- decomposeTumorGenomes(genomes, signatures)
computeExplainedVariance(exposures, signatures, genomes)

## -----------------------------------------------------------------------------
genomes_predicted <- composeGenomesFromExposures(exposures, signatures)
genomes_predicted[1:2]

## -----------------------------------------------------------------------------
evaluateDecompositionQuality(exposures[[1]], signatures,
                             genomes[[1]], plot=FALSE)

## ----fig.asp=1----------------------------------------------------------------
evaluateDecompositionQuality(exposures[[1]], signatures,
                             genomes[[1]], plot=TRUE)

## -----------------------------------------------------------------------------
# get 4 Shiraishi signatures from 21 breast cancers from
# Nik-Zainal et al (PMID: 22608084)
sigfiles <- system.file("extdata",
                 paste0("Nik-Zainal_PMID_22608084-pmsignature-sig",1:4,".tsv"), 
                 package="decompTumor2Sig")
sign_s4 <- readShiraishiSignatures(files=sigfiles)


# get 15 Shiraishi signatures obtained from
# 435 tumor genomes from Alexandrov et al.
sfile <- system.file("extdata",
              "Alexandrov_PMID_23945592_435_tumors-pmsignature-15sig.Rdata", 
              package="decompTumor2Sig")
load(sfile)
sign_s15 <- signatures

## -----------------------------------------------------------------------------
determineSignatureDistances(fromSignature=sign_s4[[1]], toSignatures=sign_s15,
                            method="frobenius")

## -----------------------------------------------------------------------------
mapSignatureSets(fromSignatures=sign_s4, toSignatures=sign_s15,
                 method="frobenius", unique=FALSE)

## ----message=FALSE, warning=FALSE---------------------------------------------
sign_a <- readAlexandrovSignatures()
sign_a2s <- convertAlexandrov2Shiraishi(sign_a)

## -----------------------------------------------------------------------------
sign_sdown <- downgradeShiraishiSignatures(sign_s15, numBases=3,
                                           removeTrDir=TRUE)
sign_s15[1]
sign_sdown[1]

## -----------------------------------------------------------------------------
mapSignatureSets(fromSignatures=sign_sdown, toSignatures=sign_a2s,
                 method="frobenius", unique=TRUE)

#' Convert Alexandrov-type signatures to Shiraishi signatures
#'
#' `convertAlexandrov2Shiraishi()` converts a set Alexandrov signatures to the
#' Shiraishi model, summing the respective frequencies of base
#' changes, and upstream and downstream flanking bases. In most cases, the
#' resulting Shiraishi signatures don't provide information on the
#' transcription strand, as this is not part of the standard Alexandrov
#' signatures. While the conversion is mainly thought for signatures, it
#' actually works also for mutation frequency data from genomes which have
#' the same format. [Attention: this conversion entails a loss of specificity
#' and the applicability of Shiraishi signatures derived from Alexandrov
#' signatures has not been extensively explored!]
#'
#' @usage convertAlexandrov2Shiraishi(signatures)
#' @param signatures (Mandatory) A list of Alexandrov signatures with named
#' elements as produced by \code{readAlexandrovSignatures}.
#' @return A list of Shiraishi signatures that can be used for
#' \code{decomposeTumorGenomes}.
#' @author Rosario M. Piro\cr Politecnico di Milano\cr Maintainer: Rosario
#' M. Piro\cr E-Mail: <rmpiro@@gmail.com> or <rosariomichael.piro@@polimi.it>
#' @references \url{http://rmpiro.net/decompTumor2Sig/}\cr
#' Krueger, Piro (2019) decompTumor2Sig: Identification of mutational
#' signatures active in individual tumors. BMC Bioinformatics 
#' 20(Suppl 4):152.\cr
#' @seealso \code{\link{decompTumor2Sig}}\cr
#' \code{\link{readAlexandrovSignatures}}\cr
#' \code{\link{readShiraishiSignatures}}
#' @examples
#' 
#' ### get Alexandrov signatures from COSMIC
#' signAlexandrov <- readAlexandrovSignatures()
#' 
#' ### convert them to the Shiraishi model
#' signShiraishi <- convertAlexandrov2Shiraishi(signAlexandrov)
#' 
#' @export convertAlexandrov2Shiraishi
convertAlexandrov2Shiraishi <- function(signatures) {

    if (is.probability.vector(signatures)) {
        # if the user specified a single signature, make it a list
        signatures <- list(signatures)
    }

    if (!isAlexandrovSet(signatures)) {
        stop(paste("Parameter signatures must be a set (list) of Alexandrov",
                   "signatures."))
    }

    shSignatures <- lapply(signatures, convAlx2Shi)

    return(shSignatures)
}

### helper functions for checking classes ###

######################
# internal functions #
######################

#' is.probability.vector (internal function)
#'
#' `is.probability.vector()` checks whether the input object is a numeric
#' vector of probabilities with a total sum of 1.
#' 
#' @param x Object to be checked.
#' @return Logical value (true or false).
#' @author Rosario M. Piro\cr Politecnico di Milano\cr Maintainer: Rosario
#' M. Piro\cr E-Mail: <rmpiro@@gmail.com> or <rosariomichael.piro@@polimi.it>
#' @references \url{http://rmpiro.net/decompTumor2Sig/}\cr
#' Krueger, Piro (2019) decompTumor2Sig: Identification of mutational
#' signatures active in individual tumors. BMC Bioinformatics
#' 20(Suppl 4):152.\cr
#' @keywords internal
is.probability.vector <- function(x) {
    if (is.vector(x) & is.numeric(x)) {
        return(isTRUE(all.equal.numeric(sum(x, na.rm=TRUE),
                                        tolerance=1e-5, 1)) &
                   all(x>=0 & x<=1, na.rm=TRUE))
    }

    return(FALSE) # not even a numeric vector
}


#' is.probability.matrix (internal function)
#'
#' `is.probability.matrix()` checks whether the input object is a numeric
#' matrix of probabilities with a total sum of 1 for every row. Each row
#' must have 6 columns (for Shiraishi format).
#' 
#' @param x Object to be checked.
#' @return Logical value (true or false).
#' @author Rosario M. Piro\cr Politecnico di Milano\cr Maintainer: Rosario
#' M. Piro\cr E-Mail: <rmpiro@@gmail.com> or <rosariomichael.piro@@polimi.it>
#' @references \url{http://rmpiro.net/decompTumor2Sig/}\cr
#' Krueger, Piro (2019) decompTumor2Sig: Identification of mutational
#' signatures active in individual tumors. BMC Bioinformatics
#' 20(Suppl 4):152.\cr
#' @keywords internal
is.probability.matrix <- function(x) {
    if(is.matrix(x) & is.numeric(x)) {
        if(ncol(x)==6) {
            return(all(apply(x, 1, is.probability.vector)))
        }
    }

    return(FALSE) # not even a numeric matrix
}


#' is.probability.data.frame (internal function)
#'
#' `is.probability.data.frame()` checks whether the input object is a numeric
#' data.frame of probabilities with a total sum of 1 for every row. Each row
#' must have 6 columns (for Shiraishi format).
#' 
#' @param x Object to be checked.
#' @return Logical value (true or false).
#' @author Rosario M. Piro\cr Politecnico di Milano\cr Maintainer: Rosario
#' M. Piro\cr E-Mail: <rmpiro@@gmail.com> or <rosariomichael.piro@@polimi.it>
#' @references \url{http://rmpiro.net/decompTumor2Sig/}\cr
#' Krueger, Piro (2019) decompTumor2Sig: Identification of mutational
#' signatures active in individual tumors. BMC Bioinformatics
#' 20(Suppl 4):152.\cr
#' @keywords internal
is.probability.data.frame <- function(x) {
    if(is.data.frame(x)) {
        if(all(apply(x, 1, is.numeric)) & ncol(x)==6) {
            return(all(apply(x, 1, function(r) {
                is.probability.vector(as.numeric(r))
            })))
        }
    }
    
    return(FALSE)  # not even a numeric data.frame
}


#' is.probability.object (internal function)
#'
#' `is.probability.object()` checks whether the input object is a numeric
#' vector, matrix of data.frame of probabilities with a total sum of 1 for
#' every row. Matrices and data.frames must have 6 columns (for Shiraishi
#' format).
#' 
#' @param x Object to be checked.
#' @return Logical value (true or false).
#' @author Rosario M. Piro\cr Politecnico di Milano\cr Maintainer: Rosario
#' M. Piro\cr E-Mail: <rmpiro@@gmail.com> or <rosariomichael.piro@@polimi.it>
#' @references \url{http://rmpiro.net/decompTumor2Sig/}\cr
#' Krueger, Piro (2019) decompTumor2Sig: Identification of mutational
#' signatures active in individual tumors. BMC Bioinformatics
#' 20(Suppl 4):152.\cr
#' @keywords internal
is.probability.object <- function(x) {
    return(is.probability.vector(x) ||
               is.probability.matrix(x) ||
                   is.probability.data.frame(x))
}



#' is.probability.vector.list (internal function)
#'
#' `is.probability.vector.list()` checks whether the input object is a list of
#' numeric vectors.
#' 
#' @param x Object to be checked.
#' @return Logical value (true or false).
#' @author Rosario M. Piro\cr Politecnico di Milano\cr Maintainer: Rosario
#' M. Piro\cr E-Mail: <rmpiro@@gmail.com> or <rosariomichael.piro@@polimi.it>
#' @references \url{http://rmpiro.net/decompTumor2Sig/}\cr
#' Krueger, Piro (2019) decompTumor2Sig: Identification of mutational
#' signatures active in individual tumors. BMC Bioinformatics
#' 20(Suppl 4):152.\cr
#' @importFrom plyr compact 
#' @keywords internal
is.probability.vector.list <- function(x) {
    if (is.list(x)) {
        x <- compact(x)  # exclude NULL elements from check (can happen
                         # for exposures when the min. explained variance
                         # was not reached!
        return(all(vapply(x, is.probability.vector, FUN.VALUE=logical(1))))
    }

    return(FALSE) # if not even a list ...
}


#' is.probability.matrix.list (internal function)
#'
#' `is.probability.matrix.list()` checks whether the input object is a list of
#' numeric matrices. Must have 6 columns (for Shiraishi format).
#' 
#' @param x Object to be checked.
#' @return Logical value (true or false).
#' @author Rosario M. Piro\cr Politecnico di Milano\cr Maintainer: Rosario
#' M. Piro\cr E-Mail: <rmpiro@@gmail.com> or <rosariomichael.piro@@polimi.it>
#' @references \url{http://rmpiro.net/decompTumor2Sig/}\cr
#' Krueger, Piro (2019) decompTumor2Sig: Identification of mutational
#' signatures active in individual tumors. BMC Bioinformatics
#' 20(Suppl 4):152.\cr
#' @importFrom plyr compact 
#' @keywords internal
is.probability.matrix.list <- function(x) {
    if (is.list(x)) {
        x <- compact(x)  # exclude NULL elements from check (can happen
                         # for exposures when the min. explained variance
                         # was not reached!
        return(all(vapply(x, is.probability.matrix, FUN.VALUE=logical(1))))
    }

    return(FALSE) # if not even a list ...
}

#' is.probability.data.frame.list (internal function)
#'
#' `is.probability.data.frame.list()` checks whether the input object is a
#' list of numeric data.frame objects. Must have 6 columns (for Shiraishi
#' format).
#' 
#' @param x Object to be checked.
#' @return Logical value (true or false).
#' @author Rosario M. Piro\cr Politecnico di Milano\cr Maintainer: Rosario
#' M. Piro\cr E-Mail: <rmpiro@@gmail.com> or <rosariomichael.piro@@polimi.it>
#' @references \url{http://rmpiro.net/decompTumor2Sig/}\cr
#' Krueger, Piro (2019) decompTumor2Sig: Identification of mutational
#' signatures active in individual tumors. BMC Bioinformatics
#' 20(Suppl 4):152.\cr
#' @importFrom plyr compact 
#' @keywords internal
is.probability.data.frame.list <- function(x) {
    if (is.list(x)) {
        x <- compact(x)  # exclude NULL elements from check (can happen
                         # for exposures when the min. explained variance
                         # was not reached!
        return(all(vapply(x, is.probability.data.frame, FUN.VALUE=logical(1))))
    }

    return(FALSE) # if not even a list ...
}


######################
# external functions #
######################

#' isShiraishiSet
#'
#' `isShiraishiSet()` checks whether the input object is a set (list) of
#' numeric objects compatible with the Shiraishi format (matrices or
#' data.frames of probabilities; 6 columns, each row sums up to 1). NOTE:
#' These can also be genomes compatible with the Shiraishi format!
#' 
#' @param x Object to be checked.
#' @return Logical value (true or false).
#' @author Rosario M. Piro\cr Politecnico di Milano\cr Maintainer: Rosario
#' M. Piro\cr E-Mail: <rmpiro@@gmail.com> or <rosariomichael.piro@@polimi.it>
#' @references \url{http://rmpiro.net/decompTumor2Sig/}\cr
#' Krueger, Piro (2019) decompTumor2Sig: Identification of mutational
#' signatures active in individual tumors. BMC Bioinformatics
#' 20(Suppl 4):152.\cr
#' @seealso \code{\link{decompTumor2Sig}}\cr
#' \code{\link{isSignatureSet}}\cr
#' \code{\link{readShiraishiSignatures}}
#' @examples
#' 
#' ### get Alexandrov signatures from COSMIC
#' signAlexandrov <- readAlexandrovSignatures()
#' 
#' ### convert them to the Shiraishi model
#' signShiraishi <- convertAlexandrov2Shiraishi(signAlexandrov)
#'
#' isShiraishiSet(signShiraishi)
#' @export isShiraishiSet
isShiraishiSet <- function(x) {
    return(is.probability.matrix.list(x) || is.probability.data.frame.list(x))
}


#' isAlexandrovSet
#'
#' `isAlexandrovSet()` checks whether the input object is a set (list) of
#' numeric objects compatible with the Alexandrov format (probability vectors;
#' sum up to 1). NOTE: These can also be genomes compatible with the
#' Alexandrov format!
#' 
#' @param x Object to be checked.
#' @return Logical value (true or false).
#' @author Rosario M. Piro\cr Politecnico di Milano\cr Maintainer: Rosario
#' M. Piro\cr E-Mail: <rmpiro@@gmail.com> or <rosariomichael.piro@@polimi.it>
#' @references \url{http://rmpiro.net/decompTumor2Sig/}\cr
#' Krueger, Piro (2019) decompTumor2Sig: Identification of mutational
#' signatures active in individual tumors. BMC Bioinformatics
#' 20(Suppl 4):152.\cr
#' @seealso \code{\link{decompTumor2Sig}}\cr
#' \code{\link{readAlexandrovSignatures}}\cr
#' \code{\link{isSignatureSet}}
#' @examples
#' 
#' ### get Alexandrov signatures from COSMIC
#' signAlexandrov <- readAlexandrovSignatures()
#' 
#' isAlexandrovSet(signAlexandrov)
#' @export isAlexandrovSet
isAlexandrovSet <- function(x) {
    return(is.probability.vector.list(x))
}


#' isSignatureSet
#'
#' `isSignatureSet()` checks whether the input object is a set (list) of
#' numeric objects compatible with either the Alexandrov format (probability
#' vectors; see \code{isAlexandrovSet}) or the Shiraishi format (matrices or
#' data.frames of probabilities; see \code{isShiraishiSet}).
#' NOTE: These can also be genomes compatible with one of the two formats!
#' 
#' @param x Object to be checked.
#' @return Logical value (true or false).
#' @author Rosario M. Piro\cr Politecnico di Milano\cr Maintainer: Rosario
#' M. Piro\cr E-Mail: <rmpiro@@gmail.com> or <rosariomichael.piro@@polimi.it>
#' @references \url{http://rmpiro.net/decompTumor2Sig/}\cr
#' Krueger, Piro (2019) decompTumor2Sig: Identification of mutational
#' signatures active in individual tumors. BMC Bioinformatics
#' 20(Suppl 4):152.\cr
#' @seealso \code{\link{decompTumor2Sig}}\cr
#' \code{\link{isAlexandrovSet}}\cr
#' \code{\link{isShiraishiSet}}
#' @examples
#' 
#' ### get Alexandrov signatures from COSMIC
#' signAlexandrov <- readAlexandrovSignatures()
#' 
#' isSignatureSet(signAlexandrov)
#' @export isSignatureSet
isSignatureSet <- function(x) {
    return(isShiraishiSet(x) || isAlexandrovSet(x))
}


#' isExposureSet
#'
#' `isExposureSet()` checks whether the input object is a set (list) of
#' numeric objects compatible with exposure output obtained from
#' \code{decomposeTumorGenomes}.
#' 
#' @param x Object to be checked.
#' @return Logical value (true or false).
#' @author Rosario M. Piro\cr Politecnico di Milano\cr Maintainer: Rosario
#' M. Piro\cr E-Mail: <rmpiro@@gmail.com> or <rosariomichael.piro@@polimi.it>
#' @references \url{http://rmpiro.net/decompTumor2Sig/}\cr
#' Krueger, Piro (2019) decompTumor2Sig: Identification of mutational
#' signatures active in individual tumors. BMC Bioinformatics
#' 20(Suppl 4):152.\cr
#' @seealso \code{\link{decompTumor2Sig}}\cr
#' \code{\link{decomposeTumorGenomes}}
#' @examples
#' 
#' ### get Alexandrov signatures from COSMIC
#' signatures <- readAlexandrovSignatures()
#' 
#' ### load reference genome
#' refGenome <- BSgenome.Hsapiens.UCSC.hg19::BSgenome.Hsapiens.UCSC.hg19
#' 
#' ### read breast cancer genomes from Nik-Zainal et al (PMID: 22608084) 
#' gfile <- system.file("extdata",
#'          "Nik-Zainal_PMID_22608084-VCF-convertedfromMPF.vcf.gz", 
#'          package="decompTumor2Sig")
#' genomes <- readGenomesFromVCF(gfile, numBases=3, type="Alexandrov",
#'          trDir=FALSE, refGenome=refGenome, verbose=FALSE)
#' 
#' ### compute exposures
#' exposures <- decomposeTumorGenomes(genomes, signatures, verbose=FALSE)
#' 
#' isExposureSet(exposures)
#' @export isExposureSet
isExposureSet <- function(x) {
    return(is.probability.vector.list(x))
}


#' sameSignatureFormat
#'
#' `sameSignatureFormat()` checks whether two input object are sets (lists) of
#' numeric objects both compatible with the same signature format (probability
#' vectors for Alexandrov signatures and probability matrices or data.frames
#' for Shiraishi signatures). For Shiraishi signatures also the number of
#' flanking bases and the presence of transcription-strand information are
#' compared. For Alexandrov signatures also the number of triplet changes are
#' compared.
#' 
#' @param x First object to be checked.
#' @param y Second object to be checked.
#' @return Logical value (true or false).
#' @author Rosario M. Piro\cr Politecnico di Milano\cr Maintainer: Rosario
#' M. Piro\cr E-Mail: <rmpiro@@gmail.com> or <rosariomichael.piro@@polimi.it>
#' @references \url{http://rmpiro.net/decompTumor2Sig/}\cr
#' Krueger, Piro (2019) decompTumor2Sig: Identification of mutational
#' signatures active in individual tumors. BMC Bioinformatics
#' 20(Suppl 4):152.\cr
#' @seealso \code{\link{decompTumor2Sig}}\cr
#' \code{\link{isAlexandrovSet}}\cr
#' \code{\link{isShiraishiSet}}
#' @examples
#' 
#' ### get Alexandrov signatures from COSMIC
#' signAlexandrov <- readAlexandrovSignatures()
#' 
#' ### convert them to the Shiraishi model
#' signShiraishi <- convertAlexandrov2Shiraishi(signAlexandrov)
#'
#' sameSignatureFormat(signAlexandrov, signShiraishi)
#' @export sameSignatureFormat
sameSignatureFormat <- function(x, y) {
    
    if (isAlexandrovSet(x) & isAlexandrovSet(y)) {
        if (length(x[[1]]) == length(y[[1]])) {
            return(TRUE)
        }
    } else if (isShiraishiSet(x) & isShiraishiSet(y)) {
        if (nrow(x[[1]]) == nrow(y[[1]])) {
            return(TRUE)
        }
    }
    
    return(FALSE)
}

#' Plot mutation frequency data of a mutational signature or tumor genome.
#'
#' `plotMutationDistribution()` plots a single signature or the mutation
#' frequency data for a single genome. This works for signatures or genome
#' data of both the Shiraishi and the Alexandrov type.
#'
#' @usage plotMutationDistribution(mutData, colors = NULL, strip = NULL)
#' @param mutData (Mandatory) The signature or genome mutation frequency data
#' to be plotted. This can either be a matrix (Shiraishi model) or a
#' numeric vector (Alexandrov model).
#' @param colors Vector of colors to be used for the base change data. For
#' Alexandrov-type data, this vector must contain six elements (one per base
#' change). For Shiraishi-type data, this vector must contain four elements
#' (one per base). If \code{NULL} (default), for Alexandrov-type data, the
#' colors are set to those used by the COSMIC website; for Shiraishi-type
#' data, the consensus base colors for sequence logos will be used.
#' @param strip Background color for strip labels; used only for
#' Alexandrov-type data. If \code{NULL} (default), "papayawhip" will be used.
#' @return Returns (or draws) a plot according to the Alexandrov or Shiraishi
#' model of mutational signatures.
#' @author Rosario M. Piro\cr Politecnico di Milano\cr Maintainer: Rosario
#' M. Piro\cr E-Mail: <rmpiro@@gmail.com> or <rosariomichael.piro@@polimi.it>
#' @references \url{http://rmpiro.net/decompTumor2Sig/}\cr
#' Krueger, Piro (2019) decompTumor2Sig: Identification of mutational
#' signatures active in individual tumors. BMC Bioinformatics
#' 20(Suppl 4):152.\cr
#' @seealso \code{\link{decompTumor2Sig}}
#' @examples
#' 
#' ### Attention: using plotMutationDistribution requires the package
#' ### pmsignature to be installed!
#' 
#' 
#' ### get Alexandrov signatures from COSMIC
#' signatures <- readAlexandrovSignatures()
#' 
#' ### plot the first Alexandrov signature
#' plotMutationDistribution(signatures[[1]])
#' 
#' ### read four Shiraishi signatures for breast cancer genomes from 
#' ### Nik-Zainal et al (PMID: 22608084) from flat files
#' sigfiles <- system.file("extdata",
#'          paste0("Nik-Zainal_PMID_22608084-pmsignature-sig",1:4,".tsv"),
#'          package="decompTumor2Sig")
#' signatures <- readShiraishiSignatures(sigfiles)
#' 
#' ### plot the first Shiraishi signature
#' plotMutationDistribution(signatures[[1]])
#' 
#' @importFrom methods new
#' @export plotMutationDistribution
plotMutationDistribution <- function(mutData, colors = NULL, strip = NULL) {

    if (isSignatureSet(mutData)) {
        if (length(mutData) > 1) {
            warning(paste("object 'mutData' passed to plotMutationDistribution",
                          "is a list with multiple elements. Taking only the",
                          "first element and trying to plot it"))
        }
        
        mutData <- mutData[[1]]  # take first object from list
    }

    if (!is.probability.object(mutData)) {
        stop("'mutData' must be a single genome or signature!")
    }

    
    # try to determine the signature model, the number of bases, and
    # whether the transcription direction was considered
    dataFeatures <- determineTypeNumBasesAndTrDir(mutData)
    if (is.null(dataFeatures$type)) {
        stop(paste("Object 'mutData' must be a single Shiraishi- or",
                   "Alexandrov signature!"))
    }

    sigType <- dataFeatures$type
    numBases <- dataFeatures$numBases
    trDir <- dataFeatures$trDir
    
    if(sigType == "Shiraishi") {
        # Shiraishi-type

        plotShiraishiModel(mutData, numBases, trDir, colors)
        
    } else if (sigType == "Alexandrov") {
        # Alexandrov-type

        plotAlexandrovModel(mutData, numBases, trDir, colors, strip)
    }

}

#' Plot the explained variance as a function of the number of signatures
#'
#' `plotExplainedVariance()` plots the explained variance of a single tumor
#' genome's mutation patterns as a function of the number of signatures
#' (increasing subsets of signatures) used for decomposition. For each
#' number K of signatures, the highest variance explained by possible
#' subsets of K signatures will be plotted (full or greedy search, see below).
#' This can help to evaluate what minimum threshold for the explained variance
#' can be used to decompose tumor genomes with the function
#' \code{decomposeTumorGenomes}.
#'
#' @usage plotExplainedVariance(genome, signatures, minExplainedVariance=NULL,
#' minNumSignatures=2, maxNumSignatures=NULL, greedySearch=FALSE)
#' @param genome (Mandatory) The mutation load of a single genome in
#' Alexandrov- of Shiraishi-format, i.e. as vector or matrix. The format
#' must be the same as the one used for the \code{signatures} (see below).
#' @param signatures (Mandatory) The list of signatures (vectors,
#' data frames or matrices) which are to be evaluated. Each of the list
#' objects represents one mutational signature. Vectors are used for
#' Alexandrov signatures, data frames or matrices for Shiraishi signatures.
#' @param minExplainedVariance (Optional) If a numeric value between 0 and 1
#' is specified, the plot highlights the smallest subset of signatures which
#' is sufficient to explain at least the specified fraction of the variance
#' of the genome's mutation patterns. If, for example,
#' \code{minExplainedVariance} is 0.99 the smallest subset of signatures
#' that explains at least 99\% of the variance will be highlighted.
#' @param minNumSignatures (Optional) The plot will be generated only for
#' K>=\code{minNumSignatures}. 
#' @param maxNumSignatures (Optional) The plot will be generated only for
#' K<=\code{maxNumSignatures}. 
#' @param greedySearch (Optional) If \code{greedySearch} is set to \code{TRUE}
#' then not all possible combinations of \code{minNumSignatures} to
#' \code{maxNumSignatures} signatures will be checked. Instead, first all
#' possible combinations for exactly \code{minNumSignatures} will be checked
#' to select the best starting set, then iteratively the next best signature
#' will be added (maximum increase in explained variability) until
#' \code{maxNumSignatures} is reached). NOTE: while this is only an
#' approximation, it is highly recommended for large sets of signatures (>15)!
#' @return Returns (or draws) a plot of the explained variance as a function
#' of the number of signatures.
#' @author Rosario M. Piro\cr Politecnico di Milano\cr Maintainer: Rosario
#' M. Piro\cr E-Mail: <rmpiro@@gmail.com> or <rosariomichael.piro@@polimi.it>
#' @references \url{http://rmpiro.net/decompTumor2Sig/}\cr
#' Krueger, Piro (2019) decompTumor2Sig: Identification of mutational
#' signatures active in individual tumors. BMC Bioinformatics
#' 20(Suppl 4):152.\cr
#' @seealso \code{\link{decompTumor2Sig}}\cr
#' \code{\link{decomposeTumorGenomes}}\cr
#' \code{\link{computeExplainedVariance}}
#' @examples
#' 
#' ### get 15 pre-processed Shiraishi signatures computed (object 'signatures') 
#' ### from 435 tumor genomes Alexandrov et al (PMID: 23945592)
#' ### using the pmsignature package
#' sfile <- system.file("extdata",
#'          "Alexandrov_PMID_23945592_435_tumors-pmsignature-15sig.Rdata", 
#'          package="decompTumor2Sig")
#' load(sfile)
#' 
#' ### load preprocessed breast cancer genomes (object 'genomes') from
#' ### Nik-Zainal et al (PMID: 22608084) 
#' gfile <- system.file("extdata",
#'          "Nik-Zainal_PMID_22608084-genomes-Shiraishi_5bases_trDir.Rdata", 
#'          package="decompTumor2Sig")
#' load(gfile)
#' 
#' ### plot the explained variance for 2 to 6 signatures of the first genome
#' plotExplainedVariance(genomes[[1]], signatures,
#'          minExplainedVariance=0.98, minNumSignatures=2, maxNumSignatures=6)
#' 
#' @importFrom graphics abline plot points text
#' @export plotExplainedVariance
plotExplainedVariance <- function(genome, signatures,
                                  minExplainedVariance=NULL,
                                  minNumSignatures=2, maxNumSignatures=NULL,
                                  greedySearch=FALSE) {
    # input: gnome = mutation counts for a single genome as matrix or vector
    #        signatures = a list of signatures (matrices or vectors)
    #        [need to have the same format]

    if (!isSignatureSet(signatures)) {
        stop("Parameter 'signatures' must be a set (list) of signatures!")
    }

    if (isSignatureSet(genome)) { # it's a list of genomes
        if (length(genome) == 1) {  # accept if only one!
            genome <- genome[[1]]
        } else { # more than one genome
            stop(paste("plotExplainedVariance can plot the explained",
                       "variance for only one genome!"))
        }
    }

    if (!is.probability.object(genome)) {
        stop("'genome' must be a genome in Alexandrov or Shiraishi format!")
    }


    # check the genome format; same as signature format?
    if (!sameSignatureFormat(list(genome), signatures)) {
        stop("Formats of genome and signatures must match!")
    }

    # is the signatures are unnamed, name them by enumerating them
    if(is.null(names(signatures))) {
        names(signatures) <- paste0("sign_",seq_along(signatures))
    }

    # if maximum number of signatures is not defined, set it to the total
    # number of signatures
    if(is.null(maxNumSignatures)) {
        maxNumSignatures <- length(signatures)
    }

    # greedySearch must be logical
    if (!is.logical(greedySearch)) {
         stop("greedySearch must be logical (TRUE or FALSE)!")
    }


    bestDecompositions <- list()
    
    # iterating for all possible numbers of signatures from minNumSignatures
    # to maxNumSignatures

    if(!greedySearch) {
        # not greedy; test ALL combinations

        for (k in seq(minNumSignatures,maxNumSignatures)) {
    
            bestDecompositions[[length(bestDecompositions)+1]] <-
                getBestDecomp4Ksignatures(genome, signatures, k)
        }
    } else {
        # greedy; test all combinations of minNumSignatures, then increase

        k <- minNumSignatures

        bestDecompositions[[length(bestDecompositions)+1]] <-
            getBestDecomp4Ksignatures(genome, signatures, k)

        while(k < maxNumSignatures) {
            # need to add another signature

            haveSubset <-
                bestDecompositions[[length(bestDecompositions)]]$sigList

            bestDecompositions[[length(bestDecompositions)+1]] <-
                addBestSignatureToSubset(genome, signatures, haveSubset)

            k <- k + 1
        }
    }

    # now plot: 
    # k on x-axis; 
    # expl. var on y-axis; 
    # min. k with expl. var >= thres in red

    k <- vapply(bestDecompositions, function(x) { x$k }, FUN.VALUE=numeric(1) )
    explVar <- vapply(bestDecompositions, function(x) { x$explVar },
                      FUN.VALUE=numeric(1) )
    sigList <- lapply(bestDecompositions, function(x) { x$sigList } )  # list

    minExplVarIndex <- NULL
    if (!is.null(minExplainedVariance)) {
        whichExceed <- which(explVar >= minExplainedVariance)
        if (length(whichExceed) > 0) {
            minExplVarIndex <- whichExceed[1]  # first to exceed the threshold
        }
    }

    yrange <- c(max(min(explVar),0), 1)
    
    # basic plot
    plot(k, explVar, xlab="number of signatures",
         ylab="highest explained variance", ylim=yrange)
    abline(h=1, lty=2, col="black")
    
    # indicate threshold for minimum explained variance?
    if (!is.null(minExplVarIndex)) {
        
        # indicate desired threshold for explained variance
        abline(h=minExplainedVariance, lty=2, col="red")
        y4Label <- minExplainedVariance - 2*(max(explVar)-min(explVar))/100
        text(c(maxNumSignatures), c(y4Label),
             paste("min. explained variance: ",minExplainedVariance),
             cex=0.6, pos=2, col="red")

        # also highlight the signatures exceeding the threshold
        points(c(k[minExplVarIndex]), c(explVar[minExplVarIndex]), bg="red",
               col="black", pch=21)

        text(c(k[minExplVarIndex]),
             c(min(explVar)+(max(explVar)-min(explVar))/2),
             paste(sigList[[minExplVarIndex]], collapse="\n"), cex=0.6,
             pos=4, col="red")
        
        abline(v=k[minExplVarIndex], lty=3, col="red")
    }
}

#' Plot the decomposition (contributions/exposures) of a tumor genome.
#'
#' `plotDecomposedContribution()` plots the decomposition of a tumor genome,
#' i.e., the contributions/exposures obtained from \code{decomposeTumorGenomes}
#' for a set of signatures.
#'
#' @usage plotDecomposedContribution(decomposition, signatures=NULL,
#' removeNA=TRUE)
#' @param decomposition (Mandatory) A decomposition vector (exposure vector)
#' obtained for a single tumor genome.
#' @param signatures (Optional) A list object containing the signatures used
#' to compute the decomposition. If specified, the signature labels used in
#' the plot will be taken from the element names of the list; otherwise
#' signature names will be taken from the exposure object (decomposition) or
#' named from sign_1 to sign_N.
#' @param removeNA (Optional) If \code{TRUE} (default), signatures with
#' an NA as exposure will not be included on the x-axis of the the plot.
#' Exposures can be NA if they have been determined with a greedy search.
#' @return Returns (or draws) a plot of the decomposed tumor genome (i.e.,
#' contributions of the single signatures). 
#' @author Rosario M. Piro\cr Politecnico di Milano\cr Maintainer: Rosario
#' M. Piro\cr E-Mail: <rmpiro@@gmail.com> or <rosariomichael.piro@@polimi.it>
#' @references \url{http://rmpiro.net/decompTumor2Sig/}\cr
#' Krueger, Piro (2019) decompTumor2Sig: Identification of mutational
#' signatures active in individual tumors. BMC Bioinformatics
#' 20(Suppl 4):152.\cr
#' @seealso \code{\link{decompTumor2Sig}}\cr
#' \code{\link{decomposeTumorGenomes}}
#' @examples
#' 
#' ### get Alexandrov signatures from COSMIC
#' signatures <- readAlexandrovSignatures()
#' 
#' ### load preprocessed breast cancer genomes (object 'genomes') from
#' ### Nik-Zainal et al (PMID: 22608084) 
#' gfile <- system.file("extdata",
#'          "Nik-Zainal_PMID_22608084-genomes-Alexandrov_3bases.Rdata", 
#'          package="decompTumor2Sig")
#' load(gfile)
#' 
#' ### compute exposures
#' exposures <- decomposeTumorGenomes(genomes, signatures, verbose=FALSE)
#' 
#' ### plot signature composition of the first genome
#' plotDecomposedContribution(exposures[[1]], signatures=NULL)
#' 
#' @import ggplot2
#' @importFrom graphics plot text
#' @export plotDecomposedContribution
plotDecomposedContribution <- function(decomposition, signatures=NULL,
                                       removeNA=TRUE) {

    # dummy declarations to avoid NOTEs by R CMD check together with
    # ggplot2 syntax
    Signatures <- NULL
    Exposures <- NULL
    # end of dummy stuff
    
    if (isExposureSet(decomposition)) {
        if (length(decomposition) > 1) {
            warning(paste("object 'decomposition' passed to",
                          "plotDecomposedContribution is a list with multiple",
                          "elements. Taking only the first element and",
                          "trying to plot"))
        }
        
        decomposition <- decomposition[[1]]
    }

    if (!is.probability.vector(decomposition)) {
        stop("'decomposition' must be a single exposure vector!")
    }

    if (!is.null(signatures) & !isSignatureSet(signatures)) {
        stop("'signatures', if specified, must be a set (list) of signatures!")
    }
    
    # determine signature names

    if (!is.null(signatures) && !is.null(names(signatures))) {
        
        # first choice: explicitly specified signatures
        sigNames <- names(signatures)
        
    } else if (!is.null(names(decomposition))) {
        
        # second guess: directly from the exposure vector
        sigNames <- names(decomposition)
      
    } else {
        
        # last solution: just number them
        sigNames <- paste0("sign_", seq_along(decomposition))

    }

    
    if (length(sigNames) != length(decomposition)) {
        # might happen if signatures aren't associated with the exposure vector
        stop(paste("The number of exposures is different from the",
                   "number of signatures!"))
    }


    if(removeNA) {
        # ignore NAs; might be due to a greedy search
        sigNames <- sigNames[!is.na(decomposition)]
        decomposition <- decomposition[!is.na(decomposition)]
    } else {
        decomposition[is.na(decomposition)] <- 0
    }
    
    # construct data frame for exposures
    df <- data.frame(Signatures=factor(sigNames, levels=sigNames),
                     Exposures=decomposition)

    ggplot(data=df, aes(x=Signatures, y=Exposures)) + xlab(NULL) +
        ylab("Exposures (percent contribution)") +
        geom_bar(stat="identity", width=0.75, color="black", fill="steelblue") +
        geom_text(aes(label=round(Exposures,digits=2)), vjust=1.6,
                  color="white", size=2) +
        theme(panel.background = element_rect(fill="white", colour="black"),
              panel.grid.major = element_line(size = 0.25, linetype = 'solid',
                  colour = "lightgray"),
              panel.grid.minor = element_line(size = 0.25, linetype = 'solid',
                  colour = "lightgray"),
              axis.text.x = element_text(face="bold", angle=90, vjust=0.5))

}

######################
# internal functions #
######################


### wrapper functions for reading slot data ###

#' haveTrDir (internal function)
#'
#' `haveTrDir()` extracts the content of the \code{transcriptionDirection} slot
#' (logical value) from a \code{pmsignature::MutationFeatureData} object.
#' 
#' @param x Object from which to get the slot data.
#' @return Slot data.
#' @author Rosario M. Piro\cr Politecnico di Milano\cr Maintainer: Rosario
#' M. Piro\cr E-Mail: <rmpiro@@gmail.com> or <rosariomichael.piro@@polimi.it>
#' @references \url{http://rmpiro.net/decompTumor2Sig/}\cr
#' Krueger, Piro (2019) decompTumor2Sig: Identification of mutational
#' signatures active in individual tumors. BMC Bioinformatics
#' 20(Suppl 4):152.\cr
#' @importFrom methods slot .hasSlot 
#' @keywords internal
haveTrDir <- function(x) {
    stopifnot(.hasSlot(x, "transcriptionDirection"))
    slot(x, "transcriptionDirection")
}

#' getNumFlankingBases (internal function)
#'
#' `getNumFlankingBases()` extracts the content of the \code{flankingBasesNum}
#' slot (numeric value) from a \code{pmsignature::MutationFeatureData} or
#' from a \code{pmsignature::EstimatedParameters} object.
#' 
#' @param x Object from which to get the slot data.
#' @return Slot data.
#' @author Rosario M. Piro\cr Politecnico di Milano\cr Maintainer: Rosario
#' M. Piro\cr E-Mail: <rmpiro@@gmail.com> or <rosariomichael.piro@@polimi.it>
#' @references \url{http://rmpiro.net/decompTumor2Sig/}\cr
#' Krueger, Piro (2019) decompTumor2Sig: Identification of mutational
#' signatures active in individual tumors. BMC Bioinformatics
#' 20(Suppl 4):152.\cr
#' @importFrom methods slot .hasSlot 
#' @keywords internal
getNumFlankingBases <- function(x) {
    stopifnot(.hasSlot(x, "flankingBasesNum"))
    slot(x, "flankingBasesNum")
}

#' getCountData (internal function)
#'
#' `getCountData()` extracts the content of the \code{countData}
#' slot (numeric values) from a \code{pmsignature::MutationFeatureData} object.
#' 
#' @param x Object from which to get the slot data.
#' @return Slot data.
#' @author Rosario M. Piro\cr Politecnico di Milano\cr Maintainer: Rosario
#' M. Piro\cr E-Mail: <rmpiro@@gmail.com> or <rosariomichael.piro@@polimi.it>
#' @references \url{http://rmpiro.net/decompTumor2Sig/}\cr
#' Krueger, Piro (2019) decompTumor2Sig: Identification of mutational
#' signatures active in individual tumors. BMC Bioinformatics
#' 20(Suppl 4):152.\cr
#' @importFrom methods slot .hasSlot 
#' @keywords internal
getCountData <- function(x) {
    stopifnot(.hasSlot(x, "countData"))
    slot(x, "countData")
}

#' getFeatVectList (internal function)
#'
#' `getFeatVectList()` extracts the content of the \code{featureVectorList}
#' slot from a \code{pmsignature::MutationFeatureData} object.
#' 
#' @param x Object from which to get the slot data.
#' @return Slot data.
#' @author Rosario M. Piro\cr Politecnico di Milano\cr Maintainer: Rosario
#' M. Piro\cr E-Mail: <rmpiro@@gmail.com> or <rosariomichael.piro@@polimi.it>
#' @references \url{http://rmpiro.net/decompTumor2Sig/}\cr
#' Krueger, Piro (2019) decompTumor2Sig: Identification of mutational
#' signatures active in individual tumors. BMC Bioinformatics
#' 20(Suppl 4):152.\cr
#' @importFrom methods slot .hasSlot 
#' @keywords internal
getFeatVectList <- function(x) {
    stopifnot(.hasSlot(x, "featureVectorList"))
    slot(x, "featureVectorList")
}

#' getSampleList (internal function)
#'
#' `getSampleList()` extracts the content of the \code{sampleList}
#' slot (strings) from a \code{pmsignature::MutationFeatureData} object.
#' 
#' @param x Object from which to get the slot data.
#' @return Slot data.
#' @author Rosario M. Piro\cr Politecnico di Milano\cr Maintainer: Rosario
#' M. Piro\cr E-Mail: <rmpiro@@gmail.com> or <rosariomichael.piro@@polimi.it>
#' @references \url{http://rmpiro.net/decompTumor2Sig/}\cr
#' Krueger, Piro (2019) decompTumor2Sig: Identification of mutational
#' signatures active in individual tumors. BMC Bioinformatics
#' 20(Suppl 4):152.\cr
#' @importFrom methods slot .hasSlot 
#' @keywords internal
getSampleList <- function(x) {
    stopifnot(.hasSlot(x, "sampleList"))
    slot(x, "sampleList")
}

#' getNumSignatures (internal function)
#'
#' `getNumSignatures()` extracts the content of the \code{signatureNum}
#' slot (numeric value) from a \code{pmsignature::EstimatedParameters} object.
#' 
#' @param x Object from which to get the slot data.
#' @return Slot data.
#' @author Rosario M. Piro\cr Politecnico di Milano\cr Maintainer: Rosario
#' M. Piro\cr E-Mail: <rmpiro@@gmail.com> or <rosariomichael.piro@@polimi.it>
#' @references \url{http://rmpiro.net/decompTumor2Sig/}\cr
#' Krueger, Piro (2019) decompTumor2Sig: Identification of mutational
#' signatures active in individual tumors. BMC Bioinformatics
#' 20(Suppl 4):152.\cr
#' @importFrom methods slot .hasSlot 
#' @keywords internal
getNumSignatures <- function(x) {
    stopifnot(.hasSlot(x, "signatureNum"))
    slot(x, "signatureNum")
}

#' isBackGround (internal function)
#'
#' `isBackGround()` extracts the content of the \code{isBackGround}
#' slot (logical value) from a \code{pmsignature::EstimatedParameters} object.
#' 
#' @param x Object from which to get the slot data.
#' @return Slot data.
#' @author Rosario M. Piro\cr Politecnico di Milano\cr Maintainer: Rosario
#' M. Piro\cr E-Mail: <rmpiro@@gmail.com> or <rosariomichael.piro@@polimi.it>
#' @references \url{http://rmpiro.net/decompTumor2Sig/}\cr
#' Krueger, Piro (2019) decompTumor2Sig: Identification of mutational
#' signatures active in individual tumors. BMC Bioinformatics
#' 20(Suppl 4):152.\cr
#' @importFrom methods slot .hasSlot 
#' @keywords internal
isBackGround <- function(x) {
    stopifnot(.hasSlot(x, "isBackGround"))
    slot(x, "isBackGround")
}

#' getSigType (internal function)
#'
#' `getSigType()` extracts the content of the \code{type}
#' slot (string) from a \code{pmsignature::EstimatedParameters} or a
#' \code{pmsignature::MutationFeatureData} object.
#' 
#' @param x Object from which to get the slot data.
#' @return Slot data.
#' @author Rosario M. Piro\cr Politecnico di Milano\cr Maintainer: Rosario
#' M. Piro\cr E-Mail: <rmpiro@@gmail.com> or <rosariomichael.piro@@polimi.it>
#' @references \url{http://rmpiro.net/decompTumor2Sig/}\cr
#' Krueger, Piro (2019) decompTumor2Sig: Identification of mutational
#' signatures active in individual tumors. BMC Bioinformatics
#' 20(Suppl 4):152.\cr
#' @importFrom methods slot .hasSlot 
#' @keywords internal
getSigType <- function(x) {
    stopifnot(.hasSlot(x, "type"))
    slot(x, "type")
}

#' getSigFeatDist (internal function)
#'
#' getSigFeatDist`()` extracts the content of the
#' \code{signatureFeatureDistribution} slot from a
#' \code{pmsignature::EstimatedParameters} object.
#' 
#' @param x Object from which to get the slot data.
#' @return Slot data.
#' @author Rosario M. Piro\cr Politecnico di Milano\cr Maintainer: Rosario
#' M. Piro\cr E-Mail: <rmpiro@@gmail.com> or <rosariomichael.piro@@polimi.it>
#' @references \url{http://rmpiro.net/decompTumor2Sig/}\cr
#' Krueger, Piro (2019) decompTumor2Sig: Identification of mutational
#' signatures active in individual tumors. BMC Bioinformatics
#' 20(Suppl 4):152.\cr
#' @importFrom methods slot .hasSlot 
#' @keywords internal
getSigFeatDist <- function(x) {
    stopifnot(.hasSlot(x, "signatureFeatureDistribution"))
    slot(x, "signatureFeatureDistribution")
}


#' getSigFromEstParam (internal function)
#'
#' `getSigFromEstParam()` extracts a specific signature from the
#' \code{signatureFeatureDistribution} slot of a
#' \code{pmsignature::EstimatedParameters} object.
#' 
#' @param x Object from which to get the signature.
#' @param signum Number (1..N) of the signature to be extracted.
#' @return Signature.
#' @author Rosario M. Piro\cr Politecnico di Milano\cr Maintainer: Rosario
#' M. Piro\cr E-Mail: <rmpiro@@gmail.com> or <rosariomichael.piro@@polimi.it>
#' @references \url{http://rmpiro.net/decompTumor2Sig/}\cr
#' Krueger, Piro (2019) decompTumor2Sig: Identification of mutational
#' signatures active in individual tumors. BMC Bioinformatics
#' 20(Suppl 4):152.\cr
#' @importFrom methods slot .hasSlot 
#' @keywords internal
getSigFromEstParam <- function(x, signum) {
    stopifnot(is.numeric(signum) & signum <= dim(getSigFeatDist(x))[1])
    sig <- getSigFeatDist(x)[signum,,]
}


### helper functions for checking consistency/compatibility of objects

#' isMutFeatDataObject (internal function)
#'
#' `isMutFeatDataObject()` checks whether an object is compatible to a
#' \code{pmsignature::MutationFeatureData} object (version 0.3.0), i.e.,
#' whether it contains the same info in the same format.
#' 
#' @param x Object for which to verify compatibility.
#' @return Logical value (true or false).
#' @author Rosario M. Piro\cr Politecnico di Milano\cr Maintainer: Rosario
#' M. Piro\cr E-Mail: <rmpiro@@gmail.com> or <rosariomichael.piro@@polimi.it>
#' @references \url{http://rmpiro.net/decompTumor2Sig/}\cr
#' Krueger, Piro (2019) decompTumor2Sig: Identification of mutational
#' signatures active in individual tumors. BMC Bioinformatics
#' 20(Suppl 4):152.\cr
#' @importFrom methods slot .hasSlot 
#' @keywords internal
isMutFeatDataObject <- function(x) {

    # all needed data there?
    if ( !.hasSlot(x, "sampleList") ||
         !.hasSlot(x, "featureVectorList") ||
         !.hasSlot(x, "countData") ||
         !.hasSlot(x, "type") ||
         !.hasSlot(x, "flankingBasesNum") ||
         !.hasSlot(x, "transcriptionDirection")
        ) {

        return(FALSE)
    }

    # check data types
    if ( !is.character(getSampleList(x)) ||
         !is.matrix(getFeatVectList(x)) ||
         !is.matrix(getCountData(x)) ||
         !is.character(getSigType(x)) ||
         !is.integer(getNumFlankingBases(x)) ||
         !is.logical(haveTrDir(x))
        ) {
        
        return(FALSE)
    }

    numGenomes <- length(getSampleList(x))
    numFeatVecRows <- nrow(getFeatVectList(x))
    numFeatVecCols <- ncol(getFeatVectList(x))
    numCountDataRows <- nrow(getCountData(x))
    numCountDataCols <- ncol(getCountData(x))
    sigType <- getSigType(x)
    numBases <- getNumFlankingBases(x)
    trDir <- haveTrDir(x)
    
    # check consistency of the data
    if ( sigType == "independent" ) {

        # Shiraishi-type signature
        if ( (numBases + as.numeric(trDir) != numFeatVecRows) ||    # bases
             (max(getCountData(x)[1,]) != numFeatVecCols) ||        # count data
             (length(unique(getCountData(x)[2,])) != numGenomes) || # count data
             (max(getFeatVectList(x)[1,]) != 6) ||                  # feat vect.
             !(numBases == 1 || max(getFeatVectList(x)[-1,]) == 4)  # feat vect.
             
            ) {

            return(FALSE)
        }

        # check consistency in dependency of transcription direction
        if (trDir) {
            # having transcription direction
            if ( max(getFeatVectList(x)[numFeatVecRows,]) != 2 
                ) {
                return(FALSE)
            }
        }

    } else if ( sigType == "full" ) {

        # Alexandrov-type signature

        numFeatures <- 6 * 4^(numBases-1) * (as.numeric(trDir)+1)
        
        if ( (numFeatures != max(getFeatVectList(x))) ||            # bases
             (max(getCountData(x)[1,]) != numFeatVecCols) ||        # count data
             (length(unique(getCountData(x)[2,])) != numGenomes) || # count data
             (numFeatVecRows != 1) ||                               # feat vect.
             (length(getFeatVectList(x)) != numFeatVecCols)         # feat vect.
            
            ) {

            return(FALSE)
        }

    } else {
        
        # unknown singature type
        return(FALSE)
    }
    
    return(TRUE)

}


#' isEstParamObject (internal function)
#'
#' `isEstParamObject()` checks whether an object is compatible to a
#' \code{pmsignature::EstimatedParameters} object (version 0.3.0), i.e.,
#' whether it contains the same info in the same format.
#' 
#' @param x Object for which to verify compatibility.
#' @return Logical value (true or false).
#' @author Rosario M. Piro\cr Politecnico di Milano\cr Maintainer: Rosario
#' M. Piro\cr E-Mail: <rmpiro@@gmail.com> or <rosariomichael.piro@@polimi.it>
#' @references \url{http://rmpiro.net/decompTumor2Sig/}\cr
#' Krueger, Piro (2019) decompTumor2Sig: Identification of mutational
#' signatures active in individual tumors. BMC Bioinformatics
#' 20(Suppl 4):152.\cr
#' @importFrom methods slot .hasSlot 
#' @keywords internal
isEstParamObject <- function(x) {

    # all needed data there?
    if ( !.hasSlot(x, "signatureNum") ||
         !.hasSlot(x, "isBackGround") ||
         !.hasSlot(x, "type") ||
         !.hasSlot(x, "signatureFeatureDistribution") ||
         !.hasSlot(x, "flankingBasesNum") ||
         !.hasSlot(x, "transcriptionDirection")
        ) {

        return(FALSE)
    }

    # check data types
    if ( !is.integer(getNumSignatures(x)) ||
         !is.logical(isBackGround(x)) ||
         !is.character(getSigType(x)) ||
         !is.array(getSigFeatDist(x)) ||
         !is.integer(getNumFlankingBases(x)) ||
         !is.logical(haveTrDir(x))
        ) {
        
        return(FALSE)
    }

    hasBackGround <- isBackGround(x)

    numSig <- getNumSignatures(x)
    # if one of them was background, the true number of signatures is one less!
    numSig <- numSig - as.numeric(hasBackGround)

    sigType <- getSigType(x)
    numFeatDistDim1 <- dim(getSigFeatDist(x))[1]
    numFeatDistDim2 <- dim(getSigFeatDist(x))[2]
    numFeatDistDim3 <- dim(getSigFeatDist(x))[3]
    numBases <- getNumFlankingBases(x)
    trDir <- haveTrDir(x)
   
    # check consistency of the data
    if ( sigType == "independent" ) {
        
        # Shiraishi-type signatures
        if ( (numBases + as.numeric(trDir) != numFeatDistDim2) || # bases
             (numFeatDistDim1 != numSig) ||                       # num. sig.
             (numFeatDistDim3 != 6)                               # feat. depth
            ) {

            return(FALSE)
        }
    } else if ( sigType == "full" ) {
        
        # Alexandrov-type signatures
        if ( (6 * 4^(numBases-1) * (as.numeric(trDir)+1) != numFeatDistDim3) ||
             (numFeatDistDim1 != numSig) ||                       # num. sig.
             (numFeatDistDim2 != 1)                               # feat. depth
            ) {

            return(FALSE)
        }
    } else {
        
        # unknown singature type
        return(FALSE)
    }
    
        
    return(TRUE)

}




### wrapper functions for writing slot data ###


#' setTrDir (internal function)
#'
#' `setTrDir()` serves as wrapper functions to change content of the
#' \code{transcriptionDirection} slot (logical value) of a
#' \code{pmsignature::MutationFeatureData} object.
#' 
#' @param x Object of which to change slot data.
#' @param value Value to be written to the slot.
#' @return The modified object \code{x}.
#' @author Rosario M. Piro\cr Politecnico di Milano\cr Maintainer: Rosario
#' M. Piro\cr E-Mail: <rmpiro@@gmail.com> or <rosariomichael.piro@@polimi.it>
#' @references \url{http://rmpiro.net/decompTumor2Sig/}\cr
#' Krueger, Piro (2019) decompTumor2Sig: Identification of mutational
#' signatures active in individual tumors. BMC Bioinformatics
#' 20(Suppl 4):152.\cr
#' @importFrom methods .hasSlot 
#' @keywords internal
setTrDir <- function(x, value) {
    stopifnot(.hasSlot(x, "transcriptionDirection"))
    stopifnot(is.logical(value))
    x@transcriptionDirection <- value
    x
}

#' setNumFlankingBases (internal function)
#'
#' `setNumFlankingBases()` serves as wrapper functions to
#' change content of the \code{flankingBasesNum} slot (numeric value) of a
#' \code{pmsignature::MutationFeatureData} object.
#' 
#' @param x Object of which to change slot data.
#' @param value Value to be written to the slot.
#' @return The modified object \code{x}.
#' @author Rosario M. Piro\cr Politecnico di Milano\cr Maintainer: Rosario
#' M. Piro\cr E-Mail: <rmpiro@@gmail.com> or <rosariomichael.piro@@polimi.it>
#' @references \url{http://rmpiro.net/decompTumor2Sig/}\cr
#' Krueger, Piro (2019) decompTumor2Sig: Identification of mutational
#' signatures active in individual tumors. BMC Bioinformatics
#' 20(Suppl 4):152.\cr
#' @importFrom methods .hasSlot 
#' @keywords internal
setNumFlankingBases <- function(x, value) {
    stopifnot(.hasSlot(x, "flankingBasesNum"))
    stopifnot(is.integer(value) || (value%%2 != 1) )
    x@flankingBasesNum <- value
    x
}

#' setSigType (internal function)
#'
#' `setSigType()` serves as wrapper functions to change content of the
#' \code{type} slot (string) of a
#' \code{pmsignature::EstimatedParameters} object.
#' 
#' @param x Object of which to change slot data.
#' @param value Value to be written to the slot.
#' @return The modified object \code{x}.
#' @author Rosario M. Piro\cr Politecnico di Milano\cr Maintainer: Rosario
#' M. Piro\cr E-Mail: <rmpiro@@gmail.com> or <rosariomichael.piro@@polimi.it>
#' @references \url{http://rmpiro.net/decompTumor2Sig/}\cr
#' Krueger, Piro (2019) decompTumor2Sig: Identification of mutational
#' signatures active in individual tumors. BMC Bioinformatics
#' 20(Suppl 4):152.\cr
#' @importFrom methods .hasSlot 
#' @keywords internal
setSigType <- function(x, value) {
    stopifnot(.hasSlot(x, "type"))
    stopifnot(is.character(value))
    x@type <- value
    x
}

#' setSigFeatDist (internal function)
#'
#' `setSigFeatDist()` serves as wrapper functions to change content of the
#' \code{signatureFeatureDistribution} slot (numeric values) of a
#' \code{pmsignature::EstimatedParameters} object.
#' 
#' @param x Object of which to change slot data.
#' @param value Value to be written to the slot.
#' @return The modified object \code{x}.
#' @author Rosario M. Piro\cr Politecnico di Milano\cr Maintainer: Rosario
#' M. Piro\cr E-Mail: <rmpiro@@gmail.com> or <rosariomichael.piro@@polimi.it>
#' @references \url{http://rmpiro.net/decompTumor2Sig/}\cr
#' Krueger, Piro (2019) decompTumor2Sig: Identification of mutational
#' signatures active in individual tumors. BMC Bioinformatics
#' 20(Suppl 4):152.\cr
#' @importFrom methods .hasSlot 
#' @keywords internal
setSigFeatDist <- function(x, value) {
    stopifnot(.hasSlot(x, "signatureFeatureDistribution"))
    stopifnot(is.numeric(value))
    x@signatureFeatureDistribution <- value
    x
}

#####################
# internal function #
#####################

#' buildGenomesFromMutationData (internal function)
#'
#' Build genome data structures (same as signatures) and fill then with
#' mutation data.
#'
#' SNVs are specified as a matrix of the following format (adapted from VCF):\cr
#' #> snvs[1:2,]\cr
#' #     CHROM POS  REF ALT FORMAT           sample1                 sample2\cr
#' #[1,] "2"  "947" "C" "T" "GT:PL:GQ:AD:DP" "1/1:84,6,0:6:0,2:2"    NA\cr
#' #[2,] "2"  "992" "G" "A" "GT:PL:GQ:AD:DP" "0/1:123,0,33:33:1,3:4" "0/0:..."
#' 
#' @usage buildGenomesFromMutationData(snvs, numBases, type, trDir,
#' uniqueTrDir=TRUE, refGenome, transcriptAnno, verbose)
#' @param snvs SNV matrix (see description above).
#' @param numBases Number of bases for the sequence pattern (odd integer).
#' @param type Type of signature to be used ("Alexandrov", "Shiraishi").
#' @param trDir Logical: use transcription-strand information?
#' @param uniqueTrDir Logical; used only if trDir is also \code{TRUE}: if
#' \code{uniqueTrDir} is \code{TRUE} (default), then only mutations with only
#' one defined transcription strand will be used, mutations for which both 
#' strands are valid are ignored. If \code{FALSE}, these mutations are accepted 
#' and one of the two transcription strands will be arbitrarily taken (the  
#' first one encountered in the databse specified for \code{transcriptAnno}). 
#' The latter was the behavior until version 1.3.5 of \code{decompTumor2Sig} 
#' and is also the behavior of \code{pmsignature}.
#' @param refGenome Reference genome (\code{BSgenome} object).
#' @param transcriptAnno Transcription information (\code{TxDb} object).
#' @param verbose Logical. Print additional information?
#' @return A list of genomes: each genome is represented by the observed
#' frequencies of mutation patterns according to the selected signature type.
#' @author Rosario M. Piro\cr Politecnico di Milano\cr Maintainer: Rosario
#' M. Piro\cr E-Mail: <rmpiro@@gmail.com> or <rosariomichael.piro@@polimi.it>
#' @references \url{http://rmpiro.net/decompTumor2Sig/}\cr
#' Krueger, Piro (2019) decompTumor2Sig: Identification of mutational
#' signatures active in individual tumors. BMC Bioinformatics
#' 20(Suppl 4):152.\cr
#' @importFrom GenomicRanges seqnames seqinfo makeGRangesFromDataFrame resize
#' findOverlaps
#' @importFrom Seqinfo seqlengths
#' @importFrom Biostrings getSeq reverseComplement
#' @importFrom GenomicFeatures transcripts
#' @importFrom S4Vectors queryHits subjectHits
#' @importFrom BiocGenerics strand
#' @importFrom plyr alply
#' @keywords internal
buildGenomesFromMutationData <- function(snvs, numBases, type, trDir,
                                         uniqueTrDir = TRUE,
                                         refGenome, transcriptAnno, verbose) {

    if (type == "independent") {
        type <- "Shiraishi"
    } else if (type == "full") {
        type <- "Alexandrov"
    } else if (type != "Shiraishi" && type != "Alexandrov") {
        stop("Unkown signature 'type'!")
    }

    if (!is.logical(trDir)) {
        stop("The parameter 'trDir' must be logical/boolean!")
    }

    if (numBases < 1 || (numBases %% 2) != 1) {
        stop("The parameter 'numBases' must be positive and odd!")
    }


    # check for MT versus M for mitochondrion
    # first: ref. genome
    if(verbose) {
        cat(paste("Comparing specification of mitochondrion in mutation data",
                  "(M or MT?) to reference genome and adjusting if",
                  "necessary.\n"))
    }

    # check whether the mitochondrion is specified as chromosome "MT" or "M"

    refMT <- ""
    if (length(grep("MT", GenomicRanges::seqnames(refGenome))) == 1) { 
        refMT <- "MT"
    } else if (length(grep("M", GenomicRanges::seqnames(refGenome)))
               == 1) {
        refMT <- "M"
    } # else empty, no clear mitochondrion found

    #second: mutation file
    fileMT <- ""
    if (length(grep("MT", unique(snvs[,"CHROM"]))) == 1) { # having MT
        fileMT <- "MT"
    } else if (length(grep("M", unique(snvs[,"CHROM"]))) == 1) {
        fileMT <- "M"
    } # else empty, no clear mitochondrion found

    # third: check and adjust mutation data, if necessary
    if (fileMT != "" && fileMT != refMT) {
        if (refMT != "") {
            # invert
            snvs[,"CHROM"] <- gsub(fileMT, refMT, snvs[,"CHROM"])
        }
    }


    
    # check if chromosome IDs match what we have in the reference genome
    # (with or without prefix "chr")
    if(verbose) {
        cat(paste("Checking chromosome IDs of mutation data (1 or chr1?)",
                  "and adjusting if necessary.\n"))
    }

    setF <- unique(snvs[,"CHROM"])
    setR <- GenomicRanges::seqnames(refGenome)

    # check what "chr"-prefix we have in the ref. genome: chr? Chr? CHR? none?
    refPrefix <- unique(substr(grep("^chr", setR,
                                    ignore.case=TRUE, value=TRUE), 1, 3))
    if (!length(refPrefix)) {
        refPrefix <- ""
    }
    
    # check what "chr"-prefix we have in the mut. file: chr? Chr? CHR? none?
    filePrefix <- unique(substr(grep("^chr", setF,
                                    ignore.case=TRUE, value=TRUE), 1, 3))
    if (!length(filePrefix)) {
        filePrefix <- ""
    }

    if (refPrefix != filePrefix) {
        # not the same "chr"-prefix
        if (verbose) {
            cat(paste0("Having prefix for chromosome names: '", filePrefix,
                       "'; requiring prefix for reference genome: '",
                       refPrefix,"' ... replacing.\n"))
        }
        
        # first, remove whatever different prefix we have in the mutation file
        if (filePrefix != "") {
            snvs[,"CHROM"] <- gsub(paste0("^",filePrefix), "", snvs[,"CHROM"])
        }

        # then, add whatever prefix we need for the reference genome
        if (refPrefix != "") {
            snvs[,"CHROM"] <- paste(refPrefix,snvs[,"CHROM"], sep="")
        }
    }

    # now check, which chromosomes we don't find in the reference
    # genome and exclude them
    setF = unique(snvs[,"CHROM"])
    # setR has in any case remained the same

    excludeSeq <- setF[!(setF %in% setR)]

    if (length(excludeSeq)) {
        cat(paste("Warning: cannot find the following chromosomes in the",
                  "reference genome (will be ignored):\n"))
        cat(excludeSeq)
        cat("\n")

        snvs <- snvs[!(snvs[,"CHROM"] %in% excludeSeq),]
    }

    if (verbose) {
        cat(paste("Processing a total of", nrow(snvs), "mutations.\n"))
    }

    # If we didn't find any mutation
    if (!nrow(snvs)) {
        stop("No single nucleotide variants found!")
    }


    # If using trancription direction:
    # check that the reference genome and transcript annotation match!
    if (trDir) {
        setT <- GenomicRanges::seqnames(GenomicRanges::seqinfo(transcriptAnno))
        setRT <- setR[setR %in% setT]

        if (!all(Seqinfo::seqlengths(refGenome)[setRT] ==
                 Seqinfo::seqlengths(transcriptAnno)[setRT]
                 )
            ) {
            stop(paste("Inconsistent reference sequence lengths indicate",
                       "mismatch between reference genome (refGenome) and",
                       "annotation (transcriptAnno)!")
                 )
        }
    }
    


    
    # get sequences from the reference genome
    if (verbose) {
        cat(paste("Extracting sequences with flanking bases of mutations",
                  "from the reference genome.\n"))
    }
    
    gr <- tryCatch(GenomicRanges::makeGRangesFromDataFrame(
                             data.frame(chr = snvs[,"CHROM"], 
                                        start = as.numeric(snvs[,"POS"]), 
                                        end = as.numeric(snvs[,"POS"])),
                             ignore.strand = TRUE),
                   error=function(e) {
                       stop(paste0(e, "Cannot build valid GRanges object from ",
                                  "mutation data; correct chromosome and ",
                                  "position information?"))
                   })
    seqs <- tryCatch(Biostrings::getSeq(refGenome,
                                        GenomicRanges::resize(gr, numBases,
                                                              fix = "center")),
                     error=function(e) {
                         stop(paste0(e, "Cannot extract genomic sequences for ",
                                    "mutation data; incorrect reference ",
                                    "genome?"))
                     })

    # verify that the obtained center base is the REF base specified in the
    # mutation data (i.e., check that this is the correct reference genome 
    # for the mutation data)

    refExpected <- substr(as.character(seqs),
                            (numBases%/%2)+1, (numBases%/%2)+1)

    if( ! all( snvs[,"REF"] == refExpected ) ) {

        errIdx <- which(snvs[,"REF"] != refExpected)
        numErrors <- length(errIdx)
        
        numTop <- min(numErrors, 5)  # display maximum top 5
        errIdx <- errIdx[seq(numTop)]
        refExpected <- refExpected[errIdx]

        cat(paste0("Reference (REF) bases of ", numErrors, " mutation(s) do ",
                   "not match the specified reference genome!\n",
                   "First problematic entries:\n"))
        print.table(snvs[errIdx,])
        stop(paste("Expected REF bases are:",
                   paste(refExpected, collapse=","),
                   "...; incorrect reference genome?")
             )
    }

    
    # set strand info to NA
    strands <- rep(NA, length(seqs))
    
    # get strand info if we need it
    if(trDir) {
        if(verbose) {
            cat(paste("Getting information on transcription directions for",
                      "mutations within genes.\n"))
        }

        tr <- GenomicFeatures::transcripts(transcriptAnno)
        trHit <- GenomicRanges::findOverlaps(gr, tr, ignore.strand = FALSE)
        trStr <- cbind(S4Vectors::queryHits(trHit),
                       as.character(BiocGenerics::strand(
                           tr[S4Vectors::subjectHits(trHit)])
                                    )
                       )
        trStrUnique <- unique(trStr[trStr[,2] != "*",],MARGIN=1)

        if (!uniqueTrDir) {
            ## the following was the approach also used by pmsignature:
            ## for mutations in regions with transcripts in both directions,
            ## use the direction of the first transcript encountered in the
            ## transcript database; we did this also until version 1.3.5
            ## we now exclude these mutations! See below.
            trStrUnique <- trStrUnique[!duplicated(trStrUnique[,1]),]

        } else {
            ## uniqueTrDir == TRUE (default)

            # exclude cases where both transcription directions are valid
            # (e.g., ambiguous due to overlapping transcripts)
            trStrUnique <-
                trStrUnique[!(trStrUnique[,1] %in%
                              #trStrUnique[duplicated(trStrUnique[,1])]),]
                              trStrUnique[duplicated(trStrUnique[,1]),1]),]
        }
        
        trPlus <- as.integer(trStrUnique[trStrUnique[,2]=="+",1])
        trMinus <- as.integer(trStrUnique[trStrUnique[,2]=="-",1])

        strands[trPlus] <- "+"
        strands[trMinus] <- "-"

    }


    # take reverse complement of all sequences without pyrimidine (C or T)
    # at center
    if (verbose) {
        cat(paste("Building reverse complement of sequences for which the",
                  "REF base is a purine (A or G).\n"))
    }

    revCompIndices <- grep("[^CT]", substr(as.character(seqs), (numBases%/%2)+1,
                                           (numBases%/%2)+1))

    seqs[revCompIndices] <- Biostrings::reverseComplement(seqs[revCompIndices])
    
    # also invert the corresponding strands; thus, "strands" no longer
    # contains the _genomic strand_ but becomes the "location" of the
    # pyrimidine (C,T) with respect to the _transcription direction_!
    # rationale:
    # a T in a gene on the "+" strand -> remains T and is in transcription
    #     direction ("+")
    # a T in a gene on the "-" strand -> remains T but is not on the
    #     transcribed strand (not in tr. dir., "-")
    # an A in a gene on the "+" strand -> translated to T but the T is not
    #     on the transcribed strand ("-")
    # an A in a gene on the "-" strand -> translated to T now this T is on
    #     the transcribed strand ("+")
    # so whenever we build the reverse compliment, we can also invert the
    # "strand" ...
    strands[revCompIndices] <- chartr("+-", "-+", strands[revCompIndices])

    # add to mutation table
    snvs <- cbind(snvs, as.character(seqs), strands)
    colnames(snvs)[seq((ncol(snvs)-1),ncol(snvs))] <- c("SEQ", "STRAND")

    # now, we have everything we need; start counting occurrences ...

    # get location of genotype info in sample specifications ("GT" in format)
    # [assume it's the same for all variants ...]

    gtIndex <- as.numeric(which(unlist(strsplit(snvs[1,"FORMAT"], ":",
                                                fixed=TRUE)) == "GT"))


    #
    # first: define empty data structure for this mutational load (=signature)
    # model and size
    #

    sigModel <- NULL
    if (type == "Alexandrov" || type == "full") {
        sigModel <- rep(0, 4^(numBases-1)*6*(1+as.numeric(trDir)))

        names(sigModel) <-
            buildSortedAlexandrovSignaturePatternList(numBases=numBases,
                                                      trDir=trDir)
        
    } else { # Shiraishi (table)
        sigModel <- matrix(0, ncol=6, nrow=(numBases+as.numeric(trDir)))

        sigModel <- setNames4ShiraishiTable(sigModel)

        # we need additional mapping to the colnames from single flanking
        # bases and transcription directions
        shColMapping <-
            c("[C>A]", "[C>G]", "[C>T]", "[T>A]", "[C>A]", "[C>G]")
        names(shColMapping) <-
            c(  "A",     "C",     "G",     "T",     "+",     "-"  )
    }

    #
    # now, iterate over samples/genomes!
    #

    sampleCols <- colnames(snvs)[!(colnames(snvs) %in%
                                   c("CHROM", "REF", "FORMAT",
                                     "POS", "ALT", "SEQ", "STRAND"))]

    if(verbose) {
        cat("Samples/genomes to be processed:\n")
        cat(paste0("  ",sampleCols,"\n"))
    }

    genomes <- plyr::alply(as.matrix(snvs[,sampleCols]), 2, function(sample) {
        ## apply to all samples (genotype column)

        if(verbose) {
            cat("Processing new genome:\n")
        }
        
        # get indices of mutations we need to process (genotype not NA and at
        # least heterozygous)
        if(verbose) {
            cat(paste("  Selecting mutations present in this genome",
                      "(genotype information), with defined ALT base and",
                      "without flanking N: "))
        }
        
        mutIndices <- grep("[^0/|]",
                           rapply(strsplit(sample,  ":", fixed=TRUE),
                                  function(x) { x[gtIndex] }))

        # but: exclude mutations with REF or ALT base different from
        # A, C, G or T (e.g. "N")
        mutIndices <- mutIndices[which(snvs[mutIndices, "REF"] %in%
                                       c("A","C","G","T"))]
        mutIndices <- mutIndices[which(snvs[mutIndices, "ALT"] %in%
                                       c("A","C","G","T"))]
        
        # exclude also those which have an N in their sequence pattern
        mutIndices <- mutIndices[grep("[^ACGT]", snvs[mutIndices, "SEQ"],
                                      invert=TRUE)]

        if(verbose) {
            cat(paste0(length(mutIndices)," variants left.\n"))
        }
        
        # but: in case we need transcriptional direction, remove all mutation
        # that don't have it
        # (i.e., that don't lie within genes)
        if (trDir) {
            if (verbose) {
                cat(paste("  Selecting mutations with information on",
                          "transcription direction (within genes): "))
            }

            mutIndices <- mutIndices[which(!is.na(snvs[mutIndices, "STRAND"]))]

            if(verbose) {
                cat(paste0(length(mutIndices)," variants left.\n"))
            }
        }


        # now build count occurrences for this sample/genome
        if (verbose) {
            cat(paste0("  Processing ", length(mutIndices),
                       " mutations to obtain frequencies.\n"))
        }

        genome <- sigModel
        
        for (mutIndex in mutIndices) {

            snv <- snvs[mutIndex,]
         
            ref <- snv["REF"]
            alt <- snv["ALT"]

            if (!ref %in% c("C","T")) {
                # need the complement also of the ALT base
                ref <- chartr("AG", "TC", ref)
                alt <- chartr("ACGT", "TGCA", alt)
            }
            basechange <- paste0("[",ref,">",alt,"]")
            
            if (type == "Shiraishi") {
                # increment base change
                genome["mut", basechange] <- genome["mut", basechange] + 1

                # increment counts for flanking bases
                flanking <-
                    unlist(strsplit(snv["SEQ"], ""))[-((numBases %/% 2)+1)]

                for (ii in seq_along(flanking)) {
                    genome[1+ii, shColMapping[flanking[ii]]] =
                        genome[1+ii, shColMapping[flanking[ii]]] + 1
                }

                # increment count for transcription direction, if required
                if (trDir) {
                    genome["tr", shColMapping[snv["STRAND"]]] =
                        genome["tr", shColMapping[snv["STRAND"]]] + 1
                }

            } else { # Alexandrov
                # construct element name (index of signature vector)
                index <- paste0(substr(snv["SEQ"], 1, (numBases %/% 2)),
                                basechange,
                                substr(snv["SEQ"], (numBases %/% 2)+2,
                                       numBases))
                if (trDir) {
                    index <- paste0(index, snv["STRAND"])
                }

                # increment this single element
                genome[index] <- genome[index] + 1
            }

        }

        # normalize the counts to get fractions
        genome <- genome/length(mutIndices)
        
        genome

    }) # genomes <- apply over samples ...

    names(genomes) <- sampleCols
    
    # finally, exclude all genomes without mutations
    if(verbose) {
        cat("Cleaning genome list; removing genomes without mutations.\n")
    }
    genomes <- genomes[unlist(lapply(genomes, function(x){ all(!is.nan(x)) }))]
    
    return(genomes)
    
}

###################################
# internal mathematical functions #
###################################

#' computeFrobeniusNorm (internal function)
#'
#' Compute the Frobenius norm of a numeric matrix (if this matrix is the 
#' difference between two matrices, then this corresponds to the Frobenius 
#' distance between these two matrices).
#'
#' @usage computeFrobeniusNorm(A)
#' @param A The numeric matrix.
#' @return The Frobenius norm.
#' @author Rosario M. Piro\cr Politecnico di Milano\cr Maintainer: Rosario
#' M. Piro\cr E-Mail: <rmpiro@@gmail.com> or <rosariomichael.piro@@polimi.it>
#' @references \url{http://rmpiro.net/decompTumor2Sig/}\cr
#' Krueger, Piro (2019) decompTumor2Sig: Identification of mutational
#' signatures active in individual tumors. BMC Bioinformatics
#' 20(Suppl 4):152.\cr
#' @keywords internal
computeFrobeniusNorm <- function(A) { # compute the Frobenius norm of matrix A
    A <- as.matrix(A) # in case A was a data.frame

    trace <- sum(diag(A %*% t(A)))      # need the conjugate transpose here, 
                                        # but for real-valued matrices this is 
                                        # equivalent to the transpose!

    return(sqrt(trace))
}


#' computeRSS (internal function)
#'
#' Compute the residual sum of squares (RSS), i.e., the sum of squared errors.
#'
#' @usage computeRSS(x, y)
#' @param x The first numeric object (e.g., matrix).
#' @param y The second numeric object (of the same type as \code{x}).
#' @return The RSS.
#' @author Rosario M. Piro\cr Politecnico di Milano\cr Maintainer: Rosario
#' M. Piro\cr E-Mail: <rmpiro@@gmail.com> or <rosariomichael.piro@@polimi.it>
#' @references \url{http://rmpiro.net/decompTumor2Sig/}\cr
#' Krueger, Piro (2019) decompTumor2Sig: Identification of mutational
#' signatures active in individual tumors. BMC Bioinformatics
#' 20(Suppl 4):152.\cr
#' @keywords internal
computeRSS <- function(x, y) {
    if (length(x) != length(y)) {
        stop("In computeRSS: x and y need to have the same length!")
    }

    return(sum((x-y)^2))
}


#' roundIntegerSum (internal function)
#'
#' update a numeric vector such that it's composed of integers and its sum
#' reaches a desired total. Positive or negative discrepancies are distributed
#' proportionally between the summands.
#'
#' @usage roundIntegerSum(vec, targetSum)
#' @param vec Vector of integers.
#' @param targetSum The target sum to be reached.
#' @return The updated vector with the desired total sum.
#' @author Rosario M. Piro\cr Politecnico di Milano\cr Maintainer: Rosario
#' M. Piro\cr E-Mail: <rmpiro@@gmail.com> or <rosariomichael.piro@@polimi.it>
#' @references \url{http://rmpiro.net/decompTumor2Sig/}\cr
#' Krueger, Piro (2019) decompTumor2Sig: Identification of mutational
#' signatures active in individual tumors. BMC Bioinformatics
#' 20(Suppl 4):152.\cr
#' @keywords internal
roundIntegerSum <- function(vec, targetSum) {
    stopifnot(is.numeric(vec) || is.integer(vec))
    stopifnot(is.numeric(targetSum) || is.integer(targetSum))

    # first get an approximation
    vec <- round(targetSum * (vec / sum(vec)))
    
    # modification order: highest first, etc.
    modOrder <- order(vec, decreasing=TRUE)

    # See if we still have some discrepancy
    diff <- targetSum - sum(vec)    # pos: need to add; neg: need to subtract

    # The difference should be between -1 and 1, not beyond this range
    if (diff == -1) {
        vec[modOrder[length(vec)]] <- vec[modOrder[length(vec)]] - 1
    } else if (diff == 1) {
        vec[modOrder[1]] <- vec[modOrder[1]] + 1
    } else {
        stopifnot(!diff)
    }

    vec
}

#####################
# internal function #
#####################

#' plotAlexandrovModel (internal function)
#'
#' `plotAlexandrovModel()` plots a single signature or the mutation
#' frequency data for a single genome of the Alexandrov-type model.
#'
#' @usage plotAlexandrovModel(mutData, numBases, trDir, colors = NULL,
#' strip = NULL)
#' @param mutData (Mandatory) The signature or genome mutation frequency data
#' to be plotted.
#' @param numBases The number of bases of the sequence pattern.
#' @param trDir Logical value specifying whether transcription strand
#' information is present.
#' @param colors Vector of six colors to be used for the base change data.
#' If \code{NULL} (default), the colors are set to those used by the COSMIC
#' website.
#' @param strip Background color for strip labels. If \code{NULL} (default),
#' "papayawhip" will be used.
#' @return Returns (or draws) a plot according to the Alexandrov model of
#' mutational signatures.
#' @author Rosario M. Piro\cr Politecnico di Milano\cr Maintainer: Rosario
#' M. Piro\cr E-Mail: <rmpiro@@gmail.com> or <rosariomichael.piro@@polimi.it>
#' @references \url{http://rmpiro.net/decompTumor2Sig/}\cr
#' Krueger, Piro (2019) decompTumor2Sig: Identification of mutational
#' signatures active in individual tumors. BMC Bioinformatics
#' 20(Suppl 4):152.\cr
#' @importFrom ggplot2 ggplot geom_bar scale_fill_manual theme_bw theme rel
#' element_text element_blank element_rect guides facet_grid scale_x_continuous
#' @keywords internal
plotAlexandrovModel <- function(mutData, numBases, trDir,
                                colors = NULL, strip = NULL) {

    # this function assumes all probabilities are sorted as follows:
    # first, alphabetically according to the six base changes; 
    # then, blockwise alphabetically according to the flanking bases (within
    # each base change block.
    
    # base change types and colors
    changes <- c("[C>A]","[C>G]","[C>T]","[T>A]","[T>C]","[T>G]")

    if (is.null(colors)) {
        # default colors are those used by the COSMIC website!
        colors = c("#1ebff0", "#050708", "#e62725", "#cbcacb",
            "#a1cf64", "#edc8c5")
    }

    if (is.null(strip)) {
        strip = "papayawhip"
    }
    
    # number of blocks (one per base change)
    numBlocks <- length(changes)

    # make sure we have the correct number of colors
    stopifnot(length(colors) == numBlocks)
    
    # numer of probabilies per block (depends on sequence pattern length)
    probsPerBlock <- 4^(numBases-1)

    # transcription strand information?
    strands <- c("transcription independent")
    if (trDir) {
        strands <- c("transcription strand", "opposite strand")
    }

    # quickly verify, we got the correct counts (should not happen)
    stopifnot(length(mutData) ==
                  numBlocks * probsPerBlock * (as.numeric(trDir)+1))

    
    # get list of all sequence patterns and set colors per blocks
    patterns <- buildSortedAlexandrovSignaturePatternList(numBases, FALSE)
    patterns <- gsub("\\[.{3}\\]", " ~ ", patterns)
    #patterns <- gsub("\\[", "", gsub(">.]", "", patterns))

    # build data frame with:
    # <strand> <base change> <seq. pattern> <pos in block> <probability/prob.>
    dat <- data.frame(strand = factor(rep(strands,
                          each = probsPerBlock * numBlocks),
                          levels = strands),
                      change = factor(rep(rep(changes,
                          each = probsPerBlock), length(strands)),
                          levels = changes),
                      pattern = rep(patterns, length(strands)),
                      pos = seq(probsPerBlock),
                      probability = as.vector(mutData)
                      )

    xlabels <- element_blank()
    if (numBases == 3) {
        # if only one base or too many bases (>3); don't print sequence labels
        xlabels <- element_text(face="bold", vjust=0.5,
                                size=rel(0.8), angle=90)
    }
    
    ggp <- ggplot(dat, aes_string(x = "pos", y = "probability",
                                  fill = "change")) +
            geom_bar(stat = "identity", position = "identity", width = 0.8) + 
            scale_fill_manual(values = colors) +
            scale_x_continuous(breaks = seq(probsPerBlock),
                               labels = patterns[seq(probsPerBlock)]) +
            theme_bw() + 
            theme(axis.text.x = xlabels,
                  axis.ticks.x = element_blank(),
                  axis.title.x = element_blank(),
                  axis.text.y = element_text(size = rel(1.2)),
                  axis.title.y = element_text(size = rel(1.2)),
                  panel.grid.major.x = element_blank(),
                  panel.grid.minor.x = element_blank(),
                  strip.text = element_text(face = "bold", size = rel(1.2)),
                  strip.background = element_rect(fill = strip)) +
            guides(fill = FALSE) +
            facet_grid(strand ~ change)

    ggp$labels$y = "Mutation type frequency or probability"
    
    ggp

}

#####################
# internal function #
#####################

#' QPforSig (internal function)
#'
#' Perform quadratic programming for signatures to determine exposures.
#'
#' @usage QPforSig(counts, signatures, constrainToMaxContribution=FALSE,
#' tolerance=0.1)
#' @param counts The genome's mutation frequencies (either in Alexandrov or
#' Shiraishi format).
#' @param signatures The signatures to be used for decomposition. Must be in
#' the same format as the genome's \code{counts}.
#' @param constrainToMaxContribution (Optional) [Note: this is experimental
#' and is usually not needed!] If \code{TRUE}, the maximum contribution that
#' can be attributed to a signature will be constraint by the variant feature
#' counts (e.g., specific flanking bases) observed in the individual tumor
#' genome. If, for example, 30\% of all observed variants have a specific
#' feature and 60\% of the variants produced by a mutational process/signature
#' will manifest the feature, then the signature can have contributed up to
#' 0.3/0.6 (=0.5 or 50\%) of the observed variants. The lowest possible
#' contribution over all signature features will be taken as the allowed
#' maximum contribution of the signature. This allowed maximum will
#' additionally be increased by the value specified as \code{tolerance}
#' (see below). For the illustrated example and \code{tolerance}=0.1 a
#' contribution of up to 0.5+0.1 = 0.6 (or 60\%) of the signature would be
#' allowed. 
#' @param tolerance (Optional) If \code{constrainToMaxContribution} is
#' \code{TRUE}, the maximum contribution computed for a signature is increased
#' by this value (see above). If the parameter \code{constrainToMaxContribution}
#' is \code{FALSE}, the tolerance value is ignored. Default: 0.1.
#' @return The decomposition in form of an exposure vector (same order as
#' \code{signatures}).
#' @author Rosario M. Piro, Politecnico di Milano\cr
#' Sandra Krueger, Freie Universitaet Berlin\cr Maintainer: Rosario
#' M. Piro\cr E-Mail: <rmpiro@@gmail.com> or <rosariomichael.piro@@polimi.it>
#' @references \url{http://rmpiro.net/decompTumor2Sig/}\cr
#' Krueger, Piro (2019) decompTumor2Sig: Identification of mutational
#' signatures active in individual tumors. BMC Bioinformatics
#' 20(Suppl 4):152.\cr
#' @importFrom Matrix nearPD
#' @keywords internal
QPforSig <- function(counts, signatures, constrainToMaxContribution=FALSE,
                     tolerance=0.1) {

    if (!isSignatureSet(signatures)) {
        stop("Signatures must be a set (list) for function QPforSig")
    }

    if (constrainToMaxContribution && (tolerance < 0 ||  tolerance > 1)) {
        stop(paste("Tolerance must be between 0 and 1 when constraining the",
                   "maximum contribution of signatures in function QPforSig"))
    }

    # if necessary, convert signatures from matrices to vectors
    if (isShiraishiSet(signatures)) {
        
        signatures <-
            lapply(signatures, function(x){as.vector(t(as.matrix(x)))})
    }

    # if necessary, convert counts from matrix to vector
    if(isShiraishiSet(list(counts))) {
        counts <- as.vector(t(as.matrix(counts)))
    }

    # the signatures should be stored in a matrix, one row is one signature
    sigMa <- do.call(rbind,signatures) 

    ### needed to make sure that the matrix (sigMa %*% t(sigMa)) is
    ### positive definite!
    sigMaSquared.nearPD =
        nearPD((sigMa %*% t(sigMa)), corr=FALSE, keepDiag=TRUE,
               ensureSymmetry=TRUE)$mat

    #Rinverse <- backsolve(chol(sigMa %*% t(sigMa)),diag(dim(sigMa)[1]))
    Rinverse <- backsolve(chol(sigMaSquared.nearPD),diag(dim(sigMa)[1]))

    if (constrainToMaxContribution) {
        # We want to constrain the maximum contribution each signature can
        # have (given some tolerance):
        # For each row in sigMa (each signature), we divide the counts from
        # the genome by the corresponding fractions in the signature and take
        # the minimum over the signature, the signature can't have a higher
        # contribution than this ratio, but we add a tolerance value (given
        # that the data is noisy!)
        # Example: if in the genome 30% of variants have a specific feature
        # (e.g. a specific flanking base), i.e., the counts score is 0.3, and
        # 60% (0.6) of the variants produced by a process/signature have this 
        # feature, then the signature can have contributed up to 0.3/0.6 = 0.5
        # (50%) of the genome's variants. 
        # With the default tolerance of 0.1, we would allow the quadratic
        # programming approach to assign up to 0.5+0.1 (60%) of the variants
        # to this signature

        maxContributions <-
            apply(sigMa, 1, function(x) {
                min((counts/x)[!is.na(counts/x)]) + tolerance })

        # limit maximum contribution to 100%
        maxContributions[maxContributions>1] <- 1


        # for the additional constraints, we use negative values because we 
        # require contribution/weight w <= w_max, which we can implement 
        # as -w >= -w_max (because quadprog uses Ax >= b, so we have to
        # use >= instead of <=!)
        Amat <- cbind(rep(1,dim(Rinverse)[1]),
                      diag(dim(Rinverse)[1]), -diag(length(maxContributions)))
        bvec <- c(1, rep(0,dim(Rinverse)[1]), -maxContributions)
    }
    else { # !constrainToMaxContribution
        Amat <- cbind(rep(1,dim(Rinverse)[1]), diag(dim(Rinverse)[1]))
        bvec <- c(1, rep(0,dim(Rinverse)[1]))
    }

    dvec <- (counts) %*% t(sigMa)
    resQP <- quadprog::solve.QP(Dmat=Rinverse, dvec=dvec, Amat=Amat,
                                bvec=bvec, meq=1, factorized=TRUE)
    resQP$solution[resQP$solution<0]=0  # there can be some values below 0
                                        # which should actually be 0 (very 
                                        # close to 0 in any case, e.g., -10^-15)
    resQP$solution[resQP$solution>1]=1  # same for values beyond 1
    
    return(resQP$solution)
}

#' Get genomes (mutation frequencies) from \code{MutationFeatureData}.
#'
#' `getGenomesFromMutFeatData()` takes a \code{MutationFeatureData} object
#' (mutation count data) as read by the '\code{pmsignature}' package (e.g.,
#' by \code{pmsignature::readMPFile}, version 0.3.0) and extracts the mutation
#' counts of the genomes therein. For passing the genomes to
#' \code{decomposeTumorGenomes}, the mutation counts must be normalized to
#' mutation frequencies, which is done by default. [IMPORTANT: set
#' \code{normalize} to \code{FALSE} only if you are interested in full
#' integer counts, but do not pass unnormalized counts to
#' \code{decomposeTumorGenomes}!] 
#' 
#' @usage getGenomesFromMutFeatData(mutFeatData, normalize=TRUE)
#' @param mutFeatData (Mandatory) A \code{MutationFeatureData} object as
#' constructed, for example, by \code{pmsignature::readMPFile}.
#' @param normalize (Optional) Boolean value to specify whether to normalize
#' the mutation count data to mutation fractions between 0 and 1. This is
#' the default and NECESSARY in case you want to pass the return value to
#' \code{decomposeTumorGenomes}. Set \code{normalize} to \code{FALSE} only
#' if you are interested in full integer counts, but do not pass unnormalized
#' counts to \code{decomposeTumorGenomes}!
#' @return  A list of mutation frequencies (or mutation counts if not
#' normalized), one object per genome. The format is either according to the
#' Shiraishi or the Alexandrov model, depending on how the mutation data was
#' loaded with \code{pmsignature}. 
#' @author Rosario M. Piro, Politecnico di Milano\cr
#' Sandra Krueger, Freie Universitaet Berlin\cr Maintainer: Rosario
#' M. Piro\cr E-Mail: <rmpiro@@gmail.com> or <rosariomichael.piro@@polimi.it>
#' @references \url{http://rmpiro.net/decompTumor2Sig/}\cr
#' Krueger, Piro (2019) decompTumor2Sig: Identification of mutational
#' signatures active in individual tumors. BMC Bioinformatics
#' 20(Suppl 4):152.\cr
#' @seealso \code{\link{decompTumor2Sig}}
#' @examples
#' 
#' ### get breast cancer genomes from 
#' ### Nik-Zainal et al (PMID: 22608084) in the format produced by
#' ### pmsignature (PMID: 26630308)
#' pmsigdata <- system.file("extdata", 
#'          "Nik-Zainal_PMID_22608084-pmsignature-G.Rdata", 
#'          package="decompTumor2Sig")
#' load(pmsigdata)
#' 
#' ### extract the genomes from the pmsignature G object
#' genomes <- getGenomesFromMutFeatData(G, normalize=TRUE)
#' 
#' @importFrom methods is
#' @export getGenomesFromMutFeatData
getGenomesFromMutFeatData <- function(mutFeatData, normalize=TRUE) {
    # convert MutationFeatureData (e.g. read with pmsignature's function
    # readMPFile) to a list of genome matrices

    # IMPORTANT: set normalize=FALSE only if you want to see full counts,
    # but USE ONLY NORMALIZED count tables for predicting/computing exposures,
    # i.e., the contributions of mutational signatures (because these are
    # normalized, too)

    if (!isMutFeatDataObject(mutFeatData)) {
        stop(paste("Function getGenomesFromMutFeatData requires the",
                   "'mutFeatData' input to be compatible an object of type",
                   "MutationFeatureData (as produced by pmsignature's",
                   "function readMPFile; version 0.3.0)"))
    }
    
    tableList <- list()

    # get list of samples (numbers)
    samples <- unique(getCountData(mutFeatData)[2,])

    # get number of flanking bases and transcription direction
    numBases <- getNumFlankingBases(mutFeatData)
    trDir <- haveTrDir(mutFeatData)

    
    # what signature model do we have?
    isShiraishi <- TRUE
    if (getSigType(mutFeatData) == "full") {
        isShiraishi <- FALSE
    }

    if (isShiraishi) {
        # if the user has set trDir = TRUE, we need flankinBasesNum+1 rows,
        # otherwise only the flankingBasesNum
        if (haveTrDir(mutFeatData)) {
            rows <- as.numeric(getNumFlankingBases(mutFeatData)+1)
        } else {
            rows <- as.numeric(getNumFlankingBases(mutFeatData)) 
        }
    } else {
        rows <- 1   # for Alexandrov we expect only vectors, not matrices
    }

    for (l in seq_along(samples)) {  # for each sample l

        # initialize the new count table/matrix (or vector) with 0
        if (isShiraishi) {
            countTable <- matrix(rep(0, 6*rows), nrow=rows, ncol=6) 
        } else {
            countTable <- rep(0, 6 * 4^(numBases-1) * (as.numeric(trDir)+1))

        }
        
        # in oneSample we extract the count data relative to sample l
        oneSample <-
            getCountData(mutFeatData)[,which(getCountData(mutFeatData)[2,]==l)]

        for (i in seq_len(ncol(oneSample))) { # for each i in the vector

            # index of the mutation type in featureVectorList
            mutTypeIndex <- oneSample[1,i] 

            # get the features for this mutation type
            # (corresponds to the column indices to be incremented for each
            # row in the count table)
            v <- getFeatVectList(mutFeatData)[,mutTypeIndex] 

            if (isShiraishi) {
                for (k in seq_len(rows)) { #for each k in the length of our rows
                
                    # in our countTable at position k and v[k] we store the
                    # number of occurrences which is stored in the third row
                    # and i-th column of oneSample
                    countTable[k,v[k]] <- countTable[k,v[k]] + oneSample[3,i]
                }
            } else {
                # only one row, so v is already the index and not a list
                # of indices
                countTable[v] <- countTable[v] + oneSample[3,i]
            }
        }

        # normalize the count table/vector?
        if (normalize) {
            if (isShiraishi) {
                countTable <- countTable/(sum(countTable)/nrow(countTable))
            } else {
                countTable <- countTable/sum(countTable)
            }
        }

        # finally, name the rows and/or columns of the count table/vector
        if (isShiraishi) {
            countTable <- setNames4ShiraishiTable(countTable)
        } else {
            names(countTable) <-
                buildSortedAlexandrovSignaturePatternList(numBases=numBases,
                                                          trDir=trDir)
        }
        
        tableList[[l]] <- countTable  # put each countTable in the tableList

    }

    # keep the samples' names/IDs!
    names(tableList) <- getSampleList(mutFeatData)

    return(tableList)
}

#####################
# internal function #
#####################

#' determineTypeNumBasesAndTrDir (internal function)
#'
#' For a given signature or genome representation: determine the
#' type (Shiraishi or Alexandrov), the number of bases, and whether
#' transcription-strand information is included.
#'
#' @usage determineTypeNumBasesAndTrDir(mutData)
#' @param mutData The mutation frequency data of the signature or genome.
#' @return A list object composed of: "type"=type of signature or genome;
#' "numBases"=number of bases of the sequence patterns; and
#' "trDir"=logical value indicating whether transcription-strand information
#' has been considered in the mutation frequency data.
#' @author Rosario M. Piro\cr Politecnico di Milano\cr Maintainer: Rosario
#' M. Piro\cr E-Mail: <rmpiro@@gmail.com> or <rosariomichael.piro@@polimi.it>
#' @references \url{http://rmpiro.net/decompTumor2Sig/}\cr
#' Krueger, Piro (2019) decompTumor2Sig: Identification of mutational
#' signatures active in individual tumors. BMC Bioinformatics 
#' 20(Suppl 4):152.\cr
#' @keywords internal
determineTypeNumBasesAndTrDir <- function(mutData) {

    haveTrDir <- NULL
    haveNumBases <- NULL
    haveType <- NULL
    
    if(isShiraishiSet(list(mutData))) {
        # Shiraishi-type

        # number of bases of sequence pattern and transcription dir.
        haveNumBases <- nrow(mutData)
        haveTrDir <- FALSE
        if ( (nrow(mutData) %% 2) == 0 ) { # even number of rows,
                                           # must have transcript direction!
            haveNumBases <- haveNumBases -1
            haveTrDir <- TRUE
        }
    
        haveType <- "Shiraishi"
        
    } else if (isAlexandrovSet(list(mutData))) {
        # Alexandrov-type
 
        if ( ( (log10(length(mutData)/6)/log10(4)) %% 1 ) == 0 ) {
            
            # this must be without transcription direction
            haveNumBases <- log10(length(mutData)/6)/log10(4) + 1
            haveTrDir <- FALSE
            haveType <- "Alexandrov"
            
        } else if ( ( (log10(length(mutData)/(6*2))/log10(4)) %% 1 ) == 0 ) {
            
            # this must be with transcription direction
            haveNumBases <- log10(length(mutData)/(6*2))/log10(4) + 1
            haveTrDir <- TRUE
            haveType <- "Alexandrov"
        }
        
    } else{
        warning(paste("cannot determine the number of bases and presence",
                      "of transcription direction for signature/genome!\n"))
    }

    return(list("type"=haveType, "numBases"=haveNumBases, "trDir"=haveTrDir))
}

#####################
# internal function #
#####################

#' convAlx2Shi (internal function)
#'
#' Convert a single Alexandrov signature to a Shiraishi signature.
#'
#' @usage convAlx2Shi(x)
#' @param x The Alexandrov signature (mutation pattern vector) to be converted.
#' @return A Shiraishi signature (mutation pattern matrix).
#' @author Rosario M. Piro\cr Politecnico di Milano\cr Maintainer: Rosario
#' M. Piro\cr E-Mail: <rmpiro@@gmail.com> or <rosariomichael.piro@@polimi.it>
#' @references \url{http://rmpiro.net/decompTumor2Sig/}\cr
#' Krueger, Piro (2019) decompTumor2Sig: Identification of mutational
#' signatures active in individual tumors. BMC Bioinformatics 
#' 20(Suppl 4):152.\cr
#' @keywords internal
convAlx2Shi <- function(x) {

    shSig <- NULL
    
    sigprop <- determineTypeNumBasesAndTrDir(x)
    
    haveTrDir <- sigprop$trDir

    basesAdj <- (sigprop$numBases-1)/2

    strLen <- 5 + 2*basesAdj + as.numeric(haveTrDir)   # examples: "A[T>G]C"
                                                       # or "AA[T>G]AC+" 

    if (is.null(names(x))) {
        # plain vector; need to name it according to Alexandrov model
        names(x) <- buildSortedAlexandrovSignaturePatternList(sigprop$numBases,
                                                              haveTrDir)
    }
    
    # first row: base change frequencies
    shSig <- rbind(shSig, as.vector(tapply(x, substr(names(x),
                                                     basesAdj+2,
                                                     basesAdj+4),
                                           sum)))

    if (basesAdj > 0) {
        # upstream base frequencies
        for (ii in seq(0,(basesAdj-1))) {
            shSig <- rbind(shSig,
                           c(as.vector(tapply(x, substr(names(x),1+ii,1+ii),
                                              sum)), rep(0,2))
                           )
        }

        # downstream base frequencies
        for (ii in seq(0,(basesAdj-1))) {
            shSig <- rbind(shSig,
                           c(as.vector(tapply(x, substr(names(x),
                                                        strLen-ii
                                                        -as.numeric(haveTrDir),
                                                        strLen-ii
                                                        -as.numeric(haveTrDir)),
                                              sum)), rep(0,2))
                           )
        }
    }

    if(haveTrDir) {
        shSig <- rbind(shSig,
                       c(as.vector(tapply(x, substr(names(x),strLen,strLen),
                                          sum)[c("+","-")]), rep(0,4))
                       )
    }

    setNames4ShiraishiTable(shSig)
}

# produces the file:
# Alexandrov_PMID_23945592_435_tumors-pmsignature-15sig.Rdata

###
### This is run by Alexandrov_PMID_23945592_435_tumors-pmsignature-15sig.sh !!!
###

library(pmsignature)
library(decompTumor2Sig)

NUMSIG <- 15

numBases <- 5
trDir <- TRUE
sigType <- "independent"   # Shiraishi

# get reference genome and transcript annotation
refGenome <- BSgenome.Hsapiens.UCSC.hg19::BSgenome.Hsapiens.UCSC.hg19
transcriptAnno <-
    TxDb.Hsapiens.UCSC.hg19.knownGene::TxDb.Hsapiens.UCSC.hg19.knownGene


# read mutation data by pmsignature

gfile <- "Somatic_SNVs_Alexandrov_genomes_only-noMT-min100snvs.tsv.gz"

G <- readMPFile(infile=gfile, trDir=trDir, numBases=numBases, type=sigType, bs_genome=refGenome, txdb_transcript=transcriptAnno)


# get signatures (and exposures) by de novo signature inference (pmsignature)
### IMPORTANT: this is a stochastic process, so signatures can slightly change
### every time this is executed; above all: there is no guarantee that they
### will have the same order as before!
Param <- getPMSignature(G, K=NUMSIG)


# convert the signatures to the decompTumor2Sig format
signatures <- getSignaturesFromEstParam(Param)

save(signatures, file="Alexandrov_PMID_23945592_435_tumors-pmsignature-15sig.Rdata")

#' Map one signature set to another.
#'
#' `mapSignatureSets()` determines a mapping from one set of signatures to
#' another. Both Alexandrov and Shiraishi signatures can be handled, but both
#' sets must be of the same type. The mapping can either be a unique
#' (one-to-one) mapping or identify best matches while allowing multiple
#' signatures to be mapped to the same target signature if it is the best
#' match for more than one signature.
#' Different distance measures can be used (see details below).
#'
#' Distances that can be used are:
#' 
#' \tabular{ll}{
#' \code{"frobenius"} \tab Forbenius distance between real-valued matrices\cr
#'                    \tab (or Shiraishi signatures) \code{A} and \code{B}:\cr
#'                    \tab \code{F = sqrt(trace( (A-B) \%*\% t(A-B) ))} \cr
#' \code{"rss"}       \tab Residual sum of squares (i.e., squared error):\cr
#'                    \tab \code{rss = sum((A-B)^2)} \cr
#' \code{"euclidean"} \tab (see \code{?dist} for details)\cr
#' \code{"maximum"}   \tab (see \code{?dist} for details)\cr
#' \code{"manhattan"} \tab (see \code{?dist} for details)\cr
#' \code{"canberra"}  \tab (see \code{?dist} for details)\cr
#' \code{"binary"}    \tab (see \code{?dist} for details)\cr
#' \code{"minkowski"} \tab (see \code{?dist} for details)\cr
#' }
#'
#' @usage mapSignatureSets(fromSignatures, toSignatures, method="euclidean",
#' unique=FALSE)
#' @param fromSignatures (Mandatory) A set (list) of signatures of the
#' Alexandrov (vector) or Shiraishi type (data frame or matrix), that has
#' to be mapped to the signatures of a second set (\code{toSignatures}).
#' @param toSignatures (Mandatory) The set (list) of signatures to which the
#' set of \code{fromSignatures} has to be mapped.
#' @param method (Optional) The distance measure to be used. This can be one
#' of the following: \code{"frobenius"} for Frobenius distance between matrices
#' (only for Shiraishi signatures); \code{"rss"} for the residual sum of squares
#' (squared error); or any distance measure available for the function
#' \code{dist()} of the \code{stats} package. Default: \code{"euclidean"}.
#' @param unique (Optional) If set to \code{FALSE} (default), then for each
#' signature of \code{fromSignatures} the best match (minimum distance) from
#' \code{toSignatures} is selected. The selected signatures need not be unique,
#' i.e., one signature of \code{toSignatures} may be the best match for
#' multiple signatures of \code{fromSignatures}. If set to \code{TRUE}, i.e.,
#' if a unique (one-to-one) mapping is required, an iterative approach is
#' performed: in each step, the best matching pair from \code{fromSignatures}
#' and \code{toSignatures} is mapped and then removed from the list of
#' signatures that remain to be mapped, such that they cannot be selected
#' again.
#' @return A vector having as elements the mapped signatures of
#' \code{toSignatures}, and as names the signatures of \code{fromSignatures}
#' with which they have been associated.
#' @author Rosario M. Piro\cr Politecnico di Milano\cr Maintainer: Rosario
#' M. Piro\cr E-Mail: <rmpiro@@gmail.com> or <rosariomichael.piro@@polimi.it>
#' @references \url{http://rmpiro.net/decompTumor2Sig/}\cr
#' Krueger, Piro (2019) decompTumor2Sig: Identification of mutational
#' signatures active in individual tumors. BMC Bioinformatics
#' 20(Suppl 4):152.\cr
#' @seealso \code{\link{decompTumor2Sig}}\cr
#' \code{\link{determineSignatureDistances}}
#' @examples
#' 
#' ### get Alexandrov signatures from COSMIC
#' signAlexandrov <- readAlexandrovSignatures()
#' 
#' ### convert them to Shiraishi signatures
#' signAlex2Shi <- convertAlexandrov2Shiraishi(signAlexandrov)
#' 
#' ### define a small set of arbitrary signatures just for testing
#' ### (similar to signatures 1, 5 and 13, respectively)
#' test1 <- matrix(c( 0.1,  0,    0.7,  0.1,  0.1,  0,
#'                    0.3,  0.2,  0.3,  0.2,  0,    0,
#'                    0.2,  0.1,  0.5,  0.2,  0,    0   ), nrow=3, byrow=TRUE)
#' 
#' test2 <- matrix(c( 0.1,  0.1,  0.3,  0.1,  0.3,  0.1,
#'                    0.3,  0.25, 0.2,  0.25, 0,    0,
#'                    0.3,  0.2,  0.2,  0.3,  0,    0   ), nrow=3, byrow=TRUE)
#' 
#' test3 <- matrix(c( 0.1,  0.7,  0.2,  0,    0,    0,
#'                    0,    0,    0,    1.0,  0,    0,
#'                    0.5,  0.1,  0,    0.4,  0,    0   ), nrow=3, byrow=TRUE)
#' 
#' fromSig <- list(sig1=test1, sig2=test2, sig3=test3)
#' 
#' ### compute distances of the test signature to the converted
#' ### Alexandrov signatures from COSMIC
#' mapSignatureSets(fromSig, signAlex2Shi, method="frobenius", unique=TRUE)
#' 
#' @export mapSignatureSets
mapSignatureSets <- function(fromSignatures, toSignatures,
                             method="euclidean", unique=FALSE) {
    
    if (!isSignatureSet(fromSignatures)) {
        stop("Parameter 'fromSignatures' must be a set (list) of signatures!")
    }

    if (!isSignatureSet(toSignatures)) {
        stop("Parameter 'toSignatures' must be a set (list) of signatures!")
    }

    # from and to must be of the same format
    if (!sameSignatureFormat(fromSignatures, toSignatures)) {
        stop(paste("fromSignatures and toSignatures must be of the same",
                   "type and format!"))
    }

    # if we require a unique mapping, the number of fromSignatures must not
    # exceed the number of toSignatures
    if (unique & (length(fromSignatures) > length(toSignatures))) {
        stop(paste("for a unique mapping the number of fromSignatures",
                   "must not exceed the number of toSignatures!"))
    }

    # make sure we have signature names
    if (is.null(names(fromSignatures))) {
        names(fromSignatures) <- paste0("sign_", c(seq_along(fromSignatures)))
    }
    if (is.null(names(toSignatures))) {
        names(toSignatures) <- paste0("sign_", c(seq_along(toSignatures)))
    }

    # keep the names of the fromSignatures, but remove them from the object
    fromSigNames <- names(fromSignatures)
    names(fromSignatures) <- NULL

    
    if (!unique) {
        
        # no unique mapping is required; for each fromSignature
        # simply choose the most similar one from toSignatures
        mapping <- vapply(fromSignatures, function(from) {
            d <- determineSignatureDistances(from, toSignatures, method=method)
            names(sort(d))[1] # sort by distance, take name of first
        }, FUN.VALUE=character(1) )

        names(mapping) <- fromSigNames
    } else {
        
        # we want a unique mapping, iteratively identify the best 
        # from->to pair (shortest distance), then remove both to find the
        # next best ...
        mapping <- c()

        names(fromSignatures) <- fromSigNames
        
        while (length(fromSignatures) > 0) {

            if (length(fromSignatures) == 1 &&
                length(toSignatures) == 1) {

                # the remaining signatures are 1 for each set; this mapping
                # is clear ...
                fromS <- names(fromSignatures)
                toS <- names(toSignatures)

                # keep mapping
                names(toS) <- fromS
                mapping <- c(mapping, toS)

                # no need to continue
                break
            }

            # there are either multiple "from" or multiple "to" signatures
            # need to continue to find the minimum distance
            
            distsMatrix <- vapply(fromSignatures, function(from) {
                d <- determineSignatureDistances(from, toSignatures,
                                                 method=method)
            }, FUN.VALUE=numeric(length(toSignatures)) )

            # find minimum distance
            thisMin <- which(distsMatrix==min(distsMatrix), arr.ind=TRUE)

            fromS <- colnames(distsMatrix)[thisMin[1,"col"]]
            toS <- rownames(distsMatrix)[thisMin[1,"row"]]

            # keep mapping
            names(toS) <- fromS
            mapping <- c(mapping, toS)

            # remove the two signatures from the respective sets
            fromSignatures[thisMin[1,"col"]] <- NULL
            toSignatures[thisMin[1,"row"]] <- NULL
        }

        # reorder mapping according to fromSignature input
        mapping <- mapping[fromSigNames]
    }

    return(mapping)
}

.onAttach <- function(libname, pkgname){
     packageStartupMessage( "" )
     packageStartupMessage( "Welcome to decompTumor2Sig" )
     packageStartupMessage( "--------------------------" )
     packageStartupMessage( "" )
     packageStartupMessage( "See ?decompTumor2Sig for a list of" )
     packageStartupMessage( "available functions." )
     packageStartupMessage( "" )
}

#####################
# internal function #
#####################

#' processMultipleSigSets (internal function)
#'
#' Performs the quadratic programming/exposure prediction for multiple
#' subsets (of size k) of mutational signatures and returns information on the
#' best subset (highest explained variance). This function is used by
#' \code{getBestDecomp4Ksignatures} and \code{addBestSignatureToSubset}.
#'
#' @usage processMultipleSigSets(genome, signatures, sigCombn, k,
#' constrainToMaxContribution=FALSE, tolerance=0.1)
#' @param genome Genome for which to approximate the decomposition.
#' @param signatures The whole set of signatures (from which to choose
#' a subset signatures.
#' @param sigCombn The combinations of subsets of \code{k} signatures to use.
#' Has to be the same format as generated by \code{combn}.
#' @param k Number of signatures to use (subset size).
#' @param constrainToMaxContribution (Optional) [Note: this is experimental
#' and is usually not needed!] If \code{TRUE}, the maximum contribution that
#' can be attributed to a signature will be constraint by the variant feature
#' counts (e.g., specific flanking bases) observed in the individual tumor
#' genome. If, for example, 30\% of all observed variants have a specific
#' feature and 60\% of the variants produced by a mutational process/signature
#' will manifest the feature, then the signature can have contributed up to
#' 0.3/0.6 (=0.5 or 50\%) of the observed variants. The lowest possible
#' contribution over all signature features will be taken as the allowed
#' maximum contribution of the signature. This allowed maximum will
#' additionally be increased by the value specified as \code{tolerance}
#' (see below). For the illustrated example and \code{tolerance}=0.1 a
#' contribution of up to 0.5+0.1 = 0.6 (or 60\%) of the signature would be
#' allowed. 
#' @param tolerance (Optional) If \code{constrainToMaxContribution} is
#' \code{TRUE}, the maximum contribution computed for a signature is increased
#' by this value (see above). If the parameter \code{constrainToMaxContribution}
#' is \code{FALSE}, the tolerance value is ignored. Default: 0.1. 
#' @return A list object containing: k=number of signatures; 
#' explVar=variance explained by these signatures; 
#' sigList=list of the signatures; 
#' decomposition=decomposition (exposures) obtained with these signatures.
#' @author Rosario M. Piro\cr Politecnico di Milano\cr Maintainer: Rosario
#' M. Piro\cr E-Mail: <rmpiro@@gmail.com> or <rosariomichael.piro@@polimi.it>
#' @references \url{http://rmpiro.net/decompTumor2Sig/}\cr
#' Krueger, Piro (2019) decompTumor2Sig: Identification of mutational
#' signatures active in individual tumors. BMC Bioinformatics
#' 20(Suppl 4):152.\cr
#' @keywords internal
processMultipleSigSets <- function(genome, signatures, sigCombn, k,
                                   constrainToMaxContribution=FALSE,
                                   tolerance=0.1) {

    decompTmp <- lapply(sigCombn, function(sigIndices) {

        # signatures to be used
        sigs <- signatures[sigIndices]
                
        # decompose for these signatures
        QPforSig(genome, sigs,
                 constrainToMaxContribution=constrainToMaxContribution,
                 tolerance=tolerance)
    } )

    explVarTmp <- vapply(names(decompTmp), function(sigsNames) {

        # signatures to be used
        sigs <- signatures[unlist(strsplit(sigsNames, "|", fixed=TRUE))]
                
        # determine the explained variance for this decomposition
        computeExplainedVariance(decompTmp[sigsNames], sigs, list(genome))
    }, FUN.VALUE=numeric(1) )
    names(explVarTmp) <- names(decompTmp)

    # which was the best explained variance for this number of signatures?
    explVar <- max(explVarTmp)

    # which decomposition achieved this explained variance? If multiple do,
    # select one at random
    if (length(which(explVarTmp == explVar)) > 1) {
        explVarIndex <- sample(which(explVarTmp == explVar),1)
    } else {
        # only on, using sample would lead to wrong behavior!
        explVarIndex <- which(explVarTmp == explVar)
    }
    
    sigList <-
        unlist(strsplit(names(explVarTmp)[explVarIndex], "|", fixed=TRUE))

    decomposition <- decompTmp[[explVarIndex]]
    names(decomposition) <- sigList

    list(k = k,
         explVar = explVar,
         sigList = sigList,
         decomposition = decomposition)
}

#####################
# internal function #
#####################

#' setNames4ShiraishiTable (internal function)
#'
#' Set row and column names of a Shiraishi-model genome or signature table.
#'
#' @usage setNames4ShiraishiTable(table)
#' @param table The table to be named.
#' @return The same table with named columns and rows.
#' @author Rosario M. Piro\cr Politecnico di Milano\cr Maintainer: Rosario
#' M. Piro\cr E-Mail: <rmpiro@@gmail.com> or <rosariomichael.piro@@polimi.it>
#' @references \url{http://rmpiro.net/decompTumor2Sig/}\cr
#' Krueger, Piro (2019) decompTumor2Sig: Identification of mutational
#' signatures active in individual tumors. BMC Bioinformatics
#' 20(Suppl 4):152.\cr
#' @keywords internal
setNames4ShiraishiTable <- function(table) {

    # the table needs to be compatible with the Shiraishi model
    stopifnot(ncol(table) == 6)
    
    # determine whether we have transcription information and how many
    # bases the sequence patterns have [note: we don't use the function
    # 'determineTypeNumBasesAndTrDir' here, because that works only
    # for tables which respect the probability constraints (row sums are 1).
    # But we want to be able to use 'setNames4ShiraishiTable' also
    # for initialized tables which contain only zeroes or dummy values

    trDir <- TRUE
    if (nrow(table) %% 2) {
        # odd number of rows: only sequence pattern, no transcript direction
        trDir <- FALSE
    }

    numBases <- nrow(table) - as.numeric(trDir)


    # set column names
    colnames(table) <- c("[C>A]","[C>G]","[C>T]","[T>A]","[T>C]","[T>G]")

    # set row names
    rnames <- c("mut")

    if (numBases > 1) {
        rnames <- c(rnames, seq(-(numBases%/%2),-1), seq_len(numBases%/%2))
        rnames <- gsub("^([0-9]*)$", "+\\1", rnames)
    }
        
    if(trDir) {
        rnames <- c(rnames, "tr")
    }

    rownames(table) <- rnames

    # return the named table
    table
}

#' decompTumor2Sig - Decomposition of individual tumors into mutational
#' signatures by signature refitting
#' 
#' The decompTumor2Sig package uses quadratic programming to decompose the
#' somatic mutation catalog from an individual tumor sample (or multiple
#' individual tumor samples) into a set of given mutational signatures (either
#' of the "Alexandrov model" by Alexandrov et al, Nature 500(7463):415-421,
#' 2013, or the "Shiraishi model" by Shiraishi et al, PLoS Genet
#' 11(12):e1005657, 2015), thus computing weights (or "exposures") that reflect
#' the contributions of the signatures to the mutation load of the tumor.
#' 
#' \tabular{ll}{
#' Package: \tab decompTumor2Sig\cr
#' Type: \tab Package\cr
#' Version: \tab 2.13.1\cr
#' Date: \tab 2022-05-09\cr
#' License: \tab GPL (>=2)\cr
#' }
#' 
#' The package provides the following functions:
#' 
#' \tabular{ll}{
#'
#' adjustSignaturesForRegionSet():\tab adjust (normalize) mutational\cr
#'                         \tab signatures for use with mutation data from a\cr
#'                         \tab specific, limited subset of genomic regions\cr
#'                         \tab (e.g., for targetted sequencing).\cr 
#' 
#' composeGenomesFromExposures():\tab (re-)construct tumor genome mutation\cr
#'                         \tab frequencies from the signatures and\cr
#'                         \tab their corresponding exposures, or\cr
#'                         \tab contributions.\cr
#'
#' computeExplainedVariance():\tab determine the variance explained by \cr
#'                         \tab estimated signature contributions\cr
#'                         \tab (i.e., exposures to signatures).\cr
#'
#' convertAlexandrov2Shiraishi():\tab convert a set of Alexandrov \cr
#'                         \tab signatures to Shiraishi signatures.\cr
#'
#' convertGenomesFromVRanges():\tab convert a genome or set of genomes\cr
#'                         \tab from a \code{VariantAnnotation::VRanges}\cr
#'                         \tab object.\cr
#'
#' decomposeTumorGenomes():\tab determine the weights/contributions of\cr
#'                         \tab a set of signatures to each of a set of\cr
#'                         \tab individual tumor genomes.\cr
#' 
#' determineSignatureDistances():\tab for a given signature \cr
#'                         \tab compute its distances to each of a set\cr
#'                         \tab of target signatures.\cr
#'
#' downgradeShiraishiSignatures():\tab downgrade Shiraishi signatures\cr
#'                         \tab by removing flanking bases and/or the\cr
#'                         \tab transcription direction.\cr
#' 
#' evaluateDecompositionQuality():\tab evaluate the quality of a\cr
#'                         \tab decomposition by comparing the\cr
#'                         \tab re-composed (=re-constructed) tumor\cr
#'                         \tab mutation frequencies to those actually\cr
#'                         \tab observed in the tumor genome.\cr
#'
#' getGenomesFromMutFeatData():\tab extract the genomes from a \cr
#'                         \tab \code{MutationFeatureData} object as \cr
#'                         \tab provided by, for example,\cr
#'                         \tab \code{pmsignature::readMPFile}.\cr
#'
#' getSignaturesFromEstParam():\tab extract a set of signatures from an \cr
#'                         \tab \code{EstimatedParameters} object as\cr
#'                         \tab returned by function \code{getPMSignature}\cr
#'                         \tab of the \code{pmsignature} package.\cr
#'
#' isAlexandrovSet():      \tab checks whether the input list is\cr
#'                         \tab compatible with the Alexandrov format\cr
#'                         \tab (probability vectors).\cr
#'
#' isExposureSet():        \tab checks whether the input list is\cr
#'                         \tab compatible with exposure output obtained\cr
#'                         \tab from \code{decomposeTumorGenomes}.\cr
#' 
#' isShiraishiSet():       \tab checks whether the input list is\cr
#'                         \tab compatible with the Shiraishi format\cr
#'                         \tab (matrices or data.frames of\cr
#'                         \tab probabilities).\cr
#' 
#' isSignatureSet():       \tab checks whether the input list is\cr
#'                         \tab compatible with either the Alexandrov\cr
#'                         \tab or Shiraishi format.\cr
#' 
#' mapSignatureSets():     \tab find a mapping from one signature\cr
#'                         \tab set to another.\cr
#'
#' plotDecomposedContribution():\tab plot the decomposition of a\cr
#'                         \tab genome into mutational signatures\cr
#'                         \tab (i.e., the contributions of, or\cr
#'                         \tab exposures to, the signatures).\cr
#'
#' plotExplainedVariance():\tab plot the variance of a genome's\cr
#'                         \tab mutation patterns which can be\cr
#'                         \tab explained with an increasing number\cr
#'                         \tab of signatures.\cr
#'
#' plotMutationDistribution():\tab plot a single signature or the\cr
#'                         \tab mutation frequency data for a single\cr
#'                         \tab genome.\cr
#'
#' readAlexandrovSignatures():\tab read Alexandrov signatures in the\cr
#'                         \tab COSMIC format from a flat file or URL.\cr
#'
#' readGenomesFromMPF():   \tab read a genome or set of genomes from a \cr
#'                         \tab Mutation Position Format (MPF) file.\cr
#'
#' readGenomesFromVCF():   \tab read a genome or set of genomes from a\cr
#'                         \tab Variant Call Format (VCF) file.\cr
#'
#' readShiraishiSignatures():\tab read Shiraishi signatures from\cr
#'                         \tab flat files.\cr
#'
#' sameSignatureFormat():  \tab checks whether two input lists are sets\cr
#'                         \tab of signatures of the same format.\cr
#' 
#' }
#' 
#' @name decompTumor2Sig-package
#' @aliases decompTumor2Sig-package decompTumor2Sig
#' @docType package
#' @author Rosario M. Piro, Politecnico di Milano [aut, cre]\cr
#' Sandra Krueger, Freie Universitaet Berlin [ctb]\cr
#' Maintainer: Rosario M. Piro\cr
#' E-Mail: <rmpiro@@gmail.com> or <rosariomichael.piro@@polimi.it>
#' @references \url{http://rmpiro.net/decompTumor2Sig/}\cr
#' Krueger, Piro (2019) decompTumor2Sig: Identification of mutational
#' signatures active in individual tumors. BMC Bioinformatics 
#' 20(Suppl 4):152.\cr
NULL

#' Compose tumor genomes from exposures.
#'
#' `composeGenomesFromExposures()` re-composes (or predicts) tumor genomes
#' (i.e., their mutation frequencies) from the given mutational signatures and
#' their corresponding exposures, or contributions. The (re-)composition is
#' performed by computing the weighted sum of the mutational signatures, where
#' the weights are the exposures (=contributions) of the corresponding
#' signatures. This can, for example, be used to verify that a decomposition
#' obtained from \code{decomposeTumorGenomes} is meaningful.
#'
#' @usage composeGenomesFromExposures(exposures, signatures)
#' @param exposures (Mandatory) A single vector or list of vectors containing
#' the estimated signature contributions/exposures as computed by the function
#' \code{decomposeTumorGenomes}. A list of vectors is used if the
#' (re-)composition shall be performed for multiple genomes. The number of
#' elements of each exposure vector must correspond to the number of
#' \code{signatures}. 
#' @param signatures (Mandatory) The list of signatures (vectors, data frames
#' or matrices) for which the exposures were obtained. Each of the list
#' objects represents one mutational signature. Vectors are used for
#' Alexandrov signatures, data frames or matrices for Shiraishi signatures.
#' @return A list of "predicted" genomes, i.e., the frequencies of their
#' mutational patterns computed as weighted sums of the mutational signatures,
#' where the weights correspond to the contributions of, i.e., exposures to,
#' the corresponding signatures.
#'
#' @author Rosario M. Piro\cr Politecnico di Milano\cr Maintainer: Rosario
#' M. Piro\cr E-Mail: <rmpiro@@gmail.com> or <rosariomichael.piro@@polimi.it>
#' @references \url{http://rmpiro.net/decompTumor2Sig/}\cr
#' Krueger, Piro (2019) decompTumor2Sig: Identification of mutational
#' signatures active in individual tumors. BMC Bioinformatics 
#' 20(Suppl 4):152.\cr
#' @seealso \code{\link{decompTumor2Sig}}\cr
#' \code{\link{decomposeTumorGenomes}}
#' @examples
#' 
#' ### get Alexandrov signatures from COSMIC
#' signatures <- readAlexandrovSignatures()
#' 
#' ### load preprocessed breast cancer genomes (object 'genomes') from
#' ### Nik-Zainal et al (PMID: 22608084) 
#' gfile <- system.file("extdata",
#'          "Nik-Zainal_PMID_22608084-genomes-Alexandrov_3bases.Rdata", 
#'          package="decompTumor2Sig")
#' load(gfile)
#' 
#' ### compute exposures
#' exposures <- decomposeTumorGenomes(genomes, signatures, verbose=FALSE)
#' 
#' ### re-compose (predict) tumor genome features from exposures
#' predGenomes <- composeGenomesFromExposures(exposures, signatures)
#' 
#' @export composeGenomesFromExposures
composeGenomesFromExposures <- function(exposures, signatures) {

    if (is.probability.vector(exposures)) {
        # this is only one genome, use a list nonetheless for later iteration
        exposures <- list(exposures)
    }

    if (!isExposureSet(exposures)) {
        stop("Parameter exposures must be a list of probability vectors.")
    }
    
    if (!isSignatureSet(signatures)) {
        stop("Parameter signatures must be a set (list) of signatures.")
    }

    predGenomes <- list()
    
    for (e in seq_along(exposures)) {

        if(is.null(exposures[[e]])) {
            # didn't exceed minExplainedVariance ... can't reconstruct this
            predGenomes[[e]] <- NULL
            next
        }
        
        exp <- exposures[[e]]

        if (!is.numeric(exp)) {
            stop("exposures must be numeric vectors.")
        }

        
        # make sure we replace NA by 0 (signatures that were not selected in a
        # search, i.e., they of course have 0 contribution/exposure
        exp[which(is.na(exp))] <- 0
        
        # check that we have as many exposure values as signatures
        if(length(exp)!=length(signatures)) {
            stop(paste("Number of exposure values different from",
                       "number of signatures."))
        }

        # multiply exposures with the corresponding signatures and sum results
        for (ii in seq_along(exp)) {

            if (ii==1) {
                # first: set pred
                pred <- exp[ii]*signatures[[ii]]
            } else {
                # add the following
                pred <- pred + exp[ii]*signatures[[ii]]
            }
        }

        tnbt <- determineTypeNumBasesAndTrDir(pred)
        if (tnbt$type == "Shiraishi") {
            # Shiraishi model; add column and row names
            pred <- setNames4ShiraishiTable(pred)
        } else if (tnbt$type == "Alexandrov") {
            # Alexandrov model; add vector names
            names(pred) <-
                buildSortedAlexandrovSignaturePatternList(tnbt$numBases,
                                                          tnbt$trDir)
        }
        
        predGenomes[[e]] <- pred
    }

    # names of the genomes
    if (!is.null(names(exposures))) {
        names(predGenomes) <- names(exposures)
    }
    
    return(predGenomes)
}

#' Read tumor genomes from an MPF file (Mutation Position Format).
#'
#' `readGenomesFromMPF()` reads somatic mutations of a single tumor genome
#' (sample) or a set of genomes from an MPF file (Mutation Position Format;
#' see details below) and determines the mutation frequencies according to
#' a specific model of mutational signatures (Alexandrov or Shiraishi).
#'
#' An MPF file has the following format (one line per mutation and
#' patient/sample):
#'
#' [sampleID]<tab>[chrom]<tab>[position]<tab>[ref_bases]<tab>[alt_bases]
#'
#' @usage readGenomesFromMPF(file, numBases=5, type="Shiraishi", trDir=TRUE,
#' enforceUniqueTrDir=TRUE, 
#' refGenome=BSgenome.Hsapiens.UCSC.hg19::BSgenome.Hsapiens.UCSC.hg19,
#' transcriptAnno=
#' TxDb.Hsapiens.UCSC.hg19.knownGene::TxDb.Hsapiens.UCSC.hg19.knownGene,
#' verbose=TRUE)
#' @param file (Mandatory) The name of the MPF file (can be compressed with
#' \code{gzip}).
#' @param numBases (Mandatory) Total number of bases (mutated base and
#' flanking bases) to be used for sequence patterns. Must be odd. Default: 5
#' @param type (Mandatory) Signature model or type (\code{"Alexandrov"} or
#' \code{"Shiraishi"}). Default: \code{"Shiraishi"}
#' @param trDir (Mandatory) Specifies whether the transcription direction is
#' taken into account in the signature model. If so, only mutations within
#' genomic regions with a defined transcription direction can be considered.
#' Default: \code{TRUE}
#' @param enforceUniqueTrDir (Optional) Used only if \code{trDir} is
#' \code{TRUE}. If \code{enforceUniqueTrDir} is TRUE (default), then mutations
#' which map to a region with multiple overlapping genes with opposing
#' transcription directions will be excluded from the analysis. If \code{FALSE},
#' the transcript direction encountered first in the transcript database (see
#' \code{transcriptAnno}) is assigned to the mutation. The latter was the
#' behavior until version 1.3.5 of \code{decompTumor2Sig} and is also the
#' behavior of \code{pmsignature}. However, it is preferable to exclude
#' these mutations from the count (default) because from mutation data alone
#' it cannot be inferred which of the two genes has the higher transcriptional
#' activity which might potentially be linked to the occurrence of the mutation.
#' (If you are unsure, use the default setting; this option exists mostly for
#' backward compatibility with older versions.)
#' @param refGenome (Mandatory) The reference genome (\code{BSgenome}) needed
#' to extract sequence patterns. Default: \code{BSgenome} object for hg19.
#' @param transcriptAnno (Optional) Transcript annotation (\code{TxDb} object)
#' used to determine the transcription direction. This is required only if
#' \code{trDir} is \code{TRUE}. Default: \code{TxDb} object for hg19.
#' @param verbose (Optional) Print information about reading and processing the
#' mutation data. Default: \code{TRUE}
#' @return A list containing the genomes in terms of frequencies of the mutated
#' sequence patterns. This list of genomes can be used for
#' \code{decomposeTumorGenomes}. 
#' @author Rosario M. Piro\cr Politecnico di Milano\cr Maintainer: Rosario
#' M. Piro\cr E-Mail: <rmpiro@@gmail.com> or <rosariomichael.piro@@polimi.it>
#' @references \url{http://rmpiro.net/decompTumor2Sig/}\cr
#' Krueger, Piro (2019) decompTumor2Sig: Identification of mutational
#' signatures active in individual tumors. BMC Bioinformatics
#' 20(Suppl 4):152.\cr
#' @seealso \code{\link{decompTumor2Sig}}\cr
#' \code{\link{decomposeTumorGenomes}}\cr
#' \code{\link{readGenomesFromVCF}}\cr
#' \code{\link{getGenomesFromMutFeatData}}
#' @examples
#' 
#' ### load reference genome and transcript annotation (if direction is needed)
#' refGenome <- BSgenome.Hsapiens.UCSC.hg19::BSgenome.Hsapiens.UCSC.hg19
#' transcriptAnno <-
#'   TxDb.Hsapiens.UCSC.hg19.knownGene::TxDb.Hsapiens.UCSC.hg19.knownGene
#' 
#' ### read breast cancer genomes from Nik-Zainal et al (PMID: 22608084) 
#' gfile <- system.file("extdata", "Nik-Zainal_PMID_22608084-MPF.txt.gz", 
#'          package="decompTumor2Sig")
#' genomes <- readGenomesFromMPF(gfile, numBases=5, type="Shiraishi",
#'          trDir=TRUE, enforceUniqueTrDir=TRUE, refGenome=refGenome,
#'          transcriptAnno=transcriptAnno, verbose=FALSE)
#' 
#' @importFrom plyr aaply
#' @importFrom utils read.table
#' @importFrom data.table as.data.table
#' @importFrom BSgenome.Hsapiens.UCSC.hg19 BSgenome.Hsapiens.UCSC.hg19
#' @importFrom TxDb.Hsapiens.UCSC.hg19.knownGene
#' TxDb.Hsapiens.UCSC.hg19.knownGene
#' @export readGenomesFromMPF
readGenomesFromMPF <- function(file, numBases=5, type="Shiraishi", trDir=TRUE,
    enforceUniqueTrDir=TRUE,
    refGenome=BSgenome.Hsapiens.UCSC.hg19::BSgenome.Hsapiens.UCSC.hg19,
    transcriptAnno=
        TxDb.Hsapiens.UCSC.hg19.knownGene::TxDb.Hsapiens.UCSC.hg19.knownGene,
    verbose=TRUE) {

    # read mutation data
    if(verbose) {
        cat("Reading mutations and patient/sample IDs from MPF file:\n")
    }

    mpf <- as.matrix(read.table(file, header=FALSE, row.names=NULL, sep="\t"))
    colnames(mpf) <- c("SAMPLE", "CHROM", "POS", "REF", "ALT")

    # remove all spaces (some files contain them, e.g., in the POS field ...
    # (this is faster for a table than a data.table, so we do it first)
    mpf <- gsub(" ", "", mpf)
    
    # data.table objects can be modified much more efficiently
    mpf <- as.data.table(mpf)

    # get only SNVs (one REF base and one ALT base)
    # (indels can be specified as, e.g. deletion, "AG > A" or as "G > -")
    snvRows <- (nchar(mpf$REF) == 1) & (nchar(mpf$ALT) == 1) &
        (mpf$REF != "-") & (mpf$ALT != "-") &
        (mpf$REF != "N") & (mpf$ALT != "N")
    mpf <- mpf[snvRows]

    # we need to map mutations to samples, so that we can create
    # VCF-like, dummy genotype information

    sampleIDlist <- sort(unique(mpf$SAMPLE))


    ## add genotype information
    #mpf$FORMAT <- rep("GT", nrow(mpf))
    #
    ## construct genotype information for individual samples
    #for (sid in sampleIDlist) {
    #    gt <- rep(NA, nrow(mpf))
    #    gt[mpf$SAMPLE == sid] <- "1/1"
    #
    #    mpf[,sid] <- gt
    #}
    #
    ## now remove the sample ID (we have it in the genotype information)
    #mpf$SAMPLE = NULL
    #
    ## we have now (example):
    ##> mpf[1:10,]
    ##X1  CHROM  POS      REF ALT FORMAT PD3851a PD3890a PD3904a PD3905a 
    ##  1 "chr1" "809687" "G" "C" "GT"   "1/1"   NA      NA      NA      
    ##  2 "chr1" "819245" "G" "T" "GT"   "1/1"   NA      NA      NA 
    #
    #genomes <- buildGenomesFromMutationData(snvs=as.matrix(mpf),
    #                                        numBases=numBases,
    #                                        type=type, trDir=trDir,
    #                                        uniqueTrDir=enforceUniqueTrDir,
    #                                        refGenome=refGenome,
    #                                        transcriptAnno=transcriptAnno,
    #                                        verbose=verbose)

    maxN <- 20        # don't process more than 20 genomes at once,
                      # otherwise the memory consumption explodes
    
    if (verbose & (length(sampleIDlist) > maxN)) {
        cat(paste0("Too many tumors genomes; processing in batches ",
                   "(max ",maxN,") to limit memory usage!\n"))
    }

    genomes <- list()
        
    while(length(sampleIDlist)) {

        if (length(sampleIDlist) < maxN) {
            # remainder is smaller than batch size
            maxN <- length(sampleIDlist)
        }

        # get subset of mutations for this sample
        mpfS <- mpf[mpf$SAMPLE %in% sampleIDlist[seq(maxN)],]
        mpfS$FORMAT <- rep("GT", nrow(mpfS))

        for (sid in sampleIDlist[seq(maxN)]) {
            gt <- rep(NA, nrow(mpfS))
            gt[mpfS$SAMPLE == sid] <- "1/1"

            mpfS[,sid] <- gt
        }

        mpfS$SAMPLE = NULL

        genomes <-
            c(genomes, 
              buildGenomesFromMutationData(snvs=as.matrix(mpfS),
                                           numBases=numBases,
                                           type=type, trDir=trDir,
                                           uniqueTrDir=enforceUniqueTrDir,
                                           refGenome=refGenome,
                                           transcriptAnno=transcriptAnno,
                                           verbose=verbose)
              )

        # remove this batch of samples from the list
        sampleIDlist <- sampleIDlist[-seq(maxN)]

    } # end while

    if(verbose && length(genomes) > 0) {
        cat("Done reading genomes.\n")
    }

    return(genomes)

}

#' Determine differences between a given signature and a set of
#' target signatures.
#'
#' `determineSignatureDistances()` determines all distances (i.e., differences)
#' between a given signature (of type Alexandrov or Shiraishi) and a set
#' of target signatures (of the same type). This can help to compare signatures
#' that have been determined in different ways or from different datasets.
#' Different distance measures can be used (see details below).
#'
#' Distances that can be used are:
#' 
#' \tabular{ll}{
#' \code{"frobenius"} \tab Forbenius distance between real-valued matrices\cr
#'                    \tab (or Shiraishi signatures) \code{A} and \code{B}:\cr
#'                    \tab \code{F = sqrt(trace( (A-B) \%*\% t(A-B) ))} \cr
#' \code{"rss"}       \tab Residual sum of squares (i.e., squared error):\cr
#'                    \tab \code{rss = sum((A-B)^2)} \cr
#' \code{"euclidean"} \tab (see \code{?dist} for details)\cr
#' \code{"maximum"}   \tab (see \code{?dist} for details)\cr
#' \code{"manhattan"} \tab (see \code{?dist} for details)\cr
#' \code{"canberra"}  \tab (see \code{?dist} for details)\cr
#' \code{"binary"}    \tab (see \code{?dist} for details)\cr
#' \code{"minkowski"} \tab (see \code{?dist} for details)\cr
#' }
#' 
#' @usage determineSignatureDistances(fromSignature, toSignatures,
#'                                    method="euclidean")
#' @param fromSignature (Mandatory) A single signature of the Alexandrov
#' (vector) or Shiraishi type (data frame or matrix). 
#' @param toSignatures (Mandatory) The list of target signatures for which to
#' compute the distances to \code{fromSignature}. These target signatures
#' must be of the same type and format as \code{fromSignature}. 
#' @param method (Optional) The distance measure to be used. This can be one
#' of the following: \code{"frobenius"} for Frobenius distance between
#' matrices (only for Shiraishi signatures); \code{"rss"} for the residual
#' sum of squares (squared error); or any distance measure available for
#' the function \code{dist} of the \code{stats} package.
#' Default: \code{"euclidean"}.
#' @return A signature-named vector containing all distances. This vector has
#' the same order as the target signature list, so it is not sorted according
#' to distance.
#' @author Rosario M. Piro\cr Politecnico di Milano\cr Maintainer: Rosario
#' M. Piro\cr E-Mail: <rmpiro@@gmail.com> or <rosariomichael.piro@@polimi.it>
#' @references \url{http://rmpiro.net/decompTumor2Sig/}\cr
#' Krueger, Piro (2019) decompTumor2Sig: Identification of mutational
#' signatures active in individual tumors. BMC Bioinformatics 
#' 20(Suppl 4):152.\cr
#' @seealso \code{\link{decompTumor2Sig}}\cr
#' \code{\link{mapSignatureSets}}
#' @examples
#' 
#' ### get Alexandrov signatures from COSMIC
#' signAlexandrov <- readAlexandrovSignatures()
#' 
#' ### convert them to Shiraishi signatures
#' signAlex2Shi <- convertAlexandrov2Shiraishi(signAlexandrov)
#' 
#' ### define an arbitrary signature just for testing
#' ### (similar to signature 1)
#' testSig <- matrix(c(0.1,   0, 0.7, 0.1, 0.1,   0,
#'                     0.3, 0.2, 0.3, 0.2,   0,   0,
#'                     0.2, 0.1, 0.5, 0.2,   0,   0), nrow=3, byrow=TRUE) 
#' 
#' ### compute distances of the test signature to the converted
#' ### Alexandrov signatures from COSMIC
#' determineSignatureDistances(testSig, signAlex2Shi, method="frobenius")
#' 
#' @importFrom stats dist
#' @export determineSignatureDistances
determineSignatureDistances <- function(fromSignature, toSignatures,
                                        method="euclidean") {

    if (!isSignatureSet(toSignatures)) {
        stop("Parameter 'toSignatures' must be a list of signature objects!")
    }
    
    # is the toSignatures are unnamed, name them by enumerating them
    if(is.null(names(toSignatures))) {
        names(toSignatures) <- paste0("sign_",seq_along(toSignatures))
    }

    if (!is.probability.object(fromSignature)) {
        
        stop(paste("'fromSignature' must be a single Alexandrov signature",
                   "(data.frame or matrix) or Shiraishi signature (vector)!"))
    }

    if (!sameSignatureFormat(list(fromSignature), toSignatures)) {
        stop("fromSignature and toSignatures must be of the same format.")
    }

    
    # allow Frobenius distance only for data.frame or matrix
    if (method == "frobenius" &
        !(isShiraishiSet(list(fromSignature))) ) {

        stop(paste("Frobenius distance can be used only for Shiraishi",
                   "signatures (matrix or data.frame)!"))
    }
    
    distances <- vapply(toSignatures, function(s) {
        # first, check we have the same format as fromSignature
        if (as.vector(length(fromSignature)) != as.vector(length(s))) {
            stop("Formats of fromSignature and toSignatures must match!")
        }

        # determine distance
        if (method == "frobenius") {
            # Frobenius distance? use own implementation
            d <- computeFrobeniusNorm(as.matrix(fromSignature)-as.matrix(s))
        } else if (method == "rss") {
            # Residual sum of squares (squared error)
            d <- computeRSS(as.vector(fromSignature),as.vector(s))
        } else {
            # other distances? use "dist" from "stats"
            d <- dist(rbind(as.vector(fromSignature),as.vector(s)),
                      method=method)
        }

        d # return the computed distance
    }, FUN.VALUE=numeric(1) )
    
    #names(distances) <- names(toSignatures)
    #sort(distances)

    return(distances)
}

#' Read tumor genomes from a VCF file (Variant Call Format).
#'
#' `readGenomesFromVCF()` reads somatic mutations of a single tumor genome
#' (sample) or a set of genomes from a VCF file (Variant Call Format) and
#' determines the mutation frequencies according to a specific model of
#' mutational signatures (Alexandrov or Shiraishi).
#'
#' @usage readGenomesFromVCF(file, numBases=5, type="Shiraishi", trDir=TRUE,
#' enforceUniqueTrDir=TRUE,
#' refGenome=BSgenome.Hsapiens.UCSC.hg19::BSgenome.Hsapiens.UCSC.hg19,
#' transcriptAnno=
#' TxDb.Hsapiens.UCSC.hg19.knownGene::TxDb.Hsapiens.UCSC.hg19.knownGene,
#' verbose=TRUE)
#' @param file (Mandatory) The name of the VCF file (can be compressed with
#' \code{gzip}).
#' @param numBases (Mandatory) Total number of bases (mutated base and
#' flanking bases) to be used for sequence patterns. Must be odd. Default: 5
#' @param type (Mandatory) Signature model or type (\code{"Alexandrov"} or
#' \code{"Shiraishi"}). Default: \code{"Shiraishi"}
#' @param trDir (Mandatory) Specifies whether the transcription direction is
#' taken into account in the signature model. If so, only mutations within
#' genomic regions with a defined transcription direction can be considered.
#' Default: \code{TRUE}
#' @param enforceUniqueTrDir (Optional) Used only if \code{trDir} is
#' \code{TRUE}. If \code{enforceUniqueTrDir} is TRUE (default), then mutations
#' which map to a region with multiple overlapping genes with opposing
#' transcription directions will be excluded from the analysis. If \code{FALSE},
#' the transcript direction encountered first in the transcript database (see
#' \code{transcriptAnno}) is assigned to the mutation. The latter was the
#' behavior until version 1.3.5 of \code{decompTumor2Sig} and is also the
#' behavior of \code{pmsignature}. However, it is preferable to exclude
#' these mutations from the count (default) because from mutation data alone
#' it cannot be inferred which of the two genes has the higher transcriptional
#' activity which might potentially be linked to the occurrence of the mutation.
#' (If you are unsure, use the default setting; this option exists mostly for
#' backward compatibility with older versions.)
#' @param refGenome (Mandatory) The reference genome (\code{BSgenome}) needed
#' to extract sequence patterns. Default: \code{BSgenome} object for hg19.
#' @param transcriptAnno (Optional) Transcript annotation (\code{TxDb} object)
#' used to determine the transcription direction. This is required only if
#' \code{trDir} is \code{TRUE}. Default: \code{TxDb} object for hg19.
#' @param verbose (Optional) Print information about reading and processing the
#' mutation data. Default: \code{TRUE}
#' @return A list containing the genomes in terms of frequencies of the mutated
#' sequence patterns. This list of genomes can be used for
#' \code{decomposeTumorGenomes}. 
#' @author Rosario M. Piro\cr Politecnico di Milano\cr Maintainer: Rosario
#' M. Piro\cr E-Mail: <rmpiro@@gmail.com> or <rosariomichael.piro@@polimi.it>
#' @references \url{http://rmpiro.net/decompTumor2Sig/}\cr
#' Krueger, Piro (2019) decompTumor2Sig: Identification of mutational
#' signatures active in individual tumors. BMC Bioinformatics
#' 20(Suppl 4):152.\cr
#' @seealso \code{\link{decompTumor2Sig}}\cr
#' \code{\link{decomposeTumorGenomes}}\cr
#' \code{\link{readGenomesFromMPF}}\cr
#' \code{\link{getGenomesFromMutFeatData}}
#' @examples
#' 
#' ### load reference genome and transcript annotation (if direction is needed)
#' refGenome <- BSgenome.Hsapiens.UCSC.hg19::BSgenome.Hsapiens.UCSC.hg19
#' transcriptAnno <-
#'   TxDb.Hsapiens.UCSC.hg19.knownGene::TxDb.Hsapiens.UCSC.hg19.knownGene
#' 
#' ### read breast cancer genomes from Nik-Zainal et al (PMID: 22608084) 
#' gfile <- system.file("extdata",
#'          "Nik-Zainal_PMID_22608084-VCF-convertedfromMPF.vcf.gz", 
#'          package="decompTumor2Sig")
#' genomes <- readGenomesFromVCF(gfile, numBases=5, type="Shiraishi",
#'          trDir=TRUE, enforceUniqueTrDir=TRUE, refGenome=refGenome,
#'          transcriptAnno=transcriptAnno, verbose=FALSE)
#' 
#' @importFrom VariantAnnotation readVcf expand alt ref geno
#' @importFrom GenomicRanges seqnames start
#' @importFrom BSgenome.Hsapiens.UCSC.hg19 BSgenome.Hsapiens.UCSC.hg19
#' @importFrom TxDb.Hsapiens.UCSC.hg19.knownGene
#' TxDb.Hsapiens.UCSC.hg19.knownGene
#' @export readGenomesFromVCF
readGenomesFromVCF <- function(file, numBases=5, type="Shiraishi", trDir=TRUE,
    enforceUniqueTrDir=TRUE,
    refGenome=BSgenome.Hsapiens.UCSC.hg19::BSgenome.Hsapiens.UCSC.hg19,
    transcriptAnno=
        TxDb.Hsapiens.UCSC.hg19.knownGene::TxDb.Hsapiens.UCSC.hg19.knownGene,
    verbose=TRUE) {

    # read mutation data
    if(verbose) {
        cat("Reading mutations and genotype information from VCF file:\n")
    }

    # read VCF file (using VariantAnnotation)
    vcf <- tryCatch(readVcf(file),
                    error=function(e) {
                        stop(paste0(e, "Cannot read VCF file; is this a VCF ",
                                    "file containing one or more individual ",
                                    "samples?"))
                    })

    if (is(vcf, "CollapsedVCF")) {
        vcf <- expand(vcf)  # split multiallelic entries!
    }


    # get only SNVs (one REF base and one ALT base)
    # (indels can be specified as, e.g. deletion, "AG > A" or as "G > -")
    snvRows <-
        (nchar(as.character(ref(vcf))) == 1) &
            (nchar(as.character(alt(vcf))) == 1) &
            (as.character(ref(vcf)) != "-") & (as.character(alt(vcf)) != "-") &
            (as.character(ref(vcf)) != "N") & (as.character(alt(vcf)) != "N")
    
    # basic variant information (chr, pos, ref, alt)

    snvs <- cbind(as.character(seqnames(vcf)),
                  as.character(start(vcf)),
                  as.character(ref(vcf)),
                  as.character(alt(vcf)))
    snvs <- snvs[snvRows,]
    colnames(snvs) <- c("CHROM","POS","REF","ALT")

    # get genotypes (if FORMAT and genotypes are present in the VCF)

    gtypes <- tryCatch(geno(vcf)$GT[snvRows,],
                       error=function(e) { return(NULL) })
    gtypes[gtypes == "."] <- NA

    # if this was only one sample: have a vector, need a matrix
    if (!is.matrix(gtypes)) {
        gtypes <- as.matrix(gtypes)
    }

    # make sure we keep the correct sample names
    colnames(gtypes) <- colnames(geno(vcf)$GT)
    
    # genotype information
    if (!is.null(gtypes)) {
        # if we do have genotype information, add it!
        snvs <- cbind(snvs,                        # CHR, POS, REF, ALT
                      "FORMAT"=rep("GT", sum(snvRows)),  # FORMAT
                      gtypes)                      # genotype info for samples
        
    } else {
        # we don't have genotype information from the VCF file
        # take all variants as originating from the same sample/genome,
        # create dummy genotype
        snvs <- cbind(snvs, matrix(c("GT", "1/1"),
                                   nrow=length(which(snvRows)),
                                   ncol=2, byrow=TRUE)
                      )
        colnames(snvs)[seq((ncol(snvs)-1),ncol(snvs))] =
            c("FORMAT", "variants_without_genotype_info")
    }

    ## we have now (example):
    #> snvs[1:10,]
    #     CHROM POS  REF ALT FORMAT           sample1                 sample2
    #[1,] "2"  "947" "C" "T" "GT:PL:GQ:AD:DP" "1/1:84,6,0:6:0,2:2"    NA    
    #[2,] "2"  "992" "G" "A" "GT:PL:GQ:AD:DP" "0/1:123,0,33:33:1,3:4" "0/0:..."

    genomes <- buildGenomesFromMutationData(snvs=snvs, numBases=numBases,
                                            type=type, trDir=trDir,
                                            uniqueTrDir=enforceUniqueTrDir,
                                            refGenome=refGenome,
                                            transcriptAnno=transcriptAnno,
                                            verbose=verbose)

    if(verbose && !is.null(genomes)) {
        cat("Done reading genomes.\n")
    }

    return(genomes)

}

#' Read a set of Shiraishi signatures.
#'
#' `readShiraishiSignatures()` reads one or more Shiraishi-type signatures
#' from flat files (one file per signature). The signatures must be specified
#' as matrices without headers and row names (see details below).
#'
#' Format (see Shiraishi et al. PLoS Genetics 11(12):e1005657, 2015):
#' 
#' First line: Frequencies of the base changes C>A, C>G, C>T, T>A, T>C,
#' and T>G
#' 
#' Following 2k lines (for k up- and downstream flanking bases):
#' Frequencies of the bases A, C, G, and T, followed by two 0 values
#' 
#' Final line (only if transcription direction is considered):
#' Frequencies of occurrences on the transcription strand, and on the
#' opposite strand, followed by four 0 values.
#' 
#' Example:
#' \tabular{llllll}{
#' 1.8874e-14 \tab 0.10974 \tab 0.045918 \tab
#' 0.11308 \tab 0.07429 \tab 0.65697\cr
#' 3.8079e-01 \tab 0.12215 \tab 0.191456 \tab
#' 0.30561 \tab 0.00000 \tab 0.00000\cr
#' 1.5311e-01 \tab 0.34214 \tab 0.179774 \tab
#' 0.32497 \tab 0.00000 \tab 0.00000\cr
#' 1.2378e-01 \tab 0.10243 \tab 0.163461 \tab
#' 0.61032 \tab 0.00000 \tab 0.00000\cr
#' 3.4891e-01 \tab 0.15346 \tab 0.156687 \tab
#' 0.34094 \tab 0.00000 \tab 0.00000\cr
#' 5.6435e-01 \tab 0.43565 \tab 0.000000 \tab
#' 0.00000 \tab 0.00000 \tab 0.00000 \cr
#' }
#'
#' @usage readShiraishiSignatures(files)
#' @param files (Mandatory) Can be a single file name, a vector of file names,
#' or a list of file names.
#' @return A list of Shiraishi signatures that can be used for
#' \code{decomposeTumorGenomes}.
#' @author Rosario M. Piro, Politecnico di Milano\cr
#' Sandra Krueger, Freie Universitaet Berlin\cr Maintainer: Rosario
#' M. Piro\cr E-Mail: <rmpiro@@gmail.com> or <rosariomichael.piro@@polimi.it>
#' @references \url{http://rmpiro.net/decompTumor2Sig/}\cr
#' Krueger, Piro (2019) decompTumor2Sig: Identification of mutational
#' signatures active in individual tumors. BMC Bioinformatics
#' 20(Suppl 4):152.\cr
#' @seealso \code{\link{decompTumor2Sig}}\cr
#' \code{\link{readAlexandrovSignatures}}\cr
#' \code{\link{getSignaturesFromEstParam}}
#' @examples
#' 
#' ### read four Shiraishi signatures for breast cancer genomes from 
#' ### Nik-Zainal et al (PMID: 22608084) from flat files
#' sigfiles <- system.file("extdata",
#'          paste0("Nik-Zainal_PMID_22608084-pmsignature-sig",1:4,".tsv"),
#'          package="decompTumor2Sig")
#' 
#' signatures <- readShiraishiSignatures(sigfiles)
#' 
#' @importFrom utils read.table
#' @export readShiraishiSignatures
readShiraishiSignatures <- function(files) {
    # read a set of Shiraishi signatures from flat files
    # files can be a single file name of vector of file names as returned
    #   by list.files(path="", pattern="" ....)

    if (is.list(files)) {
        files <- unlist(files)
    }

    if (!is.character(files)) {
        stop(paste("Parameter 'files' must be a filename or a list/vector",
                   "of file names!"))
    }
    
    fnames <- as.vector(files)
    
    sigList <- list()

    for (fn in fnames) {
        sigmatrix <- as.matrix(read.table(fn, header=FALSE, row.names=NULL))

        sigmatrix <- setNames4ShiraishiTable(sigmatrix)

        sigList[[length(sigList)+1]] <- sigmatrix
    }

    if (length(unique(basename(fnames))) == length(fnames)) {
        # base file names (without paths) are unique, take as signature names
        names(sigList) <- basename(fnames)
    } else {
        # take the unique path/file names as signature names
        names(sigList) <- fnames
    }
    
    return(sigList)
}

#' Evaluate tumor decomposition quality.
#'
#' `evaluateDecompositionQuality()` evaluates the quality of the decomposition
#' into exposures of a single tumor. The function evaluates the quality of a
#' decomposition obtained from the function \code{decomposeTumorGenomes}
#' by comparing the re-composed (=re-constructed) tumor genome mutation
#' frequencies to those actually observed in the tumor genome. Tumor genome
#' mutation frequencies are reconstructed using
#' \code{composeGenomesFromExposures} and the results can optionally be plotted.
#'
#' @usage evaluateDecompositionQuality(exposure, signatures, genome,
#' plot=FALSE)
#' @param exposure (Mandatory) A single vector containing the estimated
#' signature contributions, or exposures, of a single tumor as provided by
#' \code{decomposeTumorGenomes}. The number of elements of the
#' exposure vector must correspond to the number of signatures (see below). 
#' @param signatures (Mandatory) The list of signatures (vectors, data
#' frames or matrices) for which the exposures were obtained. Each of the
#' list objects represents one mutational signature. Vectors are used for
#' Alexandrov signatures, data frames or matrices for Shiraishi signatures.
#' @param genome (Mandatory) A single tumor genome in form of mutation
#' frequencies specified either in the Alexandrov or the Shiraishi format
#' (must match the format used for \code{signatures}, see above). 
#' @param plot (Optional) If \code{FALSE} (default), the numerical results
#' (see below) will be returned. If \code{TRUE}, the reconstructed mutation
#' frequencies will be plotted against the original, observed mutation
#' frequencies and the numerical results will be integrated as text labels
#' in the plot.
#' @return A named list object containing measurements for the Pearson
#' correlation coefficient between the reconstructed and observed mutation
#' frequencies, and the explained variance; or alternatively, a plot with
#' these measurements (see option \code{plot} above).
#' @author Rosario M. Piro\cr Politecnico di Milano\cr Maintainer: Rosario
#' M. Piro\cr E-Mail: <rmpiro@@gmail.com> or <rosariomichael.piro@@polimi.it>
#' @references \url{http://rmpiro.net/decompTumor2Sig/}\cr
#' Krueger, Piro (2019) decompTumor2Sig: Identification of mutational
#' signatures active in individual tumors. BMC Bioinformatics
#' 20(Suppl 4):152.\cr
#' @seealso \code{\link{decompTumor2Sig}}\cr
#' \code{\link{decomposeTumorGenomes}}\cr
#' \code{\link{composeGenomesFromExposures}}\cr
#' \code{\link{computeExplainedVariance}}
#' @examples
#' 
#' ### get Alexandrov signatures from COSMIC
#' signatures <- readAlexandrovSignatures()
#' 
#' ### load preprocessed breast cancer genomes (object 'genomes') from
#' ### Nik-Zainal et al (PMID: 22608084) 
#' gfile <- system.file("extdata",
#'          "Nik-Zainal_PMID_22608084-genomes-Alexandrov_3bases.Rdata", 
#'          package="decompTumor2Sig")
#' load(gfile)
#' 
#' ### compute exposures
#' exposures <- decomposeTumorGenomes(genomes, signatures, verbose=FALSE)
#' 
#' ### evaluate the decomposition by comparing to the original data
#' evaluateDecompositionQuality(exposures[[1]], signatures, genomes[[1]])
#' 
#' @importFrom stats cor scatter.smooth
#' @importFrom graphics text
#' @export evaluateDecompositionQuality
evaluateDecompositionQuality <- function(exposure, signatures, genome,
                                         plot=FALSE) {
    if (!is.probability.object(genome)) {
        # must be a single genome
        stop(paste("'genome' must be an the mutation frequencies of an",
                   "individual genome (in Alexandrov or Shiraishi format)."))
    }
    
    if (!is.probability.vector(exposure)) {
        stop(paste("'exposure' must be the exposure vector of a single",
                   "decomposition."))
    }
    if (!isSignatureSet(signatures)) {
        stop("'signatures' must be a set (list) of signatures.")
    }

    # check the genome format; same as signature format?
    if (!sameSignatureFormat(list(genome), signatures)) {
        stop("Formats of genome and signatures must match!")
    }
    
    if (!is.logical(plot)) {
        stop("plot must be logical (TRUE or FALSE).")
    }
    

    decQual <- list()
    
    # compute explained variance
    decQual$explainedVariance <- computeExplainedVariance(exposure,
                                                          signatures, genome)

    # re-compose genome from exposure and signatures
    predGenome <- composeGenomesFromExposures(exposure, signatures)[[1]]

    # compute correlation of re-composed and original genome
    decQual$pearsonCorr <- cor(as.numeric(as.matrix(predGenome)),
                               as.numeric(as.matrix(genome)), method="pearson")
    # (as.numeric(as.matrix(X)) works on vectors, matrices and data frames!)

    
    if (!plot) {
        return (decQual)
    }
    # else continue and plot

    scatter.smooth(x=genome, y=predGenome,
                   main="Quality of decomposition",
                   #main="Observed and reconstructed mutation frequencies",
                   sub="mutation frequencies",
                   xlab="observed", ylab="reconstructed",
                   pch=20, cex=0.7)
    text(x=max(genome),y=0, pos=2,
         labels=paste("Explained variance:",
                      round(decQual$explainedVariance, digits=4)))
    text(x=max(genome),y=max(predGenome)/25, pos=2,
         labels=paste("Pearson correlation:",
                      round(decQual$pearsonCorr, digits=4)))
}

#' Get signatures from an \code{EstimatedParameters} object.
#'
#' `getSignaturesFromEstParam()` takes an \code{EstimatedParameters} object
#' (signatures data) as computed by the '\code{pmsignature}' package (by
#' \code{pmsignature::getPMSignature}; version 0.3.0) and extracts the
#' signature information. The signatures can then be passed to
#' \code{decomposeTumorGenomes}. 
#'
#' @usage getSignaturesFromEstParam(Param)
#' @param Param (Mandatory) A \code{pmsignature::EstimatedParameters} object
#' as those produced by the de novo signature construction method
#' \code{pmsignature::getPMSignature}.
#' @return A list of Shiraishi signatures, one object per signature. Please
#' see \code{readShiraishiSignatures} or the \code{decompTumor2Sig} vignette
#' for more information on the format of Shiraishi signatures.
#' @author Rosario M. Piro, Politecnico di Milano\cr
#' Sandra Krueger, Freie Universitaet Berlin\cr Maintainer: Rosario
#' M. Piro\cr E-Mail: <rmpiro@@gmail.com> or <rosariomichael.piro@@polimi.it>
#' @references \url{http://rmpiro.net/decompTumor2Sig/}\cr
#' Krueger, Piro (2019) decompTumor2Sig: Identification of mutational
#' signatures active in individual tumors. BMC Bioinformatics
#' 20(Suppl 4):152.\cr
#' @seealso \code{\link{decompTumor2Sig}}\cr
#' \code{\link{readShiraishiSignatures}}
#' @examples
#' 
#' ### load signatures for breast cancer genomes from 
#' ### Nik-Zainal et al (PMID: 22608084) in the format produced by
#' ### pmsignature (PMID: 26630308)
#' pmsigdata <- system.file("extdata",
#'          "Nik-Zainal_PMID_22608084-pmsignature-Param.Rdata", 
#'          package="decompTumor2Sig")
#' load(pmsigdata)
#' 
#' ### extract the signatures from the pmsignature Param object
#' signatures <- getSignaturesFromEstParam(Param)
#' 
#' @importFrom methods is
#' @export getSignaturesFromEstParam
getSignaturesFromEstParam <- function(Param) {
    # convert the signatures from an "EstimatedParameters" (Param),
    # as obtained from pmsignature, to a list of signature matrices or vectors

    if (!isEstParamObject(Param)) {
        stop(paste("Param must be compatible to an object of type",
                   "EstimatedParameters (as produced by pmsignature's",
                   "function getPMSignature; version 0.3.0)"))
    }

    sigList <- list()

    # number of signatures, etc.
    numSigs <- getNumSignatures(Param)
    numBases <- getNumFlankingBases(Param)
    trDir <- haveTrDir(Param)
    
    # if one of them was background, the true number of signatures is one less!
    numSigs <- numSigs - as.numeric(isBackGround(Param))

    for (sig in seq_len(numSigs)) {
        sigList[[length(sigList)+1]] <-
            getSigFromEstParam(Param, sig)

        # set row and/or column names
        if (getSigType(Param) == "independent") {
            # Shiraishi
            if (is.vector(sigList[[length(sigList)]])) {
                # this can happen when numBases=1 and trDir=FALSE;
                # would be vector, we need table!
                sigList[[length(sigList)]] <- matrix(sigList[[length(sigList)]],
                                                     nrow=1)
            }
            
            sigList[[length(sigList)]] <-
                setNames4ShiraishiTable(sigList[[length(sigList)]])
        } else {
            # Alexandrov
            names(sigList[[length(sigList)]]) <-
                buildSortedAlexandrovSignaturePatternList(numBases=numBases,
                                                          trDir=trDir)
        }
    }

    return(sigList)
}

#' Adjust (normalize) signatures for a set of genomic regions.
#'
#' `adjustSignaturesForRegionSet()` takes a set of signatures that have
#' been orginally defined with respect to the nucleotide frequencies within
#' a specific reference genome or region (e.g., by deriving them from whole
#' genome mutation data) and adjusts or normalizes them to the often different
#' nucleotide frequencies of another specific subset of genomic regions.
#'
#' This may be useful, for example, to perform signature refitting (using
#' \code{\link{decomposeTumorGenomes}}) for mutation data from targetted
#' sequencing (e.g., only a subset of genes), whole exome sequencing (only
#' exonic regions), or other limited subsets of the genome with particular
#' nucleotide frequencies.
#'
#' For Alexandrov-type signatures, the important frequencies are those of the
#' whole sequence patterns (e.g., trinucleotides) whose central base can be
#' mutated. Therefore, adjustment factors for individual mutation types
#' (e.g., A[C>T]G) are computed by comparing the corresponding sequence
#' pattern frequencies (e.g., ACG) between the original reference
#' regions (e.g., whole genome) and the target regions (e.g., target
#' regions of whole exome sequencing).
#' 
#' In the Shiraishi-type signature model, individual bases of the sequence
#' patterns are considered as independent features. Thus, to compute nucleotide
#' frequencies for such signatures, the frequencies of the sequence patterns
#' (computed as for Alexandrov-type signatures) are broken down to
#' single-nucleotide frequencies for the individual positions of the patterns.
#'
#' In both cases, after the appropriate adjustment of individual features,
#' signatures are re-normalized such that overall probabilites sum up to 1.
#'
#' @usage adjustSignaturesForRegionSet(signatures,
#' regionsTarget, regionsOriginal=NULL, 
#' refGenome=BSgenome.Hsapiens.UCSC.hg19::BSgenome.Hsapiens.UCSC.hg19)
#' @param signatures (Mandatory) Signatures to be adjusted to the nucleotide
#' frequencies of the genomic regions defined by the parameter \code{regions}.
#' @param regionsTarget (Mandatory) \code{GRanges} object defining a subset
#' of the genome (i.e., a set of genomic regions) for which the signatures
#' need to be adjusted (can be set to \code{NULL} for the whole genome).
#' @param regionsOriginal (Optional) \code{GRanges} object defining the subset
#' of the genome (i.e., set of genomic regions) from which the signatures
#' where originally derived. Default: \code{NULL} (whole genome).
#' @param refGenome (Optional) Reference genome sequence from which to
#' compute the nucleotide frequencies. Default:\cr
#' \code{BSgenome.Hsapiens.UCSC.hg19::BSgenome.Hsapiens.UCSC.hg19}.
#' @return A set of adjusted mutational signatures in the same format as those
#' specified for \code{signatures}.
#' @author Rosario M. Piro\cr Politecnico di Milano\cr Maintainer: Rosario
#' M. Piro\cr E-Mail: <rmpiro@@gmail.com> or <rosariomichael.piro@@polimi.it>
#' @references \url{http://rmpiro.net/decompTumor2Sig/}\cr
#' Krueger, Piro (2019) decompTumor2Sig: Identification of mutational
#' signatures active in individual tumors. BMC Bioinformatics
#' 20(Suppl 4):152.\cr
#' @seealso \code{\link{decompTumor2Sig}}\cr
#' \code{\link{decomposeTumorGenomes}}
#' @examples
#' 
#' ### get Alexandrov signatures from COSMIC
#' signatures <- readAlexandrovSignatures()
#' 
#' ### get gene annotation for the default reference genome (hg19)
#' library(TxDb.Hsapiens.UCSC.hg19.knownGene)
#' txdb <- TxDb.Hsapiens.UCSC.hg19.knownGene::TxDb.Hsapiens.UCSC.hg19.knownGene
#'
#' ### get a GRanges object for gene promoters (-2000 to +200 bases from TSS)
#' ### [taking only the first 1000 for testing purpose]
#' library(GenomicRanges)
#' regionsTarget <- promoters(txdb, upstream=2000, downstream=200)[seq(1000)]
#'
#' ### assume these signatures were derived only from mutation data from
#' ### exons on chromosome X [not true; just for illustrative purpose]
#' filter <- list(tx_chrom = c("chrX"))
#' regionsOriginal <- exons(txdb, filter=filter)
#' 
#' ### adjust signatures according to nucleotide frequencies in the target
#' ### subset of the genome
#' sign_adj <- adjustSignaturesForRegionSet(signatures, regionsTarget,
#'                                                      regionsOriginal)
#'
#' @importFrom GenomicRanges start end trim
#' @importFrom Biostrings getSeq
#' @export adjustSignaturesForRegionSet
adjustSignaturesForRegionSet <- function(signatures,
                                         regionsTarget, regionsOriginal=NULL,
        refGenome=BSgenome.Hsapiens.UCSC.hg19::BSgenome.Hsapiens.UCSC.hg19) {
    
    if (!isSignatureSet(signatures)) {
        stop("Parameter 'signatures' must be a set (list) of signatures!")
    }

    if (!is.null(regionsTarget) && !is(regionsTarget, "GRanges")) {
        stop("Parameter 'regionsTarget' must be NULL or of type GRanges!")
    }

    if (!is.null(regionsOriginal) && !is(regionsOriginal, "GRanges")) {
        stop("Parameter 'regionsOriginal' must be NULL or of type GRanges!")
    }

    if ( (is.null(regionsTarget) && is.null(regionsOriginal) ) ||
         (!is.null(regionsTarget) && !is.null(regionsOriginal) &&
          length(regionsTarget) == length(regionsOriginal) &&
          all(regionsOriginal == regionsTarget)
         )
        ) {
        stop("Parameters 'regionsOriginal' and 'regionsTarget' must differ!")
    }

    # Size (and type) of sequence patterns of the signatures
    sigType <- determineTypeNumBasesAndTrDir(signatures[[1]])
    numBases <- sigType$numBases

    # If necessary, extend the regions
    if (numBases > 1) {
        # With sequence patterns of trinculeotides (or more) each nucleotide in
        # a region set needs to be the _center_ of a sequence pattern, 
        # so we need to extend each region by the number of flanking bases!

        if (!is.null(regionsTarget)) {
            tryCatch( {
                GenomicRanges::start(regionsTarget) <-
                    GenomicRanges::start(regionsTarget) - (numBases-1)/2
                GenomicRanges::end(regionsTarget) <-
                    GenomicRanges::end(regionsTarget) + (numBases-1)/2
                # Got a warning here? we're out of bounds and need to trim
            }, warning=function(w) {regionsTarget <-
                                        GenomicRanges::trim(regionsTarget)} )
            
        }

        if (!is.null(regionsOriginal)) {
            tryCatch( {
                GenomicRanges::start(regionsOriginal) <-
                    GenomicRanges::start(regionsOriginal) - (numBases-1)/2
                GenomicRanges::end(regionsOriginal) <-
                    GenomicRanges::end(regionsOriginal) + (numBases-1)/2
                # Got a warning here? we're out of bounds and need to trim
            }, warning=function(w) {regionsOriginal <-
                                        GenomicRanges::trim(regionsOriginal)} )
        }
    }


    # Compute nucleotide frequencies for original reference sequences
    # (merging counts from reverse complement sequence patterns)
    freqO <- compNucFreq(refGenome, regionsOriginal,
                         numBases=numBases, mergeByRevComp=TRUE)

    # Compute the same for target sequences
    freqT <- compNucFreq(refGenome, regionsTarget,
                         numBases=numBases, mergeByRevComp=TRUE)


    # compute adjustment factors: 
    signaturesAdj <- NULL

    if (isAlexandrovSet(signatures)) {
        # These are Alexandrov signatures with a full dependency between all
        # bases of the basic sequence pattern (usually trinucleotides)
        
        # Divide by original (genome-wide?) frequency, then multiply 
        # by frequency in the target region set, i.e., if the limited
        # region has double frequency of a trinucleotide (e.g., ACG) with 
        # respect to the whole genome, the mutation probabilities of the 
        # corresponding mutation types (A[C>A]G, A[C>G]G, A[C>T]G) in the 
        # signatures will be multiplied by 2. Reasoning: the signatures
        # has more opportunities to mutate that trinucleotide in the limited
        # region set then in the whole genome.
        factors <- freqT / freqO

        # now adjust all signatures according to these factors
        signaturesAdj <- base::lapply(signatures,
                                      adjustAlexandrovSignature, factors)

    } else if (isShiraishiSet(signatures)) {
        # these are Shiraishi signatures; need to compute frequencies for
        # the individual bases of the sequence pattern (e.g., frequencies of
        # A,C,G,T for the first base, etc., and frequencies of C and T for
        # the central base; these are determined from the frequencies of
        # complete sequence patterns (freqOMerged, freqTMerged)

        # convert pattern frequency vectors to base frequency matrices 
        freqOMatrix <- convertSeqFreqToBaseFreq(freqO, sigType)
        freqTMatrix <- convertSeqFreqToBaseFreq(freqT, sigType)
        
                
        # adjustment factors 
        factorsMatrix <- freqTMatrix / freqOMatrix

        # now adjust all signatures according to these factors
        signaturesAdj <- base::lapply(signatures,
                                      adjustShiraishiSignature, factorsMatrix)
    } else {
        stop("Unknown signature type!")
    }

    return(signaturesAdj)
}

# produces the files:
# Nik-Zainal_PMID_22608084-genomes-Alexandrov_3bases.Rdata
# Nik-Zainal_PMID_22608084-genomes-Shiraishi_5bases_trDir.Rdata

library(decompTumor2Sig)

refGenome <- BSgenome.Hsapiens.UCSC.hg19::BSgenome.Hsapiens.UCSC.hg19

gfile <- "inst/extdata/Nik-Zainal_PMID_22608084-MPF.txt.gz"


# read according to Alexandrov model (3 bases, no transcription direction)
genomes <- readGenomesFromMPF(gfile, numBases=3, type="Alexandrov",
                              trDir=FALSE, refGenome=refGenome,
                              verbose=FALSE)

save(genomes, file="Nik-Zainal_PMID_22608084-genomes-Alexandrov_3bases.Rdata")

# read accoring to Shiraishi model (5 bases, transcript direction)
transcriptAnno <-
    TxDb.Hsapiens.UCSC.hg19.knownGene::TxDb.Hsapiens.UCSC.hg19.knownGene

genomes <- readGenomesFromMPF(gfile, numBases=5, type="Shiraishi",
                              trDir=TRUE, refGenome=refGenome,
                              transcriptAnno=transcriptAnno, verbose=FALSE)

save(genomes, file="Nik-Zainal_PMID_22608084-genomes-Shiraishi_5bases_trDir.Rdata")

#####################
# internal function #
#####################

#' plotShiraishiModel (internal function)
#'
#' `plotShiraishiModel()` plots a single signature or the mutation
#' frequency data for a single genome of the Shiraishi-type model.
#'
#' @usage plotShiraishiModel(mutData, numBases, trDir, colors = NULL)
#' @param mutData (Mandatory) The signature or genome mutation frequency data
#' to be plotted.
#' @param numBases The number of bases of the sequence pattern.
#' @param trDir Logical value specifying whether transcription strand
#' information is present.
#' @param colors Vector of four colors to be used for the base data.
#' If \code{NULL} (default), the colors are consensus colors used for
#' sequence logos.
#' @return Returns (or draws) a plot according to the Shiraishi model of
#' mutational signatures.
#' @author Rosario M. Piro\cr Politecnico di Milano\cr Maintainer: Rosario
#' M. Piro\cr E-Mail: <rmpiro@@gmail.com> or <rosariomichael.piro@@polimi.it>
#' @references \url{http://rmpiro.net/decompTumor2Sig/}\cr
#' Krueger, Piro (2019) decompTumor2Sig: Identification of mutational
#' signatures active in individual tumors. BMC Bioinformatics
#' 20(Suppl 4):152.\cr
#' @importFrom ggseqlogo ggseqlogo make_col_scheme
#' @importFrom ggplot2 ggplot geom_polygon theme_bw theme scale_y_continuous
#' scale_fill_manual dup_axis labs  rel aes guides element_blank element_rect
#' element_text
#' @importFrom gridExtra grid.arrange
#' @keywords internal
plotShiraishiModel <- function(mutData, numBases, trDir, colors = NULL) {

    # To avoid R CMD complaining about "global variable"
    arrow_poly <- NULL
    
    # this function assumes the input data is a Shiraishi probability matrix
    
    # bases and colors
    bases <- c("A", "C", "G", "T")

    if (is.null(colors)) {
        # default colors are those used by ggseqlogo
        colors = c("#109648", "#255c99", "#f7b32b", "#d62839")
    }

    # other default colors
    panelBackCol <- "#eeeeee"   # background color for mutation base panel
    trColors <- c("coral3", "skyblue3")
    arrowCol <- "#a8a8a8"
    
    # set own colorschemes for bases
    colscheme <- make_col_scheme(chars=bases, cols=colors)
                                  
    # make sure we have the correct number of colors
    stopifnot(length(colors) == length(bases))
    
    # numer of probabilies per block (=base)
    probsPerBlock <- 4

    # quickly verify, we got the correct counts (should not happen)
    stopifnot(ncol(mutData) == 6 &&
                  nrow(mutData) == numBases + as.numeric(trDir))

    # construct dummy sequence data for ggseqlogo::geom_logo
    # maximum 0.1% accurracy is fair enough (i.e., 1000 sequences)
    numSeqs <- 1000

    # probabilities of mutated bases C and T:
    probMut <- c(sum(mutData[1, seq_len(3)]), sum(mutData[1, seq(from=4,to=6)]))

    
    # sequence logos for mutated bases

    baseBoth <- ggseqlogo("CT", method="probability", col_scheme=colscheme) +
        theme_bw() + 
        labs(caption="mutated base", size=(4)) +
        theme(axis.title = element_blank(),
              axis.ticks = element_blank(),
              axis.text.x = element_blank(),
              axis.text.y = element_blank(),
              panel.grid.minor = element_blank(),
              panel.grid.major.x = element_blank(),
              panel.background = element_rect(fill=panelBackCol),
              plot.caption = element_text(hjust=0.5, size=rel(1.2))) +
        geom_text(data = data.frame(prob=paste(sprintf("%.1f",
                                        probMut*100),"%")),
                  aes_string(x=seq_len(2), y=-0.1, label="prob"), size=rel(4),
                  color="black") +
        geom_vline(xintercept = 1.5, linetype="dotted")
        
    # sequence logos for variant bases

    # first base
    seqs <- rep(bases[-2], roundIntegerSum(numSeqs * mutData[1, seq_len(3)],
                                           targetSum=numSeqs))
    # add second base
    seqs <- paste0(seqs,
                   rep(bases[-4],
                       roundIntegerSum(numSeqs * mutData[1, seq(from=4,
                                                                to=6)],
                                       targetSum=numSeqs)))

    mutBoth <- ggseqlogo(seqs, method="probability", col_scheme=colscheme) +
        theme_bw() + 
        labs(caption="variant base", size=(4)) +
        theme(axis.title = element_blank(),
              axis.ticks = element_blank(),
              axis.text.x = element_blank(),
              axis.text.y = element_blank(),
              panel.grid.minor = element_blank(),
              panel.grid.major.x = element_blank(),
              panel.background = element_rect(fill=panelBackCol),
              plot.caption = element_text(hjust=0.5, size=rel(1.2))) +
         geom_vline(xintercept = 1.5, linetype="dotted")

    
    # sequence logos for upstream and downstream bases

    flankBases <- list()

    if (numBases > 1) {
        rows <- seq(2, numBases)
        basePos <- c(0, seq(from=-(numBases%/%2), to=-1),   # used for labeling
                     seq(from=1, to=numBases%/%2))
        basePos <- gsub("+-", "-", gsub("^", "+", as.character(basePos)),
                        fixed=TRUE)

        flankBases <- list()

        for (r in rows) {
            seqs <- rep(bases, round(numSeqs * mutData[r, seq_len(4)]))

            ggp <- ggseqlogo(seqs, method="probability", col_scheme=colscheme) +
                labs(caption=paste("pos", basePos[r])) + 
                theme_bw() +
                theme(axis.title = element_blank(),
                      axis.text.x = element_blank(),
                      axis.ticks = element_blank(),
                      panel.grid.minor = element_blank(),
                      panel.grid.major.x = element_blank(),
                      plot.caption = element_text(hjust=0.5, size=rel(1.2)))
            if (r == 2) {
                # first: ticks left
                #ggp <- ggp + theme(axis.text.y = element_blank())
                ggp <- ggp + scale_y_continuous(sec.axis = dup_axis()) +
                    theme(axis.text.x = element_blank(),
                          axis.text.y.right = element_blank())
            } else if (r == numBases) {
                # last: ticks right
                ggp <- ggp + scale_y_continuous(sec.axis = dup_axis()) +
                    theme(axis.text.x = element_blank(),
                          axis.text.y.left = element_blank())
            } else {
                # others: no ticks
                ggp <- ggp + scale_y_continuous(sec.axis = dup_axis()) +
                    theme(axis.text = element_blank())
            }
        
            flankBases[[length(flankBases)+1]] <- ggp
        }
    }

    # dummy logo, only with probability labels on right side
    labelR <- ggseqlogo(rep("C", 10), method="probability",
                        col_scheme=make_col_scheme("C", cols="#ffffff")) +
        scale_y_continuous(sec.axis = dup_axis()) +
        labs(caption=" ", size=(4)) +
        theme(axis.title.x = element_blank(),
              axis.text.x = element_blank(),
              axis.text.y.left = element_blank(),
              axis.title=element_blank(),
              plot.caption = element_text(hjust=0.5, size=rel(1.2)))

    if (trDir) {
        trPlot <- ggplot(data=data.frame(x=factor(c("+", "-"),
                                                  levels=c("+", "-")),
                             probability=mutData[nrow(mutData), seq_len(2)]),
                  aes_string(x="x", y="probability")) +
                  geom_bar(stat="identity", fill=trColors) +
                  geom_text(aes_string(label="x"), vjust=-0.2, size=rel(6)) +
                  scale_y_continuous(sec.axis = dup_axis(), limits=c(0,1)) +
                  labs(caption="transcription\nstrand", size=(4)) +
                  theme_bw() +
                  theme(panel.grid = element_blank(),
                        panel.border = element_blank(),
                        axis.ticks = element_blank(),
                        axis.title = element_blank(),
                        #axis.text.x = element_text(size=rel(1.2)),
                        axis.text.x = element_blank(),
                        axis.text.y.left = element_blank(),
                        plot.caption = element_text(hjust=0.5, size=rel(1.2)))
        
    } else {
        # empty plot
        trPlot <- ggplot() + theme(panel.background=element_blank())
    }
    
    # arrow
    xs <- c(1/3, 2/3, 2/3, 5/6, 1/2, 1/6, 1/3, 1/3)
    xs2 <- c(1/3, 2/3, 2/3, 5/6, 1/2, 1/6, 1/3, 1/3) + 0.75
    ys <- c(1/4, 1/4, 1/2, 1/2, 3/4, 1/2, 1/2, 1/4)
    vs <- rep("arrow", length(xs))

    arrow <- ggplot() +
        geom_polygon(data = arrow_poly,
                     aes(x = xs, y = ys, fill = vs)) +
        geom_polygon(data = arrow_poly,
                     aes(x = xs2, y = ys, fill = vs)) +
        theme(axis.title=element_blank(),
              axis.text=element_blank(),
              axis.line=element_blank(),
              axis.ticks=element_blank(),
              panel.background=element_blank(),
              plot.background=element_blank()) +
        guides(fill=FALSE) +
        scale_fill_manual(values=c(arrow=arrowCol))

    
    # get list of plots for grid.arrange
    if (numBases > 1) {
        plots <- c(list(labelR, mutBoth, trPlot, arrow),
                   flankBases[seq(numBases%/%2)],
                   list(baseBoth),
                   flankBases[seq(numBases%/%2+1, numBases-1)])
        nGridCols <- numBases
    } else {
        # numBases = 1
        plots <- list(labelR, mutBoth, trPlot, arrow, baseBoth)
        nGridCols <- 3   # we need at least 3 columns
    }
    
    # define layout for grid.arrange
    heights <- c(2,1,2)

    widths <- rep(1, nGridCols)
    widths[1] <- 1.25
    widths[nGridCols] <- 1.25
    widths[nGridCols%/%2+1] <- 1.8

    layout <- matrix(NA, nrow=3, ncol=nGridCols)
    layout[1, nGridCols%/%2] <- 1
    layout[1, nGridCols%/%2+1] <- 2
    layout[1, nGridCols] <- 3
    layout[2, nGridCols%/%2+1] <- 4
    if (numBases > 1) {
        layout[3, ] <- seq(from=5, to=numBases+4)
    } else {
        layout[3, nGridCols%/%2+1] <- 5
    }
    
    # call grid.arrange
    args <- list(nrow=3, ncol=nGridCols, widths=widths,
                 heights=heights, layout_matrix=layout)

    do.call("grid.arrange", c(plots, args))

}

#####################
# internal function #
#####################

#' buildSortedAlexandrovSignaturePatternList (internal function)
#'
#' Build and sort the pattern list of an Alexandrov signature in the following
#' way: First according to the base change: C>A, C>G, C>T, T>A, T>C, T>G,
#' then within these categories according to the flanking bases: A, C, G, T.
#'
#' @usage buildSortedAlexandrovSignaturePatternList(numBases, trDir)
#' @param numBases Number of bases for the sequence pattern (odd integer).
#' @param trDir Logical: use transcription-strand information?
#' @return A sorted list of mutation features (e.g., triplets with base change).
#' @author Rosario M. Piro\cr Politecnico di Milano\cr Maintainer: Rosario
#' M. Piro\cr E-Mail: <rmpiro@@gmail.com> or <rosariomichael.piro@@polimi.it>
#' @references \url{http://rmpiro.net/decompTumor2Sig/}\cr
#' Krueger, Piro (2019) decompTumor2Sig: Identification of mutational
#' signatures active in individual tumors. BMC Bioinformatics 
#' 20(Suppl 4):152.\cr
#' @keywords internal
buildSortedAlexandrovSignaturePatternList <- function(numBases, trDir) {
    seqpatterns <- NULL
    for (ii in seq((numBases-1),1)) {
        seqpatterns <- paste0(seqpatterns, gl(4, 4^(ii-1), 4^(numBases-1),
                                              labels=c("A","C","G","T")))
    }
    
    # add the central base
    seqpatterns <-
        paste0(substr(seqpatterns,1,(numBases-1)/2),
               sort(rep(c("[C>A]","[C>G]","[C>T]","[T>A]","[T>C]","[T>G]"),
                        length(seqpatterns))),
               substr(seqpatterns,(numBases-1)/2+1,numBases-1))

    # double if we consider the transcription direction ...
    if (trDir) {
        seqpatterns <- paste0(c(seqpatterns,seqpatterns),
                              c(rep("+", length(seqpatterns)),
                                rep("-", length(seqpatterns))))
    }

    return(seqpatterns)
}

#' Convert genomes from a \code{VRanges} object
#'
#' `convertGenomesFromVRanges()` converts the SNVs of a single tumor genome
#' (sample) or a set of genomes from a \code{VRanges} object (package
#' \code{VariantAnnotation}) and determines the mutation frequencies according
#' to a specific model of mutational signatures (Alexandrov or Shiraishi),
#' such that the resulting format can be used as genomes input for
#' \code{decomposeTumorGenomes}.
#'
#' @usage convertGenomesFromVRanges(vranges, numBases=5, type="Shiraishi",
#' trDir=TRUE, enforceUniqueTrDir=TRUE, 
#' refGenome=BSgenome.Hsapiens.UCSC.hg19::BSgenome.Hsapiens.UCSC.hg19,
#' transcriptAnno=
#' TxDb.Hsapiens.UCSC.hg19.knownGene::TxDb.Hsapiens.UCSC.hg19.knownGene,
#' verbose=TRUE)
#' @param vranges (Mandatory) The \code{VRanges} object which specifies the
#' mutations.
#' @param numBases (Mandatory) Total number of bases (mutated base and
#' flanking bases) to be used for sequence patterns. Must be odd. Default: 5
#' @param type (Mandatory) Signature model or type (\code{"Alexandrov"} or
#' \code{"Shiraishi"}). Default: \code{"Shiraishi"}
#' @param trDir (Mandatory) Specifies whether the transcription direction is
#' taken into account in the signature model. If so, only mutations within
#' genomic regions with a defined transcription direction can be considered.
#' Default: \code{TRUE}
#' @param enforceUniqueTrDir (Optional) Used only if \code{trDir} is
#' \code{TRUE}. If \code{enforceUniqueTrDir} is TRUE (default), then mutations
#' which map to a region with multiple overlapping genes with opposing
#' transcription directions will be excluded from the analysis. If \code{FALSE},
#' the transcript direction encountered first in the transcript database (see
#' \code{transcriptAnno}) is assigned to the mutation. The latter was the
#' behavior until version 1.3.5 of \code{decompTumor2Sig} and is also the
#' behavior of \code{pmsignature}. However, it is preferable to exclude
#' these mutations from the count (default) because from mutation data alone
#' it cannot be inferred which of the two genes has the higher transcriptional
#' activity which might potentially be linked to the occurrence of the mutation.
#' (If you are unsure, use the default setting; this option exists mostly for
#' backward compatibility with older versions.)
#' @param refGenome (Mandatory) The reference genome (\code{BSgenome}) needed
#' to extract sequence patterns. Default: \code{BSgenome} object for hg19.
#' @param transcriptAnno (Optional) Transcript annotation (\code{TxDb} object)
#' used to determine the transcription direction. This is required only if
#' \code{trDir} is \code{TRUE}. Default: \code{TxDb} object for hg19.
#' @param verbose (Optional) Print information about reading and processing
#' the mutation data. Default: \code{TRUE}
#' @return A list containing the genomes in terms of frequencies of the
#' mutated sequence patterns. This list of genomes can be used for
#' \code{decomposeTumorGenomes}. 
#' @author Rosario M. Piro\cr Politecnico di Milano\cr Maintainer: Rosario
#' M. Piro\cr E-Mail: <rmpiro@@gmail.com> or <rosariomichael.piro@@polimi.it>
#' @references \url{http://rmpiro.net/decompTumor2Sig/}\cr
#' Krueger, Piro (2019) decompTumor2Sig: Identification of mutational
#' signatures active in individual tumors. BMC Bioinformatics 
#' 20(Suppl 4):152.\cr
#' @seealso \code{\link{decompTumor2Sig}}\cr
#' \code{\link{decomposeTumorGenomes}}\cr
#' \code{\link{readGenomesFromVCF}}\cr
#' \code{\link{readGenomesFromMPF}}\cr
#' \code{\link{getGenomesFromMutFeatData}}
#' @examples
#' 
#' ### load the reference genome and the transcript annotation database
#' refGenome <- BSgenome.Hsapiens.UCSC.hg19::BSgenome.Hsapiens.UCSC.hg19
#' transcriptAnno <-
#'   TxDb.Hsapiens.UCSC.hg19.knownGene::TxDb.Hsapiens.UCSC.hg19.knownGene
#' 
#' ### take the breast cancer genomes from Nik-Zainal et al (PMID: 22608084) 
#' gfile <- system.file("extdata",
#'          "Nik-Zainal_PMID_22608084-VCF-convertedfromMPF.vcf.gz", 
#'          package="decompTumor2Sig")
#' 
#' ### get the corresponding VRanges object (using the VariantAnnotation
#' ### package)
#' library(VariantAnnotation)
#' vr <- readVcfAsVRanges(gfile, genome="hg19")
#' 
#' ### convert the VRanges object to the decompTumor2Sig format
#' genomes <- convertGenomesFromVRanges(vr, numBases=5, type="Shiraishi",
#'          trDir=TRUE, enforceUniqueTrDir=TRUE, refGenome=refGenome, 
#'          transcriptAnno=transcriptAnno, verbose=FALSE)
#' 
#' @importFrom VariantAnnotation asVCF isSNV readVcfAsVRanges header geno ref
#' alt
#' @importFrom GenomicRanges ranges seqnames start
#' @importFrom SummarizedExperiment rowRanges
#' @importFrom methods is
#' @importFrom BSgenome.Hsapiens.UCSC.hg19 BSgenome.Hsapiens.UCSC.hg19
#' @importFrom TxDb.Hsapiens.UCSC.hg19.knownGene
#' TxDb.Hsapiens.UCSC.hg19.knownGene
#' @export convertGenomesFromVRanges
convertGenomesFromVRanges <- function(vranges,
    numBases=5, type="Shiraishi", trDir=TRUE, enforceUniqueTrDir=TRUE,
    refGenome=BSgenome.Hsapiens.UCSC.hg19::BSgenome.Hsapiens.UCSC.hg19,
    transcriptAnno=
        TxDb.Hsapiens.UCSC.hg19.knownGene::TxDb.Hsapiens.UCSC.hg19.knownGene,
    verbose=TRUE) {

    if (!is(vranges, "VRanges")) {
        stop("vranges must be an object of type VRanges!")
    }
    
    # read mutation data
    if(verbose) {
        cat(paste("Extracting mutations and sample/genotype information",
                  "from VRanges:\n"))
    }

    # convert VRanges to VCF
    vcf <- asVCF(vranges)

    # reduce to contain only SNVs
    vcf <- vcf[isSNV(vcf, singleAltOnly=FALSE)]
    
    samples <- samples(header(vcf))


    # construct table with SNVs
    sampleGT <- geno(vcf)$GT
    sampleGT[sampleGT == "."] <- NA

    snvs <- cbind(as.character(seqnames(rowRanges(vcf))),  # CHROM
                  start(ranges(rowRanges(vcf))),           # POS
                  as.character(ref(vcf)),                  # REF
                  as.character(alt(vcf)),                  # ALT
                  rep("GT", nrow(sampleGT)))               # FORMAT
    colnames(snvs) <- c("CHROM", "POS", "REF", "ALT", "FORMAT")

    snvs <- cbind(snvs, sampleGT)
    
    ## we have now (example):
    #> snvs[1:10,]
    #     CHROM POS  REF ALT FORMAT           sample1                 sample2
    #[1,] "2"  "947" "C" "T" "GT:PL:GQ:AD:DP" "1/1:84,6,0:6:0,2:2"    NA    
    #[2,] "2"  "992" "G" "A" "GT:PL:GQ:AD:DP" "0/1:123,0,33:33:1,3:4" "0/0:..."

    genomes <- buildGenomesFromMutationData(snvs=snvs, numBases=numBases,
                                            type=type, trDir=trDir,
                                            uniqueTrDir=enforceUniqueTrDir,
                                            refGenome=refGenome,
                                            transcriptAnno=transcriptAnno,
                                            verbose=verbose)

    if(verbose) {
        cat("Done converting genomes.\n")
    }

    return(genomes)

}

#' Read Alexandrov-type signatures (COSMIC format).
#'
#' `readAlexandrovSignatures()` reads a set of Alexandrov-type signatures
#' (COSMIC format) from a flat file or URL. Signatures must be specified in the
#' tab-separated format used by the COSMIC website for signatures version 2
#' (March 2015), the comma-separated format used for signatures version 3
#' (May 2019), the Microsoft Excel 2007+ sheet used for version 3.1, or the
#' tab-sperated format used for version 3.2 (see Details below). Excel sheets
#' cannot be read from an URL and must be downloaded first.
#' 
#' For details on the accepted signature formats, see below or\cr
#' \url{http://cancer.sanger.ac.uk/cosmic/signatures_v2} ->
#' "Download signatures" for version 2,\cr
#' \url{https://www.synapse.org/#!Synapse:syn12009743} for version 3,\cr
#' \url{https://cancer.sanger.ac.uk/sigs-assets-20/COSMIC_Mutational_Signatures_v3.1.xlsx}
#' for version 3.1, \cr
#' and \url{https://cancer.sanger.ac.uk/signatures/} for version 3.2. 
#' For versions 3, 3.1 and 3.2, only Single Base Substitution (SBS)
#' signatures can be used.
#'
#' COSMIC format for Alexandrov signatures, version 2:
#'
#' \tabular{llllll}{
#' Subst. \tab Trinucleotide \tab Mutation Type \tab Signature 1 \tab
#' Signature 2 \tab...\cr
#' C>A \tab ACA \tab A[C>A]A \tab 0.0110983262 \tab 0.0006827082 \tab...\cr
#' C>A \tab ACC \tab A[C>A]C \tab 0.0091493407 \tab 0.0006191072 \tab...\cr
#' C>A \tab ACG \tab A[C>A]G \tab 0.0014900705 \tab 0.0000992790 \tab...\cr
#' C>A \tab ACT \tab A[C>A]T \tab 0.0062338852 \tab 0.0003238914 \tab...\cr
#' [...]\cr
#' T>G \tab TTG \tab T[T>G]G \tab 0.0020310769 \tab 0.0002066152 \tab...\cr
#' T>G \tab TTT \tab T[T>G]T \tab 0.0040301281 \tab 0.0000235982 \tab...\cr
#' }
#' 
#' COSMIC/Synapse format for Alexandrov signatures, version 3 and 3.1:
#'
#' \tabular{llllll}{
#' Type,SubType,SBS1,SBS2,SBS3,SBS4,SBS5,SBS6, ...\cr
#' C>A,ACA,8.86E-04,5.80E-07,2.08E-02,4.22E-02,1.20E-02,4.25E-04, ...\cr
#' C>A,ACC,2.28E-03,1.48E-04,1.65E-02,3.33E-02,9.44E-03,5.24E-04, ...\cr
#' C>A,ACG,1.77E-04,5.23E-05,1.75E-03,1.56E-02,1.85E-03,5.20E-05, ...\cr
#' C>A,ACT,1.28E-03,9.78E-05,1.22E-02,2.95E-02,6.61E-03,1.80E-04, ...\cr
#' [...]\cr
#' T>G,TTG,5.83E-04,9.54E-05,8.05E-03,2.32E-03,6.94E-03,3.24E-04, ...\cr
#' T>G,TTT,2.23E-16,2.23E-16,1.05E-02,5.68E-04,1.35E-02,1.01E-03, ...\cr
#' }
#'
#' Version 3.1 has assentially the same format as version 3, but is distributed
#' as an Excel spread sheet.
#' 
#' COSMIC/Synapse format for Alexandrov signatures, version 3.2:
#'
#' \tabular{llll}{
#' Type \tab SBS1 \tab SBS2 \tab...\cr
#' A[C>A]A \tab 0.0110983262 \tab 0.0006827082 \tab...\cr
#' A[C>A]C \tab 0.0091493407 \tab 0.0006191072 \tab...\cr
#' A[C>A]G \tab 0.0014900705 \tab 0.0000992790 \tab...\cr
#' A[C>A]T \tab 0.0062338852 \tab 0.0003238914 \tab...\cr
#' [...]\cr
#' T[T>G]G \tab 0.0020310769 \tab 0.0002066152 \tab...\cr
#' T[T>G]T \tab 0.0040301281 \tab 0.0000235982 \tab...\cr
#' }
#'
#' @usage
#' readAlexandrovSignatures(file)
#' @param file (Mandatory) Can be a file name or an URL for download.
#' Default:\cr
#' "https://cancer.sanger.ac.uk/cancergenome/assets/signatures_probabilities.txt"
#' (COSMIC signatures v2).
#' @return A list of Alexandrov signatures that can be used for
#' \code{decomposeTumorGenomes}. 
#' @author Rosario M. Piro\cr Politecnico di Milano\cr Maintainer: Rosario
#' M. Piro\cr E-Mail: <rmpiro@@gmail.com> or <rosariomichael.piro@@polimi.it>
#' @references \url{http://rmpiro.net/decompTumor2Sig/}\cr
#' Krueger, Piro (2019) decompTumor2Sig: Identification of mutational
#' signatures active in individual tumors. BMC Bioinformatics
#' 20(Suppl 4):152.\cr
#' @seealso \code{\link{decompTumor2Sig}}\cr
#' \code{\link{readShiraishiSignatures}}
#' @examples
#' 
#' ### get Alexandrov signatures from COSMIC
#' signatures <- readAlexandrovSignatures()
#' 
#' @importFrom utils read.table
#' @importFrom readxl read_excel excel_format
#' @export readAlexandrovSignatures
readAlexandrovSignatures <-
    function(file=paste0("https://cancer.sanger.ac.uk/cancergenome/assets/",
                         "signatures_probabilities.txt")) {

    # read a set of Alexandrov signatures from a tab-separated flat file in one
    # of the formats that are (or were) provided by COSMIC Mutational Signatures

    if (!is.character(file)) {
        stop("Parameter 'file' must be a filename or URL!")
    }

    # read all data in one table
    sigmatrix <- NULL

    # First, try to read this as an Excel sheet (version 3.1):
    if (!is.na(readxl::excel_format(file))) {
        sigmatrix <- readxl::read_excel(file, trim_ws=TRUE)

        # convert to data frame
        sigmatrix <- as.data.frame(sigmatrix)

    } else {
        # This is NOT an Excel file, so read it as TSV or CSV table!

        sigmatrix <- tryCatch(
            # try tab as column separator/delimiter (version 2 and 3.2):
            as.matrix(read.table(file, header=TRUE,
                                 row.names=NULL, sep="\t")),
            warning = function(cond) {
                return(NULL)
            },
            error = function(cond) {
                return(NULL)
            }
        )

        if (is.null(sigmatrix) || ncol(sigmatrix) < 2) {
            # cannot contain signature data (at least 1 column of annotation)
            # try comma as column separator/delimiter (used for version 3):
            sigmatrix <- tryCatch(
                as.matrix(read.table(file, header=TRUE,
                                     row.names=NULL, sep=",")),
                warning = function(cond) {
                    return(NULL)
                },
                error = function(cond) {
                    return(NULL)
                }
            )
        }
    }
        
    if (is.null(sigmatrix) || ncol(sigmatrix) < 2) {
        stop(paste("Couldn't read", file, "as tabular data file."))
    }


    # Check that we have one of the expected formats!

    if (length(grep("^[ACGT]\\[[CT]>[ACGT]\\][ACGT]$", sigmatrix[,1])) ==
        nrow(sigmatrix)) {
        # This is version 3.2, there is only one annotation column
        
        sigVecNames <- sigmatrix[,1]  # take first column as mutation types
        firstSigCol <- 2              # data starts from the second column

    } else if (ncol(sigmatrix) > 2
               && length(grep("^[ACGT]\\[[CT]>[ACGT]\\][ACGT]$",
                              sigmatrix[,3])) == nrow(sigmatrix)
               ) {
        # This is verion 2, the mutation type is in the third column
        
        # we have the third column, use it as element names for the vector
        sigVecNames <- sigmatrix[,3]
        firstSigCol <- 4

    } else {
        # This might be version 3 or 3.1; get mutation type from columns 1&2

        # verify format of first column (e.g., "C>A")
        # verify format of second column (e.g., "ACA")
        if (length(grep("^[CT]>[ACGT]$", sigmatrix[,1])) != nrow(sigmatrix)
            || length(grep("^[ACGT]{3}$", sigmatrix[,2])) != nrow(sigmatrix)) {
            stop(paste("Wrong file format. Need mutation type in first",
                       "or third column (e.g., 'A[C>A]A'); and/or SNV",
                       "annotation for pyrimidines in first column (e.g.",
                       "'C>A') and mutated triplet in second column (e.g.",
                       "'ACA')."))
        } else {
            # need to construct the mutation types from the first two columns
            sigVecNames <- apply(sigmatrix[,seq_len(2)], 1,
                                 function(x) {
                                     y = unlist(strsplit(x[2], ""));
                                     paste0(y[1],"[",x[1],"]",y[3])
                                 })
            firstSigCol <- 3
        }
    }

    # Final check: do we have numeric data in the next column?
    if (anyNA(suppressWarnings(as.numeric(sigmatrix[,firstSigCol])))) {
        stop(paste0("Wrong file format. Expected a signature in column ",
                    firstSigCol,"."))
    }


    # now extract the signatures from the table
    sigList <- list()
    sigNames <- c()

    for (colId in seq(firstSigCol, ncol(sigmatrix))) {
        if (!all(is.na(sigmatrix[,colId]))) { # signature is defined

            sigVec <- as.numeric(sigmatrix[,colId])
            names(sigVec) <- sigVecNames

            # make sure this is normalized (doesn't hold for versions 3 and 3.1
            # where the sum of probabilities is somtimes minimally different
            # from 1 ...
            while(sum(sigVec) != 1) {  # once wasn't always sufficient!
                sigVec <- sigVec/sum(sigVec)
            }

            # make sure we sort the vector correctly (the version 2 file has
            # another sorting): first check number of bases and presence of
            # transcription direction
            sigFeatures <- determineTypeNumBasesAndTrDir(sigVec)
            if (is.null(sigFeatures$type) || sigFeatures$type != "Alexandrov") {
                stop("Wrong number of patterns for an Alexandrov signature!")
            }
            # reorder the signature vector so that base changes stay together
            sigVec <-
                sigVec[buildSortedAlexandrovSignaturePatternList(
                    numBases=sigFeatures$numBases,
                    trDir=sigFeatures$trDir)]
            
            # the vector is fine now, save in list of multiple signatures
            sigList[[length(sigList)+1]] <- sigVec
            sigNames <- c(sigNames, colnames(sigmatrix)[colId])
        }
    }

    names(sigList) <- sigNames

    return(sigList)
}

#####################
# internal function #
#####################


#' getBestDecomp4Ksignatures (internal function)
#'
#' Get the best decomposition for a subset of k signatures.
#'
#' @usage getBestDecomp4Ksignatures(genome, signatures, k,
#' constrainToMaxContribution=FALSE, tolerance=0.1)
#' @param genome Genome for which to approximate the decomposition.
#' @param signatures The whole set of signatures (from which to choose
#' a subset signatures.
#' @param k Number of signatures to use (subset size).
#' @param constrainToMaxContribution (Optional) [Note: this is experimental
#' and is usually not needed!] If \code{TRUE}, the maximum contribution that
#' can be attributed to a signature will be constraint by the variant feature
#' counts (e.g., specific flanking bases) observed in the individual tumor
#' genome. If, for example, 30\% of all observed variants have a specific
#' feature and 60\% of the variants produced by a mutational process/signature
#' will manifest the feature, then the signature can have contributed up to
#' 0.3/0.6 (=0.5 or 50\%) of the observed variants. The lowest possible
#' contribution over all signature features will be taken as the allowed
#' maximum contribution of the signature. This allowed maximum will
#' additionally be increased by the value specified as \code{tolerance}
#' (see below). For the illustrated example and \code{tolerance}=0.1 a
#' contribution of up to 0.5+0.1 = 0.6 (or 60\%) of the signature would be
#' allowed. 
#' @param tolerance (Optional) If \code{constrainToMaxContribution} is
#' \code{TRUE}, the maximum contribution computed for a signature is increased
#' by this value (see above). If the parameter \code{constrainToMaxContribution}
#' is \code{FALSE}, the tolerance value is ignored. Default: 0.1. 
#' @return A list object containing: k=number of signatures; 
#' explVar=variance explained by these signatures; 
#' sigList=list of the signatures; 
#' decomposition=decomposition (exposures) obtained with these signatures.
#' @author Rosario M. Piro\cr Politecnico di Milano\cr Maintainer: Rosario
#' M. Piro\cr E-Mail: <rmpiro@@gmail.com> or <rosariomichael.piro@@polimi.it>
#' @references \url{http://rmpiro.net/decompTumor2Sig/}\cr
#' Krueger, Piro (2019) decompTumor2Sig: Identification of mutational
#' signatures active in individual tumors. BMC Bioinformatics
#' 20(Suppl 4):152.\cr
#' @importFrom utils combn
#' @keywords internal
getBestDecomp4Ksignatures <- function(genome, signatures, k,
                                      constrainToMaxContribution=FALSE,
                                      tolerance=0.1) {

    # get list of all possible combinations of k signatures
    sigCombn <- combn(seq_along(signatures), k)
    sigCombnNames <-
        apply(sigCombn, 2, function(x) {
            paste(names(signatures)[x], collapse="|") } )

    sigCombn <- split(t(sigCombn), seq(ncol(sigCombn)))
    names(sigCombn) <- sigCombnNames

    processMultipleSigSets(genome, signatures, sigCombn, k,
                           constrainToMaxContribution, tolerance)
}

#####################
# internal function #
#####################


#' addBestSignatureToSubset (internal function)
#'
#' Add the best signature to an existing subset (highest increase in expl. var.)
#' to improve the approximate decomposition of a genome.
#'
#' @usage addBestSignatureToSubset(genome, signatures, subset,
#' constrainToMaxContribution=FALSE, tolerance=0.1)
#' @param genome Genome for which to improve the decomposition.
#' @param signatures The whole set of signatures (from which to choose
#' additional signatures.
#' @param subset The current subset that is used for decomposition.
#' @param constrainToMaxContribution (Optional) [Note: this is experimental
#' and is usually not needed!] If \code{TRUE}, the maximum contribution that
#' can be attributed to a signature will be constraint by the variant feature
#' counts (e.g., specific flanking bases) observed in the individual tumor
#' genome. If, for example, 30\% of all observed variants have a specific
#' feature and 60\% of the variants produced by a mutational process/signature
#' will manifest the feature, then the signature can have contributed up to
#' 0.3/0.6 (=0.5 or 50\%) of the observed variants. The lowest possible
#' contribution over all signature features will be taken as the allowed
#' maximum contribution of the signature. This allowed maximum will
#' additionally be increased by the value specified as \code{tolerance}
#' (see below). For the illustrated example and \code{tolerance}=0.1 a
#' contribution of up to 0.5+0.1 = 0.6 (or 60\%) of the signature would be
#' allowed. 
#' @param tolerance (Optional) If \code{constrainToMaxContribution} is
#' \code{TRUE}, the maximum contribution computed for a signature is increased
#' by this value (see above). If the parameter \code{constrainToMaxContribution}
#' is \code{FALSE}, the tolerance value is ignored. Default: 0.1. 
#' @return A list object containing: k=number of signatures; 
#' explVar=variance explained by these signatures; 
#' sigList=list of the signatures; 
#' decomposition=decomposition (exposures) obtained with these signatures.
#' @author Rosario M. Piro\cr Politecnico di Milano\cr Maintainer: Rosario
#' M. Piro\cr E-Mail: <rmpiro@@gmail.com> or <rosariomichael.piro@@polimi.it>
#' @references \url{http://rmpiro.net/decompTumor2Sig/}\cr
#' Krueger, Piro (2019) decompTumor2Sig: Identification of mutational
#' signatures active in individual tumors. BMC Bioinformatics
#' 20(Suppl 4):152\cr
#' @keywords internal
addBestSignatureToSubset <- function(genome, signatures, subset,
                                     constrainToMaxContribution=FALSE,
                                     tolerance=0.1) {

    subsetIndices <- which(names(signatures) %in% subset)
    restIndices <- which(!(names(signatures) %in% subset))

    # get all possible combinations of subset + one assitional signature
    sigCombn <-
        lapply(restIndices, function(ix) { sort(c(subsetIndices, ix)) } )
    
    names(sigCombn) <-
        vapply(sigCombn, function(set) {
            paste(names(signatures)[set],collapse="|")
        }, FUN.VALUE=character(1) )

    #print(sigCombn)

    processMultipleSigSets(genome, signatures, sigCombn, length(subset)+1,
                           constrainToMaxContribution, tolerance)
}

#' Compute the explained variance.
#'
#' `computeExplainedVariance()` computes for one or more tumors the variance
#' which is explained by the estimated contributions (exposures) of a set of
#' signatures when compared to the observed genomes.
#'
#' @usage computeExplainedVariance(exposures, signatures, genomes)
#' @param exposures (Mandatory) A single vector or list of vectors containing
#' the estimated signature contributions/exposures as provided by the function
#' \code{decomposeTumorGenomes}. A list of vectors is used if the explained
#' variance shall be computed for multiple genomes. The number of exposure
#' vectors must correspond to the number of \code{genomes}. The number
#' of elements of each exposure vector must correspond to the number of
#' \code{signatures}.
#' @param signatures (Mandatory) The list of signatures (vectors, data frames
#' or matrices) for which the exposures were obtained. Each of the list
#' objects represents one mutational signature. Vectors are used for
#' Alexandrov signatures, data frames or matrices for Shiraishi signatures.
#' @param genomes (Mandatory) Can be either a vector, a data frame or a matrix
#' (for an individual tumor genome), or a list of one of these object types
#' (for multiple tumors). Each tumor genome must be of the same form as the
#' \code{signatures}.
#' @return A numeric vector of explained variances, one for each genome.
#' @author Rosario M. Piro\cr Politecnico di Milano\cr Maintainer: Rosario
#' M. Piro\cr E-Mail: <rmpiro@@gmail.com> or <rosariomichael.piro@@polimi.it>
#' @references \url{http://rmpiro.net/decompTumor2Sig/}\cr
#' Krueger, Piro (2019) decompTumor2Sig: Identification of mutational
#' signatures active in individual tumors. BMC Bioinformatics 
#' 20(Suppl 4):152.\cr
#' @seealso \code{\link{decompTumor2Sig}}\cr
#' \code{\link{decomposeTumorGenomes}}\cr
#' \code{\link{plotExplainedVariance}}
#' @examples
#' 
#' ### get Alexandrov signatures from COSMIC
#' signatures <- readAlexandrovSignatures()
#' 
#' ### load preprocessed breast cancer genomes (object 'genomes') from
#' ### Nik-Zainal et al (PMID: 22608084) 
#' gfile <- system.file("extdata",
#'          "Nik-Zainal_PMID_22608084-genomes-Alexandrov_3bases.Rdata", 
#'          package="decompTumor2Sig")
#' load(gfile)
#' 
#' ### compute exposures
#' exposures <- decomposeTumorGenomes(genomes, signatures, verbose=FALSE)
#' 
#' ### compute explained variance for the tumor genomes
#' computeExplainedVariance(exposures, signatures, genomes)
#' 
#' @export computeExplainedVariance
computeExplainedVariance <- function(exposures, signatures, genomes) {

    if (is.probability.object(genomes)) {
        # this is only one genome, use a list nonetheless for later iteration
        genomes <- list(genomes)
    }

    if (!isSignatureSet(genomes)) { # same type of object as signatures
        stop("Parameter genomes must be a set (list) of genomes.")
    }
    
    if (is.probability.vector(exposures)) {
        # same as for genomes
        exposures <- list(exposures)
    }

    if (!isExposureSet(exposures)) {
        stop("Parameter exposures must be a list of probability vectors.")
    }

    if (!isSignatureSet(signatures)) {
        stop("Parameter signatures must be a set (list) of signatures.")
    }

    if (!sameSignatureFormat(signatures, genomes)) {
        stop("Signatures and genomes must be of the same format.")
    }

    # check that we have as many exposure estimates as genomes
    if(length(genomes)!=length(exposures)) {
        stop("Number of exposure vectors different from number of genomes.")
    }

    expvar <- NULL

    # for each genome, compare estimated exposures
    for (g in seq_along(genomes)){

        if (is.null(exposures[[g]])) {
            # can be NULL if minExplainedVariance wasn't reached in a
            # subset search

            expvar <- c(expvar, NA)
            next
        }

        # set NA in exposures to 0
        exposures[[g]][is.na(exposures[[g]])] <- 0
        
        # first compute estimated genome from exposures and signatures
        if (length(signatures) != length(exposures[[g]])) {
            stop("Number of exposures different from number of signatures.")
        }

        first <- TRUE        
        for (s in seq_along(signatures)) {

            if (first) {
                estgenome <- signatures[[s]] * as.numeric(exposures[[g]][s])
                first <- FALSE
            } else {
                estgenome <- estgenome + (signatures[[s]] *
                                              as.numeric(exposures[[g]][s]))
            }
        }

        # now compute the residual sum of squares (RSS) between estimated and
        # observed genome
        #rss <- sum((estgenome - genomes[[g]])^2)
        rss <- computeRSS(estgenome, genomes[[g]])

        # ... and the total sum of squares (TSS) between the observed genome
        # and the "average/unvaried" genome.
        # Important: for the Alexandrov format, the unvaried genome
        # corresponds to the average over all mutation frequencies (which is
        # precisely 1/96 for all mutation frequencies because the 96 frequencies
        # add up to 1!!!)
        # For Shiraishi signatures the "unvaried" genome is represented by 
        # the following exemplary matrix:
        # [ 1/6  1/6  1/6  1/6  1/6  1/6    <- 16.7% for each of 6 base changes
        #   1/4  1/4  1/4  1/4   0    0     <- 25% for each flanking base
        #   ...
        #   1/2  1/2   0    0    0    0 ]   <- 50% for each transcription dir.

        if (isAlexandrovSet(genomes[g])) {

            tss <- sum( (genomes[[g]] - mean(genomes[[g]]))^2 )

        } else if (isShiraishiSet(genomes[g])) {

            unvargenome <- genomes[[g]]
            unvargenome[1,] <- rep(1/6, 6)
            for (ii in seq(2,nrow(genomes[[g]]))) {
                unvargenome[ii,] <- c(rep(1/4, 4), rep(0, 2))
            }
            if ( (nrow(genomes[[g]])%%2) == 0) {
                # even number of rows; last one must be transcription direction
                unvargenome[nrow(genomes[[g]]),] <- c(rep(1/2, 2), rep(0, 4))
            }

            tss <- sum( (genomes[[g]] - unvargenome)^2 )
            
        } else { # something unknown, complain
            stop(paste("genomes must be either of the Alexandrov (numeric",
                       "vectors) or the Shiraishi format (matrices or data",
                       "frames)!"))
        }

        # finally, compute the explained variance
        evar <- 1 - (rss / tss)

        # for the formulas, see for example
        # https://www.rdocumentation.org/packages/SomaticSignatures/
        #                              versions/2.8.3/topics/numberSignatures

        expvar <- c(expvar, evar)
    }

    # finally, name the explained variances like the genomes
    if (!is.null(names(genomes))) {
        names(expvar) <- names(genomes)
    }

    return(expvar)
}

#' Downgrade Shiraishi-type signatures.
#'
#' `downgradeShiraishiSignatures()` downgrades/trims signatures of the
#' Shiraishi type by discarding flanking bases (reducing the length of the
#' sequence pattern) and/or the transcription direction. The downgrade doesn't
#' pose a problem because the flanking bases and the transcription direction
#' are considered as independent features according to the Shiraishi model of
#' mutational signatures.
#'
#' @usage downgradeShiraishiSignatures(signatures, numBases=NULL,
#' removeTrDir=FALSE)
#' @param signatures (Mandatory) A list of Shiraishi signatures that need to be
#' downgraded/trimmed.
#' @param numBases (Conditionally optional) The total number of bases
#' (mutated base plus flanking bases around the mutated base) that should
#' be kept. All further flanking bases farther away from the mutated bases
#' are dropped. If specified, \code{numBases} must be odd and smaller than
#' the current number of bases of the \code{signatures}. If \code{NULL}, no
#' flanking bases will be dropped. At least one of \code{numBases} or
#' \code{removeTrDir} must be specified. 
#' @param removeTrDir (Conditionally optional) Logical value that specifies
#' whether information on the transcript direction should be dropped (if
#' present at all). At least one of \code{numBases} or \code{removeTrDir}
#' must be specified.
#' @return A list of Shiraishi signatures that have been accordingly downgraded.
#' @author Rosario M. Piro\cr Politecnico di Milano\cr Maintainer: Rosario
#' M. Piro\cr E-Mail: <rmpiro@@gmail.com> or <rosariomichael.piro@@polimi.it>
#' @references \url{http://rmpiro.net/decompTumor2Sig/}\cr
#' Krueger, Piro (2019) decompTumor2Sig: Identification of mutational
#' signatures active in individual tumors. BMC Bioinformatics 
#' 20(Suppl 4):152.\cr
#' @seealso \code{\link{decompTumor2Sig}}
#' @examples
#' 
#' ### Load 15 Shiraishi signatures obtained from 435 tumor genomes from
#' ### Alexandrov et al. (number of bases: 5, transcription direction: yes)
#' sfile <- system.file("extdata",
#'          "Alexandrov_PMID_23945592_435_tumors-pmsignature-15sig.Rdata", 
#'          package="decompTumor2Sig")
#' load(sfile)
#' 
#' ### downgrade the signatures to include only 3 bases and drop the
#' ### transcription direction 
#' downgradeShiraishiSignatures(signatures, numBases=3, removeTrDir=TRUE)
#' 
#' @export downgradeShiraishiSignatures
downgradeShiraishiSignatures <- function(signatures, numBases=NULL,
                                         removeTrDir=FALSE) {

    if (!isShiraishiSet(signatures)) {
        stop(paste("Parameter 'signatures' must be a set (list) of Shiraishi",
                   "signatures!"))
    }

    if (is.null(removeTrDir)) {
        removeTrDir <- FALSE
    }
    if(!is.logical(removeTrDir)) {
        stop("Value of removeTrDir must be logical!")
    }

    if (is.null(numBases) & !removeTrDir) {
        stop("At least one of numBases and removeTrDir must be specified!")
    }

    if (!is.null(numBases)) {
        if (!is.numeric(numBases)
            || (numBases!=round(numBases)) || ((numBases%%2)==0) ) {
            stop("Value of numBases must be an odd integer!")
        }
    }

    newsigs <- lapply(signatures, function(sig) {
        # first, check current format of the signatures

        # if we have an even number of lines, the last one must be for the
        # transcription direction
        haveTrDir <- !(nrow(sig)%%2)

        # number of bases in the sequence pattern?
        haveBases <- nrow(sig) - as.numeric(haveTrDir)

        if(!is.null(numBases) && (numBases >= haveBases)) {
            stop(paste("Value of numBases must be smaller than the",
                       "signatures' current number of bases!"))
        }

        # determine which indices to remove
        removeRows <- c()

        if(!is.null(numBases)) {
            # upstream
            removeRows <- c(removeRows,
                            seq_len((haveBases-numBases)/2)+1)
                            #c(1:((haveBases-numBases)/2))+1)
            # downstream
            removeRows <- c(removeRows,
                            seq(from=((haveBases-(haveBases-numBases)/2)+1),
                                to=haveBases))
                           #c(((haveBases-(haveBases-numBases)/2)+1):haveBases))
        }

        if(removeTrDir & haveTrDir) {
            removeRows <- c(removeRows, nrow(sig))
        }

        sig <- sig[-removeRows,]

        if (is.vector(sig)) {
            sig <- matrix(sig, nrow=1)
        }

        setNames4ShiraishiTable(sig)
    })

    return(newsigs)
}

#!/bin/bash


# the MPF data file containing somatic SNVs for 21 tumors can be downloaded from:

wget -nd https://github.com/friend1ws/pmsignature/raw/devel/inst/extdata/Nik_Zainal_2012.mutationPositionFormat.txt.gz

# we opted for a shorter file name:

mv Nik_Zainal_2012.mutationPositionFormat.txt.gz Nik-Zainal_PMID_22608084-MPF.txt.gz

#!/bin/bash

# convert the MPF file to a VCF file
# use bcftools to convert the data for all samples

for PID in `zcat inst/extdata/Nik-Zainal_PMID_22608084-MPF.txt.gz | cut -f 1 | sort | uniq`; do 

	# do this for each patient/sample ID individually

	# create temporary file, adding a dummy header to be read by bcftools
	TSVFILE="tmp.$PID.tsv"; 
	echo -e "ID\tCHROM\tPOS\tAA" > $TSVFILE; 

	# get all mutations for the patientID, filter for SNVs
	zcat inst/extdata/Nik-Zainal_PMID_22608084-MPF.txt.gz | grep "^$PID" | grep "[[:space:]][ACGT][[:space:]][ACGT]$" | cut -f 2-5 | sed -e "s/[[:space:]]\([ACGT]\)[[:space:]]\([ACGT]\)$/\t\1\2/; s/^/.\t/; s/chr//" >> $TSVFILE; 

	# convert this TSV file to VCF using bcftools
	bcftools convert -c ID,CHROM,POS,AA -s $PID -f ~/bioinfo/data/ngs-data/ref-genomes/human/hs37d5.fa --tsv2vcf $TSVFILE -Oz -o $TSVFILE.vcf.gz ; 

	# remove the temporary TSV file
	rm -f $TSVFILE; 

	# index the temporary VCF file (tabix)
	tabix -p vcf $TSVFILE.vcf.gz; 

done; 

# now merge all the temporary VCF files into one multi-sample VCF file
vcf-merge tmp.*.tsv.vcf.gz | bgzip -c > Nik-Zainal_PMID_22608084-VCF-convertedfromMPF.vcf.gz; 

# remove the temporary VCF file for single samples
rm -f tmp.*.tsv.vcf.gz*

#!/bin/bash

# Paper: https://www.nature.com/articles/nature12477
# Somatic mutations available at:
# ftp://ftp.sanger.ac.uk/pub/cancer/AlexandrovEtAl/

# get all the somatic mutation data (about 767M) ...
wget -np -nH --cut-dirs=3 -r ftp://ftp.sanger.ac.uk/pub/cancer/AlexandrovEtAl/


# get IDs for all genomes:
OUTF="genomes-tumor-patientID-map.tsv"; rm -f $OUTF; for TUMOR in `ls mutational_catalogs/genomes/ | sed -e "s/ .*//"`; do echo $TUMOR; cat mutational_catalogs/genomes/$TUMOR*/*subs.txt | grep "^Mutation Type" | sed -e "s/\t/\n/g;" | grep -v "^Mutation" | sed -e "s/^/$TUMOR\t/" >> $OUTF; done

cat genomes-tumor-patientID-map.tsv | cut -f 2 > genomes-patientID.list


# get all SNVs, but from genomes only:

cat somatic_mutation_data/*/*_clean_somatic_mutations_for_signature_analysis.txt | grep -w subs | ./extractSpecColumns.pl -c 3,1,4,6,7 | sed -e "s/^/chr/" | ./extractSpecColumns.pl -c 2,1,3-5 | ./filterLines.pl -c 1 -f genomes-patientID.list | gzip > Somatic_SNVs_Alexandrov_genomes_only.tsv.gz

# exclude MT:

zcat Somatic_SNVs_Alexandrov_genomes_only.tsv.gz | grep -w chrMT -v | gzip > Somatic_SNVs_Alexandrov_genomes_only-noMT.tsv.gz

# which samples have min 100 SNVs?
zcat Somatic_SNVs_Alexandrov_genomes_only-noMT.tsv.gz | cut -f 1 | sort | uniq -c | sed -e "s/^ *//; s/ /\t/" | sort -n | ./filterLinesNumeric.pl -c 1 -T GE -V 100 | cut -f 2 > genomes-patientID-min100snvs.list

# get the corresponding SNVs:

zcat Somatic_SNVs_Alexandrov_genomes_only-noMT.tsv.gz | ./filterLines.pl -c 1 -f genomes-patientID-min100snvs.list | gzip > Somatic_SNVs_Alexandrov_genomes_only-noMT-min100snvs.tsv.gz

# remove intermediate files (if you want):

rm -f genomes-tumor-patientID-map.tsv \
   genomes-patientID.list \
   Somatic_SNVs_Alexandrov_genomes_only.tsv.gz \
   Somatic_SNVs_Alexandrov_genomes_only-noMT.tsv.gz \
   genomes-patientID-min100snvs.list
   


# postprocess with pmsignature and decompTumor2Sig to get and save signatures

R CMD BATCH --vanilla Alexandrov_PMID_23945592_435_tumors-pmsignature-15sig.R

---
title: "A brief introduction to decompTumor2Sig"
author:
- name: "Rosario Michael Piro"
  affiliation: Dipartimento di Elettronica, Informazione e Bioingegneria (DEIB),
               Politecnico di Milano, Italy
  email: rmpiro@gmail.com or rosariomichael.piro@polimi.it
date: "`r Sys.Date()`"
vignette: >
  %\VignetteIndexEntry{A brief introduction to decompTumor2Sig}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}
output: 
  BiocStyle::html_document
---

```{r style, echo = FALSE, results = 'asis'}
library(BiocStyle)
```

```{r, echo = FALSE}
library(knitr)
```


# Introduction

The R package **decompTumor2Sig** has been developed to decompose individual
tumor genomes (i.e., the lists of somatic single nucleotide variants identified
in individual tumors) according to a set of given mutational signatures---a
problem termed signature refitting---using a quadratic-programming approach.

Mutational signatures can be either of the form initially proposed by Alexandrov
et al. (Cell Rep. 3:246--259, 2013 and Nature 500:415--421, 2013)---in the
following called "Alexandrov signatures"---or of the simplified form proposed
by Shiraishi et al. (PLoS Genet. 11:e1005657, 2015)---in the following called
"Shiraishi signatures".

For each of the given mutational signatures, **decompTumor2Sig** determines
their contribution to the load of somatic mutations observed in a tumor.

**Please read the following important notes first**:

*Note*: here and in the following, when referring to "mutations", we intend
single nucleotide variants (SNVs).

*Note*: given the number of parameters to be estimated, **decompTumor2Sig** 
should best be applied only to tumor samples with a sufficient number of somatic
mutations. From our experience, using tumor samples with 100+ somatic mutations
was reasonable when using version 2 of the COSMIC Mutational Signatures
(30 signatures). Tumor samples with fewer somatic mutations should be avoided
unless a tumor-type specific subset of signatures is used.

*Note*: be aware that publicly available signature sets have often been defined
with respect to genome wide mutation frequencies, so they should best be applied
to somatic mutation data from whole genome sequencing. Background frequencies
may be different for subsets of the genome, i.e., current signature sets might
yield incorrect results when applied to, for example, mutation data from
targetted sequencing of only a subset of genes!

*Note*: for all functions provided by **decompTumor2Sig**, please see the
manual or the inline R help page for further details and explanations.


## Papers / how to cite

> Krüger S, Piro RM (2019) decompTumor2Sig: Identification of mutational
signatures active in individual tumors. *BMC Bioinformatics*
**20**(Suppl 4):152.

> Krüger S, Piro RM (2017) Identification of mutational signatures active in
individual tumors. *PeerJ Preprints* **5**:e3257v1 (Proceedings of the NETTAB
2017 Workshop on Methods, Tools \& Platforms for Personalized Medicine in the
Big Data Era, October 16-18, 2017 in Palermo, Italy).

BibTeX:
```
@UNPUBLISHED(krueger-decompTumor2Sig-paper,
   author = "Kr{\"u}ger, Sandra and Piro, Rosario Michael",
   title = "decompTumor2Sig: Identification of mutational signatures active in individual tumors",
   journal = "BMC Bioinformatics",
   volume = "20",
   number = "Suppl 4",
   pages = "152",
   year = 2019
);

@ARTICLE(krueger-decompTumor2Sig-nettab,
   author = "Kr{\"u}ger, Sandra and Piro, Rosario Michael",
   title = "Identification of mutational signatures active in individual tumors",
   journal = "PeerJ Preprints",
   volume = "5",
   pages = "e3257v1",
   year = 2017
);
```

# Installing and loading the package {#installation}

## Installation

### Bioconductor

**decompTumor2Sig** requires several CRAN and Bioconductor R packages to be
installed. Dependencies are usually handled automatically, when installing the
package using the following commands:

```
install.packages("BiocManager")
BiocManager::install("decompTumor2Sig")
```
[NOTE: Ignore the first line if you already have installed the
`r CRANpkg("BiocManager")`.]

### Manual installation

In the unlikely case that a manual installation is required, e.g., if you do
not install **decompTumor2Sig** via Bioconductor (which is highly recommended),
before installing **decompTumor2Sig** make sure the following packages are
installed:

CRAN packages:

`r CRANpkg("Matrix")`, `r CRANpkg("quadprog")`, 
`r CRANpkg("plyr")`, `r CRANpkg("ggplot2")`, `r CRANpkg("ggseqlogo")`,
`r CRANpkg("gridExtra")`

Bioconductor packages:

`r Biocpkg("GenomicRanges")`, `r Biocpkg("GenomicFeatures")`,
`r Biocpkg("Seqinfo")`, 
`r Biocpkg("Biostrings")`, `r Biocpkg("BiocGenerics")`,
`r Biocpkg("S4Vectors")`, `r Biocpkg("BSgenome.Hsapiens.UCSC.hg19")`,
`r Biocpkg("TxDb.Hsapiens.UCSC.hg19.knownGene")`,
`r Biocpkg("VariantAnnotation")`,  `r Biocpkg("SummarizedExperiment")`

If you intend to work with Shiraishi-type signatures, you may also want to
install the R package `r Rpackage("pmsignature")` which is neither part of
CRAN nor of Bioconductor and must be downloaded and installed manually
(available at: <https://github.com/friend1ws/pmsignature>).

CRAN packages can be installed from R using the following command:

```
install.packages("<package_name>")
```

Bioconductor packages can be installed from R using the following command:

```
BiocManager::install("<package_name>")
```

Sometimes, it may also be useful to update Bioconductor:

```
BiocManager::install()
```

Finally, the manual installation of **decompTumor2Sig** can, for example, be
done from the command line ...
```
R CMD INSTALL decompTumor2Sig_<version>.tar.gz
```
... or the newest version can directly be installed from GitHub using the
CRAN package  `r CRANpkg("devtools")`:
```
library(devtools)
install_github("rmpiro/decompTumor2Sig")
```


## Loading the package

After installation, loading the package is simple:
```{r, results='hide', message=FALSE}
library(decompTumor2Sig)
```

# Input data {#input}

**decompTumor2Sig** works with two kinds of input data:

i) a set of given mutational signatures, and
ii) a set of somatic mutations (single nucleotide variants) observed in a tumor
genome.

Additionally, **decompTumor2Sig** requires the genomic sequence (in form of a
`r Rpackage("BSgenome")` object) to determine neighboring nucleotides of the
mutated bases. It may also require transcript annotations (in form of a
`r Rpackage("TxDb")` object) in case the given mutational signatures take
information on the transcription direction into account.


## Mutational signatures {#input-sign}

Mutational signatures can be read in two different formats: Alexandrov-type
signatures and Shiraishi-type signatures.

### Alexandrov signatures {#input-sign-alexandrov}

Alexandrov signatures are specified either in the format used at the
COSMIC Mutational Signatures website for signatures version 2 (March 2015,
see <http://cancer.sanger.ac.uk/cosmic/signatures_v2> -> "Download signatures"),
in the format used for signatures version 3 (May 2019; see
<https://www.synapse.org/#!Synapse:syn12009743>), or in the format used for
singatures version 3.2 (March 2021; see
<https://cancer.sanger.ac.uk/cosmic/signatures/SBS/>). Also the signatures of
version 3.1 (same as version 3.0 but distributed as an Excel spread sheet
on the COSMIC Mutational Signatures website) can be read. For versions 3, 3.1
and 3.2, only Single Base Substitution (SBS) signatures can be used.

The standard Alexandrov-type signatures report mutation frequencies for
nucleotide triplets where the mutated base is at the center. Also, the basic
Alexandrov signatures do not take transcription direction into account when
computing mutation frequencies.

Example for version 2:

```
Substitution Type  Trinucleotide  Somatic Mutation Type  Signature 1     ...
C>A                ACA            A[C>A]A                0.011098326166  ...
C>A                ACC            A[C>A]C                0.009149340734  ...
C>A                ACG            A[C>A]G                0.001490070468  ...
C>A                ACT            A[C>A]T                0.006233885236  ...
...
T>G                TTG            T[T>G]G                0.002031076880  ...
T>G                TTT            T[T>G]T                0.004030128160  ...
```

Example for version 3:

```
Type,SubType,SBS1,SBS2,SBS3,SBS4,SBS5,SBS6, ...
C>A,ACA,8.86E-04,5.80E-07,2.08E-02,4.22E-02,1.20E-02,4.25E-04, ...
C>A,ACC,2.28E-03,1.48E-04,1.65E-02,3.33E-02,9.44E-03,5.24E-04, ...
C>A,ACG,1.77E-04,5.23E-05,1.75E-03,1.56E-02,1.85E-03,5.20E-05, ...
C>A,ACT,1.28E-03,9.78E-05,1.22E-02,2.95E-02,6.61E-03,1.80E-04, ...
...
T>G,TTG,5.83E-04,9.54E-05,8.05E-03,2.32E-03,6.94E-03,3.24E-04, ...
T>G,TTT,2.23E-16,2.23E-16,1.05E-02,5.68E-04,1.35E-02,1.01E-03, ...
```

(Apart from the change of tab- to comma-separator, the main difference is
the lack of the redundant 3rd annotation column in version 3. Version 3.1 has
the same format as version 3, but is distributed as an Excel spread sheet.)

Example for version 3.2:

```
Type       SBS1                    SBS2                    ...
A[C>A]A    0.000876022860356065    5.79005909129116e-07    ...
A[C>A]C    0.0022201195808427      0.000145504532003707    ...
A[C>A]G    0.000179727205679816    5.36186073164881e-05    ...
A[C>A]T    0.00126505263784183     9.75912243380865e-05    ...
...
T[T>G]G    0.000577613846957072    9.54312693870027e-05    ...
T[T>G]T    2.20126302870092e-16    2.22251767921597e-16    ...
```


To read Alexandrov-type signatures, use the command
**readAlexandrovSignatures()**. By default, the command reads the version 2 (!)
signatures directly from COSMIC and stores them in a list object:

```{r, message=FALSE, warning=FALSE}
signatures <- readAlexandrovSignatures()
length(signatures)
signatures[1]
```

Alternatively, the signatures can be read from a file of the format shown
above (TSV, CSV or Excel spread sheet):

```{r, eval=FALSE}
signatures <- readAlexandrovSignatures(file="<signature_file>")
```


### Shiraishi signatures {#input-sign-shiraishi}

Shiraishi signatures are specified as matrices (in flat files without headers
and row names; one file per signature).

Format (see Shiraishi et al. PLoS Genetics 11(12):e1005657, 2015):

* The first row:
Frequencies of the six possible base changes C>A, C>G, C>T, T>A, T>C, and T>G.
Please note that due to the complementarity of base pairing these six base
changes already include A>? and G>?.

* The following *2k* rows (for *k* up- and downstream flanking bases):
Frequencies of the bases A, C, G, and T, followed by two 0 values.

* The optional last row (only if transcription direction is considered):
Frequencies of occurrences on the transcription strand, and on the
opposite strand, followed by four 0 values.

Example:
```
0.05606328   0.07038910   0.39331059   0.13103780   0.20797476   0.14122446
0.27758477   0.21075424   0.23543226   0.27622874   0            0
0.33081021   0.25347427   0.23662536   0.17909016   0            0
0.21472304   2.6656e-09   0.55231053   0.23296643   0            0
0.22640542   0.20024237   0.32113377   0.25221844   0            0
0.50140066   0.49859934   0            0            0            0
```

Among its examples, the **decompTumor2Sig** package provides a small set of
four Shiraishi-type signatures in flat files. These signatures were obtained
from 21 breast cancer genomes (Nik-Zainal et al. Cell 149:979--993, 2012) using
the R package `r Rpackage("pmsignature")` (Shiraishi et al. PLoS Genet.
11:e1005657, 2015).

To read these flat files as signatures, you can use the following example:

```{r}
# take the example signature flat files provided with decompTumor2Sig
sigfiles <- system.file("extdata",
                 paste0("Nik-Zainal_PMID_22608084-pmsignature-sig",1:4,".tsv"),
                 package="decompTumor2Sig")

# read the signature flat files
signatures <- readShiraishiSignatures(files=sigfiles)
signatures[1]
```

### Get signatures from the package `r Rpackage("pmsignature")` {#input-pmsig}

The third possibility is to convert Shiraishi-type signatures directly from
the package that computes them (`r Rpackage("pmsignature")`; Shiraishi et al.
PLoS Genet. 11:e1005657, 2015).

Example workflow:

```{r}
# load example signatures for breast cancer genomes from Nik-Zainal et al
# (PMID: 22608084) in the format produced by pmsignature (PMID: 26630308)
pmsigdata <- system.file("extdata",
          "Nik-Zainal_PMID_22608084-pmsignature-Param.Rdata", 
          package="decompTumor2Sig")
load(pmsigdata)
 
# extract the signatures from the pmsignature 'Param' object
signatures <- getSignaturesFromEstParam(Param)
signatures[1]
```


Please note that `r Rpackage("pmsignature")` is neither part of CRAN nor of
Bioconductor and must be downloaded and installed manually (available at:
<https://github.com/friend1ws/pmsignature>). To load mutational signatures
without `r Rpackage("pmsignature")` being installed, see the previous sections.


### Conversion of Alexandrov signatures to Shiraishi signatures {#sign-Alex2Shi}

An Alexandrov-type signature can be converted into a Shiraishi-type signature
(but not *vice versa* due to the loss of information). Consider the following
example:

```{r, message=FALSE, warning=FALSE}
sign_a <- readAlexandrovSignatures()
sign_s <- convertAlexandrov2Shiraishi(sign_a)
sign_s[1]
```

*Note*: since the standard Alexandrov-type signatures regard nucleotide
triplets and do not take transcription direction into account, the obtained
Shiraishi-type signatures will also be limited to triplets without information
about transcription direction.

**Important**: Please be aware that signatures are initially not determined in
isolation but as a set of signatures derived from a commonly large set of tumor
genomes (Alexandrov et al. Cell Rep. 3:246--259, 2013; Alexandrov et al. Nature
500:415--421, 2013; Shiraishi et al. PLoS Genet. 11:e1005657, 2015). Therefore,
the biological meaning of converting signatures is not well defined, and the
approach should be taken with caution! As an example for the possible outcome,
please see our paper (Krüger and Piro, 2019).


### Adjustment/normalization of mutational signatures for subsets of the genome

The exact numeric features of mutational signatures (e.g., the 96 mutation
probabilities of trinucleotide mutation types within an Alexandrov-type
signature) depend not only on the mutational processes themselves, but also
on the nucleotide frequencies within the reference sequences of the mutation
data from which the signatures were derived.

Consider, for example, a hypothetical biochemical mutational process which can
potentially cause C[C>T]G and A[C>T]A mutations with equal probability.
Even if both mutation types are potentially equiprobable, in CG-rich regions
more C[C>T]G than A[C>T]A mutations will be observed, simply because these
regions likely contain more CCG trinucleotides than ACA trinucleotides which
can be mutated. This illustrates that the observed fractions of mutations do
not only depend on the underlying mutational process alone, but also on the
nucleotide frequencies within the reference sequences from which the mutational
signatures were inferred in the first place (e.g., whole genome, whole exome,
another subset of genomic regions?).

Sometimes, however, it may be useful to apply signature refitting to
mutation data from genomic regions whose nucelotide frequencies differ from
those for which mutational signatures are available. For example, signature
refitting might need to be applied to mutation data from whole exome
sequencing, or targetted sequencing (only a specific set of genes) although
mutational signatures were derived for data from the whole reference genome.

For this purpose, the function **adjustSignaturesForRegionSet()** provides
the possibility to (re-)adjust/normalize mutational signatures for a given
reference sequence (e.g., whole genome) to the nucleotide frequencies present
in another target set of genomic regions (e.g., whole exome) to which
signature refitting has to be applied.


**Adjustment/normalization of Alexandrov-type signatures:**

For Alexandrov-type signatures, the important frequencies are those of
multi-nucleotide sequence patterns (usually trinucleotides) whose central base
can be mutated. Therefore, adjustment factors for individual multi-nucleotide
mutation types (e.g., A[C>T]G) are computed by comparing the corresponding
multi-nucleotide frequencies (e.g., ACG) between the original reference regions
and the target regions.

Mathematical approach: divide the mutation probabilities of individual mutation
features (e.g., trinucleotide mutation types for Alexandrov signatures) by the
original (genome-wide?) multi-nucleotide frequency, then multiply it by
the corresponding frequency in the target region set. That is, if the target
regions, for example, have a doubled frequency of a certain trinucleotide
(e.g., ACG) with respect to the original reference sequence, the mutation
probabilities of the corresponding mutation types (A[C>A]G, A[C>G]G, A[C>T]G)
in an Alexandrov signature will be multiplied by 2. Reasoning: the mutational
process has more opportunities to mutate that trinucleotide in the target
regions than in the original reference sequence for which the signature was
initially derived. After the appropriate adjustment of individual features,
an Alexandrov signature is re-normalized such that overall probability over
all mutation types sum up to 1.


**Adjustment/normalization of Shiraishi-type signatures:**

In the Shiraishi-type signature model, individual bases of the multi-nucleotide
sequence patterns are considered as independent features. Therefore, the
adjustment of such signatures should be applied to individual bases while still
reflecting the presence of absence (hence, the frequencies) of the full sequence
patterns in the genomic regions. Thus, to compute single-nucleotide frequencies
for the adjustment, first the frequencies of the multi-nucleotide sequence
patterns are determined (as for Alexandrov-type signatures) and then broken
down to single-nucleotide frequencies for the individual positions of the
patterns. That is, for each position in the sequence patterns a set of
single-nucleotide frequencies is determined to describe, for example, how
frequent a specific nucleotide occurs at a specific position in the pattern
(very much like in position-frequency matrices used for transcription factor
binding motives).

Mathematical approach: for signature adjustment, the position-specific
nucleotide frequencies are applied to the position-specific mutation
probabilities of a Shiraishi signature much in the same way as described above
for the adjustment of multi-nucleotide frequencies in Alexandrov signatures.
After the appropriate adjustment of individual position-specific features,
a Shirishi signature is re-normalized such that for each individual position
in the pattern the overall base change probability (for the central base) or
nucleotide probabilities (for flanking bases) sum up to 1.

**Usage example:**

Example for adjusting Alexandrov signatures (derived from mutation data from
the whole genome) to the nucleotide frequencies present in promoter regions:

```{r, message=FALSE, warning=FALSE}
# get Alexandrov signatures from COSMIC
signatures <- readAlexandrovSignatures()

signatures$Signature.1[1:5]


# get gene annotation for the default reference genome (hg19)
txdb <- TxDb.Hsapiens.UCSC.hg19.knownGene::TxDb.Hsapiens.UCSC.hg19.knownGene

# get a GRanges object for gene promoters (-2000 to +200 bases from TSS)
library(GenomicRanges)
regionsTarget <- promoters(txdb, upstream=2000, downstream=200)

# adjust signatures according to nucleotide frequencies in this subset of
# the genome
sign_adj <-
   adjustSignaturesForRegionSet(signatures,
            regionsTarget, regionsOriginal=NULL,
            refGenome=BSgenome.Hsapiens.UCSC.hg19::BSgenome.Hsapiens.UCSC.hg19)

sign_adj$Signature.1[1:5]
```

**adjustSignaturesForRegionSet()** accepts both types of signatures with the
following arguments:

* *signatures*: The signature set (list) to be adjusted/normalized.
* *regionsTarget*: A **GRanges** object (package `r Biocpkg("GenomicRanges")`)
containing the target regions for which to adjust the signatures. This can
also be NULL if the new target regions correspond to the whole genome.
* *regionsOriginal*: Optional **GRanges** object containing the genomic regions
for which the signatures were originally derived. By default (NULL) this is the whole genome.
* *refGenome*: Optional **BSgenome** object with the reference genome from
which to extract sequences for both the original and the target regions. By
default, the human refernce genome hg19 is taken.


### Verifying the signature format

For certain applications it may be necessary to construct signatures or
convert them from other kind of data. To do so, each signature must be either
a numeric *vector* of probabilities which sum up to 1 (for Alexandrov-type
signatures) or a *matrix* or *data.frame* with six numeric columns, every row
of which sums up to 1 (for Shiraishi-type signatures).

A set of signatures is then simply a *list* of such signatures.

To verify whether a signature set has a format that can be used with
**decompTumor2Sig** the package provides the following set of functions. Since
the mutation frequencies in genomes are specified in exactly the same way,
these functions can be used for both signatures and genomes:

* **isAlexandrovSet()**: Verify whether a list object (set of signatures or
genomes) is compatible with the Alexandrov model.
* **isShiraishiSet()**: Verify whether a list object (set of signatures or
genomes) is compatible with the Shiraishi model.
* **isSignatureSet()**: Verify whether a list object (set of signatures or
genomes) is compatible with either the Alexandrov or the Shiraishi model.
* **sameSignatureFormat()**: Verify whether two list objects (two sets of
signatures or genomes) contain signatures/genomes of the same format.

Examples:
```{r}
isAlexandrovSet(sign_a)
isSignatureSet(sign_a)
isShiraishiSet(sign_s)
isSignatureSet(sign_s)
sameSignatureFormat(sign_a, sign_s)
```

## Somatic mutations from individual tumors {#input-mut}

Information on the somatic mutations found in a tumor can be read from one of
the following formats and converted to mutation frequencies for
**decompTumor2Sig**.

### Variant Call Format (VCF) {#input-mut-vcf}

The somatic mutations of a tumor genome can be read from a VCF file. For
detailed information on this format (including an example), see
<https://samtools.github.io/hts-specs/VCFv4.2.pdf>.

Mutations from multiple tumor genomes can also be read from a multi-sample VCF
file.

As an example, the **decompTumor2Sig** package provides the somatic mutations
for a subset of six of the 21 breast cancer genomes originally published by
Nik-Zainal et al (Cell 149:979--993, 2012). The dataset has been converted
from MPF (see below) to VCF.

Example workflow:

```{r}
# load the reference genome and the transcript annotation database
refGenome <- BSgenome.Hsapiens.UCSC.hg19::BSgenome.Hsapiens.UCSC.hg19
transcriptAnno <-
           TxDb.Hsapiens.UCSC.hg19.knownGene::TxDb.Hsapiens.UCSC.hg19.knownGene

# take the six breast cancer genomes from Nik-Zainal et al (PMID: 22608084) 
gfile <- system.file("extdata",
                     "Nik-Zainal_PMID_22608084-VCF-convertedfromMPF.vcf.gz",
                     package="decompTumor2Sig")

# read the cancer genomes in VCF format
genomes <- readGenomesFromVCF(gfile, numBases=5, type="Shiraishi",
                              trDir=TRUE, refGenome=refGenome,
                              transcriptAnno=transcriptAnno, verbose=FALSE)
length(genomes)
genomes[1:2]
```

When reading somatic mutations of tumor genomes with **readGenomesFromVCF()**,
they are preprocessed to determine mutation frequencies according to specific
sequence characteristics which can be controlled by the following arguments:

* *type*: Type of signatures that will be used with the genomes, "Shiraishi" or
"Alexandrov".
* *numBases*: The odd number of nucleotides/bases of the mutated sequence
(where the mutated base is at the center). 
* *trDir*: Whether the transcription direction should be taken into account
(default: TRUE). If so, only mutations located within genomic regions for which
a transcript direction is defined will be considered.
* *refGenome*: The reference genome from which to obtain the flanking bases of
the mutated base.
* *transcriptAnno*: The transcript annotation database from which to obtain the
transcription direction (if needed, i.e., if *trDir*=TRUE).
* *enforceUniqueTrDir*: If *trDir* is TRUE, then by default each mutation which
maps to a region with multiple overlapping genes with opposing transcription
directions will be excluded from the analysis. This is because from mutation
data alone it cannot be inferred which of the two genes has the higher
transcription activity which might potentially be linked to the occurrence of
the mutation. Until version 1.3.5 of **decompTumor2Sig** the behavior for
mutations associated with two valid transcription directions was different: the
transcript direction encountered first in the transcript database (specified
with *transcriptAnno*) was assigned to the mutation; the latter is also the
default behavior of the `r Rpackage("pmsignature")` package. If you need to
reproduce the old behavior---which basically arbitrarily assigns one of the two
transcriptions strands---then you can set *enforceUniqueTrDir*=FALSE (this
option exists mostly for backward compatibility with older versions), but it is
recommended to entirely exclude mutations without ambiguous transcription
strands. Note: this option is ignored when *trDir*=FALSE, where all mutations
can be used.


### Mutation Position Format (MPF) {#input-mut-mpf}

Alternatively, somatic mutations can be read from an MPF file.

Example MPF file:

```
patient1   chr1   809687    G   C
patient1   chr1   819245    G   T
patient1   chr2   2818266   A   G
patient1   chr2   3433314   G   A
patient2   chr1   2927666   A   G
patient2   chr1   3359791   C   T
```

The five columns contain

1. the name of the sample (or tumor ID); 
1. the chromosome name; 
1. the position on the chromosome; 
1. the reference base at that position (A, C, G, or T); 
1. the alternate or variant base (A, C, G, or T).

Hence, with an MPF file, too, multiple tumors can be described.

As an example, the **decompTumor2Sig** package provides the somatic mutations
for six of the 21 breast cancer genomes originally published by Nik-Zainal et
al (Cell 149:979--993, 2012).

Example workflow:

```{r}
# load the reference genome and the transcript annotation database
refGenome <- BSgenome.Hsapiens.UCSC.hg19::BSgenome.Hsapiens.UCSC.hg19
transcriptAnno <-
           TxDb.Hsapiens.UCSC.hg19.knownGene::TxDb.Hsapiens.UCSC.hg19.knownGene

# take the six breast cancer genomes from Nik-Zainal et al (PMID: 22608084) 
gfile <- system.file("extdata", "Nik-Zainal_PMID_22608084-MPF.txt.gz", 
                     package="decompTumor2Sig")

# read the cancer genomes in MPF format
genomes <- readGenomesFromMPF(gfile, numBases=5, type="Shiraishi",
                              trDir=TRUE, refGenome=refGenome,
                              transcriptAnno=transcriptAnno, verbose=FALSE)
```

Note: the preprocessing of the somatic mutations into mutation frequencies can
be controlled with the same function arguments that have been described above
for **readGenomesFromVCF()**.



### Get somatic mutations from the package `r Rpackage("pmsignature")` {#mutpm}

The third possibility to get the somatic mutations from one or more tumor
genomes is to convert them directly from a tumor data object
(*MutationFeatureData* object) loaded using the `r Rpackage("pmsignature")`
package (Shiraishi et al. PLoS Genet. 11:e1005657, 2015).

An example of such an object is provided with **decompTumor2Sig**:

```{r}
# get breast cancer genomes from Nik-Zainal et al (PMID: 22608084) 
# in the format produced by pmsignature (PMID: 26630308)
pmsigdata <- system.file("extdata", 
                         "Nik-Zainal_PMID_22608084-pmsignature-G.Rdata", 
                         package="decompTumor2Sig")
load(pmsigdata)

# extract the genomes from the pmsignature 'G' object
genomes <- getGenomesFromMutFeatData(G, normalize=TRUE)
genomes[1]
```


Please note that `r Rpackage("pmsignature")` is neither part of CRAN nor of
Bioconductor and must be downloaded and installed manually (available at:
<https://github.com/friend1ws/pmsignature>). To read tumor genomes without
`r Rpackage("pmsignature")` being installed, see the previous sections about
VCF and MPF and the following section.

**Important**: the argument *normalize*, that can be specified for
**getGenomesFromMutFeatData()**, controls whether the function should simply
count the number of occurrences or whether it provides (normalized)
fractions/percentages of mutations among the total set. Normalization is the
default and is what **should be used** for determining the contribution of
individual signatures to the mutational load of a tumor. *normalize*=FALSE
should be used only in case you are interested in how many somatic mutations
of the single signature categories can be found in a tumor; it should not be
used for further processing with **decompTumor2Sig**!

**Important**: There is a slight difference on how `r Rpackage("pmsignature")`
and **decompTumor2Sig** preprocess mutations for counting them when taking the
transcription direction into account: For mutations which map to a region with
multiple overlapping genes with opposing transcription directions,
`r Rpackage("pmsignature")` assigns the transcript direction of the gene
encountered first in the transcript database (see also Section 3.2.1). This
was also the behavior of **decompTumor2Sig** until version 1.3.5 (used for
our papers; Krüger and Piro, 2017, 2019). In newer versions,
**decompTumor2Sig** excludes these mutations
by default from the count because from mutation data alone it cannot be
inferred which of the two genes has the higher transcriptional activity which
might potentially be linked to the occurrence of the mutation. However, when
converting data from `r Rpackage("pmsignature")` these mutations have already
been processed and can therefore not be excluded during the conversion.


### Get somatic mutations from a VRanges object {#input-mut-vranges}

The Bioconductor package `r Biocpkg("VariantAnnotation")` provides the class
**VRanges** which can be used to store mutation information. **decompTumor2Sig**
allows to extract single nucleotide variants (SNVs) from such an object and
convert them into the tumor genomes' mutation frequencies using the function
**convertGenomesFromVRanges()**, as in the following example workflow:

```{r, message=FALSE}
# load the reference genome and the transcript annotation database
refGenome <- BSgenome.Hsapiens.UCSC.hg19::BSgenome.Hsapiens.UCSC.hg19
transcriptAnno <-
           TxDb.Hsapiens.UCSC.hg19.knownGene::TxDb.Hsapiens.UCSC.hg19.knownGene

# take six breast cancer genomes from Nik-Zainal et al (PMID: 22608084) 
gfile <- system.file("extdata",
                     "Nik-Zainal_PMID_22608084-VCF-convertedfromMPF.vcf.gz", 
                     package="decompTumor2Sig")

# get the corresponding VRanges object (using the VariantAnnotation package)
library(VariantAnnotation)
vr <- readVcfAsVRanges(gfile, genome="hg19")

# convert the VRanges object to the decompTumor2Sig format
genomes <- convertGenomesFromVRanges(vr, numBases=5, type="Shiraishi",
                                     trDir=TRUE, refGenome=refGenome,
                                     transcriptAnno=transcriptAnno,
                                     verbose=FALSE)
```

Note: the preprocessing of the somatic mutations into mutation frequencies can
be controlled with the same function arguments that have been described above
for **readGenomesFromVCF()**.



### Verifying the mutation data ("genomes") format

Since the mutation data of genomes is specified as mutation probabilities
and has exactly the same format as signatures, the format can be verified with
the very same functions described in Section 3.1.6 (see above).



# Workflow {#workflow}

(*Note*: The following examples are for illustrative purpose only and need not
be biologically meaningful.)

Once both the tumor genome(s) and the given mutational signatures have been
read (see above), the contribution of the given signatures to the somatic
mutations in individual tumors can be determined using the following workflow.

In the following, we assume to have the signatures in a list object named
*signatures* and the mutation frequencies of the tumor genome(s) in another
list object named *genomes*.

**Important note**: it is imperative that the mutation frequencies represented
by both *signatures* and *genomes* have been computed with the same
characteristics. That is, if the *signatures* refer to sequences of 5
nucleotides/bases (with the mutated base at the center), then also the
*genomes* must have been read for 5 bases. If the *signatures* have been
produced taking the transcription direction into account, then also the
*genomes* must have been read taking the transcription direction into account,
and so on.


## Visualizing genome characteristics and mutational signatures

Given that the signatures and the genomes (if read appropriately) have the same
format and contain the same type of information (fractions/percentages of
somatic mutations that have specific features, e.g., specific neighboring
bases), both can essentially be visualized in the same way.

The function **plotMutationDistribution()** takes as an input either a single
signature or the mutation frequencies of an individual tumor genome (either of
Alexandrov- or of Shiraishi-type) and plots the mutation frequency data
according to the signature model.

To plot, for example, Alexandrov/COSMIC signature 1 (obtained as described in
Section 3.1.1):

```{r}
signatures <- readAlexandrovSignatures()
plotMutationDistribution(signatures[[1]])
```

To plot one of the Shiraishi signatures provided with this package (see Section
3.1.2):

```{r}
sigfiles <- system.file("extdata",
                 paste0("Nik-Zainal_PMID_22608084-pmsignature-sig",1:4,".tsv"), 
                 package="decompTumor2Sig")
signatures <- readShiraishiSignatures(files=sigfiles)

plotMutationDistribution(signatures[[1]])
```

**decompTumor2Sig**'s representation of the mutation frequency data of
Shiraishi-type signatures uses sequence logos for the flanking bases and the
variant bases (with the heights of the bases being proportional to their
probability/frequency). The two possibilities for the mutated central base
(**C** or **T**) are represented next to each other and their respective
frequency is indicated below. This side-by-side representation allows to
distinguish the probabilities of variant bases (on top) according to the
mutated base. Transcription strand bias (if information on transcription
direction is used) is shown in the upper right corner (frequency of mutations
on the transcription strand, "+", and the opposite strand, "-").

In the plot above, for example, **C** and **T** are nearly equally likely
to be mutated by the represented mutational process, but a mutated **C** most
frequently becomes a **T**, while a mutated **T** becomes one of the other
bases with roughly equal probability. Also, the mutational signature has next
to no strand bias.

This representation is similar to the way the `r Rpackage("pmsignature")`
package represents such signatures, as shown by the following example:

```{r, echo=FALSE}
include_graphics("example-sign-Shiraishi.png")
```
(This plot above was generated with `r Rpackage("pmsignature")` and serves only
for comparison, showing the same signature as above.)


To show that genome mutation frequencies can be represented in the same manner,
the following example reads the tumor genomes provided with this package (see
Section 3.2.1) using the Alexandrov model and plots the mutation frequencies of
the first genome:

```{r}
refGenome <- BSgenome.Hsapiens.UCSC.hg19::BSgenome.Hsapiens.UCSC.hg19
gfile <- system.file("extdata",
                     "Nik-Zainal_PMID_22608084-VCF-convertedfromMPF.vcf.gz", 
                     package="decompTumor2Sig")
genomes <- readGenomesFromVCF(gfile, numBases=3, type="Alexandrov",
         trDir=FALSE, refGenome=refGenome, verbose=FALSE)

plotMutationDistribution(genomes[[1]])
```


## Explained variance as a function of the number of signatures

In many cases already a small subset of the given signatures is sufficient to
explain the major part of the variance of the mutation frequencies observed
in a single tumor genome.

The explained variance can be determined by comparing the true mutation
frequencies $g_i$ of the tumor genome---where $i$ is one of the mutation
features of the signature model (e.g., triplet mutations for Alexandrov
signatures, or base changes or flanking bases for Shiraishi signatures)---to
the mutation frequencies $\hat{g}_i$ obtained when re-composing/reconstructing
the mutation frequencies of the tumor genome from the mutational signatures and
their computed exposures/contributions. (See Section 4.3 for computing the
exposures/contributions, and Section 4.4 for reconstructing the mutation
frequencies of a tumor.)

For the Alexandrov model, the explained variance can be estimated as:

$$ \mathrm{evar}=1-\frac{\sum_i{(g_i-\hat{g}_i)^2}}{\sum_i({g_i}-\bar{g})^2} $$

where the numerator is the residual sum of squares (RSS) between the predicted
and true mutation frequencies of the tumor genome (i.e., the squared error),
and the denominator can be interpreted as the deviation from a tumor genome
with a uniform mutation frequency of 1/96 for each feature (which is
precisely the average mutation frequency $\bar{g}$).

For the Shiraishi model, $\bar{g}$ does not describe a tumor genome with
uniform mutation frequencies, and hence the explained variance is estimated as:

$$\mathrm{evar}=1-\frac{\sum_i{(g_i-\hat{g}_i)^2}}{\sum_i({g_i}-{g}^{*}_i)^2}$$

where $g^{*}$ is a uniform tumor model that uses mutation frequencies of 1/6
for the six possible base changes, 1/4 for each of the possible flanking bases,
and 1/2 for each of the two possible transcription-strand directions. For more
details, please see Krüger and Piro (2019).

The function **plotExplainedVariance()** allows to visually analyze how many
signatures are necessary to explain certain fractions of the variance of a
tumor genome's mutational patterns.

For an increasing number *K* of signatures, the highest variance explained by
subsets of *K* signatures will be plotted. This can help to evaluate what
minimum threshold for the explained variance could be used to decompose tumor
genomes with the function **decomposeTumorGenomes()** (see below).

### Example: input data

As a simple example, load a set of 15 Shiraishi-type signatures (object
*signatures*) provided with this package. These signatures were obtained with
the package `r Rpackage("pmsignature")` from a set of 435 tumor genomes with at
least 100 somatic mutations from ten different tumor entities (data from
Alexandrov et al. Nature 500:415-421, 2013; for the analysis, see our papers
mentioned in Section 1.1):

```{r}
# load the 15 Shiraishi signatures obtained from 
# 435 tumor genomes from Alexandrov et al.
sfile <- system.file("extdata",
              "Alexandrov_PMID_23945592_435_tumors-pmsignature-15sig.Rdata", 
              package="decompTumor2Sig")
load(sfile)
length(signatures)
signatures[1]
```

This loads an object *signatures* with 15 Shiraishi signatures for mutated
subsequences of length 5 (five nucleotides with the mutated base at the center)
and taking transcription direction into account.

Now read the tumor genomes (object *genomes*) provided with this package, as
described in Section 3.2.1:
```{r}
# load the reference genome and the transcript annotation database
refGenome <- BSgenome.Hsapiens.UCSC.hg19::BSgenome.Hsapiens.UCSC.hg19
transcriptAnno <-
           TxDb.Hsapiens.UCSC.hg19.knownGene::TxDb.Hsapiens.UCSC.hg19.knownGene

# take six breast cancer genomes from Nik-Zainal et al (PMID: 22608084) 
gfile <- system.file("extdata",
                     "Nik-Zainal_PMID_22608084-VCF-convertedfromMPF.vcf.gz", 
                     package="decompTumor2Sig")

# read the cancer genomes in VCF format
genomes <- readGenomesFromVCF(gfile, numBases=5, type="Shiraishi",
                              trDir=TRUE, refGenome=refGenome,
                              transcriptAnno=transcriptAnno, verbose=FALSE)
```

### Example: plot the explained variance

The explained variance can be plotted only for a single tumor genome. Plotting
the explained variance of the first tumor genome when using increasing subsets
of the 15 mutational signatures (see above), for example, can be done with the
following command: 

```{r, fig.asp=1}
plotExplainedVariance(genomes[[1]], signatures, minExplainedVariance=0.9,
                                    minNumSignatures=2, maxNumSignatures=NULL,
                                    greedySearch=TRUE)
```

The function **plotExplainedVariance()** takes the following arguments:

* *genome*: The mutation frequencies of a single tumor genome (according to the
Alexandrov or Shiraishi model).
* *signatures*: The set of given signatures (must be of the same model as the
genome).
* *minExplainedVariance* (default is NULL): If specified, the smallest subset of
signatures necessary to explain at least this fraction of the variance is
highlighted in red (including the list of the signatures in the subset).
* *minNumSignatures* (default is 2): Take at least this minimum number of
signatures.
* *maxNumSignatures* (default is NULL, i.e., all): If specified, take at most
this maximum number of signatures.
* *greedySearch* (default is FALSE): If FALSE, the function will evaluate for
each number of signatures *K* **all** possible subsets of *K* signatures to
compute the highest explained variance for *K*. This can take very long if
the total number of given signatures is too high. If TRUE, first, all possible
subsets with *K*=*minNumSignatures* are evaluated, taking the subset with the
highest explained variance, then stepwise one additional signature (highest
increase in explained variance) is added to the already identified set. This
approximation is much faster but not guaranteed to plot the maximum explained
variance for all *K* (a greedy search can get stuck in a local optimum).


## Decomposing tumor genomes by signature refitting (contribution prediction)

This is the heart of the functionality of **decompTumor2Sig**, its main purpose.

Given a tumor genome and a set of mutational signatures (that represent
mutational processes like UV light, smoking, etc; see  Alexandrov and Stratton,
Curr Opin Genet Dev 24:52-60, 2014), we would like to estimate how strongly the
different signatures (processes) contributed to the overall mutational load
observed in the tumor. To this end **decompTumor2Sig** relies on quadratic
programming. For details, see our paper (Krüger and Piro, 2019).

The result will be a vector of weights/contributions (or "exposures") which
indicate the fractions or percentages of somatic mutations which can likely be
attributed to the given signatures.

Lets take, for instance, the signature and tumor data used for the example in
Section 4.2 (see there).

To compute the contributions of the 15 given signatures to the first tumor
genome, we can run the following command ...

```{r}
exposure <- decomposeTumorGenomes(genomes[1], signatures)
```

... and get the following *exposures* (contributions) for the 15 signatures:

```{r}
exposure
```

The exposures/contributions for a single tumor genome can also be plotted:

```{r, message=FALSE, warning=FALSE, fig.asp=1}
plotDecomposedContribution(exposure)
```

In some cases, multiple tumor genomes need to be decomposed (each one, however,
individually). In this case, a set of tumor genomes can be passed to
**decomposeTumorGenomes()**:

```{r}
exposures <- decomposeTumorGenomes(genomes, signatures)
length(exposures)
exposures[1:2]
```

**decompTumor2Sig** provides an additional function that can be used to verify
whether a list object is of the same format as it is returned by
**decomposeTumorGenomes()**:

```{r}
isExposureSet(exposures)
```


### Finding a subset of signatures with a minimum explained variance

Instead of decomposing a tumor genome precisely into the given set of signatures
(15 in the example above), the function **decomposeTumorGenomes()** can
alternatively be used to search for subsets of signatures for which the
decomposition satisfies a minimum threshold of explained variance (here, we
show this only for the first tumor):

```{r}
exposures <- decomposeTumorGenomes(genomes[1], signatures,
                                   minExplainedVariance=0.9,
                                   minNumSignatures=2, maxNumSignatures=NULL,
                                   greedySearch=FALSE, verbose=TRUE)
```

For each tumor genome, the minimum subset of signatures that explain at least
*minExplainedVariance* percent of the variance of the mutation frequencies will
be identified (the exposures of all other signatures will be set to NA):

```{r}
exposures
```


```{r, fig.asp=1}
plotDecomposedContribution(exposures[[1]])
```

[If **plotDecomposedContribution()** is run with *removeNA=FALSE*, also
signatures with an NA value as exposure will be included in the x-axis of the
plot. Additionally, the signatures can be passed to the function using the
parameter *signatures*; if so, signature names for the plot will be taken
from this object, otherwise they are inferred from the exposure object or
set sign_1 to sign_N.]

**Important note**: although a subset of signatures may explain the somatic
mutations observed in the tumor genomes reasonably well, they need not
necessarily be the signatures with the highest contribution when taking the
entire set of signatures (e.g., due to a greedy search which can get stuck in
a local optimum).

**Important note**: if for a tumor genome no (sub)set of signatures is
sufficient to explain at least *minExplainedVariance* percent of the variance,
no result (NULL) is returned for that tumor.

The search behavior of **decomposeTumorGenomes()** when finding a subset of
signatures to explain the somatic mutations of a tumor can be influenced by the
following arguments:

* *minExplainedVariance* (default is NULL): If not specified, exactly
*maxNumSignatures* (see below; default: all) will be taken for decomposing
each genome; if specified (between 0 and 1), the smallest subset of signatures
which explains at least *minExplainedVariance* of the variance is taken for
the decomposition.
* *minNumSignatures* (default is 2): If a search for a subset of signatures is
performed, at least *minNumSignatures* will be taken.
* *maxNumSignatures* (default is NULL, i.e., all): If a search for a subset of
signatures is performed, at most *maxNumSignatures* will be taken; if NULL, all
given signatures will be taken as the maximum; if *maxNumSignatures* is
specified but *minExplainedVariance=NULL* (no search), then exactly the best
*maxNumSignatures* will be taken.
* *greedySearch* (default is FALSE): If FALSE, a full search will be performed:
for increasing numbers *K* of signatures, *all* possible subsets of *K*
signatures will be tested and the subset with the highest explained variance is
chosen, increasing *K* until the threshold of *minExplainedVariance* is
satisfied; if TRUE, a much faster, greedy search is performed: first, all
possible subsets with *K*=*minNumSignatures* are evaluated, taking the subset
with the highest explained variance. Then, stepwise one additional signature at
a time (highest increase in explained variance) is added to the already
identified set until the threshold of *minExplainedVariance* is satisfied.

Performing, for example, a greedy search for the example above is much faster
(shown only for the first tumor):

```{r, fig.asp=1}
exposures <- decomposeTumorGenomes(genomes[1], signatures,
                                   minExplainedVariance=0.95,
                                   minNumSignatures=2, maxNumSignatures=NULL,
                                   greedySearch=TRUE, verbose=TRUE)

exposures

plotDecomposedContribution(exposures[[1]])
```

**Important note**: of course, a greedy search which starts from the best
combination of *minNumSignatures* need not yield the same result as a full
search because the latter finds the overall best subset while the greedy search
can get stuck in a local optimum depending on the starting point of the search.
The precise behavior depends on different factors, including for example the
similarity between mutational signatures and the minimum required explained
variance (lower thresholds can easily be satisfied by very different
combinations of signatures). We recommend to test different settings (minimum
numbers of signatures, thresholds for explained variance, etc) and learn about
the behavior to ensure a meaningful biological interpretation of the results.


### Computing the explained variance

Given the mutation frequencies of one or more tumor genomes (*genomes*),
a set of mutational signatures (*signatures*) and their computed
exposures/contributions to the given tumor (*exposures*), the following command
allows to compute---for each individual tumor---the variance of the mutation
frequency data that the exposures explain.

The following is an example taking the full set of tumors and signatures from
Section 4.2.1:
```{r, echo=FALSE}
# load the reference genome and the transcript annotation database
refGenome <- BSgenome.Hsapiens.UCSC.hg19::BSgenome.Hsapiens.UCSC.hg19
transcriptAnno <-
           TxDb.Hsapiens.UCSC.hg19.knownGene::TxDb.Hsapiens.UCSC.hg19.knownGene

# take the 15 Shiraishi signatures obtained from
# 435 tumor genomes from Alexandrov et al.
sfile <- system.file("extdata",
              "Alexandrov_PMID_23945592_435_tumors-pmsignature-15sig.Rdata", 
              package="decompTumor2Sig")
load(sfile)

gfile <- system.file("extdata",
              "Nik-Zainal_PMID_22608084-VCF-convertedfromMPF.vcf.gz", 
              package="decompTumor2Sig")

# read the cancer genomes in VCF format
genomes <- readGenomesFromVCF(gfile, numBases=5, type="Shiraishi",
                              trDir=TRUE, refGenome=refGenome,
                              transcriptAnno=transcriptAnno, verbose=FALSE)
```

```{r}
exposures <- decomposeTumorGenomes(genomes, signatures)
computeExplainedVariance(exposures, signatures, genomes)
```

**Note**: for computing the variance explained for a single tumor by a set of
signatures, the corresponding number of exposure values must be the same as the
number of signatures. Undefined exposure values (NA), which can be present if a
search for a subset of signatures has been performed as described above, will
be set to zero such that the corresponding signature does not contribute. For
genomes for which the *minExplainedVariance* could not be reached, and whose
exposure vectors are NULL, the explained variance will be set to NA.


## Re-composing/reconstructing tumor genomes from exposures and signatures

Estimating the explained variance of the decomposition of a tumor genome (see
Sections 4.2 and 4.3.2) and assessing its quality requires the mutation
frequencies $\hat{g}_i$ of the tumor genome to be reconstructed, or predicted,
from the mutational signatures $S_j$ and their exposures/contributions (or
weights) $w_j$:

$$ \hat{g}_i = \sum_j{w_j * (S_j)_i} $$

This can be easily achieved using the function
**composeGenomesFromExposures()**. The following is an example taking the
tumor genomes from Section 3.2, the signatures from Section 4.2.1, and the
exposures as computed in Section 4.3:
```{r}
genomes_predicted <- composeGenomesFromExposures(exposures, signatures)
genomes_predicted[1:2]
```

Once genomes have been reconstructed, the function
**evaluateDecompositionQuality()** allows to compare the reconstructed genome
mutation features to the originally observed features in order to assess the
quality of the decomposition. The function is applied to an individual tumor
genome, and can either return numerical quality measurements, or provide a
quality plot which includes said measurements.

Numerical measurements to compare the reconstructed/predicted and the original
tumor mutation patterns are:

* *explainedVariance*: The explained variance (see Section 4.2).
* *pearsonCorr*: The Pearson correlation coefficient (PCC) between the
predicted/reconstructed and the original mutation frequencies of the tumor
genome. Although the PCC does usually not consider the amplitudes of two input
data vectors---only their linear relationship---here, a high PCC also entails
small absolute differences in the mutation frequencies because the frequencies
in both the predicted and the original data sum up to 1 (i.e., they are
normalized at the same level), such that a high correlation automatically means
very similar values.

Example for obtaining numerical measurements:

```{r}
evaluateDecompositionQuality(exposures[[1]], signatures,
                             genomes[[1]], plot=FALSE)
```

Example for obtaining a quality plot which compares the reconstructed and the
original data:

```{r, fig.asp=1}
evaluateDecompositionQuality(exposures[[1]], signatures,
                             genomes[[1]], plot=TRUE)
```


## Mapping and comparing sets of signatures

In some cases it may be of interest to compare or find a mapping between two
sets of signatures, e.g., if they have been inferred from different datasets.
For this purpose, **decompTumor2Sig** provides a set of additional functions.

### Comparison of signatures of the same format

Let's first read two distinct sets of Shiraishi signatures of the same format
(5 bases, with transcript-strand direction):

```{r}
# get 4 Shiraishi signatures from 21 breast cancers from
# Nik-Zainal et al (PMID: 22608084)
sigfiles <- system.file("extdata",
                 paste0("Nik-Zainal_PMID_22608084-pmsignature-sig",1:4,".tsv"), 
                 package="decompTumor2Sig")
sign_s4 <- readShiraishiSignatures(files=sigfiles)


# get 15 Shiraishi signatures obtained from
# 435 tumor genomes from Alexandrov et al.
sfile <- system.file("extdata",
              "Alexandrov_PMID_23945592_435_tumors-pmsignature-15sig.Rdata", 
              package="decompTumor2Sig")
load(sfile)
sign_s15 <- signatures
```

Since these signatures have the same format, we can directly compare them.
Using the function **determineSignatureDistances()**, we can compute the
distances of one given signature to all target signatures from a set:

```{r}
determineSignatureDistances(fromSignature=sign_s4[[1]], toSignatures=sign_s15,
                            method="frobenius")
```

Apart from the Frobenius distance (*method*="frobenius"), which is suitable to
compare matrices and hence Shiraishi signatures, other distance metrics can be
used: the "rss" (residual sum of squares = squared error) or any distance
measure available for the function *dist* of the package `r Rpackage("stats")`.

If not the distances of one signature to an entire signature set is needed, but
instead a mapping from one signature set to another, **mapSignatureSets()** can
be used.

```{r}
mapSignatureSets(fromSignatures=sign_s4, toSignatures=sign_s15,
                 method="frobenius", unique=FALSE)
```

Like for **determineSignatureDistances()**, with the function
**mapSignatureSets()** a mapping can be built based on different distance
metrics. Additionally, the user can specify whether the mapping should be
unique (one-to-one mapping), or not.

If *unique*=FALSE then for each signature of *fromSignatures* the best match
(minimum distance) of *toSignatures* is selected. The selected signatures
need not be unique, i.e., one signature of *toSignatures* may be the best match
for multiple signatures of *fromSignatures*.

If *unique*=TRUE, i.e., if a unique (one-to-one) mapping is required, an
iterative procedure is performed: in each step, the best matching pair from
*fromSignatures* and *toSignatures* is mapped and then removed from the list of
signatures that remain to be mapped, such that they cannot be selected again.
In this case, of course, *fromSignatures* must not contain more signatures than
*toSignatures*.


### Comparison of signatures of different types or formats

Sometimes it may also be useful to compare different types or formats of
signatures. For example, since Alexandrov signatures are comparably well
studied, it might be interesting to determine which Alexandrov signature is
closest to a Shiraishi signature of interest.

Since only signatures of the same format can be directly compared or mapped
(see above), **decompTumor2Sig** provides two functions that transform
signatures, such that two signatures, or two sets of signatures, can be
converted to the same format.

One of these functions, **convertAlexandrov2Shiraishi()**, has already been
presented in Section 3.1.4 (see there for details). We can convert Alexandrov
signatures to Shiraishi-type signatures with 3 bases (without
transcription-strand direction):

```{r, message=FALSE, warning=FALSE}
sign_a <- readAlexandrovSignatures()
sign_a2s <- convertAlexandrov2Shiraishi(sign_a)
```

*Note*: Of course, there is some information loss here (better: a loss of
specificity), as we discuss in our paper (Krüger and Piro, 2019).

Additionally, the function **downgradeShiraishiSignatures()** can be used to
reduce the number of flanking bases and/or discard the information on
transcription-strand direction from one or more Shiraishi signatures:

```{r}
sign_sdown <- downgradeShiraishiSignatures(sign_s15, numBases=3,
                                           removeTrDir=TRUE)
sign_s15[1]
sign_sdown[1]
```

Having obtained two signature sets of the same format (sequence triplets, but
no transcription-strand direction), we can now map one set to the other:

```{r}
mapSignatureSets(fromSignatures=sign_sdown, toSignatures=sign_a2s,
                 method="frobenius", unique=TRUE)
```

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/downgradeShiraishiSignatures.R
\name{downgradeShiraishiSignatures}
\alias{downgradeShiraishiSignatures}
\title{Downgrade Shiraishi-type signatures.}
\usage{
downgradeShiraishiSignatures(signatures, numBases=NULL,
removeTrDir=FALSE)
}
\arguments{
\item{signatures}{(Mandatory) A list of Shiraishi signatures that need to be
downgraded/trimmed.}

\item{numBases}{(Conditionally optional) The total number of bases
(mutated base plus flanking bases around the mutated base) that should
be kept. All further flanking bases farther away from the mutated bases
are dropped. If specified, \code{numBases} must be odd and smaller than
the current number of bases of the \code{signatures}. If \code{NULL}, no
flanking bases will be dropped. At least one of \code{numBases} or
\code{removeTrDir} must be specified.}

\item{removeTrDir}{(Conditionally optional) Logical value that specifies
whether information on the transcript direction should be dropped (if
present at all). At least one of \code{numBases} or \code{removeTrDir}
must be specified.}
}
\value{
A list of Shiraishi signatures that have been accordingly downgraded.
}
\description{
`downgradeShiraishiSignatures()` downgrades/trims signatures of the
Shiraishi type by discarding flanking bases (reducing the length of the
sequence pattern) and/or the transcription direction. The downgrade doesn't
pose a problem because the flanking bases and the transcription direction
are considered as independent features according to the Shiraishi model of
mutational signatures.
}
\examples{

### Load 15 Shiraishi signatures obtained from 435 tumor genomes from
### Alexandrov et al. (number of bases: 5, transcription direction: yes)
sfile <- system.file("extdata",
         "Alexandrov_PMID_23945592_435_tumors-pmsignature-15sig.Rdata", 
         package="decompTumor2Sig")
load(sfile)

### downgrade the signatures to include only 3 bases and drop the
### transcription direction 
downgradeShiraishiSignatures(signatures, numBases=3, removeTrDir=TRUE)

}
\references{
\url{http://rmpiro.net/decompTumor2Sig/}\cr
Krueger, Piro (2019) decompTumor2Sig: Identification of mutational
signatures active in individual tumors. BMC Bioinformatics 
20(Suppl 4):152.\cr
}
\seealso{
\code{\link{decompTumor2Sig}}
}
\author{
Rosario M. Piro\cr Politecnico di Milano\cr Maintainer: Rosario
M. Piro\cr E-Mail: <rmpiro@gmail.com> or <rosariomichael.piro@polimi.it>
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/helper_functions_for_sequences.R
\name{adjustShiraishiSignature}
\alias{adjustShiraishiSignature}
\title{Adjust an Shiraishi signature (internal function)}
\usage{
adjustShiraishiSignature(signature, factorsMatrix)
}
\arguments{
\item{signature}{Single Shiraishi signature to be adjusted}

\item{factorsMatrix}{Factors for single nucleotides (Shiraishi-like matrix)}
}
\value{
Adjusted Shiraishi signature
}
\description{
Adjust an Shiraishi signature by a set of base-specific factors.
}
\references{
\url{http://rmpiro.net/decompTumor2Sig/}\cr
Krueger, Piro (2019) decompTumor2Sig: Identification of mutational
signature active in individual tumors. BMC Bioinformatics
20(Suppl 4):152.\cr
}
\author{
Rosario M. Piro\cr Politecnico di Milano\cr Maintainer: Rosario
M. Piro\cr E-Mail: <rmpiro@gmail.com> or <rosariomichael.piro@polimi.it>
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/plotShiraishiModel.R
\name{plotShiraishiModel}
\alias{plotShiraishiModel}
\title{plotShiraishiModel (internal function)}
\usage{
plotShiraishiModel(mutData, numBases, trDir, colors = NULL)
}
\arguments{
\item{mutData}{(Mandatory) The signature or genome mutation frequency data
to be plotted.}

\item{numBases}{The number of bases of the sequence pattern.}

\item{trDir}{Logical value specifying whether transcription strand
information is present.}

\item{colors}{Vector of four colors to be used for the base data.
If \code{NULL} (default), the colors are consensus colors used for
sequence logos.}
}
\value{
Returns (or draws) a plot according to the Shiraishi model of
mutational signatures.
}
\description{
`plotShiraishiModel()` plots a single signature or the mutation
frequency data for a single genome of the Shiraishi-type model.
}
\references{
\url{http://rmpiro.net/decompTumor2Sig/}\cr
Krueger, Piro (2019) decompTumor2Sig: Identification of mutational
signatures active in individual tumors. BMC Bioinformatics
20(Suppl 4):152.\cr
}
\author{
Rosario M. Piro\cr Politecnico di Milano\cr Maintainer: Rosario
M. Piro\cr E-Mail: <rmpiro@gmail.com> or <rosariomichael.piro@polimi.it>
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/mapSignatureSets.R
\name{mapSignatureSets}
\alias{mapSignatureSets}
\title{Map one signature set to another.}
\usage{
mapSignatureSets(fromSignatures, toSignatures, method="euclidean",
unique=FALSE)
}
\arguments{
\item{fromSignatures}{(Mandatory) A set (list) of signatures of the
Alexandrov (vector) or Shiraishi type (data frame or matrix), that has
to be mapped to the signatures of a second set (\code{toSignatures}).}

\item{toSignatures}{(Mandatory) The set (list) of signatures to which the
set of \code{fromSignatures} has to be mapped.}

\item{method}{(Optional) The distance measure to be used. This can be one
of the following: \code{"frobenius"} for Frobenius distance between matrices
(only for Shiraishi signatures); \code{"rss"} for the residual sum of squares
(squared error); or any distance measure available for the function
\code{dist()} of the \code{stats} package. Default: \code{"euclidean"}.}

\item{unique}{(Optional) If set to \code{FALSE} (default), then for each
signature of \code{fromSignatures} the best match (minimum distance) from
\code{toSignatures} is selected. The selected signatures need not be unique,
i.e., one signature of \code{toSignatures} may be the best match for
multiple signatures of \code{fromSignatures}. If set to \code{TRUE}, i.e.,
if a unique (one-to-one) mapping is required, an iterative approach is
performed: in each step, the best matching pair from \code{fromSignatures}
and \code{toSignatures} is mapped and then removed from the list of
signatures that remain to be mapped, such that they cannot be selected
again.}
}
\value{
A vector having as elements the mapped signatures of
\code{toSignatures}, and as names the signatures of \code{fromSignatures}
with which they have been associated.
}
\description{
`mapSignatureSets()` determines a mapping from one set of signatures to
another. Both Alexandrov and Shiraishi signatures can be handled, but both
sets must be of the same type. The mapping can either be a unique
(one-to-one) mapping or identify best matches while allowing multiple
signatures to be mapped to the same target signature if it is the best
match for more than one signature.
Different distance measures can be used (see details below).
}
\details{
Distances that can be used are:

\tabular{ll}{
\code{"frobenius"} \tab Forbenius distance between real-valued matrices\cr
                   \tab (or Shiraishi signatures) \code{A} and \code{B}:\cr
                   \tab \code{F = sqrt(trace( (A-B) \%*\% t(A-B) ))} \cr
\code{"rss"}       \tab Residual sum of squares (i.e., squared error):\cr
                   \tab \code{rss = sum((A-B)^2)} \cr
\code{"euclidean"} \tab (see \code{?dist} for details)\cr
\code{"maximum"}   \tab (see \code{?dist} for details)\cr
\code{"manhattan"} \tab (see \code{?dist} for details)\cr
\code{"canberra"}  \tab (see \code{?dist} for details)\cr
\code{"binary"}    \tab (see \code{?dist} for details)\cr
\code{"minkowski"} \tab (see \code{?dist} for details)\cr
}
}
\examples{

### get Alexandrov signatures from COSMIC
signAlexandrov <- readAlexandrovSignatures()

### convert them to Shiraishi signatures
signAlex2Shi <- convertAlexandrov2Shiraishi(signAlexandrov)

### define a small set of arbitrary signatures just for testing
### (similar to signatures 1, 5 and 13, respectively)
test1 <- matrix(c( 0.1,  0,    0.7,  0.1,  0.1,  0,
                   0.3,  0.2,  0.3,  0.2,  0,    0,
                   0.2,  0.1,  0.5,  0.2,  0,    0   ), nrow=3, byrow=TRUE)

test2 <- matrix(c( 0.1,  0.1,  0.3,  0.1,  0.3,  0.1,
                   0.3,  0.25, 0.2,  0.25, 0,    0,
                   0.3,  0.2,  0.2,  0.3,  0,    0   ), nrow=3, byrow=TRUE)

test3 <- matrix(c( 0.1,  0.7,  0.2,  0,    0,    0,
                   0,    0,    0,    1.0,  0,    0,
                   0.5,  0.1,  0,    0.4,  0,    0   ), nrow=3, byrow=TRUE)

fromSig <- list(sig1=test1, sig2=test2, sig3=test3)

### compute distances of the test signature to the converted
### Alexandrov signatures from COSMIC
mapSignatureSets(fromSig, signAlex2Shi, method="frobenius", unique=TRUE)

}
\references{
\url{http://rmpiro.net/decompTumor2Sig/}\cr
Krueger, Piro (2019) decompTumor2Sig: Identification of mutational
signatures active in individual tumors. BMC Bioinformatics
20(Suppl 4):152.\cr
}
\seealso{
\code{\link{decompTumor2Sig}}\cr
\code{\link{determineSignatureDistances}}
}
\author{
Rosario M. Piro\cr Politecnico di Milano\cr Maintainer: Rosario
M. Piro\cr E-Mail: <rmpiro@gmail.com> or <rosariomichael.piro@polimi.it>
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/readAlexandrovSignatures.R
\name{readAlexandrovSignatures}
\alias{readAlexandrovSignatures}
\title{Read Alexandrov-type signatures (COSMIC format).}
\usage{
readAlexandrovSignatures(file)
}
\arguments{
\item{file}{(Mandatory) Can be a file name or an URL for download.
Default:\cr
"https://cancer.sanger.ac.uk/cancergenome/assets/signatures_probabilities.txt"
(COSMIC signatures v2).}
}
\value{
A list of Alexandrov signatures that can be used for
\code{decomposeTumorGenomes}.
}
\description{
`readAlexandrovSignatures()` reads a set of Alexandrov-type signatures
(COSMIC format) from a flat file or URL. Signatures must be specified in the
tab-separated format used by the COSMIC website for signatures version 2
(March 2015), the comma-separated format used for signatures version 3
(May 2019), the Microsoft Excel 2007+ sheet used for version 3.1, or the
tab-sperated format used for version 3.2 (see Details below). Excel sheets
cannot be read from an URL and must be downloaded first.
}
\details{
For details on the accepted signature formats, see below or\cr
\url{http://cancer.sanger.ac.uk/cosmic/signatures_v2} ->
"Download signatures" for version 2,\cr
\url{https://www.synapse.org/#!Synapse:syn12009743} for version 3,\cr
\url{https://cancer.sanger.ac.uk/sigs-assets-20/COSMIC_Mutational_Signatures_v3.1.xlsx}
for version 3.1, \cr
and \url{https://cancer.sanger.ac.uk/signatures/} for version 3.2. 
For versions 3, 3.1 and 3.2, only Single Base Substitution (SBS)
signatures can be used.

COSMIC format for Alexandrov signatures, version 2:

\tabular{llllll}{
Subst. \tab Trinucleotide \tab Mutation Type \tab Signature 1 \tab
Signature 2 \tab...\cr
C>A \tab ACA \tab A[C>A]A \tab 0.0110983262 \tab 0.0006827082 \tab...\cr
C>A \tab ACC \tab A[C>A]C \tab 0.0091493407 \tab 0.0006191072 \tab...\cr
C>A \tab ACG \tab A[C>A]G \tab 0.0014900705 \tab 0.0000992790 \tab...\cr
C>A \tab ACT \tab A[C>A]T \tab 0.0062338852 \tab 0.0003238914 \tab...\cr
[...]\cr
T>G \tab TTG \tab T[T>G]G \tab 0.0020310769 \tab 0.0002066152 \tab...\cr
T>G \tab TTT \tab T[T>G]T \tab 0.0040301281 \tab 0.0000235982 \tab...\cr
}

COSMIC/Synapse format for Alexandrov signatures, version 3 and 3.1:

\tabular{llllll}{
Type,SubType,SBS1,SBS2,SBS3,SBS4,SBS5,SBS6, ...\cr
C>A,ACA,8.86E-04,5.80E-07,2.08E-02,4.22E-02,1.20E-02,4.25E-04, ...\cr
C>A,ACC,2.28E-03,1.48E-04,1.65E-02,3.33E-02,9.44E-03,5.24E-04, ...\cr
C>A,ACG,1.77E-04,5.23E-05,1.75E-03,1.56E-02,1.85E-03,5.20E-05, ...\cr
C>A,ACT,1.28E-03,9.78E-05,1.22E-02,2.95E-02,6.61E-03,1.80E-04, ...\cr
[...]\cr
T>G,TTG,5.83E-04,9.54E-05,8.05E-03,2.32E-03,6.94E-03,3.24E-04, ...\cr
T>G,TTT,2.23E-16,2.23E-16,1.05E-02,5.68E-04,1.35E-02,1.01E-03, ...\cr
}

Version 3.1 has assentially the same format as version 3, but is distributed
as an Excel spread sheet.

COSMIC/Synapse format for Alexandrov signatures, version 3.2:

\tabular{llll}{
Type \tab SBS1 \tab SBS2 \tab...\cr
A[C>A]A \tab 0.0110983262 \tab 0.0006827082 \tab...\cr
A[C>A]C \tab 0.0091493407 \tab 0.0006191072 \tab...\cr
A[C>A]G \tab 0.0014900705 \tab 0.0000992790 \tab...\cr
A[C>A]T \tab 0.0062338852 \tab 0.0003238914 \tab...\cr
[...]\cr
T[T>G]G \tab 0.0020310769 \tab 0.0002066152 \tab...\cr
T[T>G]T \tab 0.0040301281 \tab 0.0000235982 \tab...\cr
}
}
\examples{

### get Alexandrov signatures from COSMIC
signatures <- readAlexandrovSignatures()

}
\references{
\url{http://rmpiro.net/decompTumor2Sig/}\cr
Krueger, Piro (2019) decompTumor2Sig: Identification of mutational
signatures active in individual tumors. BMC Bioinformatics
20(Suppl 4):152.\cr
}
\seealso{
\code{\link{decompTumor2Sig}}\cr
\code{\link{readShiraishiSignatures}}
}
\author{
Rosario M. Piro\cr Politecnico di Milano\cr Maintainer: Rosario
M. Piro\cr E-Mail: <rmpiro@gmail.com> or <rosariomichael.piro@polimi.it>
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/determineSignatureDistances.R
\name{determineSignatureDistances}
\alias{determineSignatureDistances}
\title{Determine differences between a given signature and a set of
target signatures.}
\usage{
determineSignatureDistances(fromSignature, toSignatures,
                                   method="euclidean")
}
\arguments{
\item{fromSignature}{(Mandatory) A single signature of the Alexandrov
(vector) or Shiraishi type (data frame or matrix).}

\item{toSignatures}{(Mandatory) The list of target signatures for which to
compute the distances to \code{fromSignature}. These target signatures
must be of the same type and format as \code{fromSignature}.}

\item{method}{(Optional) The distance measure to be used. This can be one
of the following: \code{"frobenius"} for Frobenius distance between
matrices (only for Shiraishi signatures); \code{"rss"} for the residual
sum of squares (squared error); or any distance measure available for
the function \code{dist} of the \code{stats} package.
Default: \code{"euclidean"}.}
}
\value{
A signature-named vector containing all distances. This vector has
the same order as the target signature list, so it is not sorted according
to distance.
}
\description{
`determineSignatureDistances()` determines all distances (i.e., differences)
between a given signature (of type Alexandrov or Shiraishi) and a set
of target signatures (of the same type). This can help to compare signatures
that have been determined in different ways or from different datasets.
Different distance measures can be used (see details below).
}
\details{
Distances that can be used are:

\tabular{ll}{
\code{"frobenius"} \tab Forbenius distance between real-valued matrices\cr
                   \tab (or Shiraishi signatures) \code{A} and \code{B}:\cr
                   \tab \code{F = sqrt(trace( (A-B) \%*\% t(A-B) ))} \cr
\code{"rss"}       \tab Residual sum of squares (i.e., squared error):\cr
                   \tab \code{rss = sum((A-B)^2)} \cr
\code{"euclidean"} \tab (see \code{?dist} for details)\cr
\code{"maximum"}   \tab (see \code{?dist} for details)\cr
\code{"manhattan"} \tab (see \code{?dist} for details)\cr
\code{"canberra"}  \tab (see \code{?dist} for details)\cr
\code{"binary"}    \tab (see \code{?dist} for details)\cr
\code{"minkowski"} \tab (see \code{?dist} for details)\cr
}
}
\examples{

### get Alexandrov signatures from COSMIC
signAlexandrov <- readAlexandrovSignatures()

### convert them to Shiraishi signatures
signAlex2Shi <- convertAlexandrov2Shiraishi(signAlexandrov)

### define an arbitrary signature just for testing
### (similar to signature 1)
testSig <- matrix(c(0.1,   0, 0.7, 0.1, 0.1,   0,
                    0.3, 0.2, 0.3, 0.2,   0,   0,
                    0.2, 0.1, 0.5, 0.2,   0,   0), nrow=3, byrow=TRUE) 

### compute distances of the test signature to the converted
### Alexandrov signatures from COSMIC
determineSignatureDistances(testSig, signAlex2Shi, method="frobenius")

}
\references{
\url{http://rmpiro.net/decompTumor2Sig/}\cr
Krueger, Piro (2019) decompTumor2Sig: Identification of mutational
signatures active in individual tumors. BMC Bioinformatics 
20(Suppl 4):152.\cr
}
\seealso{
\code{\link{decompTumor2Sig}}\cr
\code{\link{mapSignatureSets}}
}
\author{
Rosario M. Piro\cr Politecnico di Milano\cr Maintainer: Rosario
M. Piro\cr E-Mail: <rmpiro@gmail.com> or <rosariomichael.piro@polimi.it>
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/readGenomesFromVCF.R
\name{readGenomesFromVCF}
\alias{readGenomesFromVCF}
\title{Read tumor genomes from a VCF file (Variant Call Format).}
\usage{
readGenomesFromVCF(file, numBases=5, type="Shiraishi", trDir=TRUE,
enforceUniqueTrDir=TRUE,
refGenome=BSgenome.Hsapiens.UCSC.hg19::BSgenome.Hsapiens.UCSC.hg19,
transcriptAnno=
TxDb.Hsapiens.UCSC.hg19.knownGene::TxDb.Hsapiens.UCSC.hg19.knownGene,
verbose=TRUE)
}
\arguments{
\item{file}{(Mandatory) The name of the VCF file (can be compressed with
\code{gzip}).}

\item{numBases}{(Mandatory) Total number of bases (mutated base and
flanking bases) to be used for sequence patterns. Must be odd. Default: 5}

\item{type}{(Mandatory) Signature model or type (\code{"Alexandrov"} or
\code{"Shiraishi"}). Default: \code{"Shiraishi"}}

\item{trDir}{(Mandatory) Specifies whether the transcription direction is
taken into account in the signature model. If so, only mutations within
genomic regions with a defined transcription direction can be considered.
Default: \code{TRUE}}

\item{enforceUniqueTrDir}{(Optional) Used only if \code{trDir} is
\code{TRUE}. If \code{enforceUniqueTrDir} is TRUE (default), then mutations
which map to a region with multiple overlapping genes with opposing
transcription directions will be excluded from the analysis. If \code{FALSE},
the transcript direction encountered first in the transcript database (see
\code{transcriptAnno}) is assigned to the mutation. The latter was the
behavior until version 1.3.5 of \code{decompTumor2Sig} and is also the
behavior of \code{pmsignature}. However, it is preferable to exclude
these mutations from the count (default) because from mutation data alone
it cannot be inferred which of the two genes has the higher transcriptional
activity which might potentially be linked to the occurrence of the mutation.
(If you are unsure, use the default setting; this option exists mostly for
backward compatibility with older versions.)}

\item{refGenome}{(Mandatory) The reference genome (\code{BSgenome}) needed
to extract sequence patterns. Default: \code{BSgenome} object for hg19.}

\item{transcriptAnno}{(Optional) Transcript annotation (\code{TxDb} object)
used to determine the transcription direction. This is required only if
\code{trDir} is \code{TRUE}. Default: \code{TxDb} object for hg19.}

\item{verbose}{(Optional) Print information about reading and processing the
mutation data. Default: \code{TRUE}}
}
\value{
A list containing the genomes in terms of frequencies of the mutated
sequence patterns. This list of genomes can be used for
\code{decomposeTumorGenomes}.
}
\description{
`readGenomesFromVCF()` reads somatic mutations of a single tumor genome
(sample) or a set of genomes from a VCF file (Variant Call Format) and
determines the mutation frequencies according to a specific model of
mutational signatures (Alexandrov or Shiraishi).
}
\examples{

### load reference genome and transcript annotation (if direction is needed)
refGenome <- BSgenome.Hsapiens.UCSC.hg19::BSgenome.Hsapiens.UCSC.hg19
transcriptAnno <-
  TxDb.Hsapiens.UCSC.hg19.knownGene::TxDb.Hsapiens.UCSC.hg19.knownGene

### read breast cancer genomes from Nik-Zainal et al (PMID: 22608084) 
gfile <- system.file("extdata",
         "Nik-Zainal_PMID_22608084-VCF-convertedfromMPF.vcf.gz", 
         package="decompTumor2Sig")
genomes <- readGenomesFromVCF(gfile, numBases=5, type="Shiraishi",
         trDir=TRUE, enforceUniqueTrDir=TRUE, refGenome=refGenome,
         transcriptAnno=transcriptAnno, verbose=FALSE)

}
\references{
\url{http://rmpiro.net/decompTumor2Sig/}\cr
Krueger, Piro (2019) decompTumor2Sig: Identification of mutational
signatures active in individual tumors. BMC Bioinformatics
20(Suppl 4):152.\cr
}
\seealso{
\code{\link{decompTumor2Sig}}\cr
\code{\link{decomposeTumorGenomes}}\cr
\code{\link{readGenomesFromMPF}}\cr
\code{\link{getGenomesFromMutFeatData}}
}
\author{
Rosario M. Piro\cr Politecnico di Milano\cr Maintainer: Rosario
M. Piro\cr E-Mail: <rmpiro@gmail.com> or <rosariomichael.piro@polimi.it>
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/plotExplainedVariance.R
\name{plotExplainedVariance}
\alias{plotExplainedVariance}
\title{Plot the explained variance as a function of the number of signatures}
\usage{
plotExplainedVariance(genome, signatures, minExplainedVariance=NULL,
minNumSignatures=2, maxNumSignatures=NULL, greedySearch=FALSE)
}
\arguments{
\item{genome}{(Mandatory) The mutation load of a single genome in
Alexandrov- of Shiraishi-format, i.e. as vector or matrix. The format
must be the same as the one used for the \code{signatures} (see below).}

\item{signatures}{(Mandatory) The list of signatures (vectors,
data frames or matrices) which are to be evaluated. Each of the list
objects represents one mutational signature. Vectors are used for
Alexandrov signatures, data frames or matrices for Shiraishi signatures.}

\item{minExplainedVariance}{(Optional) If a numeric value between 0 and 1
is specified, the plot highlights the smallest subset of signatures which
is sufficient to explain at least the specified fraction of the variance
of the genome's mutation patterns. If, for example,
\code{minExplainedVariance} is 0.99 the smallest subset of signatures
that explains at least 99\% of the variance will be highlighted.}

\item{minNumSignatures}{(Optional) The plot will be generated only for
K>=\code{minNumSignatures}.}

\item{maxNumSignatures}{(Optional) The plot will be generated only for
K<=\code{maxNumSignatures}.}

\item{greedySearch}{(Optional) If \code{greedySearch} is set to \code{TRUE}
then not all possible combinations of \code{minNumSignatures} to
\code{maxNumSignatures} signatures will be checked. Instead, first all
possible combinations for exactly \code{minNumSignatures} will be checked
to select the best starting set, then iteratively the next best signature
will be added (maximum increase in explained variability) until
\code{maxNumSignatures} is reached). NOTE: while this is only an
approximation, it is highly recommended for large sets of signatures (>15)!}
}
\value{
Returns (or draws) a plot of the explained variance as a function
of the number of signatures.
}
\description{
`plotExplainedVariance()` plots the explained variance of a single tumor
genome's mutation patterns as a function of the number of signatures
(increasing subsets of signatures) used for decomposition. For each
number K of signatures, the highest variance explained by possible
subsets of K signatures will be plotted (full or greedy search, see below).
This can help to evaluate what minimum threshold for the explained variance
can be used to decompose tumor genomes with the function
\code{decomposeTumorGenomes}.
}
\examples{

### get 15 pre-processed Shiraishi signatures computed (object 'signatures') 
### from 435 tumor genomes Alexandrov et al (PMID: 23945592)
### using the pmsignature package
sfile <- system.file("extdata",
         "Alexandrov_PMID_23945592_435_tumors-pmsignature-15sig.Rdata", 
         package="decompTumor2Sig")
load(sfile)

### load preprocessed breast cancer genomes (object 'genomes') from
### Nik-Zainal et al (PMID: 22608084) 
gfile <- system.file("extdata",
         "Nik-Zainal_PMID_22608084-genomes-Shiraishi_5bases_trDir.Rdata", 
         package="decompTumor2Sig")
load(gfile)

### plot the explained variance for 2 to 6 signatures of the first genome
plotExplainedVariance(genomes[[1]], signatures,
         minExplainedVariance=0.98, minNumSignatures=2, maxNumSignatures=6)

}
\references{
\url{http://rmpiro.net/decompTumor2Sig/}\cr
Krueger, Piro (2019) decompTumor2Sig: Identification of mutational
signatures active in individual tumors. BMC Bioinformatics
20(Suppl 4):152.\cr
}
\seealso{
\code{\link{decompTumor2Sig}}\cr
\code{\link{decomposeTumorGenomes}}\cr
\code{\link{computeExplainedVariance}}
}
\author{
Rosario M. Piro\cr Politecnico di Milano\cr Maintainer: Rosario
M. Piro\cr E-Mail: <rmpiro@gmail.com> or <rosariomichael.piro@polimi.it>
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/helper_functions_for_class_checks.R
\name{isAlexandrovSet}
\alias{isAlexandrovSet}
\title{isAlexandrovSet}
\usage{
isAlexandrovSet(x)
}
\arguments{
\item{x}{Object to be checked.}
}
\value{
Logical value (true or false).
}
\description{
`isAlexandrovSet()` checks whether the input object is a set (list) of
numeric objects compatible with the Alexandrov format (probability vectors;
sum up to 1). NOTE: These can also be genomes compatible with the
Alexandrov format!
}
\examples{

### get Alexandrov signatures from COSMIC
signAlexandrov <- readAlexandrovSignatures()

isAlexandrovSet(signAlexandrov)
}
\references{
\url{http://rmpiro.net/decompTumor2Sig/}\cr
Krueger, Piro (2019) decompTumor2Sig: Identification of mutational
signatures active in individual tumors. BMC Bioinformatics
20(Suppl 4):152.\cr
}
\seealso{
\code{\link{decompTumor2Sig}}\cr
\code{\link{readAlexandrovSignatures}}\cr
\code{\link{isSignatureSet}}
}
\author{
Rosario M. Piro\cr Politecnico di Milano\cr Maintainer: Rosario
M. Piro\cr E-Mail: <rmpiro@gmail.com> or <rosariomichael.piro@polimi.it>
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/decomposeTumorGenomes.R
\name{decomposeTumorGenomes}
\alias{decomposeTumorGenomes}
\title{Decompose tumor genomes into mutational signatures}
\usage{
decomposeTumorGenomes(genomes, signatures, minExplainedVariance=NULL,
minNumSignatures=2, maxNumSignatures=NULL, greedySearch=FALSE,
constrainToMaxContribution=FALSE, tolerance=0.1, verbose=FALSE)
}
\arguments{
\item{genomes}{(Mandatory) Can be either a vector, a data frame or a
matrix (for an individual tumor genome), or a list of one of these
object types (for multiple tumors). Each tumor genome must be of the
same form as the \code{signatures}.}

\item{signatures}{(Mandatory) A list of vectors, data frames or matrices.
Each of the objects represents one mutational signature. Vectors are
used for Alexandrov signatures, data frames or matrices for Shiraishi
signatures.}

\item{minExplainedVariance}{(Optional) If \code{NULL} (default), exactly
\code{maxNumSignatures} (see below; default: all) will be taken for
decomposing each genome. If a numeric value between 0 and 1 is specified
for \code{minExplainedVariance}, for each genome the function will select
the smallest number of signatures which is sufficient to explain at least
the specified fraction of the variance of the genome's mutation patterns.
E.g., if \code{minExplainedVariance}=0.99 the smallest subset of
signatures that explains at least 99\% of the variance is taken.
Please note: depending on the number of signatures, this may take quite
a while because by default for each number K of signatures, all possible
subsets composed of K signatures will be tested to identify the subset that
explains the highest part of the variance. If not enough variance is
explained, K will be incremented by one. Notes: 1) to speed up the search,
the parameters \code{minNumSignatures}, \code{maxNumSignatures} and
\code{greedySearch} can be used; 2) for genomes for which
none of the possible subsets of signatures explains enough variance, the
returned exposure vector will be set to \code{NULL}.}

\item{minNumSignatures}{(Optional) Used if \code{minExplainedVariance} is
specified (see above). To find the smallest subset of signatures which
explain the variance, at least this number of signatures will be taken. This
can be used to reduce the search space in a time-consuming search over a
large number of signatures.}

\item{maxNumSignatures}{(Optional) If \code{minExplainedVariance} is
specified to find the smallest subset of signatures which
explain the variance, at most \code{maxNumSignatures} will be taken. This 
can be used to reduce the search space in a time-consuming search over a
large number of signatures. If \code{minExplainedVariance} is \code{NULL},
then exactly \code{maxNumSignatures} signatures will be used. The default
for \code{maxNumSignatures} is \code{NULL} (all signatures).}

\item{greedySearch}{(Optional) Used only in case \code{minExplainedVariance}
has been specified. If \code{greedySearch} is \code{TRUE} then not all
possible combinations of \code{minNumSignatures} to \code{maxNumSignatures}
signatures will be checked. Instead, first all possible combinations for
exactly \code{minNumSignatures} will be checked to select the best starting
set, then iteratively the next best signature will be added (maximum
increase in explained variability) until \code{minExplainedVariance} of the
variance can be explained (or \code{maxNumSignatures} is exceeded).
NOTE: this approximate search is highly recommended for large sets of
signatures (>15)!}

\item{constrainToMaxContribution}{(Optional) [Note: this is EXPERIMENTAL
and is usually not needed!] If \code{TRUE}, the maximum contribution that
can be attributed to a signature will be constraint by the variant feature
counts (e.g., specific flanking bases) observed in the individual tumor
genome. If, for example, 30\% of all observed variants have a specific
feature and 60\% of the variants produced by a mutational process/signature
will manifest the feature, then the signature can have contributed up to
0.3/0.6 (=0.5 or 50\%) of the observed variants. The lowest possible
contribution over all signature features will be taken as the allowed
maximum contribution of the signature. This allowed maximum will
additionally be increased by the value specified as \code{tolerance}
(see below). For the illustrated example and \code{tolerance}=0.1 a
contribution of up to 0.5+0.1 = 0.6 (or 60\%) of the signature would be
allowed.}

\item{tolerance}{(Optional) If \code{constrainToMaxContribution} is
\code{TRUE}, the maximum contribution computed for a signature is increased
by this value (see above). If the parameter \code{constrainToMaxContribution}
is \code{FALSE}, the tolerance value is ignored. Default: 0.1.}

\item{verbose}{(Optional) If \code{TRUE} some information about the
processed genome and used number of signatures will be printed.}
}
\value{
A list of signature weight vectors (also called 'exposures'), one
for each tumor genome. E.g., the first vector element of the first list
object is the weight/contribution of the first signature to the first
tumor genome. IMPORTANT: If \code{minExplainedVariance} is specified, then
the exposures of a genome will NOT be returned if the minimum explained
variance is not reached within the requested minimum and maximum numbers
of signatures (\code{minNumSignatures} and \code{maxNumSignatures})! The
corresponding exposure vector will be set to \code{NULL}.
}
\description{
`decomposeTumorGenomes()` is the core function of this package. It
decomposes tumor genomes into a given set of mutational signatures by
computing their contributions (exposures) to the mutational load via
quadratic programming. The function takes a set of mutational signatures
and the mutation features of one or more tumor genomes and computes
weights, i.e., contributions for each of the signatures in each
individual genome. Alternatively, the function can determine for each
genome only a subset of signatures whose contributions are sufficient
to exceed a user-given minimum threshold for the explained variance
of the genome's mutation patterns.
}
\examples{

### get Alexandrov signatures from COSMIC
signatures <- readAlexandrovSignatures()

### load reference genome
refGenome <- BSgenome.Hsapiens.UCSC.hg19::BSgenome.Hsapiens.UCSC.hg19

### read breast cancer genomes from Nik-Zainal et al (PMID: 22608084) 
gfile <- system.file("extdata",
         "Nik-Zainal_PMID_22608084-VCF-convertedfromMPF.vcf.gz", 
         package="decompTumor2Sig")
genomes <- readGenomesFromVCF(gfile, numBases=3, type="Alexandrov",
         trDir=FALSE, refGenome=refGenome, verbose=FALSE)

### compute exposures
exposures <- decomposeTumorGenomes(genomes, signatures, verbose=FALSE)

### (for further examples on searching subsets, please see the vignette)

}
\references{
\url{http://rmpiro.net/decompTumor2Sig/}\cr
Krueger, Piro (2019) decompTumor2Sig: Identification of mutational
signatures active in individual tumors. BMC Bioinformatics 
20(Suppl 4):152.\cr
}
\seealso{
\code{\link{decompTumor2Sig}}
}
\author{
Rosario M. Piro, Politecnico di Milano\cr
Sandra Krueger, Freie Universitaet Berlin\cr Maintainer: Rosario
M. Piro\cr E-Mail: <rmpiro@gmail.com> or <rosariomichael.piro@polimi.it>
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/plotMutationDistribution.R
\name{plotMutationDistribution}
\alias{plotMutationDistribution}
\title{Plot mutation frequency data of a mutational signature or tumor genome.}
\usage{
plotMutationDistribution(mutData, colors = NULL, strip = NULL)
}
\arguments{
\item{mutData}{(Mandatory) The signature or genome mutation frequency data
to be plotted. This can either be a matrix (Shiraishi model) or a
numeric vector (Alexandrov model).}

\item{colors}{Vector of colors to be used for the base change data. For
Alexandrov-type data, this vector must contain six elements (one per base
change). For Shiraishi-type data, this vector must contain four elements
(one per base). If \code{NULL} (default), for Alexandrov-type data, the
colors are set to those used by the COSMIC website; for Shiraishi-type
data, the consensus base colors for sequence logos will be used.}

\item{strip}{Background color for strip labels; used only for
Alexandrov-type data. If \code{NULL} (default), "papayawhip" will be used.}
}
\value{
Returns (or draws) a plot according to the Alexandrov or Shiraishi
model of mutational signatures.
}
\description{
`plotMutationDistribution()` plots a single signature or the mutation
frequency data for a single genome. This works for signatures or genome
data of both the Shiraishi and the Alexandrov type.
}
\examples{

### Attention: using plotMutationDistribution requires the package
### pmsignature to be installed!


### get Alexandrov signatures from COSMIC
signatures <- readAlexandrovSignatures()

### plot the first Alexandrov signature
plotMutationDistribution(signatures[[1]])

### read four Shiraishi signatures for breast cancer genomes from 
### Nik-Zainal et al (PMID: 22608084) from flat files
sigfiles <- system.file("extdata",
         paste0("Nik-Zainal_PMID_22608084-pmsignature-sig",1:4,".tsv"),
         package="decompTumor2Sig")
signatures <- readShiraishiSignatures(sigfiles)

### plot the first Shiraishi signature
plotMutationDistribution(signatures[[1]])

}
\references{
\url{http://rmpiro.net/decompTumor2Sig/}\cr
Krueger, Piro (2019) decompTumor2Sig: Identification of mutational
signatures active in individual tumors. BMC Bioinformatics
20(Suppl 4):152.\cr
}
\seealso{
\code{\link{decompTumor2Sig}}
}
\author{
Rosario M. Piro\cr Politecnico di Milano\cr Maintainer: Rosario
M. Piro\cr E-Mail: <rmpiro@gmail.com> or <rosariomichael.piro@polimi.it>
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/helper_functions_for_class_checks.R
\name{isExposureSet}
\alias{isExposureSet}
\title{isExposureSet}
\usage{
isExposureSet(x)
}
\arguments{
\item{x}{Object to be checked.}
}
\value{
Logical value (true or false).
}
\description{
`isExposureSet()` checks whether the input object is a set (list) of
numeric objects compatible with exposure output obtained from
\code{decomposeTumorGenomes}.
}
\examples{

### get Alexandrov signatures from COSMIC
signatures <- readAlexandrovSignatures()

### load reference genome
refGenome <- BSgenome.Hsapiens.UCSC.hg19::BSgenome.Hsapiens.UCSC.hg19

### read breast cancer genomes from Nik-Zainal et al (PMID: 22608084) 
gfile <- system.file("extdata",
         "Nik-Zainal_PMID_22608084-VCF-convertedfromMPF.vcf.gz", 
         package="decompTumor2Sig")
genomes <- readGenomesFromVCF(gfile, numBases=3, type="Alexandrov",
         trDir=FALSE, refGenome=refGenome, verbose=FALSE)

### compute exposures
exposures <- decomposeTumorGenomes(genomes, signatures, verbose=FALSE)

isExposureSet(exposures)
}
\references{
\url{http://rmpiro.net/decompTumor2Sig/}\cr
Krueger, Piro (2019) decompTumor2Sig: Identification of mutational
signatures active in individual tumors. BMC Bioinformatics
20(Suppl 4):152.\cr
}
\seealso{
\code{\link{decompTumor2Sig}}\cr
\code{\link{decomposeTumorGenomes}}
}
\author{
Rosario M. Piro\cr Politecnico di Milano\cr Maintainer: Rosario
M. Piro\cr E-Mail: <rmpiro@gmail.com> or <rosariomichael.piro@polimi.it>
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/helper_functions_for_class_checks.R
\name{is.probability.object}
\alias{is.probability.object}
\title{is.probability.object (internal function)}
\usage{
is.probability.object(x)
}
\arguments{
\item{x}{Object to be checked.}
}
\value{
Logical value (true or false).
}
\description{
`is.probability.object()` checks whether the input object is a numeric
vector, matrix of data.frame of probabilities with a total sum of 1 for
every row. Matrices and data.frames must have 6 columns (for Shiraishi
format).
}
\references{
\url{http://rmpiro.net/decompTumor2Sig/}\cr
Krueger, Piro (2019) decompTumor2Sig: Identification of mutational
signatures active in individual tumors. BMC Bioinformatics
20(Suppl 4):152.\cr
}
\author{
Rosario M. Piro\cr Politecnico di Milano\cr Maintainer: Rosario
M. Piro\cr E-Mail: <rmpiro@gmail.com> or <rosariomichael.piro@polimi.it>
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/helper_functions_for_sequences.R
\name{compNucFreq}
\alias{compNucFreq}
\title{Compute nucleotide frequencies (internal function)}
\usage{
compNucFreq(refGenome, regions=NULL, numBases=1, mergeByRevComp=TRUE)
}
\arguments{
\item{refGenome}{Reference genome (\code{BSgenome})}

\item{regions}{(Optional) Regions (\code{GRanges}); default:
\code{NULL} (whole genome).}

\item{numBases}{(Optional) Sequence pattern length for which to compute
frequencies (e.g., '3' for trinucleotides). Default: 1 (single nucleotides).}

\item{mergeByRevComp}{(Optional) Reduce redundancy by merging counts
for reverse complement sequence patterns. This function allows this only
for sequence patterns with odd length (e.g., single nucleotides,
trinucleotides). Default: \code{TRUE}.}
}
\value{
Vector of computed nucleotide frequencies
}
\description{
Compute nucleotide frequencies for a reference genome and a region set.
}
\references{
\url{http://rmpiro.net/decompTumor2Sig/}\cr
Krueger, Piro (2019) decompTumor2Sig: Identification of mutational
signatures active in individual tumors. BMC Bioinformatics
20(Suppl 4):152.\cr
}
\author{
Rosario M. Piro\cr Politecnico di Milano\cr Maintainer: Rosario
M. Piro\cr E-Mail: <rmpiro@gmail.com> or <rosariomichael.piro@polimi.it>
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/mathematical_functions.R
\name{computeRSS}
\alias{computeRSS}
\title{computeRSS (internal function)}
\usage{
computeRSS(x, y)
}
\arguments{
\item{x}{The first numeric object (e.g., matrix).}

\item{y}{The second numeric object (of the same type as \code{x}).}
}
\value{
The RSS.
}
\description{
Compute the residual sum of squares (RSS), i.e., the sum of squared errors.
}
\references{
\url{http://rmpiro.net/decompTumor2Sig/}\cr
Krueger, Piro (2019) decompTumor2Sig: Identification of mutational
signatures active in individual tumors. BMC Bioinformatics
20(Suppl 4):152.\cr
}
\author{
Rosario M. Piro\cr Politecnico di Milano\cr Maintainer: Rosario
M. Piro\cr E-Mail: <rmpiro@gmail.com> or <rosariomichael.piro@polimi.it>
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/addBestSignatureToSubset.R
\name{addBestSignatureToSubset}
\alias{addBestSignatureToSubset}
\title{addBestSignatureToSubset (internal function)}
\usage{
addBestSignatureToSubset(genome, signatures, subset,
constrainToMaxContribution=FALSE, tolerance=0.1)
}
\arguments{
\item{genome}{Genome for which to improve the decomposition.}

\item{signatures}{The whole set of signatures (from which to choose
additional signatures.}

\item{subset}{The current subset that is used for decomposition.}

\item{constrainToMaxContribution}{(Optional) [Note: this is experimental
and is usually not needed!] If \code{TRUE}, the maximum contribution that
can be attributed to a signature will be constraint by the variant feature
counts (e.g., specific flanking bases) observed in the individual tumor
genome. If, for example, 30\% of all observed variants have a specific
feature and 60\% of the variants produced by a mutational process/signature
will manifest the feature, then the signature can have contributed up to
0.3/0.6 (=0.5 or 50\%) of the observed variants. The lowest possible
contribution over all signature features will be taken as the allowed
maximum contribution of the signature. This allowed maximum will
additionally be increased by the value specified as \code{tolerance}
(see below). For the illustrated example and \code{tolerance}=0.1 a
contribution of up to 0.5+0.1 = 0.6 (or 60\%) of the signature would be
allowed.}

\item{tolerance}{(Optional) If \code{constrainToMaxContribution} is
\code{TRUE}, the maximum contribution computed for a signature is increased
by this value (see above). If the parameter \code{constrainToMaxContribution}
is \code{FALSE}, the tolerance value is ignored. Default: 0.1.}
}
\value{
A list object containing: k=number of signatures; 
explVar=variance explained by these signatures; 
sigList=list of the signatures; 
decomposition=decomposition (exposures) obtained with these signatures.
}
\description{
Add the best signature to an existing subset (highest increase in expl. var.)
to improve the approximate decomposition of a genome.
}
\references{
\url{http://rmpiro.net/decompTumor2Sig/}\cr
Krueger, Piro (2019) decompTumor2Sig: Identification of mutational
signatures active in individual tumors. BMC Bioinformatics
20(Suppl 4):152\cr
}
\author{
Rosario M. Piro\cr Politecnico di Milano\cr Maintainer: Rosario
M. Piro\cr E-Mail: <rmpiro@gmail.com> or <rosariomichael.piro@polimi.it>
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/evaluateDecompositionQuality.R
\name{evaluateDecompositionQuality}
\alias{evaluateDecompositionQuality}
\title{Evaluate tumor decomposition quality.}
\usage{
evaluateDecompositionQuality(exposure, signatures, genome,
plot=FALSE)
}
\arguments{
\item{exposure}{(Mandatory) A single vector containing the estimated
signature contributions, or exposures, of a single tumor as provided by
\code{decomposeTumorGenomes}. The number of elements of the
exposure vector must correspond to the number of signatures (see below).}

\item{signatures}{(Mandatory) The list of signatures (vectors, data
frames or matrices) for which the exposures were obtained. Each of the
list objects represents one mutational signature. Vectors are used for
Alexandrov signatures, data frames or matrices for Shiraishi signatures.}

\item{genome}{(Mandatory) A single tumor genome in form of mutation
frequencies specified either in the Alexandrov or the Shiraishi format
(must match the format used for \code{signatures}, see above).}

\item{plot}{(Optional) If \code{FALSE} (default), the numerical results
(see below) will be returned. If \code{TRUE}, the reconstructed mutation
frequencies will be plotted against the original, observed mutation
frequencies and the numerical results will be integrated as text labels
in the plot.}
}
\value{
A named list object containing measurements for the Pearson
correlation coefficient between the reconstructed and observed mutation
frequencies, and the explained variance; or alternatively, a plot with
these measurements (see option \code{plot} above).
}
\description{
`evaluateDecompositionQuality()` evaluates the quality of the decomposition
into exposures of a single tumor. The function evaluates the quality of a
decomposition obtained from the function \code{decomposeTumorGenomes}
by comparing the re-composed (=re-constructed) tumor genome mutation
frequencies to those actually observed in the tumor genome. Tumor genome
mutation frequencies are reconstructed using
\code{composeGenomesFromExposures} and the results can optionally be plotted.
}
\examples{

### get Alexandrov signatures from COSMIC
signatures <- readAlexandrovSignatures()

### load preprocessed breast cancer genomes (object 'genomes') from
### Nik-Zainal et al (PMID: 22608084) 
gfile <- system.file("extdata",
         "Nik-Zainal_PMID_22608084-genomes-Alexandrov_3bases.Rdata", 
         package="decompTumor2Sig")
load(gfile)

### compute exposures
exposures <- decomposeTumorGenomes(genomes, signatures, verbose=FALSE)

### evaluate the decomposition by comparing to the original data
evaluateDecompositionQuality(exposures[[1]], signatures, genomes[[1]])

}
\references{
\url{http://rmpiro.net/decompTumor2Sig/}\cr
Krueger, Piro (2019) decompTumor2Sig: Identification of mutational
signatures active in individual tumors. BMC Bioinformatics
20(Suppl 4):152.\cr
}
\seealso{
\code{\link{decompTumor2Sig}}\cr
\code{\link{decomposeTumorGenomes}}\cr
\code{\link{composeGenomesFromExposures}}\cr
\code{\link{computeExplainedVariance}}
}
\author{
Rosario M. Piro\cr Politecnico di Milano\cr Maintainer: Rosario
M. Piro\cr E-Mail: <rmpiro@gmail.com> or <rosariomichael.piro@polimi.it>
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/mathematical_functions.R
\name{computeFrobeniusNorm}
\alias{computeFrobeniusNorm}
\title{computeFrobeniusNorm (internal function)}
\usage{
computeFrobeniusNorm(A)
}
\arguments{
\item{A}{The numeric matrix.}
}
\value{
The Frobenius norm.
}
\description{
Compute the Frobenius norm of a numeric matrix (if this matrix is the 
difference between two matrices, then this corresponds to the Frobenius 
distance between these two matrices).
}
\references{
\url{http://rmpiro.net/decompTumor2Sig/}\cr
Krueger, Piro (2019) decompTumor2Sig: Identification of mutational
signatures active in individual tumors. BMC Bioinformatics
20(Suppl 4):152.\cr
}
\author{
Rosario M. Piro\cr Politecnico di Milano\cr Maintainer: Rosario
M. Piro\cr E-Mail: <rmpiro@gmail.com> or <rosariomichael.piro@polimi.it>
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/setNames4ShiraishiTable.R
\name{setNames4ShiraishiTable}
\alias{setNames4ShiraishiTable}
\title{setNames4ShiraishiTable (internal function)}
\usage{
setNames4ShiraishiTable(table)
}
\arguments{
\item{table}{The table to be named.}
}
\value{
The same table with named columns and rows.
}
\description{
Set row and column names of a Shiraishi-model genome or signature table.
}
\references{
\url{http://rmpiro.net/decompTumor2Sig/}\cr
Krueger, Piro (2019) decompTumor2Sig: Identification of mutational
signatures active in individual tumors. BMC Bioinformatics
20(Suppl 4):152.\cr
}
\author{
Rosario M. Piro\cr Politecnico di Milano\cr Maintainer: Rosario
M. Piro\cr E-Mail: <rmpiro@gmail.com> or <rosariomichael.piro@polimi.it>
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/helper_functions_for_sequences.R
\name{convertSeqFreqToBaseFreq}
\alias{convertSeqFreqToBaseFreq}
\title{Convert sequence pattern frequencies to base frequencies (internal function)}
\usage{
convertSeqFreqToBaseFreq(frequencies, sigType)
}
\arguments{
\item{frequencies}{Vector for frequencies of individual sequence patterns}

\item{sigType}{Signature type information as returned by
\code{\link{determineTypeNumBasesAndTrDir}}}
}
\value{
Shiraishi signature-like matrix of per-base nucleotide frequencies
}
\description{
Convert sequence pattern frequencies (Alexandrov-like) to frequencies for
individual bases (Shiraishi-like).
}
\references{
\url{http://rmpiro.net/decompTumor2Sig/}\cr
Krueger, Piro (2019) decompTumor2Sig: Identification of mutational
signatures active in individual tumors. BMC Bioinformatics
20(Suppl 4):152.\cr
}
\author{
Rosario M. Piro\cr Politecnico di Milano\cr Maintainer: Rosario
M. Piro\cr E-Mail: <rmpiro@gmail.com> or <rosariomichael.piro@polimi.it>
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/computeExplainedVariance.R
\name{computeExplainedVariance}
\alias{computeExplainedVariance}
\title{Compute the explained variance.}
\usage{
computeExplainedVariance(exposures, signatures, genomes)
}
\arguments{
\item{exposures}{(Mandatory) A single vector or list of vectors containing
the estimated signature contributions/exposures as provided by the function
\code{decomposeTumorGenomes}. A list of vectors is used if the explained
variance shall be computed for multiple genomes. The number of exposure
vectors must correspond to the number of \code{genomes}. The number
of elements of each exposure vector must correspond to the number of
\code{signatures}.}

\item{signatures}{(Mandatory) The list of signatures (vectors, data frames
or matrices) for which the exposures were obtained. Each of the list
objects represents one mutational signature. Vectors are used for
Alexandrov signatures, data frames or matrices for Shiraishi signatures.}

\item{genomes}{(Mandatory) Can be either a vector, a data frame or a matrix
(for an individual tumor genome), or a list of one of these object types
(for multiple tumors). Each tumor genome must be of the same form as the
\code{signatures}.}
}
\value{
A numeric vector of explained variances, one for each genome.
}
\description{
`computeExplainedVariance()` computes for one or more tumors the variance
which is explained by the estimated contributions (exposures) of a set of
signatures when compared to the observed genomes.
}
\examples{

### get Alexandrov signatures from COSMIC
signatures <- readAlexandrovSignatures()

### load preprocessed breast cancer genomes (object 'genomes') from
### Nik-Zainal et al (PMID: 22608084) 
gfile <- system.file("extdata",
         "Nik-Zainal_PMID_22608084-genomes-Alexandrov_3bases.Rdata", 
         package="decompTumor2Sig")
load(gfile)

### compute exposures
exposures <- decomposeTumorGenomes(genomes, signatures, verbose=FALSE)

### compute explained variance for the tumor genomes
computeExplainedVariance(exposures, signatures, genomes)

}
\references{
\url{http://rmpiro.net/decompTumor2Sig/}\cr
Krueger, Piro (2019) decompTumor2Sig: Identification of mutational
signatures active in individual tumors. BMC Bioinformatics 
20(Suppl 4):152.\cr
}
\seealso{
\code{\link{decompTumor2Sig}}\cr
\code{\link{decomposeTumorGenomes}}\cr
\code{\link{plotExplainedVariance}}
}
\author{
Rosario M. Piro\cr Politecnico di Milano\cr Maintainer: Rosario
M. Piro\cr E-Mail: <rmpiro@gmail.com> or <rosariomichael.piro@polimi.it>
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/adjustSignaturesForRegionSet.R
\name{adjustSignaturesForRegionSet}
\alias{adjustSignaturesForRegionSet}
\title{Adjust (normalize) signatures for a set of genomic regions.}
\usage{
adjustSignaturesForRegionSet(signatures,
regionsTarget, regionsOriginal=NULL, 
refGenome=BSgenome.Hsapiens.UCSC.hg19::BSgenome.Hsapiens.UCSC.hg19)
}
\arguments{
\item{signatures}{(Mandatory) Signatures to be adjusted to the nucleotide
frequencies of the genomic regions defined by the parameter \code{regions}.}

\item{regionsTarget}{(Mandatory) \code{GRanges} object defining a subset
of the genome (i.e., a set of genomic regions) for which the signatures
need to be adjusted (can be set to \code{NULL} for the whole genome).}

\item{regionsOriginal}{(Optional) \code{GRanges} object defining the subset
of the genome (i.e., set of genomic regions) from which the signatures
where originally derived. Default: \code{NULL} (whole genome).}

\item{refGenome}{(Optional) Reference genome sequence from which to
compute the nucleotide frequencies. Default:\cr
\code{BSgenome.Hsapiens.UCSC.hg19::BSgenome.Hsapiens.UCSC.hg19}.}
}
\value{
A set of adjusted mutational signatures in the same format as those
specified for \code{signatures}.
}
\description{
`adjustSignaturesForRegionSet()` takes a set of signatures that have
been orginally defined with respect to the nucleotide frequencies within
a specific reference genome or region (e.g., by deriving them from whole
genome mutation data) and adjusts or normalizes them to the often different
nucleotide frequencies of another specific subset of genomic regions.
}
\details{
This may be useful, for example, to perform signature refitting (using
\code{\link{decomposeTumorGenomes}}) for mutation data from targetted
sequencing (e.g., only a subset of genes), whole exome sequencing (only
exonic regions), or other limited subsets of the genome with particular
nucleotide frequencies.

For Alexandrov-type signatures, the important frequencies are those of the
whole sequence patterns (e.g., trinucleotides) whose central base can be
mutated. Therefore, adjustment factors for individual mutation types
(e.g., A[C>T]G) are computed by comparing the corresponding sequence
pattern frequencies (e.g., ACG) between the original reference
regions (e.g., whole genome) and the target regions (e.g., target
regions of whole exome sequencing).

In the Shiraishi-type signature model, individual bases of the sequence
patterns are considered as independent features. Thus, to compute nucleotide
frequencies for such signatures, the frequencies of the sequence patterns
(computed as for Alexandrov-type signatures) are broken down to
single-nucleotide frequencies for the individual positions of the patterns.

In both cases, after the appropriate adjustment of individual features,
signatures are re-normalized such that overall probabilites sum up to 1.
}
\examples{

### get Alexandrov signatures from COSMIC
signatures <- readAlexandrovSignatures()

### get gene annotation for the default reference genome (hg19)
library(TxDb.Hsapiens.UCSC.hg19.knownGene)
txdb <- TxDb.Hsapiens.UCSC.hg19.knownGene::TxDb.Hsapiens.UCSC.hg19.knownGene

### get a GRanges object for gene promoters (-2000 to +200 bases from TSS)
### [taking only the first 1000 for testing purpose]
library(GenomicRanges)
regionsTarget <- promoters(txdb, upstream=2000, downstream=200)[seq(1000)]

### assume these signatures were derived only from mutation data from
### exons on chromosome X [not true; just for illustrative purpose]
filter <- list(tx_chrom = c("chrX"))
regionsOriginal <- exons(txdb, filter=filter)

### adjust signatures according to nucleotide frequencies in the target
### subset of the genome
sign_adj <- adjustSignaturesForRegionSet(signatures, regionsTarget,
                                                     regionsOriginal)

}
\references{
\url{http://rmpiro.net/decompTumor2Sig/}\cr
Krueger, Piro (2019) decompTumor2Sig: Identification of mutational
signatures active in individual tumors. BMC Bioinformatics
20(Suppl 4):152.\cr
}
\seealso{
\code{\link{decompTumor2Sig}}\cr
\code{\link{decomposeTumorGenomes}}
}
\author{
Rosario M. Piro\cr Politecnico di Milano\cr Maintainer: Rosario
M. Piro\cr E-Mail: <rmpiro@gmail.com> or <rosariomichael.piro@polimi.it>
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/convAlx2Shi.R
\name{convAlx2Shi}
\alias{convAlx2Shi}
\title{convAlx2Shi (internal function)}
\usage{
convAlx2Shi(x)
}
\arguments{
\item{x}{The Alexandrov signature (mutation pattern vector) to be converted.}
}
\value{
A Shiraishi signature (mutation pattern matrix).
}
\description{
Convert a single Alexandrov signature to a Shiraishi signature.
}
\references{
\url{http://rmpiro.net/decompTumor2Sig/}\cr
Krueger, Piro (2019) decompTumor2Sig: Identification of mutational
signatures active in individual tumors. BMC Bioinformatics 
20(Suppl 4):152.\cr
}
\author{
Rosario M. Piro\cr Politecnico di Milano\cr Maintainer: Rosario
M. Piro\cr E-Mail: <rmpiro@gmail.com> or <rosariomichael.piro@polimi.it>
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/mathematical_functions.R
\name{roundIntegerSum}
\alias{roundIntegerSum}
\title{roundIntegerSum (internal function)}
\usage{
roundIntegerSum(vec, targetSum)
}
\arguments{
\item{vec}{Vector of integers.}

\item{targetSum}{The target sum to be reached.}
}
\value{
The updated vector with the desired total sum.
}
\description{
update a numeric vector such that it's composed of integers and its sum
reaches a desired total. Positive or negative discrepancies are distributed
proportionally between the summands.
}
\references{
\url{http://rmpiro.net/decompTumor2Sig/}\cr
Krueger, Piro (2019) decompTumor2Sig: Identification of mutational
signatures active in individual tumors. BMC Bioinformatics
20(Suppl 4):152.\cr
}
\author{
Rosario M. Piro\cr Politecnico di Milano\cr Maintainer: Rosario
M. Piro\cr E-Mail: <rmpiro@gmail.com> or <rosariomichael.piro@polimi.it>
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/buildSortedAlexandrovSignaturePatternList.R
\name{buildSortedAlexandrovSignaturePatternList}
\alias{buildSortedAlexandrovSignaturePatternList}
\title{buildSortedAlexandrovSignaturePatternList (internal function)}
\usage{
buildSortedAlexandrovSignaturePatternList(numBases, trDir)
}
\arguments{
\item{numBases}{Number of bases for the sequence pattern (odd integer).}

\item{trDir}{Logical: use transcription-strand information?}
}
\value{
A sorted list of mutation features (e.g., triplets with base change).
}
\description{
Build and sort the pattern list of an Alexandrov signature in the following
way: First according to the base change: C>A, C>G, C>T, T>A, T>C, T>G,
then within these categories according to the flanking bases: A, C, G, T.
}
\references{
\url{http://rmpiro.net/decompTumor2Sig/}\cr
Krueger, Piro (2019) decompTumor2Sig: Identification of mutational
signatures active in individual tumors. BMC Bioinformatics 
20(Suppl 4):152.\cr
}
\author{
Rosario M. Piro\cr Politecnico di Milano\cr Maintainer: Rosario
M. Piro\cr E-Mail: <rmpiro@gmail.com> or <rosariomichael.piro@polimi.it>
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/buildGenomesFromMutationData.R
\name{buildGenomesFromMutationData}
\alias{buildGenomesFromMutationData}
\title{buildGenomesFromMutationData (internal function)}
\usage{
buildGenomesFromMutationData(snvs, numBases, type, trDir,
uniqueTrDir=TRUE, refGenome, transcriptAnno, verbose)
}
\arguments{
\item{snvs}{SNV matrix (see description above).}

\item{numBases}{Number of bases for the sequence pattern (odd integer).}

\item{type}{Type of signature to be used ("Alexandrov", "Shiraishi").}

\item{trDir}{Logical: use transcription-strand information?}

\item{uniqueTrDir}{Logical; used only if trDir is also \code{TRUE}: if
\code{uniqueTrDir} is \code{TRUE} (default), then only mutations with only
one defined transcription strand will be used, mutations for which both 
strands are valid are ignored. If \code{FALSE}, these mutations are accepted 
and one of the two transcription strands will be arbitrarily taken (the  
first one encountered in the databse specified for \code{transcriptAnno}). 
The latter was the behavior until version 1.3.5 of \code{decompTumor2Sig} 
and is also the behavior of \code{pmsignature}.}

\item{refGenome}{Reference genome (\code{BSgenome} object).}

\item{transcriptAnno}{Transcription information (\code{TxDb} object).}

\item{verbose}{Logical. Print additional information?}
}
\value{
A list of genomes: each genome is represented by the observed
frequencies of mutation patterns according to the selected signature type.
}
\description{
Build genome data structures (same as signatures) and fill then with
mutation data.
}
\details{
SNVs are specified as a matrix of the following format (adapted from VCF):\cr
#> snvs[1:2,]\cr
#     CHROM POS  REF ALT FORMAT           sample1                 sample2\cr
#[1,] "2"  "947" "C" "T" "GT:PL:GQ:AD:DP" "1/1:84,6,0:6:0,2:2"    NA\cr
#[2,] "2"  "992" "G" "A" "GT:PL:GQ:AD:DP" "0/1:123,0,33:33:1,3:4" "0/0:..."
}
\references{
\url{http://rmpiro.net/decompTumor2Sig/}\cr
Krueger, Piro (2019) decompTumor2Sig: Identification of mutational
signatures active in individual tumors. BMC Bioinformatics
20(Suppl 4):152.\cr
}
\author{
Rosario M. Piro\cr Politecnico di Milano\cr Maintainer: Rosario
M. Piro\cr E-Mail: <rmpiro@gmail.com> or <rosariomichael.piro@polimi.it>
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/composeGenomesFromExposures.R
\name{composeGenomesFromExposures}
\alias{composeGenomesFromExposures}
\title{Compose tumor genomes from exposures.}
\usage{
composeGenomesFromExposures(exposures, signatures)
}
\arguments{
\item{exposures}{(Mandatory) A single vector or list of vectors containing
the estimated signature contributions/exposures as computed by the function
\code{decomposeTumorGenomes}. A list of vectors is used if the
(re-)composition shall be performed for multiple genomes. The number of
elements of each exposure vector must correspond to the number of
\code{signatures}.}

\item{signatures}{(Mandatory) The list of signatures (vectors, data frames
or matrices) for which the exposures were obtained. Each of the list
objects represents one mutational signature. Vectors are used for
Alexandrov signatures, data frames or matrices for Shiraishi signatures.}
}
\value{
A list of "predicted" genomes, i.e., the frequencies of their
mutational patterns computed as weighted sums of the mutational signatures,
where the weights correspond to the contributions of, i.e., exposures to,
the corresponding signatures.
}
\description{
`composeGenomesFromExposures()` re-composes (or predicts) tumor genomes
(i.e., their mutation frequencies) from the given mutational signatures and
their corresponding exposures, or contributions. The (re-)composition is
performed by computing the weighted sum of the mutational signatures, where
the weights are the exposures (=contributions) of the corresponding
signatures. This can, for example, be used to verify that a decomposition
obtained from \code{decomposeTumorGenomes} is meaningful.
}
\examples{

### get Alexandrov signatures from COSMIC
signatures <- readAlexandrovSignatures()

### load preprocessed breast cancer genomes (object 'genomes') from
### Nik-Zainal et al (PMID: 22608084) 
gfile <- system.file("extdata",
         "Nik-Zainal_PMID_22608084-genomes-Alexandrov_3bases.Rdata", 
         package="decompTumor2Sig")
load(gfile)

### compute exposures
exposures <- decomposeTumorGenomes(genomes, signatures, verbose=FALSE)

### re-compose (predict) tumor genome features from exposures
predGenomes <- composeGenomesFromExposures(exposures, signatures)

}
\references{
\url{http://rmpiro.net/decompTumor2Sig/}\cr
Krueger, Piro (2019) decompTumor2Sig: Identification of mutational
signatures active in individual tumors. BMC Bioinformatics 
20(Suppl 4):152.\cr
}
\seealso{
\code{\link{decompTumor2Sig}}\cr
\code{\link{decomposeTumorGenomes}}
}
\author{
Rosario M. Piro\cr Politecnico di Milano\cr Maintainer: Rosario
M. Piro\cr E-Mail: <rmpiro@gmail.com> or <rosariomichael.piro@polimi.it>
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/external_classes_wrapper_functions.R
\name{isMutFeatDataObject}
\alias{isMutFeatDataObject}
\title{isMutFeatDataObject (internal function)}
\usage{
isMutFeatDataObject(x)
}
\arguments{
\item{x}{Object for which to verify compatibility.}
}
\value{
Logical value (true or false).
}
\description{
`isMutFeatDataObject()` checks whether an object is compatible to a
\code{pmsignature::MutationFeatureData} object (version 0.3.0), i.e.,
whether it contains the same info in the same format.
}
\references{
\url{http://rmpiro.net/decompTumor2Sig/}\cr
Krueger, Piro (2019) decompTumor2Sig: Identification of mutational
signatures active in individual tumors. BMC Bioinformatics
20(Suppl 4):152.\cr
}
\author{
Rosario M. Piro\cr Politecnico di Milano\cr Maintainer: Rosario
M. Piro\cr E-Mail: <rmpiro@gmail.com> or <rosariomichael.piro@polimi.it>
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/decompTumor2Sig-package.R
\docType{package}
\name{decompTumor2Sig-package}
\alias{decompTumor2Sig-package}
\alias{decompTumor2Sig}
\title{decompTumor2Sig - Decomposition of individual tumors into mutational
signatures by signature refitting}
\description{
The decompTumor2Sig package uses quadratic programming to decompose the
somatic mutation catalog from an individual tumor sample (or multiple
individual tumor samples) into a set of given mutational signatures (either
of the "Alexandrov model" by Alexandrov et al, Nature 500(7463):415-421,
2013, or the "Shiraishi model" by Shiraishi et al, PLoS Genet
11(12):e1005657, 2015), thus computing weights (or "exposures") that reflect
the contributions of the signatures to the mutation load of the tumor.
}
\details{
\tabular{ll}{
Package: \tab decompTumor2Sig\cr
Type: \tab Package\cr
Version: \tab 2.13.1\cr
Date: \tab 2022-05-09\cr
License: \tab GPL (>=2)\cr
}

The package provides the following functions:

\tabular{ll}{

adjustSignaturesForRegionSet():\tab adjust (normalize) mutational\cr
                        \tab signatures for use with mutation data from a\cr
                        \tab specific, limited subset of genomic regions\cr
                        \tab (e.g., for targetted sequencing).\cr 

composeGenomesFromExposures():\tab (re-)construct tumor genome mutation\cr
                        \tab frequencies from the signatures and\cr
                        \tab their corresponding exposures, or\cr
                        \tab contributions.\cr

computeExplainedVariance():\tab determine the variance explained by \cr
                        \tab estimated signature contributions\cr
                        \tab (i.e., exposures to signatures).\cr

convertAlexandrov2Shiraishi():\tab convert a set of Alexandrov \cr
                        \tab signatures to Shiraishi signatures.\cr

convertGenomesFromVRanges():\tab convert a genome or set of genomes\cr
                        \tab from a \code{VariantAnnotation::VRanges}\cr
                        \tab object.\cr

decomposeTumorGenomes():\tab determine the weights/contributions of\cr
                        \tab a set of signatures to each of a set of\cr
                        \tab individual tumor genomes.\cr

determineSignatureDistances():\tab for a given signature \cr
                        \tab compute its distances to each of a set\cr
                        \tab of target signatures.\cr

downgradeShiraishiSignatures():\tab downgrade Shiraishi signatures\cr
                        \tab by removing flanking bases and/or the\cr
                        \tab transcription direction.\cr

evaluateDecompositionQuality():\tab evaluate the quality of a\cr
                        \tab decomposition by comparing the\cr
                        \tab re-composed (=re-constructed) tumor\cr
                        \tab mutation frequencies to those actually\cr
                        \tab observed in the tumor genome.\cr

getGenomesFromMutFeatData():\tab extract the genomes from a \cr
                        \tab \code{MutationFeatureData} object as \cr
                        \tab provided by, for example,\cr
                        \tab \code{pmsignature::readMPFile}.\cr

getSignaturesFromEstParam():\tab extract a set of signatures from an \cr
                        \tab \code{EstimatedParameters} object as\cr
                        \tab returned by function \code{getPMSignature}\cr
                        \tab of the \code{pmsignature} package.\cr

isAlexandrovSet():      \tab checks whether the input list is\cr
                        \tab compatible with the Alexandrov format\cr
                        \tab (probability vectors).\cr

isExposureSet():        \tab checks whether the input list is\cr
                        \tab compatible with exposure output obtained\cr
                        \tab from \code{decomposeTumorGenomes}.\cr

isShiraishiSet():       \tab checks whether the input list is\cr
                        \tab compatible with the Shiraishi format\cr
                        \tab (matrices or data.frames of\cr
                        \tab probabilities).\cr

isSignatureSet():       \tab checks whether the input list is\cr
                        \tab compatible with either the Alexandrov\cr
                        \tab or Shiraishi format.\cr

mapSignatureSets():     \tab find a mapping from one signature\cr
                        \tab set to another.\cr

plotDecomposedContribution():\tab plot the decomposition of a\cr
                        \tab genome into mutational signatures\cr
                        \tab (i.e., the contributions of, or\cr
                        \tab exposures to, the signatures).\cr

plotExplainedVariance():\tab plot the variance of a genome's\cr
                        \tab mutation patterns which can be\cr
                        \tab explained with an increasing number\cr
                        \tab of signatures.\cr

plotMutationDistribution():\tab plot a single signature or the\cr
                        \tab mutation frequency data for a single\cr
                        \tab genome.\cr

readAlexandrovSignatures():\tab read Alexandrov signatures in the\cr
                        \tab COSMIC format from a flat file or URL.\cr

readGenomesFromMPF():   \tab read a genome or set of genomes from a \cr
                        \tab Mutation Position Format (MPF) file.\cr

readGenomesFromVCF():   \tab read a genome or set of genomes from a\cr
                        \tab Variant Call Format (VCF) file.\cr

readShiraishiSignatures():\tab read Shiraishi signatures from\cr
                        \tab flat files.\cr

sameSignatureFormat():  \tab checks whether two input lists are sets\cr
                        \tab of signatures of the same format.\cr

}
}
\references{
\url{http://rmpiro.net/decompTumor2Sig/}\cr
Krueger, Piro (2019) decompTumor2Sig: Identification of mutational
signatures active in individual tumors. BMC Bioinformatics 
20(Suppl 4):152.\cr
}
\author{
Rosario M. Piro, Politecnico di Milano [aut, cre]\cr
Sandra Krueger, Freie Universitaet Berlin [ctb]\cr
Maintainer: Rosario M. Piro\cr
E-Mail: <rmpiro@gmail.com> or <rosariomichael.piro@polimi.it>
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/getSignaturesFromEstParam.R
\name{getSignaturesFromEstParam}
\alias{getSignaturesFromEstParam}
\title{Get signatures from an \code{EstimatedParameters} object.}
\usage{
getSignaturesFromEstParam(Param)
}
\arguments{
\item{Param}{(Mandatory) A \code{pmsignature::EstimatedParameters} object
as those produced by the de novo signature construction method
\code{pmsignature::getPMSignature}.}
}
\value{
A list of Shiraishi signatures, one object per signature. Please
see \code{readShiraishiSignatures} or the \code{decompTumor2Sig} vignette
for more information on the format of Shiraishi signatures.
}
\description{
`getSignaturesFromEstParam()` takes an \code{EstimatedParameters} object
(signatures data) as computed by the '\code{pmsignature}' package (by
\code{pmsignature::getPMSignature}; version 0.3.0) and extracts the
signature information. The signatures can then be passed to
\code{decomposeTumorGenomes}.
}
\examples{

### load signatures for breast cancer genomes from 
### Nik-Zainal et al (PMID: 22608084) in the format produced by
### pmsignature (PMID: 26630308)
pmsigdata <- system.file("extdata",
         "Nik-Zainal_PMID_22608084-pmsignature-Param.Rdata", 
         package="decompTumor2Sig")
load(pmsigdata)

### extract the signatures from the pmsignature Param object
signatures <- getSignaturesFromEstParam(Param)

}
\references{
\url{http://rmpiro.net/decompTumor2Sig/}\cr
Krueger, Piro (2019) decompTumor2Sig: Identification of mutational
signatures active in individual tumors. BMC Bioinformatics
20(Suppl 4):152.\cr
}
\seealso{
\code{\link{decompTumor2Sig}}\cr
\code{\link{readShiraishiSignatures}}
}
\author{
Rosario M. Piro, Politecnico di Milano\cr
Sandra Krueger, Freie Universitaet Berlin\cr Maintainer: Rosario
M. Piro\cr E-Mail: <rmpiro@gmail.com> or <rosariomichael.piro@polimi.it>
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/helper_functions_for_class_checks.R
\name{isSignatureSet}
\alias{isSignatureSet}
\title{isSignatureSet}
\usage{
isSignatureSet(x)
}
\arguments{
\item{x}{Object to be checked.}
}
\value{
Logical value (true or false).
}
\description{
`isSignatureSet()` checks whether the input object is a set (list) of
numeric objects compatible with either the Alexandrov format (probability
vectors; see \code{isAlexandrovSet}) or the Shiraishi format (matrices or
data.frames of probabilities; see \code{isShiraishiSet}).
NOTE: These can also be genomes compatible with one of the two formats!
}
\examples{

### get Alexandrov signatures from COSMIC
signAlexandrov <- readAlexandrovSignatures()

isSignatureSet(signAlexandrov)
}
\references{
\url{http://rmpiro.net/decompTumor2Sig/}\cr
Krueger, Piro (2019) decompTumor2Sig: Identification of mutational
signatures active in individual tumors. BMC Bioinformatics
20(Suppl 4):152.\cr
}
\seealso{
\code{\link{decompTumor2Sig}}\cr
\code{\link{isAlexandrovSet}}\cr
\code{\link{isShiraishiSet}}
}
\author{
Rosario M. Piro\cr Politecnico di Milano\cr Maintainer: Rosario
M. Piro\cr E-Mail: <rmpiro@gmail.com> or <rosariomichael.piro@polimi.it>
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/convertAlexandrov2Shiraishi.R
\name{convertAlexandrov2Shiraishi}
\alias{convertAlexandrov2Shiraishi}
\title{Convert Alexandrov-type signatures to Shiraishi signatures}
\usage{
convertAlexandrov2Shiraishi(signatures)
}
\arguments{
\item{signatures}{(Mandatory) A list of Alexandrov signatures with named
elements as produced by \code{readAlexandrovSignatures}.}
}
\value{
A list of Shiraishi signatures that can be used for
\code{decomposeTumorGenomes}.
}
\description{
`convertAlexandrov2Shiraishi()` converts a set Alexandrov signatures to the
Shiraishi model, summing the respective frequencies of base
changes, and upstream and downstream flanking bases. In most cases, the
resulting Shiraishi signatures don't provide information on the
transcription strand, as this is not part of the standard Alexandrov
signatures. While the conversion is mainly thought for signatures, it
actually works also for mutation frequency data from genomes which have
the same format. [Attention: this conversion entails a loss of specificity
and the applicability of Shiraishi signatures derived from Alexandrov
signatures has not been extensively explored!]
}
\examples{

### get Alexandrov signatures from COSMIC
signAlexandrov <- readAlexandrovSignatures()

### convert them to the Shiraishi model
signShiraishi <- convertAlexandrov2Shiraishi(signAlexandrov)

}
\references{
\url{http://rmpiro.net/decompTumor2Sig/}\cr
Krueger, Piro (2019) decompTumor2Sig: Identification of mutational
signatures active in individual tumors. BMC Bioinformatics 
20(Suppl 4):152.\cr
}
\seealso{
\code{\link{decompTumor2Sig}}\cr
\code{\link{readAlexandrovSignatures}}\cr
\code{\link{readShiraishiSignatures}}
}
\author{
Rosario M. Piro\cr Politecnico di Milano\cr Maintainer: Rosario
M. Piro\cr E-Mail: <rmpiro@gmail.com> or <rosariomichael.piro@polimi.it>
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/determineTypeNumBasesAndTrDir.R
\name{determineTypeNumBasesAndTrDir}
\alias{determineTypeNumBasesAndTrDir}
\title{determineTypeNumBasesAndTrDir (internal function)}
\usage{
determineTypeNumBasesAndTrDir(mutData)
}
\arguments{
\item{mutData}{The mutation frequency data of the signature or genome.}
}
\value{
A list object composed of: "type"=type of signature or genome;
"numBases"=number of bases of the sequence patterns; and
"trDir"=logical value indicating whether transcription-strand information
has been considered in the mutation frequency data.
}
\description{
For a given signature or genome representation: determine the
type (Shiraishi or Alexandrov), the number of bases, and whether
transcription-strand information is included.
}
\references{
\url{http://rmpiro.net/decompTumor2Sig/}\cr
Krueger, Piro (2019) decompTumor2Sig: Identification of mutational
signatures active in individual tumors. BMC Bioinformatics 
20(Suppl 4):152.\cr
}
\author{
Rosario M. Piro\cr Politecnico di Milano\cr Maintainer: Rosario
M. Piro\cr E-Mail: <rmpiro@gmail.com> or <rosariomichael.piro@polimi.it>
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/plotDecomposedContribution.R
\name{plotDecomposedContribution}
\alias{plotDecomposedContribution}
\title{Plot the decomposition (contributions/exposures) of a tumor genome.}
\usage{
plotDecomposedContribution(decomposition, signatures=NULL,
removeNA=TRUE)
}
\arguments{
\item{decomposition}{(Mandatory) A decomposition vector (exposure vector)
obtained for a single tumor genome.}

\item{signatures}{(Optional) A list object containing the signatures used
to compute the decomposition. If specified, the signature labels used in
the plot will be taken from the element names of the list; otherwise
signature names will be taken from the exposure object (decomposition) or
named from sign_1 to sign_N.}

\item{removeNA}{(Optional) If \code{TRUE} (default), signatures with
an NA as exposure will not be included on the x-axis of the the plot.
Exposures can be NA if they have been determined with a greedy search.}
}
\value{
Returns (or draws) a plot of the decomposed tumor genome (i.e.,
contributions of the single signatures).
}
\description{
`plotDecomposedContribution()` plots the decomposition of a tumor genome,
i.e., the contributions/exposures obtained from \code{decomposeTumorGenomes}
for a set of signatures.
}
\examples{

### get Alexandrov signatures from COSMIC
signatures <- readAlexandrovSignatures()

### load preprocessed breast cancer genomes (object 'genomes') from
### Nik-Zainal et al (PMID: 22608084) 
gfile <- system.file("extdata",
         "Nik-Zainal_PMID_22608084-genomes-Alexandrov_3bases.Rdata", 
         package="decompTumor2Sig")
load(gfile)

### compute exposures
exposures <- decomposeTumorGenomes(genomes, signatures, verbose=FALSE)

### plot signature composition of the first genome
plotDecomposedContribution(exposures[[1]], signatures=NULL)

}
\references{
\url{http://rmpiro.net/decompTumor2Sig/}\cr
Krueger, Piro (2019) decompTumor2Sig: Identification of mutational
signatures active in individual tumors. BMC Bioinformatics
20(Suppl 4):152.\cr
}
\seealso{
\code{\link{decompTumor2Sig}}\cr
\code{\link{decomposeTumorGenomes}}
}
\author{
Rosario M. Piro\cr Politecnico di Milano\cr Maintainer: Rosario
M. Piro\cr E-Mail: <rmpiro@gmail.com> or <rosariomichael.piro@polimi.it>
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/helper_functions_for_class_checks.R
\name{sameSignatureFormat}
\alias{sameSignatureFormat}
\title{sameSignatureFormat}
\usage{
sameSignatureFormat(x, y)
}
\arguments{
\item{x}{First object to be checked.}

\item{y}{Second object to be checked.}
}
\value{
Logical value (true or false).
}
\description{
`sameSignatureFormat()` checks whether two input object are sets (lists) of
numeric objects both compatible with the same signature format (probability
vectors for Alexandrov signatures and probability matrices or data.frames
for Shiraishi signatures). For Shiraishi signatures also the number of
flanking bases and the presence of transcription-strand information are
compared. For Alexandrov signatures also the number of triplet changes are
compared.
}
\examples{

### get Alexandrov signatures from COSMIC
signAlexandrov <- readAlexandrovSignatures()

### convert them to the Shiraishi model
signShiraishi <- convertAlexandrov2Shiraishi(signAlexandrov)

sameSignatureFormat(signAlexandrov, signShiraishi)
}
\references{
\url{http://rmpiro.net/decompTumor2Sig/}\cr
Krueger, Piro (2019) decompTumor2Sig: Identification of mutational
signatures active in individual tumors. BMC Bioinformatics
20(Suppl 4):152.\cr
}
\seealso{
\code{\link{decompTumor2Sig}}\cr
\code{\link{isAlexandrovSet}}\cr
\code{\link{isShiraishiSet}}
}
\author{
Rosario M. Piro\cr Politecnico di Milano\cr Maintainer: Rosario
M. Piro\cr E-Mail: <rmpiro@gmail.com> or <rosariomichael.piro@polimi.it>
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/getGenomesFromMutFeatData.R
\name{getGenomesFromMutFeatData}
\alias{getGenomesFromMutFeatData}
\title{Get genomes (mutation frequencies) from \code{MutationFeatureData}.}
\usage{
getGenomesFromMutFeatData(mutFeatData, normalize=TRUE)
}
\arguments{
\item{mutFeatData}{(Mandatory) A \code{MutationFeatureData} object as
constructed, for example, by \code{pmsignature::readMPFile}.}

\item{normalize}{(Optional) Boolean value to specify whether to normalize
the mutation count data to mutation fractions between 0 and 1. This is
the default and NECESSARY in case you want to pass the return value to
\code{decomposeTumorGenomes}. Set \code{normalize} to \code{FALSE} only
if you are interested in full integer counts, but do not pass unnormalized
counts to \code{decomposeTumorGenomes}!}
}
\value{
A list of mutation frequencies (or mutation counts if not
normalized), one object per genome. The format is either according to the
Shiraishi or the Alexandrov model, depending on how the mutation data was
loaded with \code{pmsignature}.
}
\description{
`getGenomesFromMutFeatData()` takes a \code{MutationFeatureData} object
(mutation count data) as read by the '\code{pmsignature}' package (e.g.,
by \code{pmsignature::readMPFile}, version 0.3.0) and extracts the mutation
counts of the genomes therein. For passing the genomes to
\code{decomposeTumorGenomes}, the mutation counts must be normalized to
mutation frequencies, which is done by default. [IMPORTANT: set
\code{normalize} to \code{FALSE} only if you are interested in full
integer counts, but do not pass unnormalized counts to
\code{decomposeTumorGenomes}!]
}
\examples{

### get breast cancer genomes from 
### Nik-Zainal et al (PMID: 22608084) in the format produced by
### pmsignature (PMID: 26630308)
pmsigdata <- system.file("extdata", 
         "Nik-Zainal_PMID_22608084-pmsignature-G.Rdata", 
         package="decompTumor2Sig")
load(pmsigdata)

### extract the genomes from the pmsignature G object
genomes <- getGenomesFromMutFeatData(G, normalize=TRUE)

}
\references{
\url{http://rmpiro.net/decompTumor2Sig/}\cr
Krueger, Piro (2019) decompTumor2Sig: Identification of mutational
signatures active in individual tumors. BMC Bioinformatics
20(Suppl 4):152.\cr
}
\seealso{
\code{\link{decompTumor2Sig}}
}
\author{
Rosario M. Piro, Politecnico di Milano\cr
Sandra Krueger, Freie Universitaet Berlin\cr Maintainer: Rosario
M. Piro\cr E-Mail: <rmpiro@gmail.com> or <rosariomichael.piro@polimi.it>
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/readShiraishiSignatures.R
\name{readShiraishiSignatures}
\alias{readShiraishiSignatures}
\title{Read a set of Shiraishi signatures.}
\usage{
readShiraishiSignatures(files)
}
\arguments{
\item{files}{(Mandatory) Can be a single file name, a vector of file names,
or a list of file names.}
}
\value{
A list of Shiraishi signatures that can be used for
\code{decomposeTumorGenomes}.
}
\description{
`readShiraishiSignatures()` reads one or more Shiraishi-type signatures
from flat files (one file per signature). The signatures must be specified
as matrices without headers and row names (see details below).
}
\details{
Format (see Shiraishi et al. PLoS Genetics 11(12):e1005657, 2015):

First line: Frequencies of the base changes C>A, C>G, C>T, T>A, T>C,
and T>G

Following 2k lines (for k up- and downstream flanking bases):
Frequencies of the bases A, C, G, and T, followed by two 0 values

Final line (only if transcription direction is considered):
Frequencies of occurrences on the transcription strand, and on the
opposite strand, followed by four 0 values.

Example:
\tabular{llllll}{
1.8874e-14 \tab 0.10974 \tab 0.045918 \tab
0.11308 \tab 0.07429 \tab 0.65697\cr
3.8079e-01 \tab 0.12215 \tab 0.191456 \tab
0.30561 \tab 0.00000 \tab 0.00000\cr
1.5311e-01 \tab 0.34214 \tab 0.179774 \tab
0.32497 \tab 0.00000 \tab 0.00000\cr
1.2378e-01 \tab 0.10243 \tab 0.163461 \tab
0.61032 \tab 0.00000 \tab 0.00000\cr
3.4891e-01 \tab 0.15346 \tab 0.156687 \tab
0.34094 \tab 0.00000 \tab 0.00000\cr
5.6435e-01 \tab 0.43565 \tab 0.000000 \tab
0.00000 \tab 0.00000 \tab 0.00000 \cr
}
}
\examples{

### read four Shiraishi signatures for breast cancer genomes from 
### Nik-Zainal et al (PMID: 22608084) from flat files
sigfiles <- system.file("extdata",
         paste0("Nik-Zainal_PMID_22608084-pmsignature-sig",1:4,".tsv"),
         package="decompTumor2Sig")

signatures <- readShiraishiSignatures(sigfiles)

}
\references{
\url{http://rmpiro.net/decompTumor2Sig/}\cr
Krueger, Piro (2019) decompTumor2Sig: Identification of mutational
signatures active in individual tumors. BMC Bioinformatics
20(Suppl 4):152.\cr
}
\seealso{
\code{\link{decompTumor2Sig}}\cr
\code{\link{readAlexandrovSignatures}}\cr
\code{\link{getSignaturesFromEstParam}}
}
\author{
Rosario M. Piro, Politecnico di Milano\cr
Sandra Krueger, Freie Universitaet Berlin\cr Maintainer: Rosario
M. Piro\cr E-Mail: <rmpiro@gmail.com> or <rosariomichael.piro@polimi.it>
}
